//------------------------------------------------------------------------
//	Data Retrieval

$AdminAlphaString = "abcdefghijklmnopqrstuvwxyz";


function handleAdminMenuData(%type, %msg, %line, %text, %item)
{
	Admin_List.UpdateHudData(%line, %text, %item);
}
addMessageCallback( 'MsgAdminMenuData', handleAdminMenuData );

function handleAdminMenuEnd(%type, %msg)
{
	Admin_List.UpdateHudData(27);
}
addMessageCallback( 'MsgAdminMenuDataEnd', handleAdminMenuEnd );


function Admin_List::UpdateHudData(%this, %line, %text, %item)
{
	if(%line > %this.lastupdate+1)
	{
		for(%i=%this.lastupdate+1; %i<%line; %i++)
		{
			%this.menuText[%i] = "";
			%this.menuItem[%i] = "";
		}
	}
	%this.menuText[%line] = %text;
	%this.menuItem[%line] = %item;

	%this.lastupdate = %line;
	if(%line == 27)
		%this.displayMenuData();
}

function AdminInputData(%key)
{
	%linenum = strStr($AdminAlphaString, %key)+1;
	%item = Admin_List.menuItem[%linenum];

	if(Admin_List.menuText[%item] $= "" && Admin_List.menuItem[%linenum] $= "")
		return;
	CommandToServer('AdminMenuRequest', %item);
}

package Torque_Admin
{

function ToggleConsole(%make)
{
   if (%make)
   {
      if ($ConsoleActive)
      {
         Canvas.popDialog(ConsoleDlg);
         $ConsoleActive = false;
         if (AdminMenuGui.isAwake())
			SetKeyMapping("Admin");
      }
      else
      {
         Canvas.pushDialog(ConsoleDlg, 99);
         $ConsoleActive = true;
      }
   }
}

function handleClientJoin(%msgType, %msgString, %clientName, %clientId,
   %guid, %score, %isAI, %isAdmin, %isSuperAdmin )
{

	AdminMenuGui.update(%clientid, detag(%clientName), $AdminPlayerData[%clientid, team], $AdminPlayerData[%clientid, ping], $AdminPlayerData[%clientid, pl]);

	parent::handleClientJoin(%msgType, %msgString, %clientName, %clientId,
   %guid, %score, %isAI, %isAdmin, %isSuperAdmin );

}

function handleClientDrop(%msgType, %msgString, %clientName, %clientId)
{
	$AdminPlayerData[%clientid, name] = "";
	$AdminPlayerData[%clientid, guid] = "";
	$AdminPlayerData[%clientid, ping] = "";
	$AdminPlayerData[%clientid, pl] = "";
	$AdminPlayerData[%clientid, team] = "";

   	AdminMenuGui.remove(%clientId);

   	parent::handleClientDrop(%msgType, %msgString, %clientName, %clientId);
}

function disconnectedCleanup()
{
	AdminMenuGui.clear();
	deletevariables("$AdminPlayerData*");

	parent::disconnectedCleanup();
}




};
activatepackage(Torque_Admin);


function ClientCmdCloseAdminMenu()
{
   	if (AdminMenuGui.isAwake())
		AdminMenuGui.toggle();
}


function ClientCmdRequestAdminQuery(%title, %message, %callback, %cancelCallback)
{
	MessageQueryOKCancel( %title, %message, %callback, %cancelCallback);
}



function handleAdminClientUpdate(%msgType, %msgString, %clientId, %clientName, %guid, %ping, %pl, %team )
{
	$AdminPlayerData[%clientid, name] = detag(%clientName);
	$AdminPlayerData[%clientid, guid] = %guid;
	$AdminPlayerData[%clientid, ping] = %ping;
	$AdminPlayerData[%clientid, pl] = %pl;
	$AdminPlayerData[%clientid, team] = %team;

	AdminMenuGui.update(%clientid, detag(%clientName), %team, %ping, %pl);

}
addMessageCallback( 'MsgAdminUpdate', handleAdminClientUpdate );


//Check that update operation is completed and then reschedule for next update
function handleAdminClientUpdateEnd(%msgType, %msgString )
{
	cancel(AdminMenuGui.playerUpdateSched);
	AdminMenuGui.playerUpdateSched = AdminMenuGui.schedule(1000, "updatePlayerListData");
}
addMessageCallback( 'MsgAdminUpdateEnd', handleAdminClientUpdateEnd );


function AdminMenuGui::updatePlayerListData(%this)
{
	cancel(AdminMenuGui.playerUpdateSched);
	if(%this.isAwake())
		CommandToServer('UpdatePlayerListData');
}




