//======================================================================
//	PERSONAL MUTE ADMIN
//======================================================================
//
//	This plugin adds players to mute other players so only they can not hear them
//
//
//
//----------------------------------------------------------------------
//	Register plugin with admin system

AdminMenu.RegisterPlugin("ChangeTeam_Admin");


//----------------------------------------------------------------------
//	Action Functions

function ChangeTeam_Admin::clientJoinTeam(%this, %client, %team, %admin)
{
	CommandToClient(%admin, 'CloseAdminMenu');
	messageClient(%client,'MsgTeamChange','\c2You have been changed to the %1 team by %2.',$TeamName[%team], %admin.name);
	messageClient(%admin,'MsgTeamChange','\c2You changed %1 to the %2 team.',%client.name, $TeamName[%team]);
	echo("(",%admin,") ",%admin.namebase," changed (",%client,") ",%client.namebase," to the ",$TeamName[%team]," team (",%team,")");
	%client.clientJoinTeam(%team);
}

function ChangeTeam_Admin::getNumTeams(%this)
{
	//%num = getnumteams();
	%num = %num $= "" ? 1 : %num;
	return $num;
}




//----------------------------------------------------------------------
//	Declare plugin menus and create plugin object


%admin = "AdminMenu";
%admin.addAdminMenuItem("PlayerSelected", 7, 2, "Change Players Team", "$Server::Tournament && %client.testAdmin(TournamentChangeTeam)", "AdminMenu.ListMenuData(%client, ChangeTeam);", "ChangeTeam_Admin");
%admin.addAdminMenuItem("PlayerSelected", 7, 3, "Change Players Team", "!$Server::Tournament && %client.testAdmin(FFAChangeTeam)", "AdminMenu.ListMenuData(%client, ChangeTeam);", "ChangeTeam_Admin");

for(%team=0; %team<9; %team++)
{
	if($TeamName[%team] $= "")
		$TeamName[%team] = "Team "@%team;
	%admin.addAdminMenuItem("ChangeTeam", %team+1, 1, "Change to "@$TeamName[%team], "%client.menuTargetClient.team != "@%team@" && ChangeTeam_Admin_Object.getNumTeams() > "@%team, "ChangeTeam_Admin_Object.clientJoinTeam(%client.menuTargetClient, "@%team@", %client);", "ChangeTeam_Admin");
}

%admin.addAdminMask(TournamentChangeTeam, 0); 	// "The ability to change other players team whilst in Tournament Mode";
%admin.addAdminMask(FFAChangeTeam, 0); 			// "The ability to change other players team whilst in Free for All Mode";




