//=============================================================================
//	CONSOLE OPERATION PLUGIN
//=============================================================================
//
//	This plugin has a two-fold role.
//	1)	Supply server admins some easy to use console commands
//	2)	Console Chat Display
//
//
//=============================================================================

AdminMenu.registerPlugin("Console_Admin");



//-----------------------------------------------------------------------------
//	Server console chat display

function Console_Admin::recordConsoleChat(%this, %client, %msgString, %team)
{
	if($Pref::Server::ConsoleChat $= "" || $Pref::Server::ConsoleChat == 0)
		return;
	if(%team $= "")
	{
		%prefix = "GLOBAL - ("@%client@") "@%client.namebase@" - ";
	}
	else
	{
		%prefix = "TEAM "@%team@" - ("@%client@") "@%client.namebase@" - ";
	}
	echo(%prefix,%msgString);
}


package Console_Admin
{
function chatMessageTeam( %sender, %team, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 )
{
   	if ( ( %msgString $= "" ) || spamAlert( %sender ) )
      	return;
	Console_Admin_Object.recordConsoleChat(%sender, %msgString, %team);

	parent::chatMessageTeam( %sender, %team, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 );
}

function chatMessageAll( %sender, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 )
{
   	if ( ( %msgString $= "" ) || spamAlert( %sender ) )
      	return;
	Console_Admin_Object.recordConsoleChat(%sender, %msgString);

	parent::chatMessageAll( %sender, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 );
}
};
activatepackage(Console_Admin);



//-----------------------------------------------------------------------------

function help()
{
	echo("------------------------------------------------------------------");
	echo(" TORQUE ADMIN CONSOLE COMMANDS");
	echo("------------------------------------------------------------------");
	echo("");
	echo(" listplayers();                 - This function will list out the ");
	echo("                                  current players and their info");
	echo(" togglechat();                  - Turns console chat display on or off");
	echo(" setlogmode(%opt);              - Turns console logging on or off.");
	echo("                                  %opt should be 0 or 1");
	echo(" SADSetPassword(%password);     - Sets a new god admin password");
	echo("                                  %password is case sensitive");
	echo(" chatall(%msg);                 - Sends a global message to all players");
	echo(" chatteam(%msg, %team);         - Sends a message to all players on %team");
	echo(" chatclient(%msg, %client);     - Sends a message to %client");
	echo(" ");
	echo("------------------------------------------------------------------");
}


//	Lists out current players in the console
function listplayers()
{
   	echo("------------------------------------------------------------------");
	echo(" PLAYER LIST");
   	%count = ClientGroup.getCount();
   	for( %cl = 0; %cl < %count; %cl++ )
   	{
      	%client = ClientGroup.getObject( %cl );
      	if (%client.isAIControlled())
        	%bot = "BOT";
      	echo(" ",%client," ",%client.namebase," ",%client.team," ",%client.score," ",%bot);
   	}
	echo(" ");
	echo("------------------------------------------------------------------");
}


//	Turns console chat display on or off
function togglechat()
{
	if($Pref::Server::ConsoleChat)
	{
		$Pref::Server::ConsoleChat = 0;
		echo("------------------------------------------------------------------");
		echo(" CONSOLE CHAT DISABLED");
		echo("------------------------------------------------------------------");
	}
	else
	{
		$Pref::Server::ConsoleChat = 1;
		echo("------------------------------------------------------------------");
		echo(" CONSOLE CHAT ENABLED");
		echo("------------------------------------------------------------------");
	}
}


//	Set the server god password
function SADSetPassword(%password)
{
	$Pref::Server::AdminPassword = %password;
	echo("------------------------------------------------------------------");
	echo(" Server Admin Password changed to - ",$Pref::Server::AdminPassword);
	echo("------------------------------------------------------------------");
}


//	Send global server admin message
function chatall(%msgString)
{
	messageAll("AdminMessage", %msgString);
	%prefix = "GLOBAL - (ConsoleAdmin) - ";
	echo(%prefix @ %msgString);
}

function chatteam(%msgString, %team)
{
	messageTeam(%team, "AdminMessage", %msgString);
	%prefix = "TEAM "@%team@" - (ConsoleAdmin) - ";
	echo(%prefix @ %msgString);
}

function chatclient(%msgString, %client)
{
	messageClient(%client, "AdminMessage", %msgString);
	%prefix = "CLIENT "@%client@" - (ConsoleAdmin) - ";
	echo(%prefix @ %msgString);
}

