//======================================================================
//	KICK AND BAN ADMIN OPTIONS
//======================================================================
//
//	This plugin adds amdin and vote optison for kicking and banning
//
//
//
//----------------------------------------------------------------------
//	Register plugin with admin system

AdminMenu.RegisterPlugin("KickBan_Admin");

error("Registered KickBan_Admin plugin!");

//----------------------------------------------------------------------
//	Action Functions

function KickBan_Admin::SelectBanTime(%this, %client, %seconds)
{
	if(%client.selectActionMenu)
	{
		ban(%client.selectActionMenu, %client, %seconds);
	}
	else
	{
		$Pref::Server::BanTime = %seconds;
		messageClient(%client,'MsgAlterBan','\c2You have altered the default ban time to %1 seconds.',%seconds);
		echo("(",%client,") ",%client.namebase," changed the default ban time to ",%seconds," seconds.");
	}
	%client.selectActionMenu = "";
	AdminMenu.ListMenuData(%client, "Main");
}

function KickBan_Admin::SelectKickBanTime(%this, %client, %seconds)
{
	$Pref::Server::KickBanTime = %seconds;
	messageClient(%client,'MsgAlterBan','\c2You have altered the default kickban time to %1 seconds.',%seconds);
	echo("(",%client,") ",%client.namebase," changed the default kickban time to ",%seconds," seconds.");
	AdminMenu.ListMenuData(%client, "Main");
}



package KickBan_Admin
{

function kick(%client, %admin)
{
   	if(%admin == -1)
   		messageAll('MsgAdminKick', '\c2%1 was kicked by vote.', %client.name);
   	else if(%admin.name !$= "")
   		messageAll( 'MsgAdminKick', '\c2%2 has kicked %1.', %client.name, %admin.name);
   	else
   		messageAll( 'MsgAdminKick', '\c2The Admin has kicked %1.', %client.name);

   	if (!%client.isAIControlled())
      	BanList::add(%client.guid, %client.getAddress(), $Pref::Server::KickBanTime);
   	%client.delete("You have been kicked from this server");
}

function ban(%client, %admin, %time)
{
   	if(%admin == -1)
   		messageAll('MsgAdminBan', '\c2%1 was banned by vote.', %client.name);
   	else if(%admin.name !$= "")
   		messageAll('MsgAdminBan', '\c2%2 has banned %1.', %client.name, %admin.name);
   	else
   		messageAll('MsgAdminBan', '\c2The Admin has banned %1.', %client.name);

	%time = %time $= "" ? $Pref::Server::BanTime : %time;

   	if (!%client.isAIControlled())
      	BanList::add(0, %client.getAddress(), %time);
//       BanList::add(%client.guid, %client.getAddress(), %time);
   	%client.delete("You have been banned from this server");
}

};
activatepackage(KickBan_Admin);


//----------------------------------------------------------------------
//	Declare plugin menus and create plugin object

%admin = "AdminMenu";
%admin.addAdminMenuItem("PlayerSelected", 12, 2, "Kick", "$Server::Tournament && %client.testAdmin(TournamentForceKick) && !%client.menuTargetClient.testAdmin(Immunity) && %client!=%client.menuTargetClient", "kick(%client.menuTargetClient, %client);", "KickBan_Admin");
%admin.addAdminMenuItem("PlayerSelected", 12, 3, "Kick", "!$Server::Tournament && %client.testAdmin(FFAForceKick) && !%client.menuTargetClient.testAdmin(Immunity) && %client!=%client.menuTargetClient", "kick(%client.menuTargetClient, %client);", "KickBan_Admin");
%admin.addAdminMenuItem("PlayerSelected", 12, 4, "Vote to Kick", "$Server::Tournament && %client.testAdmin(TournamentVoteKick) && !%client.menuTargetClient.testAdmin(Immunity) && %client!=%client.menuTargetClient", "AdminMenu.InitVote(%client, \"Kick\", %client.menuTargetClient);", "KickBan_Admin");
%admin.addAdminMenuItem("PlayerSelected", 12, 5, "Vote to Kick", "!$Server::Tournament && %client.testAdmin(FFAVoteKick) && !%client.menuTargetClient.testAdmin(Immunity) && %client!=%client.menuTargetClient", "AdminMenu.InitVote(%client, \"Kick\", %client.menuTargetClient);", "KickBan_Admin");
%admin.addAdminMenuItem("PlayerSelected", 14, 2, "Ban", "$Server::Tournament && %client.testAdmin(TournamentForceBan) && !%client.menuTargetClient.testAdmin(Immunity) && %client!=%client.menuTargetClient", "AdminMenu.ListMenuData(%client, BanTimeSelect, 1, %client.menuTargetClient);", "KickBan_Admin");
%admin.addAdminMenuItem("PlayerSelected", 14, 3, "Ban", "!$Server::Tournament && %client.testAdmin(FFAForceBan) && !%client.menuTargetClient.testAdmin(Immunity) && %client!=%client.menuTargetClient", "AdminMenu.ListMenuData(%client, BanTimeSelect, 1, %client.menuTargetClient);", "KickBan_Admin");
%admin.addAdminMenuItem("PlayerSelected", 14, 4, "Vote to Ban", "$Server::Tournament && %client.testAdmin(TournamentVoteBan) && !%client.menuTargetClient.testAdmin(Immunity) && %client!=%client.menuTargetClient", "AdminMenu.InitVote(%client, \"Ban\", %client.menuTargetClient);", "KickBan_Admin");
%admin.addAdminMenuItem("PlayerSelected", 14, 5, "Vote to Ban", "!$Server::Tournament && %client.testAdmin(FFAVoteBan) && !%client.menuTargetClient.testAdmin(Immunity) && %client!=%client.menuTargetClient", "AdminMenu.InitVote(%client, \"Ban\", %client.menuTargetClient);", "KickBan_Admin");

//%admin.addAdminMenuItem("PlayerSelected", 12, 2, "Kick", "true", "kick(%client.menuTargetClient, %client);", "KickBan_Admin");
//%admin.addAdminMenuItem("PlayerSelected", 12, 4, "Vote to Kick", "true", "AdminMenu.InitVote(%client, \"Kick\", %client.menuTargetClient);", "KickBan_Admin");
//%admin.addAdminMenuItem("PlayerSelected", 14, 2, "Ban", "true", "AdminMenu.ListMenuData(%client, BanTimeSelect, 1, %client.menuTargetClient);", "KickBan_Admin");
//%admin.addAdminMenuItem("PlayerSelected", 14, 4, "Vote to Ban", "true", "AdminMenu.InitVote(%client, \"Ban\", %client.menuTargetClient);", "KickBan_Admin");

%admin.addAdminMenuItem("BanTimeSelect", 1, 1, "5 Minutes", "true", "KickBan_Admin_Object.SelectBanTime(%client, 300);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 2, 1, "10 Minutes", "true", "KickBan_Admin_Object.SelectBanTime(%client, 600);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 3, 1, "15 Minutes", "true", "KickBan_Admin_Object.SelectBanTime(%client, 900);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 4, 1, "30 Minutes", "true", "KickBan_Admin_Object.SelectBanTime(%client, 1800);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 5, 1, "1 Hour", "true", "KickBan_Admin_Object.SelectBanTime(%client, 3600);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 6, 1, "2 Hours", "true", "KickBan_Admin_Object.SelectBanTime(%client, 7200);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 7, 1, "12 Hours", "true", "KickBan_Admin_Object.SelectBanTime(%client, 43200);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 8, 1, "1 Day", "true", "KickBan_Admin_Object.SelectBanTime(%client, 86400);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 9, 1, "2 Days", "true", "KickBan_Admin_Object.SelectBanTime(%client, 172800);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 10, 1, "5 Days", "true", "KickBan_Admin_Object.SelectBanTime(%client, 432000);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 11, 1, "1 Week", "true", "KickBan_Admin_Object.SelectBanTime(%client, 604800);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 12, 1, "2 Weeks", "true", "KickBan_Admin_Object.SelectBanTime(%client, 1209600);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 13, 1, "4 Weeks", "true", "KickBan_Admin_Object.SelectBanTime(%client, 2419200);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 14, 1, "1 Year", "true", "KickBan_Admin_Object.SelectBanTime(%client, 31449600);", "KickBan_Admin");
%admin.addAdminMenuItem("BanTimeSelect", 15, 1, "Infinite", "true", "KickBan_Admin_Object.SelectBanTime(%client, 999999999);", "KickBan_Admin");

%admin.addAdminMenuItem("KickBanTimeSelect", 1, 1, "1 Minute", "true", "KickBan_Admin_Object.SelectKickBanTime(%client, 60);", "KickBan_Admin");
%admin.addAdminMenuItem("KickBanTimeSelect", 2, 1, "2 Minutes", "true", "KickBan_Admin_Object.SelectKickBanTime(%client, 120);", "KickBan_Admin");
%admin.addAdminMenuItem("KickBanTimeSelect", 3, 1, "5 Minutes", "true", "KickBan_Admin_Object.SelectKickBanTime(%client, 300);", "KickBan_Admin");
%admin.addAdminMenuItem("KickBanTimeSelect", 4, 1, "10 Minutes", "true", "KickBan_Admin_Object.SelectKickBanTime(%client, 600);", "KickBan_Admin");
%admin.addAdminMenuItem("KickBanTimeSelect", 5, 1, "20 Minutes", "true", "KickBan_Admin_Object.SelectKickBanTime(%client, 1200);", "KickBan_Admin");
%admin.addAdminMenuItem("KickBanTimeSelect", 6, 1, "30 Minutes", "true", "KickBan_Admin_Object.SelectKickBanTime(%client, 1800);", "KickBan_Admin");
%admin.addAdminMenuItem("KickBanTimeSelect", 7, 1, "1 Hour", "true", "KickBan_Admin_Object.SelectKickBanTime(%client, 3600);", "KickBan_Admin");

%admin.addAdminMenuItem("ServerOptions", 4, 1, "Alter Kick Ban Time", "true", "AdminMenu.ListMenuData(%client, KickBanTimeSelect);", "KickBan_Admin");
%admin.addAdminMenuItem("ServerOptions", 5, 1, "Alter Ban Time", "true", "AdminMenu.ListMenuData(%client, BanTimeSelect);", "KickBan_Admin");



%admin.addAdminMask(TournamentForceKick, 0); 	// "The ability to kick players whilst in Tournament Mode";
%admin.addAdminMask(TournamentVoteKick, 1); 	// "The ability to vote to kick players whilst in Tournament Mode";
%admin.addAdminMask(FFAForceKick, 0); 			// "The ability to kick players whilst in Free for All Mode";
%admin.addAdminMask(FFAVoteKick, 1); 			// "The ability to vote to kick players whilst in Free for All Mode";
%admin.addAdminMask(TournamentForceBan, 0); 	// "The ability to ban players whilst in Tournament Mode";
%admin.addAdminMask(TournamentVoteBan, 0); 		// "The ability to vote to ban players whilst in Tournament Mode";
%admin.addAdminMask(FFAForceBan, 0); 			// "The ability to ban players whilst in Free for All Mode";
%admin.addAdminMask(FFAVoteBan, 0); 			// "The ability to vote to ban players whilst in Free for All Mode";


%admin.addVoteType("Kick", "Kick", "kick(%target);");
%admin.addVoteType("Ban", "Ban", "ban(%target);");



