//======================================================================
//	PASSWORD SERVER
//======================================================================
//
//	Allows admins to password the server from the menu system
//
//
//----------------------------------------------------------------------
//	Register plugin with admin system

AdminMenu.RegisterPlugin("passwordserver_admin");


//----------------------------------------------------------------------
//	Action Functions

function passwordserver_admin::PasswordServer(%client)
{
	CommandToClient(%client, 'CloseAdminMenu');
	CommandToClient(%client, 'RequestAdminQuery', "Enter Server Password", "Enter the new server password.  Leave blank to disable.", "QueryBoxResponse(MBQueryTextData.getValue(), SetServerPassword);", "");
}

function ServerCmdSetServerPassword(%client, %password)
{
	$Pref::Server::Password = %password;
	if(%password $= "")
	{
		messageClient(%client,'MsgServerPassword','\c2Server password disabled.');
		echo("(",%client,") ",%client.namebase," disabled the server password");
	}
	else
	{
		messageClient(%client,'MsgAdminPassword','\c2Server password set to %1.', %password);
		echo("(",%client,") ",%client.namebase," changed the server password to ",%password);
	}
	ServerCmdAdminMenuRequest(%client);
}



//----------------------------------------------------------------------
//	Declare plugin menus and create plugin object

%admin = "AdminMenu";
%admin.addAdminMenuItem("ServerOptions", 8, 1, "Set Server Password", "%client.testAdmin(PasswordServer)", "passwordserver_admin_Object.PasswordServer(%client);", "PasswordServer_Admin");


%admin.addAdminMask(PasswordServer, 0); 	// The ability to password the server



