//======================================================================
//	SWAP TEAM ADMIN OPTIONS
//======================================================================
//
//	This plugin allows players to change their own teams
//
//	Notes:	This plugin requires the function getNumTeams() to return the number
//			of player teams (non observer)
//			It also requires the function  %client.clientJoinTeam(%team)
//			which should change the clients team.
//
//
//
//----------------------------------------------------------------------
//	Register plugin with admin system

AdminMenu.RegisterPlugin("SwapTeam_Admin");



//----------------------------------------------------------------------
//	Action Functions

function SwapTeam_Admin::clientJoinTeam(%this, %client, %team)
{
	CommandToClient(%client, 'CloseAdminMenu');
	%client.clientJoinTeam(%team);
}

function SwapTeam_Admin::getNumTeams(%this)
{
	//%num = getnumteams();
	%num = %num $= "" ? 1 : %num;
	return $num;
}




//----------------------------------------------------------------------
//	Declare plugin menus and create plugin object

%admin = "AdminMenu";
%admin.addAdminMenuItem("Main", 1, 1, "Change Teams", "$Server::Tournament && SwapTeam_Admin_Object.getNumTeams() > 1 && %client.testAdmin(TournamentChangeOwnTeam)", "AdminMenu.ListMenuData(%client, JoinTeam);", "SwapTeam_Admin");
%admin.addAdminMenuItem("Main", 1, 2, "Change Teams", "!$Server::Tournament && SwapTeam_Admin_Object.getNumTeams() > 1 && %client.testAdmin(FFAChangeOwnTeam)", "AdminMenu.ListMenuData(%client, JoinTeam);", "SwapTeam_Admin");
%admin.addAdminMenuItem("Main", 1, 3, "Join the Action", "$Server::Tournament && %client.team < 1 && %client.testAdmin(TournamentChangeOwnTeam)", "SwapTeam_Admin_Object.clientJoinTeam(%client, 1);", "SwapTeam_Admin");
%admin.addAdminMenuItem("Main", 1, 4, "Join the Action", "!$Server::Tournament && %client.team < 1 && %client.testAdmin(FFAChangeOwnTeam)", "SwapTeam_Admin_Object.clientJoinTeam(%client, 1);", "SwapTeam_Admin");
%admin.addAdminMenuItem("Main", 1, 5, "Join Observer", "true", "SwapTeam_Admin_Object.clientJoinTeam(%client, 0);");

for(%team=1; %team<9; %team++)
{
	$TeamName[%team] = $TeamName[%team] $= "" ? "Team "@%team : $TeamName[%team];
	%admin.addAdminMenuItem("JoinTeam", %team, 1, "Join "@$TeamName[%team], "%client.team != "@%team@" && getNumTeams() > "@%team-1, "SwapTeam_Admin_Object.clientJoinTeam(%client, "@%team@");", "SwapTeam_Admin");
}
$TeamName[0] = $TeamName[0] $= "" ? "Observer" : $TeamName[0];
%admin.addAdminMenuItem("JoinTeam", 9, 1, "Join Observer", "%client.team != 0", "SwapTeam_Admin_Object.clientJoinTeam(%client, 0);", "SwapTeam_Admin");

%admin.addAdminMask(TournamentChangeOwnTeam, 1); 	// "The ability to change your own team whilst in Tournament Mode";
%admin.addAdminMask(FFAChangeOwnTeam, 1); 			// "The ability to change your own team whilst in Free For All Mode";




