//=============================================================================
//	PLUGIN HANDLING
//=============================================================================

// 	This function is called from a plugin and registers it with the admin system
//	%plugin is the name of the plugin  eg.  "ChangeMission_Admin"
function AdminMenu::RegisterPlugin(%this, %plugin)
{
	if(%plugin $= "")
		return;
	if(isObject(%plugin))
	{
		error("Torque Plugin ",%plugin," previously loaded");
		return;
	}
	%name = %plugin@"_Object";
	%plugid = new ScriptObject(%name)
	{
		class = %plugin;
		adminmenu = %this;
		menuItem = 0;
	};
	%nextPlugin = %this.maxPlugin;
	%nextPlugin = %nextPlugin $= "" ? 0 : %nextPlugin;
	%plugin.id = %nextPlugin;
	%this.maxPlugin++;
	%this.pluginList[%nextPlugin] = %name;
}


function AdminMenu::RemovePlugin(%this, %plugin)
{
	if(%plugin $= "")
		return;
	if(!isObject(%plugin))
	{
		error("Torque Plugin ",%plugin," does not exist");
		return;
	}

	for(%i=0; %i<%plugin.menuItem; %i++)
	{
		%menu = %plugin.itemMenu[%id];
		%item = %plugin.itemItem[%id];
		%rank = %plugin.itemRank[%id];
		%this.removeAdminMenuItem(%menu, %item, %rank);
	}

	%id = %plugin.id;
	for(%i=%id; %i<%this.maxPlugin; %i++)
	{
		%newname = %this.pluginList[%i+1];
		%newname.id = %newname.id+1;
		%this.pluginList[%i] = %newname;
	}
	%this.maxPlugin--;
	%plugin.delete();

}

function AdminMenu::isRegisteredPlugin(%this, %plugin)
{
	%name = %plugin@"_Object";
	for(%p=0; %p<%this.maxPlugin; %p++)
	{
		if(%this.pluginList[%p] $= %name)
		{
			return true;
		}
	}
	return false;
}



//	This function loads all the admin plugin files.
//	An admin plugin file is any file that ends with   _admin.cs
//
//	Note:  filename MUST be the same as the registered plugin name to prevent multiple execution
//
function AdminMenu::LoadAllPlugins(%this)
{
	%search = "*_admin.cs";
	for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search))
	{
		%type = fileBase(%file);
		if(!%this.isRegisteredPlugin(%type) && !$TorqueAdminSystem::disablePlugin[%type])
			exec("./admin/" @ %type @ ".cs");
	}
}
AdminMenu.LoadAllPlugins();



