//-----------------------------------------------------------------------------
// Torque Engine
// 
// Copyright (c) 2001 GarageGames.Com
//-----------------------------------------------------------------------------

function OpenALInit()
{
   OpenALShutdownDriver();

   echo("");
   echo("OpenAL Driver Init:");

   echo ($pref::Audio::driver);

   if($pref::Audio::driver $= "OpenAL")
   {
      if(!OpenALInitDriver())
      {
         error("   Failed to initialize driver.");
         $Audio::initFailed = true;
      } else {
         // this should go here
         echo("   Vendor: " @ alGetString("AL_VENDOR"));
         echo("   Version: " @ alGetString("AL_VERSION"));  
         echo("   Renderer: " @ alGetString("AL_RENDERER"));
         echo("   Extensions: " @ alGetString("AL_EXTENSIONS"));

         alxListenerf(AL_GAIN_LINEAR, $pref::Audio::masterVolume );
   
         for (%channel=1; %channel <= 8; %channel++)
         {
           %volume = $pref::Audio::channelVolume[%channel];
           alxSetChannelVolume(%channel, %volume);
           echo("Audio Volume Init. Channel " @ %channel @ " set to " @ %volume);
           echo("Actual channel volume is now: " @ alxGetChannelVolume(%channel));
         }
         echo("");
      }
   }

}


//--------------------------------------------------------------------------

function OpenALShutdown()
{
   OpenALShutdownDriver();
   //alxStopAll();
   //AudioGui.delete();
   //sButtonDown.delete();
   //sButtonOver.delete();
}
