//-----------------------------------------------------------------------------

// Variables used by client scripts & code.  The ones marked with (c)
// are accessed from code.  Variables preceeded by Pref:: are client
// preferences and stored automatically in the ~/client/prefs.cs file
// in between sessions.
//
//    (c) Client::MissionFile             Mission file name
//    ( ) Client::Password                Password for server join

//    (?) Pref::Player::CurrentFOV
//    (?) Pref::Player::DefaultFov
//    ( ) Pref::Input::KeyboardTurnSpeed

//    (c) pref::Master[n]                 List of master servers
//    (c) pref::Net::RegionMask     
//    (c) pref::Client::ServerFavoriteCount
//    (c) pref::Client::ServerFavorite[FavoriteCount]
//    .. Many more prefs... need to finish this off

// Moves, not finished with this either...
//    (c) firstPerson
//    $mv*Action...



//-----------------------------------------------------------------------------
// These are variables used to control the shell scripts and
// can be overriden by mods:

//-----------------------------------------------------------------------------

function isDemo()
{
  return $babaGanush;
}

function isDone()
{
  return $babaGanush2;
}
function initClient()
{
   echo("\n--------- Initializing FPS: Client ---------");

   // Make sure this variable reflects the correct state.
   $Server::Dedicated = false;
   
   // Game information used to query the master server
   $Client::GameTypeQuery = "DHLDEV2";
   $Client::MissionTypeQuery = "Any";
   $pref::Master0 = "2:v12master.dyndns.org:28002";

   // The common module provides basic client functionality
   // InitCanvas starts up the graphics system.
   initBaseClient();
   initCanvas("Dark Horizons");
   // Load client-side Audio Profiles/Descriptions
   exec("./scripts/audioProfiles.cs");

   //Load up the GUI Profiles
   exec("./ui/shellProfiles.cs");
   exec("./ui/gameProfiles.cs");

   // Defaults
   exec("./scripts/defaults.joystick.cs");
   exec("./scripts/defaults.mouse.cs");
   exec("./scripts/defaults.music.cs");
   exec("./scripts/defaults.messages.cs");
   
   //Load customized settings
   exec("./musiclists.cs");
   exec("./messages.cs");

   // Load up the Game GUIs
   exec("./ui/gameHudChat.gui");
   exec("./ui/gameSelectMain.gui");
   exec("./ui/gamePlayerList.gui");
   exec("./ui/gameLoadingGui.gui");
   exec("./ui/gameEndGame.gui");
   exec("./ui/GameSinglePlayerEndGui.gui");
   exec("./ui/gameHudFS.gui");
   exec("./ui/gameHudEC.gui");
   exec("./ui/commanderHud.gui");
   
   // Load up the shell GUIs
   exec("./ui/menuLan.gui");
   exec("./ui/menuComcent.gui");
   exec("./ui/menuSplashGui.gui");
   exec("./ui/menuMainGui.gui");
   exec("./ui/menuSinglePlayer.gui");
   exec("./ui/menuMultiMain.gui");
   exec("./ui/menuMultiNewGame.gui");
   exec("./ui/menuMultiLogin.gui");
   exec("./ui/menuOptionsDlg.gui");
   exec("./ui/menuRemapDlg.gui");
   exec("./ui/menuHelpDlg.gui");
   exec("./ui/menuStagingArea.gui");
   exec("./ui/menuPlaylists.gui");
   exec("./ui/menuRecordingsDlg.gui");
   
   // Load up Message Box Dialogs.
   exec("./ui/menuMessageBox.gui");
   exec("./ui/menuDialogBox.gui");
   exec("./scripts/menuMessageBox.cs");

   // Load up the UI based Scripts.
   exec("./scripts/menuComcent.cs");
   exec("./scripts/menuStagingArea.cs");
   exec("./scripts/menuObjects.cs");
   exec("./scripts/menuStrings.cs");
   exec("./scripts/menuHelp.cs");
   exec("./scripts/menuJoin.cs");
   exec("./scripts/menuOptions.cs");
   exec("./scripts/menuPlaylist.cs");
   exec("./scripts/menuSupport.cs");
   exec("./scripts/gamePlayerList.cs");
   exec("./scripts/gameSelectMain.cs");
   exec("./scripts/gameMessageHud.cs");
   exec("./scripts/gamePlayHud.cs");
   exec("./scripts/gameSupport.cs");

   // Client scripts
   exec("./scripts/clientCommands.cs");
   exec("./scripts/messageCallbacks.cs");
   exec("./scripts/missionDownload.cs");
   exec("./scripts/serverConnection.cs");

   // Load Bind Scripts
   exec("./scripts/bind.main.cs");
   exec("./config.cs");
   exec("./scripts/bind.movement.cs");
   exec("./scripts/bind.actions.cs");


   
   // Really shouldn't be starting the networking unless we are
   // going to connect to a remote server, or host a multi-player
   // game.
   setNetPort(0);

   // Copy saved script prefs into C++ code.
   setShadowDetailLevel( $pref::shadows );
   setDefaultFov( $pref::Player::defaultFov );
   setZoomSpeed( $pref::Player::zoomSpeed );

   // Setup for RSS
   initRSSView();
   
   exec("./scripts/menuIgnition.cs");
   exec("./ui/yesggRegDlg.gui");
   exec("./ui/MGTggRegDlg.gui");
   exec("./ui/ignitionggRegDlg.gui");
   loadMainMenu();
   // Connect to server if requested.
   if ($JoinGameAddress !$= "") {
      connect($JoinGameAddress, "", $Pref::Player::Name);
   }
}


//-----------------------------------------------------------------------------

function initClientDedi()
{
   //initBaseClient();
   exec("./scripts/audioProfiles.cs");
}

function initRSSView() {
	// Load GUI Profile
	exec("./ui/menuRSSGui.gui");
	exec("./scripts/menuRSS.cs");

	// Flag to denote if recieving RSS information
	TCPObj.rsson = false;

}
//-----------------------------------------------------------------------------

function loadMainMenu()
{
   //Startup the client with the Main menu...
   //exec("fps/AVI/avitest.cs");
   Gui::LoadObjects();
   ComcentClientSetup();
   //ComcentLoadObjects();
   Canvas.setCursor("DefaultCursor");
   Canvas.setContent("menuSplashGui");
   menuPlaylists::initialize();
   gah1.setVisible(isDemo());
   gah2.setVisible(isDemo());
   buymenowbg.setvisible(isDemo());
   buymenow.setvisible(isDemo());
}

