// ACTION Binds
//------------------------------------------------------------------------------
//Globals
$current = 1;
$zoomfov = 45;
$default = 90;
$cameraFov = 90;
$zoomOn = false;
$HideHud = false;

//------------------------------------------------------------------------------
// Triggers / Actions
//------------------------------------------------------------------------------
// Trigger 0 is fire
// Trigger 1 is unused
// Trigger 2 is Jump (movement)
// Trigger 3 is Jetting (movement)
function actionFire(%val)
{
   $mvTriggerCount0++;
}

function actionAltFire(%val)
{
   $mvTriggerCount1++;
}

function primGun (%val)
{
   if ( %val )
      commandToServer('use',"Primary");
}

function secGun (%val)
{
   if ( %val )
      commandToServer('use',"Secondary");
}

function toggleGun (%val)
{
   if ( %val )
      if ($current == 1)
         commandToServer('use',"Secondary");
      else
         commandToServer('use',"Primary");
}
function cycleWeaponAxis( %val )
{
   if ( %val )
      if ($current == 1)
         commandToServer('use',"Secondary");
      else
         commandToServer('use',"Primary");
}
function throwFlare( %val )
{
   if ( %val )
      commandToServer( 'throwFlare' );
}

//function throwMine( %val )
//{
//   if ( %val )
//      commandToServer( 'throwMine' );
//}

function throwCore( %val )
{
   if ( %val )
      commandToServer( 'throwCore' );
}
function useSpecial( %val )
{
   if ( %val )
     commandToServer( 'useSpecial' );
}

//------------------------------------------------------------------------------
// Zoom and FOV functions
//------------------------------------------------------------------------------

if($Pref::player::CurrentFOV $= "")
   $Pref::player::CurrentFOV = 45;


function setZoomFOV(%val)
{
   if (%val) {
      if (!$zoomOn)
      {
         $ZoomOn = true;
         $cameraFov = 45;
         setFov($cameraFov);
         ec_hud.setVisible(false);
         ec_zoom.setVisible(true);
         fs_hud.setVisible(false);
         fs_zoom.setVisible(true);
      }
      else
      {
         $ZoomOn = false;
         $cameraFov = 90;
         setFov($cameraFov);
         ec_hud.setVisible(true);
         ec_zoom.setVisible(false);
         fs_hud.setVisible(true);
         fs_zoom.setVisible(false);
      }
   }
}

function toggleZoom( %val )
{
  if ($firstPerson == 1) // --> no zoom when 3rd person
  {
    if ( %val )
    {
      $ZoomOn = true;
         $cameraFov = 45;
         setFov($cameraFov);
      ec_hud.setVisible(false);
      ec_zoom.setVisible(true);
      fs_hud.setVisible(false);
      fs_zoom.setVisible(true);
    }
    else
    {
      $ZoomOn = false;
         $cameraFov = 90;
         setFov($cameraFov);
      ec_hud.setVisible(true);
      ec_zoom.setVisible(false);
      fs_hud.setVisible(true);
      fs_zoom.setVisible(false);
    }
  }
}

//------------------------------------------------------------------------------
// Camera & View functions
//------------------------------------------------------------------------------

function toggleFreeLook( %val )
{
   if ( %val )
      $mvFreeLook = true;
   else
      $mvFreeLook = false;
}

function toggleCamera(%val)
{
   if (%val)                          {
      commandToServer('ToggleCamera');
      hideHud(%val);
      }
}

function toggleFirstPerson(%val)
{
   if (%val)
   {
      $firstPerson = !$firstPerson;
   }
}

function hideHud(%val)
{
  if (%val){
    if (!$HideHud)
    {
      GameECHudControl.setVisible(false);
      GameFSHudControl.setVisible(false);
      $HideHud = true;
    } else {
      GameECHudControl.setVisible(true);
      GameFSHudControl.setVisible(true);
      $HideHud = false;
    }
  }
}

// UI Functions
//------------------------------------------------------------------------------
// Show FPS counter
function showFPS(%val)
{
	if(%val)
	{
		metrics(fps);
	}
}

function showOptions(%val)
{
 	if(%val)
	{
      canvas.pushDialog(menuOptionsDlg);
	}
}
// Back to Staging Area/Quit
function escapeFromGame()
{
   if ( $Server::ServerType $= "SinglePlayer" )
      MessageBoxYesNo( "Quit Mission", "Exit from this Mission?", "disconnect();", "");
   else
      MessageBoxYesNo( "Disconnect", "Go back to staging area?", "commandToServer('suicide'); leavegame();", "");
}
// Team Select UI
function TeamSelect(%val)
{
  if ($GUI::SP)
     if (%val)
        gameSelectMain::toggle(%this);
}
// Show Player List
function ShowList(%val)
{
   gamePlayerListGui.toggle();
}

//------------------------------------------------------------------------------
// Message HUD functions
//------------------------------------------------------------------------------

function pageMessageHudUp( %val )
{
   if ( %val )
      pageUpMessageHud();
}

function pageMessageHudDown( %val )
{
   if ( %val )
      pageDownMessageHud();
}

//------------------------------------------------------------------------------
// Demo recording functions
//------------------------------------------------------------------------------
function startRecordingDemo( %val )
{
   if ( %val )
      startDemoRecord();
}

function stopRecordingDemo( %val )
{
   if ( %val )
      stopDemoRecord();
}
function quickmessages0(%val)
{
  if (%val) {
     %text = $messages::message[0];
     %team = $messages::teammsg[0];
     gameMessageHud.isTeamMsg = %team;
     MessageHud_Edit.setText(%text);
     MessageHud_Edit::eval(MessageHud_Edit);
  }
}
function quickmessages1(%val)
{
  if (%val) {
     %text = $messages::message[1];
     %team = $messages::teammsg[1];
     gameMessageHud.isTeamMsg = %team;
     MessageHud_Edit.setText(%text);
     MessageHud_Edit::eval(MessageHud_Edit);
  }
}
function quickmessages2(%val)
{
  if (%val) {
     %text = $messages::message[2];
     %team = $messages::teammsg[2];
     gameMessageHud.isTeamMsg = %team;
     MessageHud_Edit.setText(%text);
     MessageHud_Edit::eval(MessageHud_Edit);
  }
}
function quickmessages3(%val)
{
  if (%val) {
     %text = $messages::message[3];
     %team = $messages::teammsg[3];
     gameMessageHud.isTeamMsg = %team;
     MessageHud_Edit.setText(%text);
     MessageHud_Edit::eval(MessageHud_Edit);
  }
}
function quickmessages4(%val)
{
  if (%val) {
     %text = $messages::message[4];
     %team = $messages::teammsg[4];
     gameMessageHud.isTeamMsg = %team;
     MessageHud_Edit.setText(%text);
     MessageHud_Edit::eval(MessageHud_Edit);
  }
}
function quickmessages5(%val)
{
  if (%val) {
     %text = $messages::message[5];
     %team = $messages::teammsg[5];
     gameMessageHud.isTeamMsg = %team;
     MessageHud_Edit.setText(%text);
     MessageHud_Edit::eval(MessageHud_Edit);
  }
}
function quickmessages6(%val)
{
  if (%val) {
     %text = $messages::message[6];
     %team = $messages::teammsg[6];
     gameMessageHud.isTeamMsg = %team;
     MessageHud_Edit.setText(%text);
     MessageHud_Edit::eval(MessageHud_Edit);
  }
}
function quickmessages7(%val)
{
  if (%val) {
     %text = $messages::message[7];
     %team = $messages::teammsg[7];
     gameMessageHud.isTeamMsg = %team;
     MessageHud_Edit.setText(%text);
     MessageHud_Edit::eval(MessageHud_Edit);
  }
}
function quickmessages8(%val)
{
  if (%val) {
     %text = $messages::message[8];
     %team = $messages::teammsg[8];
     gameMessageHud.isTeamMsg = %team;
     MessageHud_Edit.setText(%text);
     MessageHud_Edit::eval(MessageHud_Edit);
  }
}
