/// BINDABLE COMMANDS
  
// Movement
//------------------------------------------------------------------------------
// Globals
$movementSpeed = 1; // m/s
$mvThrottle = 1;
$mvJoystickActive = $pref::Input::JoystickEnabled;
$mvSensitivity    = $pref::Input::Sensitivity;
// Secondary Function- Get Look Adjustment
function getAdjustAmount(%val)
{
   %sensitivity = $mvSensitivity;
   if ($mvJoystickActive)
      %sensitivity *= 10;
   return(%val * ($cameraFov / 90) * 0.01) * %sensitivity;
}

// Secondary Function - Set Speed
function setSpeed()
{
   if($mvMaintainSpeed)
      $mvForwardAction = $mvThrottle;
}

// Turn Auto-Run on/off
function maintainSpeed(%val)
{
   $mvMaintainSpeed = !$mvMaintainSpeed;
   if (%val)
      $mvForwardAction = $mvThrottle * $mvMaintainSpeed;
}

// Reverse Direction
function reverseSpeed(%val)
{
   if (%val)
      $mvThrottle = -$mvThrottle;
   setSpeed();
}

// Increment Speed
function incrementSpeed(%val)
{
   if (%val && $mvThrottle < 1)
      $mvThrottle += 0.05;
   setSpeed();
}

// Decrement Speed
function decrementSpeed(%val)
{
   if (%val && $mvThrottle > -1)
      $mvThrottle -= 0.05;
   setSpeed();
}

// Keyboard movement
function moveleft(%val)
{
   $mvLeftAction = %val;
   if($singlePlayerLevel == 1)
        $leftMove = true;
}

function moveright(%val)
{
   $mvLeftAction = -%val;
   if ($singlePlayerLevel == 1)
       $rightMove = true;
}

function moveforward(%val)
{
   $mvForwardAction = (%val) ? $mvThrottle : 0;
   if ($singlePlayerLevel == 1)
       $forwardMove = true;
}

function movebackward(%val)
{
   $mvForwardAction = (%val) ? -$mvThrottle : 0;
   if ($singlePlayerLevel == 1)
       $backwardsMove = true;
}

//Keyboard Look
function turnLeft( %val )
{
   $mvYawRightSpeed = %val * $Pref::Input::KeyboardTurnSpeed;
}

function turnRight( %val )
{
   $mvYawLeftSpeed = %val * $Pref::Input::KeyboardTurnSpeed;
}

function panUp( %val )
{
   $mvPitchDownSpeed = %val ? $Pref::Input::KeyboardTurnSpeed : 0;
}

function panDown( %val )
{
   $mvPitchUpSpeed = %val ? $Pref::Input::KeyboardTurnSpeed : 0;
}

//Our Axis Binds
//Throttle Axis
function axisthrottle(%val)
{
   %val += $pref::Joystick::SliderOffset;
   if (%val <= $pref::Joystick::SliderDeadzone && %val >= -$pref::Joystick::SliderDeadzone)
      %val = 0;
   else if (%val >= $pref::Joystick::SliderDeadzone)
      %val -= $pref::Joystick::SliderDeadzone;
   else
      %val += $pref::Joystick::SliderDeadzone;
   %val /= (1 - $pref::Joystick::SliderDeadzone);
   $mvForwardAction = -%val;
         if ($singlePlayerLevel == 1) {
         if(%val > 0)
                $forwardMove = true;
         if(%val < 0)
                $backwardsMove = true;
    }
}
//Yaw Axis
function axisyaw(%val)
{
   if ($pref::Input::JoystickEnabled)
   {
      %val += $pref::Joystick::XAxisOffset;
      if (%val <= $pref::Joystick::XAxisDeadzone && %val >= -$pref::Joystick::XAxisDeadzone)
         %val = 0;
      else if (%val >= $pref::Joystick::XAxisDeadzone)
         %val -= $pref::Joystick::XAxisDeadzone;
      else
         %val += $pref::Joystick::XAxisDeadzone;
      %val /= (1 - $pref::Joystick::XAxisDeadzone);
   }
   $mvYaw = getAdjustAmount(%val);
}
//Pitch Axis
function axispitch(%val)
{
   if ($pref::Input::JoystickEnabled)
   {
      %val += $pref::Joystick::YAxisOffset;
      if (%val <= $pref::Joystick::YAxisDeadzone && %val >= -$pref::Joystick::YAxisDeadzone)
         %val = 0;
      else if (%val >= $pref::Joystick::YAxisDeadzone)
         %val -= $pref::Joystick::YAxisDeadzone;
      else
         %val += $pref::Joystick::YAxisDeadzone;
      %val /= (1 - $pref::Joystick::YAxisDeadzone);
   }
   $mvPitch = getAdjustAmount(%val) * $pref::Player::InvertMouse;

}
//Z-Roll Axis (Strafe)
function axisroll(%val)
{
   if (%val <= $pref::Joystick::RZaxisDeadzone && %val >= -$pref::Joystick::RZaxisDeadzone)
      %val = 0;
   else if (%val >= $pref::Joystick::RZaxisDeadzone)
      %val -= $pref::Joystick::RZaxisDeadzone;
   else
      %val += $pref::Joystick::RZaxisDeadzone;
   %val /= (1 - $pref::Joystick::RZaxisDeadzone);
   moveleft(%val);
      if ($singlePlayerLevel == 1) {
         if(%val > 0)
                $leftMove = true;
         if(%val < 0)
                $rightMove = true;
    }
}

//Jump Axis
function jump(%val)
{
   $mvTriggerCount2++;
      if($singlePlayerLevel == 1)
        $jumpMove = true;
}

//Jetting Axis
function jet(%val)
{
   $mvTriggerCount3++;
      if($singlePlayerLevel == 1)
        $jetMove = true;
}
