//-----------------------------------------------------------------------------
// CS:LORE CLIENT COMMANDS
// 
//-----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Game start / end events sent from the server
//----------------------------------------------------------------------------
function clientCmdSetHud(%hud)
{
   if (%hud $= "")
   {
    %hud = "gameHudFS";
   }
   Canvas.setContent(%hud);
}

function clientCmdGameStart(%seq,%chan,%key)
{
   if ($INGAMEIRC)
   {
     IRCClient::ingameStart(%chan,%key);
   }
}

function clientCmdSP_MoveMap()
{
 moveMap.pop();

}
function clientCmdPlayMissionMusic(%handle)
{
   menuPlaylists::loadList("battle");
}

function clientCmdStopMissionMusic(%handle)
{
   menuPlaylists::stop();
}

function clientCmdStopAllSounds()
{
   alxStopAll();
   menuPlaylists::stop();
   menuPlaylists::play();
}
function clientCmdNewStagingArea()
{
   mSA::FullReset();
   canvas.setContent(menuStagingArea2);
}


function clientCmdLoadStagingArea()
{
   mSA::PartialReset();
   canvas.setContent(menuStagingArea2);
}

function clientCmdLoadIRCAfterGame()
{
   disconnect();
   IRCUI::cmdLoad();
   IRCClient::ingameEnd();
}
function clientCmdnoSpawnsLeft()
{
   MessageBoxOk( "No Respawns", "You have run out of available MAVs. Click Ok to return to the Staging Area and await a new game.?", "leavegame();", "");
   mSA_Launch.setActive(false);
   $GUI::LReady = false;
   $GUI::NoSpawn = true;
}

function clientCmdGameEnd(%hide,%winner)
{
   // Copy the current scores from the player list into the
   // end game gui (bit of a hack for now).
   // Display the end-game screen
   if (%winner == 1 && $GUI::Team == 1)
   {
      gEG_Background.setBitmap("fps/client/ui/backgrounds/fsVictory.png");
   }
   else if (%winner == 2 && $GUI::Team == 2)
   {
      gEG_Background.setBitmap("fps/client/ui/backgrounds/ecVictory.png");
   }
   if (%winner == 1 && $GUI::Team == 2)
   {
      gEG_Background.setBitmap("fps/client/ui/backgrounds/ecDefeat.png");
   }
   else if (%winner == 2 && $GUI::Team == 1)
   {
      gEG_Background.setBitmap("fps/client/ui/backgrounds/fsDefeat.png");
   }
   else if (%winner == 0)
   {
      gEG_Background.setBitmap("fps/client/ui/backgrounds/tieGame.png");
   }
   Canvas.setContent(gameEndGame);
   if($Server::ServerType $= "SinglePlayer")
   {
      Canvas.setContent(singlePlayerEndGameGui);
      NextMission.setVisible(!%hide);
   }
   HudMessageVector.clear();
}

//------------------------------------------------------------------------------
// GUI Information Update Functions
//------------------------------------------------------------------------------

// Ammo Ammount
function clientCmdSetAmmoAmountHud(%value)
{
 %text = FS_Weapons.getRowTextById(FS_Weapons.getSelectedId());
 %text = setField(%text,0,%value);
 FS_Weapons.setRowById(FS_Weapons.getSelectedId(),%text);
 %text = EC_weapons.getRowTextById(EC_weapons.getSelectedId());
 %text = setField(%text,0,%value);
 EC_weapons.setRowById(EC_weapons.getSelectedId(),%text);

}
function clientCmdSetCounterAmountHud(%value)
{
  FS_weapons.setRowById(3,%value TAB "Counter Measures");
  EC_weapons.setRowByID(3,%value TAB "Counter Measures");
}

// Clock Sync
function clientCmdSyncClock(%time)
{
   // Store the base time in the hud control it will automatically increment.
   EC_HudClock.setTime(%time);
   mSA_Clock.setTime(%time);
   FS_HudClock.setTime(%time);
}

