//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2001 GarageGames.Com
// Portions Copyright (c) 2001 by Sierra Online, Inc.
//-----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Enter Chat Message Hud
//----------------------------------------------------------------------------

//------------------------------------------------------------------------------
function gameMessageHud::open(%this)
{
   %offset = 6;

   if(%this.isVisible())
      return;

   if(%this.isTeamMsg)
      %text = "TEAM:";
   else
      %text = "GLOBAL:";

   MessageHud_Text.setValue(%text);
   Canvas.pushDialog(%this);
   %this.setVisible(true);
   deactivateKeyboard();
   MessageHud_Edit.makeFirstResponder(true);
}

//------------------------------------------------------------------------------
function gameMessageHud::close(%this)
{
   if(!%this.isVisible())
      return;
      
   Canvas.popDialog(%this);
   %this.setVisible(false);
   if ( $enableDirectInput )
      activateKeyboard();
   MessageHud_Edit.setValue("");
}


//------------------------------------------------------------------------------
function gameMessageHud::toggleState(%this)
{
   if(%this.isVisible())
      %this.close();
   else
      %this.open();
}

//------------------------------------------------------------------------------
function MessageHud_Edit::onEscape(%this)
{
   gameMessageHud.close();
}

//------------------------------------------------------------------------------
function MessageHud_Edit::eval(%this)
{
   %text = trim(%this.getValue());
   if(%text !$= "")
   {
     if (!$INGAMEIRC)
     {
      if(gameMessageHud.isTeamMsg)
      {
         commandToServer('teamMessageSent', %text);
      }
      else
      {
	     commandToServer('messageSent', %text);
      }
     }
     else
     {
      if(gameMessageHud.isTeamMsg)
      {
         IRCClient::ingameSend("TEAM", %text);
      }
      else
      {
         IRCClient::ingameSend("GLOBAL",%text);
      }
     }
   }
   MessageHud_Edit.setValue("");
   gameMessageHud.close();
}
//----------------------------------------------------------------------------
// MessageHud key handlers

function toggleMessageHud(%make)
{
   if(%make)
   {
      gameMessageHud.isTeamMsg = false;
      gameMessageHud.toggleState();
   }
}

function teamMessageHud(%make)
{
   if(%make)
   {
      gameMessageHud.isTeamMsg = true;
      gameMessageHud.toggleState();
   }
}

//-----------------------------------------------------------------------------
// Message Hud
//-----------------------------------------------------------------------------
new MessageVector(HudMessageVector);
//-----------------------------------------------------------------------------
function onChatMessage(%message)
{
   // XXX Client objects on the server must have voiceTag and voicePitch
   // fields for values to be passed in for %voice and %pitch... in
   // this example mod, they don't have those fields.
   // Chat goes to the chat HUD.
   if (%message !$= "")
      FSChatHud.addLine(%message);
}
function onServerMessage(%message)
{
   // Server messages go to the chat HUD too.
   if (%message !$= "")
      FSChatHud.addLine(%message);
}

function pageUpMessageHud()
{
   FS_ChatScrollHud.scrollUp();
   EC_ChatScrollHud.scrollUp();
}

function pageDownMessageHud()
{
   FS_ChatScrollHud.scrollDown();
   EC_ChatScrollHud.scrollDown();
}

//-----------------------------------------------------------------------------
function FSChatHud::addLine(%this,%text)
{
   //first, see if we're "scrolled up"...
   %textHeight = %this.profile.fontSize;
   if (%textHeight <= 0)
      %textHeight = 12;
   %chatScrollHeight = getWord(%this.getGroup().getGroup().extent, 1);
   %chatPosition = getWord(%this.extent, 1) - %chatScrollHeight + getWord(%this.position, 1);
   %linesToScroll = mFloor((%chatPosition / %textHeight) + 0.5);
   if (%linesToScroll > 0)
      %origPosition = %this.position;

   //add the message...
   while(HudMessageVector.getNumLines() && (HudMessageVector.getNumLines() >= $pref::HudMessageLogSize))
   {
      %tag = HudMessageVector.getLineTag(0);
      if(%tag != 0)
         %tag.delete();
      HudMessageVector.popFrontLine();
   }
   HudMessageVector.pushBackLine(%text, $LastHudTarget);
   $LastHudTarget = 0;
}

