//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2001 GarageGames.Com
// Portions Copyright (c) 2001 by Sierra Online, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// PlayGui is the main TSControl through which the game is viewed.
// The PlayGui also contains the hud controls.
//-----------------------------------------------------------------------------

function gameHudFS::onWake(%this)
{
   $enableDirectInput = "1";
   activateDirectInput();
   FSchatHud.attach(HudMessageVector);
   if (!$SP::Level1)
     moveMap.push();
   else
     moveMap.pop();
}

function gameHudFS::onSleep(%this)
{
   $SP::Level1 = false;
   FSchatHud.detach();
   moveMap.pop();
   Canvas.popDialog(gamePlayerListGui);
}

function gameHudEC::onWake(%this)
{
   $enableDirectInput = "1";
   activateDirectInput();
   ECchatHud.attach(HudMessageVector);
   if (!$SP::Level1)
     moveMap.push();
   else
     moveMap.pop();
}

function gameHudEC::onSleep(%this)
{
   $SP::Level1 = false;
   ECchatHud.detach();
   moveMap.pop();
   Canvas.popDialog(gamePlayerListGui);
}
//-----------------------------------------------------------------------------
function UpdateWeaponsHud(%value1,%value2,%id1,%id2,%ammo1,%ammo2,%SpecialDisplay)
{
  EC_weapons.clear();
  EC_weapons.addRow(1,%ammo1 TAB %value1 TAB %id1);
  EC_weapons.addRow(2,%ammo2 TAB %value2 TAB %id2);
  EC_weapons.addRow(3,"" TAB "Counter Measures");
  //error("Speical is " @ %SpecialDisplay);
  if(%SpecialDisplay !$= "")
  EC_weapons.addRow(4,%SpecialDisplay);
  EC_weapons.setSelectedRow(0);

  FS_weapons.clear();
  FS_weapons.addRow(1,%ammo1 TAB %value1 TAB %id1);
  FS_weapons.addRow(2,%ammo2 TAB %value2 TAB %id2);
  FS_weapons.addRow(3,"" TAB "Counter Measures");
  if(%SpecialDisplay !$= "")
  FS_weapons.addRow(4,%SpecialDisplay);
  FS_Weapons.setSelectedRow(0);
}
function isSpecialWeapon(%Name){
      switch$ (%Name)
      {
         //-------------------
         case "PredatorSpecial":
         return true;
         //--------------------
         case "PredatorSpecial":
         return true;
         //--------------------
         default:
         return false;
         }
}

function UpdateWeaponsSelected(%id)
{
  if (getField(EC_weapons.getRowText(0),2) $= %id)
  {
     EC_weapons.setSelectedRow(0);
     FS_weapons.setSelectedRow(0);
     $current = 1;
  } else {
    if(isSpecialWeapon(%id)){
    EC_weapons.setSelectedRow(3);
    FS_weapons.setSelectedRow(3);
    $current = 4;
   }
    else{
     EC_weapons.setSelectedRow(1);
     FS_weapons.setSelectedRow(1);
     $current = 2;
     }
  }

}

function UpdateWeaponAmmo(%pammo,%sammo,%cms)
{
  %text = FS_Weapons.getRowTextById(1);
  FS_weapons.setRowById(1,setField(%text,0,%pammo));
  EC_weapons.setRowById(1,setField(%text,0,%pammo));
  %text = FS_Weapons.getRowTextById(2);
  FS_weapons.setRowById(2,setField(%text,0,%sammo));
  EC_weapons.setRowById(2,setField(%text,0,%sammo));
  %text = FS_Weapons.getRowTextById(3);
  FS_weapons.setRowById(3,setField(%text,0,%cms));
  EC_weapons.setRowById(3,setField(%text,0,%cms));
}
function LeaveGame()
{
  commandToServer('LeftGame');
  Canvas.setContent("menuStagingArea2");
}
