function gamePlayerListGui::Join(%this,%clientId,%name,%isSuperAdmin,%isAdmin,%isAI)
{
   // Build the row to display.  The name can have ML control tags,
   // including color and font.  Since we're not using and
   // ML control here, we need to strip them off.
   %tag = %isSuperAdmin? "[Super]":(%isAdmin? "[Admin]":(%isAI? "[Bot]":""));
   %text = StripMLControlChars(%name) SPC %tag TAB "" TAB 0 TAB 0 TAB 0 TAB 0;

   // Update or add the player to the control
   if (PL_OB_List.getRowNumById(%clientId) == -1)
      PL_OB_List.addRow(%clientId, %text);
   else
      PL_OB_List.setRowById(%clientId, %text);
   gamePlayerListGui.checkSizes();
}

function gamePlayerListGui::JoinInfo(%this,%clientId,%name,%isSuperAdmin,%isAdmin,%isAI,%score,%kills, %deaths, %oT, %teamID)
{
   // Build the row to display.  The name can have ML control tags,
   // including color and font.  Since we're not using and
   // ML control here, we need to strip them off.
   %tag = %isSuperAdmin? "[Super]":(%isAdmin? "[Admin]":(%isAI? "[Bot]":""));
   %text = StripMLControlChars(%name) SPC %tag TAB "" TAB %kills TAB %deaths TAB %oT  TAB %score;
   if (%teamID == 1) {
      if (PL_FS_List.getRowNumById(%clientId) == -1)
         PL_FS_List.addRow(%clientId, %text);
      else
         PL_FS_List.setRowById(%clientId, %text);
   }
   else if (%teamID == 2) {
      if (PL_EC_List.getRowNumById(%clientId) == -1)
         PL_EC_List.addRow(%clientId, %text);
      else
         PL_EC_List.setRowById(%clientId, %text);
   } else {
      if (PL_OB_List.getRowNumById(%clientId) == -1)
         PL_OB_List.addRow(%clientId, %text);
      else
         PL_OB_List.setRowById(%clientId, %text);
   }
   gamePlayerListGui.checkSizes();
}
function gamePlayerListGui::teamInfo(%players1, %players2, %score1, %score2, %oT1, %oT2)
{
  %text = "Federated States Totals:" TAB "" TAB "" TAB "" TAB "" TAB %score1;
  if (PL_FS_Team_List.rowCount() == 0)
    PL_FS_Team_List.addRow(1,%text);
  else
    PL_FS_Team_List.setRowById(1,%text);

  %text = "Eastern Confedration Totals:" TAB "" TAB "" TAB "" TAB "" TAB %score2;
  if (PL_EC_Team_List.rowCount() == 0)
    PL_EC_Team_List.addRow(1,%text);
  else
    PL_EC_Team_List.setRowById(1,%text);
}

function gamePlayerListGui::updateTeam(%this,%clientId,%name,%clientTeam)
{
   %team = gamePlayerListGui::getTeam(%clientId);
   %text = ("PL_" @ %team @ "_List").getRowTextById(%clientId);
   gamePlayerListGui.removePlayer(%clientId);
   if (%clientTeam == 1)
   {
     %team = "FS";
   }
   else if (%clientTeam == 2)
   {
     %team = "EC";
   }
   else
   {
     %team = "OB";
   }
   ("PL_" @ %team @ "_List").setRowById(%clientId, %text);
   ("PL_" @ %team @ "_List").sortNumerical(5);
   gamePlayerListGui.checkSizes();
}

function gamePlayerListGui::updateTeamField(%this,%clientId,%value,%field)
{
  %team = gamePlayerListGui::getTeam(%clientId);
  %text = ("PL_" @ %team @ "_Team_List").getRowTextById(1);
  %text = setField(%text,%field,%value);
  ("PL_" @ %team @ "_Team_List").setRowById(1, %text);
}

function gamePlayerListGui::updateField(%this,%clientId,%value,%field)
{
  %team = gamePlayerListGui::getTeam(%clientId);
  %text = ("PL_" @ %team @ "_List").getRowTextById(%clientId);
  %text = setField(%text,%field,%value);
  ("PL_" @ %team @ "_List").setRowById(%clientId, %text);
  ("PL_" @ %team @ "_List").sortNumerical(1);
}

// The backend functions
// Toggle, Resize Lists, Get Team, Clear
function gamePlayerListGui::toggle(%this)
{
   if (!%this.isAwake() && !gameEndGame.isAwake() && !menuStagingArea2.isAwake())
   {
      Canvas.pushDialog(%this);
   }
   else
   {
      Canvas.popDialog(%this);
   }
}
function gamePlayerListGui::hide(%this)
{
   if (gamePlayerListGui.isAwake())
   {
      Canvas.popDialog(gamePlayerListGui);
   }
}
function gamePlayerListGui::getTeam(%value)
{
  if (PL_FS_List.getRowNumById(%value) != -1 ) {
      %team = "FS";
  }
  if (PL_EC_List.getRowNumById(%value) != -1) {
      %team = "EC";
  }
  if (PL_OB_List.getRowNumById(%value) != -1) {
      %team = "OB";
  }
  return %team;
}

function gamePlayerListGui::clear(%this)
{
   PL_EC_Team_List.clear();
   PL_EC_List.clear();
   PL_FS_Team_List.clear();
   PL_FS_List.clear();
   PL_OB_List.clear();
}

function gamePlayerListGui::removePlayer(%this,%clientId,%team)
{
  %team = gamePlayerListGui::getTeam(%clientId);
  ("PL_" @ %team @ "_List").removeRowById(%clientId);
}

function gamePlayerListGui::checkSizes(%this)
{
  // Set initial values for resizing
  %fontsize = 18; //4 higher then actual value for spacing
  %width = 570;   //Window size. Static for now
  %x1 = firstWord(PL_FS_Team_Scroll.getPosition());
  %y1 = getWord(PL_FS_Team_Scroll.getPosition(),1);

  // Check to see if Team exists first then resize
  %rows = PL_FS_List.rowCount();
  if (%rows > 0) {
    PL_FS_Team_Scroll.setVisible(true);
    PL_FS_Team_Scroll.resize(%x1,%y1,%width,%fontsize);
    %y1 += %fontsize;
    PL_FS_Scroll.setVisible(true);
    PL_FS_Scroll.resize(%x1,%y1,%width,%fontsize * %rows);
    %y1 += %fontsize * %rows;
  }
  else
  {
    PL_FS_Team_Scroll.setVisible(false);
    PL_FS_Scroll.setVisible(false);
  }
  // Check to see if Team exists first then resize
  %rows = PL_EC_List.rowCount();
  if (%rows > 0) {
    PL_EC_Team_Scroll.setVisible(true);
    PL_EC_Team_Scroll.resize(%x1,%y1,%width,%fontsize);
    %y1 += %fontsize;
    PL_EC_Scroll.setVisible(true);
    PL_EC_Scroll.resize(%x1,%y1,%width,%fontsize * %rows);
    %y1 += %fontsize * %rows;
  }
  else
  {
    PL_EC_Team_Scroll.setVisible(false);
    PL_EC_Scroll.setVisible(false);
  }

  // Do Observers
  %rows = PL_OB_List.rowCount();
  if (%rows > 0) {
    PL_OB_Scroll.setVisible(true);
    PL_OB_Scroll.resize(%x1,%y1 + %fontsize + 5,%width,%fontsize * %rows);
    %y1 += %fontsize * %rows;
  }
  else
  {
    PL_OB_Scroll.setVisible(false);
  }
}

