function getMachineGUID()
{
   ignitionOpen();
   $Ignition::machineGUID = ignitionGetMachineGUID();
   ignitionClose();
   return $Ignition::machineGUID;
}


function startIgnition(%key, %callback)
{
   $Ignition::callback = %callback;
   $Ignition::header = "";
   $Ignition::message = "";
   $Ignition::registered = false;
   $Ignition::userName = "Guest";

 	ignitionOpen();
	ignitionRegisterProduct(%key);

	$Ignition::checkSchedule = schedule(1000, 0, checkIgnition);
}


function checkIgnition()
{
	%status = ignitionGetRegistrationStatus();

	if(%status == 9)
	{
		schedule(100, 0, checkIgnition);
		return;
	}

   $Ignition::userName = ignitionGetUserName();
	$Ignition::message = "Please contact\ntechnical support.";

	switch (%status)
	{
		case 1:  
			$Ignition::header = "* Operation Successful *";
		case 2:  
			$Ignition::header = "* Ignition Not Open *";
		case 3:  
			$Ignition::header = "* Illegal Arguments *";
		case 4:  
			$Ignition::header = "* Registration Complete *";
			$Ignition::message = "Enjoy the game!";
			$Ignition::registered = true;
		case 5:  
			$Ignition::header = "* Authentication Failed *";
		case 6:  
			$Ignition::header = "* Expired Product Key *";
		case 7:  
			$Ignition::header = "* Product Key Mismatch *";
		case 8:  
			$Ignition::header = "* Date Out Of Range *";
		case 10: 
			$Ignition::header = "* Invalid Product Key *";
			$Ignition::message = "Please re-enter your key\nand try again.";
		case 11: 
			$Ignition::header = "* Product Key Disabled *";
		case 12: 
			$Ignition::header = "* Unable To Find Server *";
			$Ignition::message = "Check internet connection\nand try again.";
		case 13: 
			$Ignition::header = "* Internal Server Error *";
		case 14: 
			$Ignition::header = "* User Cancelled Operation *";
	}
   MessageBoxOk($Ignition::header,$Ignition::message,"ignitionCallback();");
	ignitionClose();
}

function ignitionCallback()
{
   if($Ignition::callback !$= "" && $Ignition::registered)
      eval($Ignition::callback);
}
function cancelIgnition()
{
	ignitionCancelRegistration();
	ignitionClose();
}

function CheckIgniteKey()
{
	%key = ggIgnitionKey2Box.getValue();
	if(%key $= "")
		return;
   MessageBoxCancel("Registration","Validating Product Key\nPlease wait...");
   startIgnition(%key, "Canvas.setContent(rssGui);");
}

function CheckKey()
{
  if (strlen(ggPasswordBox.getValue()) > 5)
  {
     if (ignitionTurnTheKey() || isDemo())
     {
        CheckRegister();
     }
     else
     {
       	%key = ggIgnitionKeyBox.getValue();
	      if(%key $= "")
	       	return;
         MessageBoxCancel("Registration","Validating Product Key\nPlease wait...","quit();");
         startIgnition(%key, "CheckRegister();");
      }
  }
  else
  {
    // Error Password Length must be greater then 5 characters.
    MessageBoxOk("Password Too Short","Passwords are required to be a minimum of 6 characters in length");
  }
}

function CheckRegister()
{
   %key = ggIgnitionKeyBox.getValue();
   %name = ggNameBox.getValue();
   %pass = ggPasswordBox.getValue();
   %mail = ggEmailBox.getValue();
   %query        = "loginname="@%name@"\t"@
                   "userpass="@%pass@"\t"@
                   "usermail="@%mail@"\t"@
                   "ignition="@ignitionGetMachineGUID();
   %server       = $IRCClient::AuthServer;
   %path         = $IRCClient::AuthServerPath;
   %script       = %path @ "gamereg.php";
   %upd = new HTTPObject(HTTPRegister);
   %client.sendObject = %upd;      //store object details just in case
   %upd.clientid = %client;
   %upd.get(%server, %script, %query);
   MessageBoxCancel("Registration","Registering Account","canvas.popDialog(MGTggRegDlg);");
}

function HTTPRegister::onLine( %this, %line )
{
   //Check if webpage returns the word Verified on the first line
   if(StrStr(%line, "Registered") != -1)
   {
      // Canvas.setContent("menuMainGui");
      Canvas.popDialog("MGTggRegDlg");
      //Canvas.setContent("rssGui");
   }
   else
   {
     MessageBoxOk("Registration",%line);
   }
}

function HTTPRegister::onConnectionDied( %this )
{
   MessageBoxOk("Connection Died","Your connection timed out. Please try again in a few minutes");
}

function HTTPRegister::onDNSFailed( %this )
{
   MessageBoxOk("DNS Failed","I cant find the server. Please recheck your connection and try again");
}

function HTTPRegister::onConnectFailed( %this )
{
   MessageBoxOk("Connection Failed","Connection Failed. Please try again in a few minutes");
}

//misc ignition calls
function SinglePlayerStart()
{
   if (ignitionTurnTheKey() || isDemo())
   {
      Canvas.setcontent(menuSinglePlayerGui);
      Canvas.repaint();
   }
   else
   {
      Canvas.pushDialog(ignitionggRegDlg);
   }
}

function MultiPlayerStart()
{
   if (ignitionTurnTheKey() || isDemo())
   {
      if ($Client::LanOnly)
         Canvas.setContent(menuLan);
      else
         IRCUI::cmdLoad();
      
   }
   else
   {
      Canvas.pushDialog(ignitionggRegDlg);
   }
}

