//----------------------------------------
function menuMultiMain::onWake()
{
   // Double check the status. Tried setting this the control
   // inactive to start with, but that didn't seem to work.
   $querybox = mMM_FSF_GamesList;
   mMM_FSF_JoinServerButton.setActive(mMM_FSF_GamesList.rowCount() > 0);
   menuMultiMain::query();
}

//----------------------------------------
function menuMultiMain::query(%this)
{
   queryMasterServer(
      0,          // Query flags
      $Client::GameTypeQuery,       // gameTypes
      $Client::MissionTypeQuery,    // missionType
      0,          // minPlayers
      100,        // maxPlayers
      0,          // maxBots
      2,          // regionMask
      0,          // maxPing
      100,        // minCPU
      0           // filterFlags
      );
      
      $querybox = mMM_FSF_GamesList;
}

//----------------------------------------
function menuMultiMain::queryLan(%this)
{
   queryLanServers(
      27999,      // Lan Port
      0,          // Query flags
      $Client::GameTypeQuery,       // gameTypes
      $Client::MissionTypeQuery,    // missionType
      0,          // minPlayers
      100,        // maxPlayers
      0,          // maxBots
      2,          // regionMask
      0,          // maxPing
      100,        // minCPU
      0           // filterFlags
      );
      
      $querybox = mL_FSF_GamesList;
}
//----------------------------------------
function menuMultiMain::cancel(%this)
{
   cancelServerQuery();
}


//----------------------------------------
function menuMultiMain::join(%this)
{
   $IRCClient::LastChannel = mMM_ChanList.getSelectedId();
   IRCClient::fileSave();
   cancelServerQuery();
   %id = $querybox.getSelectedId();
   $GUI::Host = false;
   // The server info index is stored in the row along with the
   // rest of displayed info.
   %index = getField($querybox.getRowTextById(%id),8);
   %pass = getField($querybox.getRowTextById(%id),1);
   if (%pass $= "YES")
   {
      DialogBoxSingle("Password?","Password:","menuMultiMain::joinPW();");
   }
   else
   {
      if (setServerInfo(%index)) {
         %conn = new GameConnection(ServerConnection);
         %conn.setConnectArgs($pref::Player::Name);
         %conn.setJoinPassword("");
         %conn.connect($ServerInfo::Address);
      }
   }
   IRCUI::minimize();
}

function menuMultiMain::joinLan(%this)
{
   $GUI::Lan = true;
   $pref::Player::Name = mL_LoginField.getValue();
   cancelServerQuery();
   %id = $querybox.getSelectedId();
   $GUI::Host = false;
   // The server info index is stored in the row along with the
   // rest of displayed info.
   %index = getField($querybox.getRowTextById(%id),8);
   %pass = getField($querybox.getRowTextById(%id),1);
   if (%pass $= "YES")
   {
      DialogBoxSingle("Password?","Password:","menuMultiMain::joinPW();");
   }
   else
   {
      if (setServerInfo(%index)) {
         %conn = new GameConnection(ServerConnection);
         %conn.setConnectArgs($pref::Player::Name);
         %conn.setJoinPassword("");
         %conn.connect($ServerInfo::Address);
      }
   }
}


function menuMultiMain::joinPW(%this)
{
   %id = $querybox.getSelectedId();
   %index = getField($querybox.getRowTextById(%id),8);
   if (setServerInfo(%index)) {
      %conn = new GameConnection(ServerConnection);
      %conn.setConnectArgs($pref::Player::Name);
      %conn.setJoinPassword($GUI::Input1);
      %conn.connect($ServerInfo::Address);
   }
   IRCUI::minimize();
}
function menuMultiMain::DirectIP(%this)
{
   DialogBoxDouble("Direct IP Connection","IP","Password:","menuMultiMain::DirectIP2();");
}
function menuMultiMain::DirectIP2(%this)
{
   if ($GUI::Input1 !$= "") {
      %conn = new GameConnection(ServerConnection);
      %conn.setConnectArgs($pref::Player::Name);
      %conn.setJoinPassword($GUI::Input2);
      %conn.connect($GUI::Input1);
   }
   IRCUI::minimize();
}


//"ServerInfo::Address"       <-- Not shown, no reason
//"ServerInfo::Name"          <-- Used
//"ServerInfo::GameType"      <-- Internal Game Query String
//"ServerInfo::MissionName"   <-- Used
//"ServerInfo::MissionType"   <-- Used
//"ServerInfo::State"         <-- Heart beak message "Doing Ok"
//"ServerInfo::Info"          <-- Server::Info (useless)
//"ServerInfo::PlayerCount"   <-- Used
//"ServerInfo::MaxPlayers"    <-- Used
//"ServerInfo::BotCount"      <-- We dont have bots
//"ServerInfo::Version"       <-- Internal Version num
//"ServerInfo::Ping"          <-- Used
//"ServerInfo::CPUSpeed"
//"ServerInfo::Favorite"      <--- Unused
//"ServerInfo::Dedicated"     <-- Used
//"ServerInfo::Password"      <-- Used
//----------------------------------------
function menuMultiMain::update(%this)
{
   // Copy the servers into the server list.
   JS_queryStatus.setVisible(false);
   $querybox.clear();
   %sc = getServerCount();
   for (%i = 0; %i < %sc; %i++) {
      setServerInfo(%i);
      $querybox.addRow(%i,
         $ServerInfo::Name TAB
         ($ServerInfo::Password? "YES" : "NO") TAB
         ($ServerInfo::Dedicated? "YES" : "NO" ) TAB
         ($ServerInfo::Reporting? "YES" : "NO") TAB
         $ServerInfo::Ping TAB
         $ServerInfo::PlayerCount @ "/" @ $ServerInfo::MaxPlayers TAB
         $ServerInfo::MissionName TAB
         menuMultiMain::missionType($ServerInfo::MissionType) TAB
         %i);  // ServerInfo index stored also
   }
   $querybox.sort(0);
   $querybox.setSelectedRow(0);
   $querybox.scrollVisible(0);

   mMM_FSF_JoinServerButton.setActive($querybox.rowCount() > 0);
}

//----------------------------------------
function onServerQueryStatus(%status, %msg, %value)
{
   // Update query status
   // States: start, update, ping, query, done
   // value = % (0-1) done for ping and query states
   if (!JS_queryStatus.isVisible())
      JS_queryStatus.setVisible(true);

   switch$ (%status) {
      case "start":
         mMM_FSF_JoinServerButton.setActive(false);
         mMM_FSF_RefreshButton.setActive(false);
         JS_statusText.setText(%msg);
         JS_statusBar.setValue(0);
         $querybox.clear();

      case "ping":
         JS_statusText.setText("Ping Servers");
         JS_statusBar.setValue(%value);

      case "query":
         JS_statusText.setText("Query Servers");
         JS_statusBar.setValue(%value);

      case "done":
         mMM_FSF_RefreshButton.setActive(true);
         JS_queryStatus.setVisible(false);
         menuMultiMain.update();
   }
}

function menuMultiMain::missionType(%num)
{
   %type[0] = "Arena";
   %type[1] = "Team Deathmatch";
   %type[2] = "Capture And Hold";
   %type[3] = "Assault";
   %type[4] = "Search and Destroy";
   %type[5] = "King of the Hill";
   %type[6] = "Capture The Core";
   return %type[%num];
}

//mMM_FSF_GamesList.addRow(%i,"[BITMAP:/fps/client/ui/buttons/lore.png]");
