//------------------------------------------------------------------------------
// MENU Based Script Objects and GUI Code
//------------------------------------------------------------------------------

// GUI GLOBAL VARIABLES
// -----------------------------------------------------------------------------
// $GUI::MusicHandle -- Audio Handle for UI Music.
// $GUI::UnitInfo -- ObjectView Unit Blocks (SimGroup)
// $GUI::LastDropDown -- Last Dropdown Used. (String)
// $GUI::MissionFile -- Mission file for Server (Multi Only)
// $GUI::MissionName -- Mission file's name
// $GUI::MissionType -- Mission's GamePlay Type (Int)
//      Defaults : 0 (Free For All)
// $GUI::MissionTypeName -- Mission Type (String)
//      Defaults : Free For All
// $GUI::Duration -- True/False value for Game Time Duration
// $GUI::DurationTime -- Actual Mission Duration (Int)
//      Defaults : 15 Minutes
// $GUI::EndGameScore -- True/False Value for End Game Score
// $GUI::EndScore -- Actual End Game Score (Int)
//      Defaults : 10 for FFA/Team Deathmatch (Otherwise Mission Set)
// $GUI::Respawn -- True/False Value for Respawn Limitation (Int)
// $GUI::RespawnCount -- Actual Respawns LEFT. (So 0 means no respawn. 1 means 1 respawn)
//      Default : Not Used. Infinite Respawns
// $GUI::Host -- True/False Value dictating weither client is the host or not
// $GUI::ServerName -- Servers Name (String)
//      Default : Dark Horizons Game Server
// $GUI::ServerPass -- Server Password (String)
//      Default : None.
// $GUI::MaxPlayers -- Player Limit (Int)
//      Default : 16.
// $GUI::MainMenu -- Kicks the user back to main menu after a mission. (SP purposes)

// $GUI::RandomLoad -- The random load text :)

// UI Objects
function Gui::LoadObjects()
{
 $Backend::PlayerGroup = new simGroup();
 //ObjectView Objects:
 $GUI::Team[1] = "Federated States";
 $GUI::Team[2] = "Eastern Confederation";
 $GUI::UnitInfo = new SimGroup();
 
   $GUI::UnitInfo.add(new SimObject()
  {
   team = 1;
   name = "Shaddrack";
   class = "Infantry Class";
   OVName = "Thumper";
   OVPath = "fps/data/shapes/player/player.dts";
   LoadCommand = "Shaddrack";
   Description =  "Designation: Shaddrack AR-85x" NL
   "The AR-85x Shaddrack by Armatron Robotics was first introduced to the Federated in 2111 to fill the role of a medium MAV. The Shaddrack is able to deliver a striking blow and still be able to stick around and receive the same.";
  });
  
 $GUI::UnitInfo.add(new SimObject()
  {
   team = 1;
   name = "Hunter Scout";
      class = "Scout Class";
   OVName = "bluescout";
   OVPath = "fps/data/shapes/player/bluescoutmech/bluescout.dts";
   LoadCommand = "HunterScout";
   Description = "Designation: Hunter AR-16b" NL
      "The AR-16b Hunter by Armatron Robotics was first introduced to the Federated in 2110 to fill the role of a light and fast recon MAV. While not heavily armored, the Hunter is capable of making quick hit and runs on slower targets.";
   
  });

  $GUI::UnitInfo.add(new SimObject()
  {
   team = 1;
   name = "Liberator";
   class = "Assault Class";
   OVName = "fsHeavy";
   OVPath = "fps/data/shapes/player/fsHeavy/fsHeavy.dts";
   LoadCommand = "Beast";
   Description = "Designation: Liberator" NL
      "This MAV is fresh off the assembly line, with the tension growing with the EC in Finland, the Federated States commissioned a purely offensive MAV.";
   });
 $GUI::UnitInfo.add( new SimObject()
  {
   team = 1;
   name = "Abolisher";
   class = "Armored Class";
   OVName = "HeavyTank1";
   OVPath = "fps/data/shapes/loretank/loretank.dts";
   LoadCommand = "Abolisher";
   Description = "Designation: Abolisher MT-5t" NL
                  "The Abolisher holds the Brimstone XL7 heavy laser. The Brimstone XL7 laser is a relatively new weapon, so far the Abolisher is the only vehicle capable of carrying such a weapon due to the enormous space the weapon's system takes up.";
  });
  
   $GUI::UnitInfo.add(new SimObject()
  {
   team = 2;
   name = "Mantis";
   class = "Infantry Class";
   OVName = "basher";
   OVPath = "fps/data/shapes/player/greyassault/greyassault.dts";
   LoadCommand = "Mantis";
   Description = "Codename: Mantis\n\nPrimary Cannon: Gattling Cannon\nSecondary Weapon: Long Range Missiles";
  });
  
 $GUI::UnitInfo.add(new SimObject()
  {
   team = 2;
   name = "Locust";
      class = "Scout Class";
   OVName = "Slasher";
   OVPath = "fps/data/shapes/player/mech2/slasher.dts";
   LoadCommand = "Locust";
   Description = "Codename: Locust\n\nPrimary Cannon: 20mm Gattling Cannon\nSecondary Weapon: Long Range Missiles";
  });

  $GUI::UnitInfo.add(new SimObject()
  {
   team = 2;
   name = "Predator";
      class = "Assault Class";
   OVName = "ecHeavy";
   OVPath = "fps/data/shapes/player/ecHeavy/echeavy.dts";
   LoadCommand = "Predator";
   Description = "Codename: Predator\n\nPrimary Weapons: 50mm Slug";
  });
 $GUI::UnitInfo.add(new SimObject()
  {
   team = 2;
   name = "Juggernaut";
      class = "Armored Class";
   OVName = "HeavyTank2";
   OVPath = "fps/data/shapes/loretank2/tank01.dts";
   LoadCommand = "Juggernaut";
   Description = "Codename: Juggernaut\n\nPrimary Cannon: 20mm Gattling Cannon";
  });
  // Single Player Drop Object
  $GUI::DropInfo = new SimGroup();
  $GUI::DropInfo.add(new SimObject()
  {
    team = 1;
    name = "Yourself";
    unit = "";
    object = "";
    Handicap = 0;
  });
  
  menuStrings();
}

function GuiMouseEventCtrl::onMouseEnter(%this)
{
  Canvas.setCursor("MouseOverCursor");
  if (%this.silent == 0)
  {
    alxPlay("AudioButtonOver");
  }
}

function GuiMouseEventCtrl::onMouseLeave()
{
  Canvas.setCursor("DefaultCursor");
}


//-----------------------------
// Dropdown Code
//-----------------------------

function DropDown::SetUp(%min,%max,%increment,%name,%suffix)
{
   (%name @ "_List").clear();
   for (%i = %min; %i <= %max; %i += %increment)
   {
      (%name @ "_List").addRow(%i,%i @ " " @ %suffix);
   }
   (%name @ "_List").setSelectedRow(0);
}

function DropDown::MouseDown(%this,%name)
{
   if ($GUI::LastDropDown !$= "")
   {
      %coords = ($GUI::LastDropDown @ "_Window").getPosition();
      %y1 = nextToken(%coords,x1, " ");
      %coords = ($GUI::LastDropDown @ "_Window").getExtent();
      %x2 = firstWord(%coords);
      ($GUI::LastDropDown @"_Window").resize(%x1,%y1,%x2,20);
      ($GUI::LastDropDown @"_List").setVisible(false);
   }
   if ($GUI::LastDropDown !$= %name)
   {
      %coords = (%name @ "_Window").getPosition();
      %y1 = nextToken(%coords,x1, " ");
      %coords = (%name @ "_Window").getExtent();
      %x2 = firstWord(%coords);
      %y2 = 18 * (%name @ "_List").rowCount() + 20;
      (%name @"_Window").resize(%x1,%y1,%x2,%y2);
      (%name @"_List").setVisible(true);
      $GUI::LastDropDown = %name;
   }
   else
   {
      $GUI::LastDropDown = "";
   }
}

function DropDown::onSelect(%this,%id,%text,%name)
{
      %coords = (%name @ "_Window").getPosition();
      %y1 = nextToken(%coords,x1, " ");
      %coords = (%name @ "_Window").getExtent();
      %x2 = firstWord(%coords);
      %text2 = getField(%text,0);
      (%name).setText(%text2);
      (%name @ "_Window").resize(%x1,%y1,%x2,20);
      (%name @ "_List").setVisible(false);
      $GUI::LastDropDown = "";
}


function DropDown::Display(%base,%dynamic)
{
   if ((%dynamic @ "_Window").visible)
   {
      (%dynamic @ "_Window").setVisible(false);
      (%dynamic @ "_Scroll").clear();
   }
   if ((%dynamic @ "_Window").current !$= %base)
   {
      %coords = (%base @ "_Base").getGlobalPosition();
      %y1 = nextToken(%coords,x1, " ");
      %coords = (%base @ "_Base").getExtent();
      nextToken(%coords,x2, " ");
      %y2 = 18 * (%base @ "_List").rowCount();
      
      if (%y2 > 200) { %y2 = 200; }

      (%dynamic @ "_Scroll").add((%base @ "_List"));
      (%dynamic @ "_Window").resize(%x1,%y1+20,%x2,%y2);
      (%dynamic @ "_Window").setVisible(true);
      (%dynamic @ "_Window").current = %base;
   }
   else
   {
      (%dynamic @ "_Window").current = "";
   }
}

function DropDown::Select(%base,%dynamic,%id,%text)
{
   %text = getField(%text,0);
   (%base).setText(%text);
   (%dynamic @ "_Window").setVisible(false);
   (%dynamic @ "_Scroll").clear();
   (%dynamic @ "_Window").current = "";
}

