// Variables needed by detail options!
$max_screenerror = 25;
$min_TSScreenError = 2;
$max_TSScreenError = 20;
$min_TSDetailAdjust = 0.6;
$max_TSDetailAdjust = 1.0;
//------------------------------------------

function menuOptionsDlg::setPane(%this, %pane)
{
   OptAudioPane.setVisible(false);
   OptGraphicsPane.setVisible(false);
   OptControlsPane.setVisible(false);
   OptDetailPane.setVisible(false);
   OptQuickPane.setVisible(false);
   OptJoystickPane.setVisible(false);
   ("Opt" @ %pane @ "Pane").setVisible(true);
   Opt_Control_MappingList.fillList();
   if (%pane $= "Joystick")
   {
      $enableDirectInput = "1";
      activateDirectInput();
   }
   else
   {
      $enableDirectInput = "0";
      deactivateDirectInput();
   }
}

function menuOptionsDlg::doTextureFlush(%this)
{
	Canvas.repaint();
	flushTextureCache();
}

function menuOptionsDlg::onWake(%this)
{
   %this.setPane("Controls");
   //Set Control Panel Up
   if ($pref::Player::InvertMouse == 1)
      Opt_Control_InvertMouse.setValue(false);
   else
      Opt_Control_InvertMouse.setValue(true);

   Opt_Joy_X_Deadzone.setValue($pref::Joystick::XaxisDeadzone);
   Opt_Joy_Y_Deadzone.setValue($pref::Joystick::YaxisDeadzone);
   Opt_Joy_Z_Deadzone.setValue($pref::Joystick::RZaxisDeadzone);
   Opt_Joy_S_Deadzone.setValue($pref::Joystick::SliderDeadzone);
   //joystick enable
   Opt_Control_disableJoy.setActive(isJoystickDetected());
   if (!isJoystickDetected()) $pref::Input::JoystickEnabled = false;
   
   Opt_Control_disableJoy.setValue($pref::Input::JoystickEnabled);
   $mvJoystickActive = $pref::Input::JoystickEnabled;

   //Sensitivity
   Opt_Control_Sensitivity.setValue($pref::Input::Sensitivity);
   $mvSensitivity = $pref::Input::Sensitivity;

   //Set Graphics Panel Up
   // Vsync
   if ($SwapIntervalSupported)
   {
      OP_Graphics_VSync.setValue( $pref::Video::disableVerticalSync );
      OP_Graphics_VSync.setVisible( true );
   }
   else
   {
      OP_Graphics_VSync.setValue( false );
      OP_Graphics_VSync.setVisible( false );
   }
   Opt_Graphics_CompressionTgl.setVisible($TextureCompressionSupported && !$pref::OpenGL::disableARBTextureCompression);
   if( $pref::OpenGL::allowCompression )
   {
      switch$( $pref::OpenGL::compressionHint )
      {
           case "GL_FASTEST":   %compression = 1;
           case "GL_NICEST":    %compression = 2;
           case "GL_DONT_CARE": %compression = 3;
      }
      Opt_Graphics_CompressionFast.setValue(%compression == 1);
      Opt_Graphics_CompressionNice.setValue(%compression == 2);
      Opt_Graphics_CompressionAuto.setValue(%compression == 3);
    }
   Opt_Graphics_AnisotropyTgl.setVisible($AnisotropySupported);
   Opt_Graphics_GammaSlider.setValue( $pref::OpenGL::gammaCorrection ); // Gamma Correction
   Opt_Graphics::SetupDrivers();
   
   // Audio
   OptAudioUpdate();
   Opt_Audio_Volume_Master.setValue( $pref::Audio::masterVolume);
   Opt_Audio_Volume_Shell.setValue(  $pref::Audio::channelVolume[1]);
   Opt_Audio_Volume_Sim.setValue(    $pref::Audio::channelVolume[2]);
   Opt_Audio_Volume_Voice.setValue(  $pref::Audio::channelVolume[5]);
   
   Opt_Audio_DriverMenu.clear();
   Opt_Audio_DriverMenu.add("OpenAL", 1);
   Opt_Audio_DriverMenu.add("none", 2);
   
   %selId = Opt_Audio_DriverMenu.findText($pref::Audio::driver);
	if ( %selId == -1 ) { %selId = 0; } // How did THAT happen?
	Opt_Audio_DriverMenu.setSelected( %selId );

	// Detail Controls
	Opt_Adv_TerrainDetailSlider.setValue($max_screenerror - $pref::Terrain::screenError );
	Opt_Adv_ShapeDetailsSlider.setValue(($max_TSScreenError - $pref::TS::screenError)/( $max_TSScreenError - $min_TSScreenError));
 	Opt_Adv_ShadowDetailSlider.setValue($pref::Shadows );

	// Sky
   Opt_Adv_SkyDetailMenu.init();
   if ( $pref::numCloudLayers >= 0 && $pref::numCloudLayers < 4 )
      %selId = 4 - $pref::numCloudLayers;
   else
      %selId = 1;
   Opt_Adv_SkyDetailMenu.setSelected( %selId );
   Opt_Adv_SkyDetailMenu.setText(Opt_Adv_SkyDetailMenu.getTextById( %selId ));
   //Opt_Adv_VertexLightingTgll.setValue( $pref::Interior::VertexLighting );
   Opt_Adv_VisibilitySlider.setValue( $pref::VisibleDistanceMod*10 );

   // And also init the texture sliders
   Opt_Adv_ShapeTextureSlider.setValue( 5 - $pref::OpenGL::mipReduction );
   Opt_Adv_TerrainTextureSlider.setValue( 6 - $pref::Terrain::texDetail );
   Opt_Adv_BuildingTextureSlider.setValue( 5 - $pref::OpenGL::interiorMipReduction );

}

function menuOptionsDlg::onSleep(%this)
{
   // write out the control config into the fps/config.cs file
   saveSettings(%this);
   moveMap.save( "~/client/config.cs" );
   export("$pref::*", "fps/client/prefs.cs", False);

   if (Canvas.getContent().getName() $= "gameHudFS" || Canvas.getContent().getName() $= "gameHudEC")
   {
      $enableDirectInput = "1";
      activateDirectInput();
   }
}

function Opt_Graphics_CompressionTgl::onAction( %this )
{
    Opt_Graphics_CompressionAuto.setActive(%this.getValue());
    Opt_Graphics_CompressionFast.setActive(%this.getValue());
    Opt_Graphics_CompressionNice.setActive(%this.getValue());
}

function Opt_Control_disableJoy::onAction( %this )
{
   $enableDirectInput = "0";
   deactivateDirectInput();
   $pref::Input::JoystickEnabled = Opt_Control_disableJoy.getValue();
   if ($pref::Input::JoystickEnabled)
      %default = "joystick";
   else
      %default = "mouse";
   MessageBoxYesNo("Reset Configuration?","Would you like to change to the default" SPC %default SPC "configuration?","restoreDefaultMappings();","");
}
function saveSettings(%this)
{
   // Control Panel
   if (Opt_Control_InvertMouse.getValue())
      $pref::Player::InvertMouse = -1;
   else
      $pref::Player::InvertMouse = 1;
   //save joystick pref
   $pref::Input::JoystickEnabled = Opt_Control_disableJoy.getValue();
   //$pref::Input::enableThrottle = Opt_Control_JoyThrottle.getValue();
   $pref::Input::Sensitivity = Opt_Control_Sensitivity.getValue();
   //leave $mvJoystickActive set to 1 to enable proper joystick response. need to set it as a pref
   //mouse does not behave normally (drifts a bit) with this enabled
   //$mvJoystickActive = 1;

   $mvJoystickActive = $pref::Input::JoystickEnabled;
   $mvSensitivity    = $pref::Input::Sensitivity;
   // Graphics Panel
   if ($SwapIntervalSupported)
   {
      $pref::Video::disableVerticalSync = OP_Graphics_VSync.getValue();
      setVerticalSync(!$pref::Video::disableVerticalSync);
   }
   if ( $pref::OpenGL::allowCompression )
   {
      if( Opt_Graphics_CompressionFast.getValue() )
          %compression = "GL_FASTEST";
      else if( Opt_Graphics_CompressionNice.getValue() )
          %compression = "GL_NICEST";
      else
          %compression = "GL_DONT_CARE";

      if( %compression !$= $pref::OpenGL::compressionHint )
      {
          setOpenGLTextureCompressionHint($pref::OpenGL::compressionHint = %compression);
          %flushTextures = true;
      }
   }

   // Detail Stuff
   $pref::Terrain::screenError = $max_screenerror - mFloor(Opt_Adv_TerrainDetailSlider.getValue());
   $pref::TS::screenError  = $max_TSScreenError - mFloor(Opt_Adv_ShapeDetailsSlider.getValue() * ( $max_TSScreenError - $min_TSScreenError ) );
   $pref::TS::detailAdjust = $min_TSDetailAdjust + Opt_Adv_ShapeDetailsSlider.getValue() * ( $max_TSDetailAdjust - $min_TSDetailAdjust );
   $pref::Shadows = Opt_Adv_ShadowDetailSlider.getValue();
   $pref::VisibleDistanceMod = Opt_Adv_VisibilitySlider.getValue()/10;
   // Sky
   $pref::SkyOn = true;
	$pref::numCloudLayers = ( 4 - Opt_Adv_SkyDetailMenu.getSelected() ); // 4 max clouds, menu options are 0..4
   $pref::Terrain::texDetail = 6 - mFloor(Opt_Adv_TerrainTextureSlider.getValue());
   
   if ( $pref::OpenGL::mipReduction != 5 - mFloor( Opt_Adv_ShapeTextureSlider.getValue()) )
   {
      $pref::OpenGL::mipReduction = 5 - mFloor( Opt_Adv_ShapeTextureSlider.getValue());
      %flushTextures = true;
   }
   if ( $pref::OpenGL::interiorMipReduction != 5 - mFloor( Opt_Adv_BuildingTextureSlider.getValue()) )
   {
      $pref::OpenGL::interiorMipReduction = 5 - mFloor( Opt_Adv_BuildingTextureSlider.getValue());
      %flushTextures = true;
   }

   setOpenGLInteriorMipReduction($pref::OpenGL::interiorMipReduction );
   setOpenGLMipReduction($pref::OpenGL::mipReduction );
   setShadowDetailLevel($pref::Shadows);

   if (%flushTextures)
     menuOptionsDlg.schedule( 0, doTextureFlush );

}


function Opt_Adv_SkyDetailMenu::init(%this)
{
	%this.clear();
	%this.add("Full Sky", 1);
	%this.add("Two Cloud Layers", 2);
	%this.add("One Cloud Layer", 3);
	%this.add("Sky Box Only", 4);
}


//------------------------------------------------------------------------------
// GRAPHICS PANEL CODE
//------------------------------------------------------------------------------

function Opt_Graphics::SetupDrivers()
{
   //supress d3d selection, only allow opengl
   %buffer = getDisplayDeviceList();
   //%buffer = "OpenGL";
   %count  = getFieldCount(%buffer);
   Opt_Graphics_DriverMenu.clear();
   for(%i = 0; %i < %count; %i++)
      Opt_Graphics_DriverMenu.add(getField(%buffer, %i), %i);
   %selId = Opt_Graphics_DriverMenu.findText( $pref::Video::displayDevice );
	if ( %selId == -1 )
		%selId = 0; // How did THAT happen?
	Opt_Graphics_DriverMenu.setSelected( %selId );
}

function Opt_Graphics::SetupRes(%device)
{
	Opt_Graphics_ResolutionMenu.clear();
	%resList = getResolutionList( %device );
	%resCount = getFieldCount( %resList );
	%deskRes = getDesktopResolution();
   %fullscreen = Opt_Graphics_FullscreenTgl.getValue();

   %count = 0;
	for ( %i = 0; %i < %resCount; %i++ )
	{
		%res = getWords( getField( %resList, %i ), 0, 1 );
		if (!%fullScreen)
		{
			if ( firstWord( %res ) >= firstWord( %deskRes ) )
				continue;
         if ( firstWord( %res ) >= 1280 )
            continue;
			if ( getWord( %res, 1 ) >= getWord( %deskRes, 1 ) )
				continue;
		}

		// Only add to list if it isn't there already:
		if ( Opt_Graphics_ResolutionMenu.findText( %res ) == -1 )
      {
			Opt_Graphics_ResolutionMenu.add( %res, %count );
         %count++;
      }
	}
}

function Opt_Graphics::SetupBitDepth(%device)
{
	Opt_Graphics_BitDepthMenu.clear();
   %resList = getResolutionList( %device );
	%resCount = getFieldCount( %resList );
   %count = 0;
   for ( %i = 0; %i < %resCount; %i++ )
	{
		%bpp = getWord( getField( %resList, %i ), 2 );
		// Only add to list if it isn't there already:
		if (Opt_Graphics_BitDepthMenu.findText( %bpp ) == -1 )
      {
   		Opt_Graphics_BitDepthMenu.add( %bpp, %count );
         %count++;
      }
	}
}

function Opt_Graphics_DriverMenu::onSelect( %this, %id, %text )
{
	// Attempt to keep the same res and bpp settings:
	if (Opt_Graphics_ResolutionMenu.size() > 0 )
		%prevRes = Opt_Graphics_ResolutionMenu.getText();
	else
		%prevRes = getWords($pref::Video::resolution, 0, 1 );
	if ( Opt_Graphics_BitDepthMenu.size() > 0 )
		%prevBPP = Opt_Graphics_BitDepthMenu.getText();
	else
		%prevBPP = getWord( $pref::Video::resolution, 2 );

	// Check if this device is full-screen only:
	if (isDeviceFullScreenOnly(%this.getText()))
	{
		Opt_Graphics_FullscreenTgl.setValue(true);
		Opt_Graphics_FullscreenTgl.setActive(false);
	}
	else
		Opt_Graphics_FullscreenTgl.setActive(true);

	// Fill the resolution and bit depth lists:
	Opt_Graphics::SetupRes( %this.getText());
	Opt_Graphics::SetupBitDepth( %this.getText() );

	// Try to select the previous settings:
	%selId = Opt_Graphics_ResolutionMenu.findText( %prevRes );
	if ( %selId == -1 ) { %selId = 0; }
   Opt_Graphics_ResolutionMenu.setSelected( %selId );

	%selId = Opt_Graphics_BitDepthMenu.findText( %prevBPP );
	if ( %selId == -1 ) { %selId = 0; }
  	Opt_Graphics_BitDepthMenu.setSelected( %selId );
	//Opt_Graphics_BitDepthMenu.setText( OptGraphicsBPPMenu.getTextById( %selId ) );
}

function Opt_Graphics_FullscreenTgl::onMouseDown(%this)
{
   %prevRes = OptGraphicsResolutionMenu.getText();
   // Update the resolution menu with the new options
   Opt_Graphics_ResolutionMenu.init( OptGraphicsDriverMenu.getText(), %this.getValue() );
   // Set it back to the previous resolution if the new mode supports it.
   %selId = Opt_Graphics_ResolutionMenu.findText(%prevRes);
   if ( %selId == -1 ) { %selId = 0; }
 	Opt_Graphics_ResolutionMenu.setSelected( %selId );
}

function menuOptionsDlg::applyGraphics( %this )
{
	%newDriver = Opt_Graphics_DriverMenu.getText();
	%newRes = Opt_Graphics_ResolutionMenu.getText();
	%newBpp = Opt_Graphics_BitDepthMenu.getText();
	%newFullScreen = Opt_Graphics_FullscreenTgl.getValue();

	if ( %newDriver !$= $pref::Video::displayDevice )
	{
		setDisplayDevice( %newDriver, firstWord( %newRes ), getWord( %newRes, 1 ), %newBpp, %newFullScreen );
	}
	else
		setScreenMode( firstWord( %newRes ), getWord( %newRes, 1 ), %newBpp, %newFullScreen );
}

//------------------------------------------------------------------------------
// CONTROL PANEL CODE
//------------------------------------------------------------------------------
function loadQuickMessages()
{
   Opt_Quick_Message0.setText($messages::message[0]);
   Opt_Quick_Message1.setText($messages::message[1]);
   Opt_Quick_Message2.setText($messages::message[2]);
   Opt_Quick_Message3.setText($messages::message[3]);
   Opt_Quick_Message4.setText($messages::message[4]);
   Opt_Quick_Message5.setText($messages::message[5]);
   Opt_Quick_Message6.setText($messages::message[6]);
   Opt_Quick_Message7.setText($messages::message[7]);
   Opt_Quick_Message8.setText($messages::message[8]);
   Opt_Quick_TeamCheck0.setValue($messages::teammsg[0]);
   Opt_Quick_TeamCheck1.setValue($messages::teammsg[1]);
   Opt_Quick_TeamCheck2.setValue($messages::teammsg[2]);
   Opt_Quick_TeamCheck3.setValue($messages::teammsg[3]);
   Opt_Quick_TeamCheck4.setValue($messages::teammsg[4]);
   Opt_Quick_TeamCheck5.setValue($messages::teammsg[5]);
   Opt_Quick_TeamCheck6.setValue($messages::teammsg[6]);
   Opt_Quick_TeamCheck7.setValue($messages::teammsg[7]);
   Opt_Quick_TeamCheck8.setValue($messages::teammsg[8]);
   menuOptionsDlg.setPane("Quick");
}

function saveQuickMessages()
{
   $messages::message[0] = Opt_Quick_Message0.getValue();
   $messages::message[1] = Opt_Quick_Message1.getValue();
   $messages::message[2] = Opt_Quick_Message2.getValue();
   $messages::message[3] = Opt_Quick_Message3.getValue();
   $messages::message[4] = Opt_Quick_Message4.getValue();
   $messages::message[5] = Opt_Quick_Message5.getValue();
   $messages::message[6] = Opt_Quick_Message6.getValue();
   $messages::message[7] = Opt_Quick_Message7.getValue();
   $messages::message[8] = Opt_Quick_Message8.getValue();
   $messages::teammsg[0] = Opt_Quick_TeamCheck0.getValue();
   $messages::teammsg[1] = Opt_Quick_TeamCheck1.getValue();
   $messages::teammsg[2] = Opt_Quick_TeamCheck2.getValue();
   $messages::teammsg[3] = Opt_Quick_TeamCheck3.getValue();
   $messages::teammsg[4] = Opt_Quick_TeamCheck4.getValue();
   $messages::teammsg[5] = Opt_Quick_TeamCheck5.getValue();
   $messages::teammsg[6] = Opt_Quick_TeamCheck6.getValue();
   $messages::teammsg[7] = Opt_Quick_TeamCheck7.getValue();
   $messages::teammsg[8] = Opt_Quick_TeamCheck8.getValue();
   menuOptionsDlg.setPane("Controls");
}

function resetQuickMessages()
{
   exec("fps/client/scripts/defaults.messages.cs");
   loadQuickMessages();
}

function cancelQuickMessages()
{
   menuOptionsDlg.setPane("Controls");
}

function restoreDefaultMappings()
{
   moveMap.delete();
   if ($pref::Input::JoystickEnabled)
      exec( "~/client/scripts/defaults.joystick.cs" );
   else
      exec( "~/client/scripts/defaults.mouse.cs" );
   Opt_Control_MappingList.fillList();
}

function getMapDisplayName( %device, %action )
{
	if ( %device $= "keyboard" )
		return( %action );		
	else if ( strstr( %device, "mouse" ) != -1 )
	{
		// Substitute "mouse" for "button" in the action string:
		%pos = strstr( %action, "button" );
		if ( %pos != -1 )
		{
			%mods = getSubStr( %action, 0, %pos );
			%object = getSubStr( %action, %pos, 1000 );
			%instance = getSubStr( %object, strlen( "button" ), 1000 );
			return( %mods @ "mouse" @ ( %instance + 1 ) );
		}
		else
			return ("Mouse");
	}
	else if ( strstr( %device, "joystick" ) != -1 )
	{
		// Substitute "joystick" for "button" in the action string:
		%pos = strstr( %action, "button" );
		if ( %pos != -1 )
		{
			%mods = getSubStr( %action, 0, %pos );
			%object = getSubStr( %action, %pos, 1000 );
			%instance = getSubStr( %object, strlen( "button" ), 1000 );
			return( %mods @ "joystick" @ ( %instance + 1 ) );
		}
		else
	   { 
	      %pos = strstr( %action, "pov" );
         if ( %pos != -1 )
         {
            %wordCount = getWordCount( %action );
            %mods = %wordCount > 1 ? getWords( %action, 0, %wordCount - 2 ) @ " " : "";
            %object = getWord( %action, %wordCount - 1 );
            switch$ ( %object )
            {
               case "upov":   %object = "POV1 up";
               case "dpov":   %object = "POV1 down";
               case "lpov":   %object = "POV1 left";
               case "rpov":   %object = "POV1 right";
               case "upov2":  %object = "POV2 up";
               case "dpov2":  %object = "POV2 down";
               case "lpov2":  %object = "POV2 left";
               case "rpov2":  %object = "POV2 right";
               default:       %object = "??";
            }
            return( %mods @ %object );
         }
         else
            return ("Joystick");
      }
	}
	return( "??" );
}

function buildFullMapString( %index )
{
   %name = $KeybindList.getObject(%index).title;
   %cmd  = $KeybindList.getObject(%index).command;
   %type = $KeybindList.getObject(%index).type;
	%temp = moveMap.getBinding( %cmd );
   %device = getField( %temp, 0 );
   %object = getField( %temp, 1 );
   if ( %device !$= "" && %object !$= "" )
	   %mapString = getMapDisplayName( %device, %object );
   else
      %mapString = "";

	return( %name TAB %mapString TAB %type );
}

function Opt_Control_MappingList::fillList(%this)
{
	%this.clear();
   for ( %i = 0; %i < $KeybindList.getCount(); %i++ )
      if ( $KeybindList.getObject(%i).type $= "axis")
         %this.addRow( %i, buildFullMapString( %i ) );
%this.addRow( 1000, "");
   for ( %i = 0; %i < $KeybindList.getCount(); %i++ )
      if ( $KeybindList.getObject(%i).type $= "movement")
         %this.addRow( %i, buildFullMapString( %i ) );
%this.addRow( 1001, "");
   for ( %i = 0; %i < $KeybindList.getCount(); %i++ )
      if ( $KeybindList.getObject(%i).type $= "mavaction")
         %this.addRow( %i, buildFullMapString( %i ) );
%this.addRow( 1002, "");
   for ( %i = 0; %i < $KeybindList.getCount(); %i++ )
      if ( $KeybindList.getObject(%i).type $= "misc")
         %this.addRow( %i, buildFullMapString( %i ) );
%this.addRow( 1003, "");
   for ( %i = 0; %i < $KeybindList.getCount(); %i++ )
      if ( $KeybindList.getObject(%i).type $= "messages")
         %this.addRow( %i, buildFullMapString( %i ) );
}

//------------------------------------------------------------------------------
function Opt_Control_MappingList::doRemap( %this )
{
	%selId = %this.getSelectedId();
   if (%this.getRowTextById(%selId) $= "")
      return;
   %name = $KeybindList.getObject(%selId).title;
   %type = $KeybindList.getObject(%selId).type;
   $enableDirectInput = "1";
   activateDirectInput();
	OptRemapInputCtrl.index = %selId;
   if (%type $= "axis")
   {
    	OptRemapText.setValue( "Press a button on the device that will control the " @ %name );
      Canvas.pushDialog( RemapDlg );
   }
   else
   {
    	OptRemapText.setValue( "REMAP \"" @ %name @ "\"" );
   	Canvas.pushDialog( RemapDlg );
   }
}

//------------------------------------------------------------------------------
function redoMapping( %device, %action, %cmd, %oldIndex, %newIndex )
{
	//%actionMap.bind( %device, %action, $RemapCmd[%newIndex] );
	moveMap.bind( %device, %action, %cmd );
	Opt_Control_MappingList.setRowById( %oldIndex, buildFullMapString( %oldIndex ) );
	Opt_Control_MappingList.setRowById( %newIndex, buildFullMapString( %newIndex ) );
}

//------------------------------------------------------------------------------
function findRemapCmdIndex( %command )
{
	for ( %i = 0; %i < $KeybindList.getCount(); %i++ )
	{
		if ( %command $= $KeybindList.getObject(%i).command )
			return( %i );			
	}
	return( -1 );	
}

function OptRemapInputCtrl::onInputEvent( %this, %device, %action )
{
	//error( "** onInputEvent called - device = " @ %device @ ", action = " @ %action @ " **" );
	Canvas.popDialog( RemapDlg );
	// Test for the reserved keystrokes:
	if ( %device $= "keyboard" )
	{
      // Cancel...
      if ( %action $= "escape" )
      {
         // Do nothing...
		   return;
      }
      if ( %action $= "f1")
      {
         %cmd  = $KeybindList.getObject(%this.index).command;
         %bind = moveMap.getBinding(%cmd);
         moveMap.unBind(firstWord(%bind),getWord(%bind,1));
         return;
      }
	}
	
   %cmd  = $KeybindList.getObject(%this.index).command;
   %name = $KeybindList.getObject(%this.index).title;
   %type = $KeybindList.getObject(%this.index).type;

	%prevMap = moveMap.getCommand( %device, %action );
   if ( %prevMap !$= %cmd )
   {
      if (%type $= "axis")
      {
         %prevMap = moveMap.getCommand( %device, %action );
	      %prevMapIndex = findRemapCmdIndex( %prevMap );
         %action = $KeybindList.getObject(%this.index).axis;
   		MessageBoxYesNo( "AXIS MAPPING","Are you sure you want to bind the axis to " @%device @ "?",
				   "redoMapping(" @ %device @ ", \"" @ %action @ "\", \"" @ %cmd @ "\", " @ %prevMapIndex @ ", " @ %this.index @ ");", "" );
      }
      else
      {
   	// First check to see if the given action is already mapped:

   	   if ( %prevMap $= "" )
	      {
            moveMap.bind( %device, %action, %cmd );
		      Opt_Control_MappingList.setRowById( %this.index, buildFullMapString( %this.index ) );
   	   }
	      else
   	   {
            %mapName = getMapDisplayName( %device, %action );
		      %prevMapIndex = findRemapCmdIndex( %prevMap );
   		   if ( %prevMapIndex == -1 )
			      MessageBoxOK( "REMAP FAILED", "\"" @ %mapName @ "\" is already bound to a non-remappable command!" );
   		   else
            {
               %prevCmdName = $KeybindList.getObject(%prevMapIndex).command;
			      MessageBoxYesNo( "WARNING",
				   "\"" @ %mapName @ "\" is already bound to \"" 
					   @ %prevCmdName @ "\"!\nDo you want to undo this mapping?", 
				   "redoMapping(" @ %device @ ", \"" @ %action @ "\", \"" @ %cmd @ "\", " @ %prevMapIndex @ ", " @ %this.index @ ");", "" );
            }
		      return;
   	   }
      }
   }
   $enableDirectInput = "0";
   deactivateDirectInput();
}

//------------------------------------------------------------------------------
// AUDIO PANEL
//------------------------------------------------------------------------------
function OptAudioUpdate()
{
   // set the driver text
   %text =   "Vendor: " @ alGetString("AL_VENDOR") @
           "\nVersion: " @ alGetString("AL_VERSION") @
           "\nRenderer: " @ alGetString("AL_RENDERER") @
           "\nExtensions: " @ alGetString("AL_EXTENSIONS");
   Opt_Audio_DriverText.setText(%text);

}


// Channel 0 is unused in-game, but is used here to test master volume.

new AudioDescription(AudioChannel0)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = 0;
};

new AudioDescription(AudioChannel1)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = 1;
};

new AudioDescription(AudioChannel2)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = 2;
};

new AudioDescription(AudioChannel3)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = 3;
};

new AudioDescription(AudioChannel4)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = 4;
};

new AudioDescription(AudioChannel5)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = 5;
};

new AudioDescription(AudioChannel6)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = 6;
};

new AudioDescription(AudioChannel7)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = 7;
};

new AudioDescription(AudioChannel8)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = 8;
};

$AudioTestHandle = 0;

function OptAudioUpdateMasterVolume(%volume)
{
   if (%volume == $pref::Audio::masterVolume)
      return;

   alxListenerf(AL_GAIN_LINEAR, %volume);
   $pref::Audio::masterVolume = %volume;
   if (!alxIsPlaying($AudioTestHandle))
   {
      $AudioTestHandle = alxCreateSource("AudioChannel0", expandFilename("~/data/sound/test.ogg"));
      alxPlay($AudioTestHandle);
   }
}

function OptAudioUpdateChannelVolume(%channel, %volume)
{
   if (%channel < 1 || %channel > 8)
      return;
   if (%volume == $pref::Audio::channelVolume[%channel])
      return;

   alxSetChannelVolume(%channel, %volume);
   $pref::Audio::channelVolume[%channel] = %volume;

   if (!alxIsPlaying($AudioTestHandle))
   {
      $AudioTestHandle = alxCreateSource("AudioChannel"@%channel, expandFilename("~/data/sound/test.ogg"));
      alxPlay($AudioTestHandle);
   }
}


function OptAudioDriverList::onSelect( %this, %id, %text )
{
   if (%text $= "")
      return;
   if ($pref::Audio::driver $= %text)
      return;
   $pref::Audio::driver = %text;
   OpenALInit();
}

//------------------------------------------
// Graphic Stuff

function updateGammaCorrection()
{
   $pref::OpenGL::gammaCorrection = Opt_Graphics_GammaSlider.getValue();
   videoSetGammaCorrection( $pref::OpenGL::gammaCorrection ); 
}

function roundOffSlider(%this)
{
   %temp = %this.getValue();
   %temp = mFloor(%temp + 0.5);
   %this.setValue(%temp);
}

// Player Render Options
function OP_PlayerRenderMenu::init( %this )
{
   %this.clear();
   %this.add( "Player and Items", 3 );
   %this.add( "Player only", 1 );
   %this.add( "Items only", 2 );
   %this.add( "Neither Player nor Items", 0 );
}

//------------------------------------------
function JoystickValueXaxis()
{
   //Apply Offset
   %value = $JoystickVals::Xaxis;
   %value += $pref::Joystick::XaxisOffset;
   if (%value <= $pref::Joystick::XaxisDeadzone && %value >= -$pref::Joystick::XaxisDeadzone)
      %value = 0;
   else if (%value >= $pref::Joystick::XaxisDeadzone)
      %value -= $pref::Joystick::XaxisDeadzone;
   else
      %value += $pref::Joystick::XaxisDeadzone;
      
   %value = %value / (1 - $pref::Joystick::XaxisDeadzone);
   
   return %value;
}

function JoystickValueYaxis()
{
   //Apply Offset
   %value = $JoystickVals::Yaxis;
   %value += $pref::Joystick::YaxisOffset;
   if (%value <= $pref::Joystick::YaxisDeadzone && %value >= -$pref::Joystick::YaxisDeadzone)
      %value = 0;
   else if (%value >= $pref::Joystick::YaxisDeadzone)
      %value -= $pref::Joystick::YaxisDeadzone;
   else
      %value += $pref::Joystick::YaxisDeadzone;
   %value /= (1 - $pref::Joystick::YaxisDeadzone);
   return %value;
}
function JoystickValueRZaxis()
{
   //Apply Offset
   %value = $JoystickVals::RZaxis;
   %value += $pref::Joystick::RZaxisOffset;
   if (%value <= $pref::Joystick::RZaxisDeadzone && %value >= -$pref::Joystick::RZaxisDeadzone)
      %value = 0;
   else if (%value >= $pref::Joystick::RZaxisDeadzone)
      %value -= $pref::Joystick::RZaxisDeadzone;
   else
      %value += $pref::Joystick::RZaxisDeadzone;
   %value /= (1 - $pref::Joystick::RZaxisDeadzone);
   return %value;
}
function JoystickValueSlider()
{
   %value = $JoystickVals::Slider;
   %value += $pref::Joystick::SliderOffset;
   if (%value <= $pref::Joystick::SliderDeadzone && %value >= -$pref::Joystick::SliderDeadzone)
      %value = 0;
   else if (%value >= $pref::Joystick::SliderDeadzone)
      %value -= $pref::Joystick::SliderDeadzone;
   else
      %value += $pref::Joystick::SliderDeadzone;
   %value /= (1 - $pref::Joystick::SliderDeadzone);
   return -%value;

}
function JoystickSetOffset()
{
  $pref::Joystick::SliderOffset = -$JoystickVals::Slider;
  $pref::Joystick::XaxisOffset  = -$JoystickVals::Xaxis;
  $pref::Joystick::YaxisOffset  = -$JoystickVals::Yaxis;
  $pref::Joystick::RZAxisOffset = -$JoystickVals::RZAxis;
}

function JoystickSetDeadzone(%axis)
{
  switch$(%axis)
  {
      case "X": $pref::Joystick::XaxisDeadzone  = Opt_Joy_X_Deadzone.getValue();
      case "Y": $pref::Joystick::YaxisDeadzone  = Opt_Joy_Y_Deadzone.getValue();
      case "Z": $pref::Joystick::RZaxisDeadzone = Opt_Joy_Z_Deadzone.getValue();
      case "S": $pref::Joystick::SliderDeadzone = Opt_Joy_S_Deadzone.getValue();
  }
}
