// Staging Area Version 2
// - Mission Info Panel
// - Mission Settings Panel (Host only)
// - Team Panel
// - Config Mav Panel
// - Player List Section
// - IRC Section
// - Other Stuff :)

//----------------------------------------------------------------------------//
// Other Stuff First                                                          //
//----------------------------------------------------------------------------//

// Launch Game
// Host has to do SetGame which loads mission server side
function mSA::Launch()
{
   if ($GUI::NoSpawns)
      return;
   if ($GUI::Host)
   {
      echo("Set Game" SPC $GUI::MissionFile);
      commandToServer('SetGame',$GUI::MissionFile);
      $GUI::Launched = true;
   }
   mSA_Config::SaveSettings();
   commandToServer('SetReady',true);
   commandToServer('LaunchGame');
}

//
function mSA::SetLaunch(%value)
{
   $GUI::LReady = %value;
   if ($GUI::Ready && $GUI::LReady)
      mSA_Launch.setActive(true);
   else
      return;

   if ($GUI::Host && $GUI::Ready)
      mSA_Status.setText("Status: You can now launch.");
   else
      mSA_Status.setText("Status: Host has now launched.");
}

// Change Panel
function mSA::Panel(%panel)
{
  mSA_PanelConfig.setVisible(false);
  mSA_PanelInfo.setVisible(false);
  mSA_PanelTeam.setVisible(false);
  mSA_PanelSettings.setVisible(false);
  ("mSA_Panel" @ %panel).setVisible(true);
  
  if (%panel $= "Settings" && $GUI::Launched)
  {
     MessageBoxOKCancel("End Game","You cannot modify this mission without first ending the one that is currently running. Press OK to end the mission now or press CANCEL to exit this message", "mSA::EndIt();","mSA::Panel(info);");
  }
  if (%panel $= "Team" && !mSA_Info_Practice.getValue() && $GUI::Faction > 0 && $GUI::Faction < 3)
  {
     MessageBoxOK("Change Teams","You cannot change factions unless Practice Mode is enabled.", "mSA::Panel(Config);");
  }
}

function mSA_Player_CheckSizes()
{
 mSA_Player::checkSizes();
}

function menuStagingArea2::onWake()
{
   //Just incase... stupid SP
   $GUI::SP = false;
   echo("OnWake");
   echo($GUI::Team);
   echo($GUI::Mav);
   //Setup IRC window
   mSA_Chat_Output.attach(hudmessagevector);
   
   //Setup Team Stuff
   mSA::Team();

   mSA_Player::checkSizes(%this);
   schedule(0,0,"mSA_Player::CheckSizes");
   //Setup Settings - Dont waste time filling them out if its been filled out before
   if (mSA_Settings_MType_List.rowCount() == 0)
   {
      mSA_Settings::MTypeSetup();
      DropDown::Setup(0,25,5,"mSA_Settings_Respawn","Spawns");
      DropDown::Setup(10,50,10,"mSA_Settings_Kill","Points");
   }
   //Do ye old panel setups. Disable that which should be disabled, etc.

   if ($GUI::Host) {
      mSA_PanelSettings.setActive(true);
      mSA_Panel_Settings.setActive(true);
      mSA::SetSettings();
   } else {
      mSA_PanelSettings.setActive(false);
      mSA_Panel_Settings.setActive(false);
   }
   if (!$GUI::Team) {
      mSA_Panel_ConfigMav.setActive(false);
      mSA::Panel("Team");
      if ($GUI::Host)
      {
         mSA::setLaunch(false);
      }
      mSA_Status.setText("Status: Select a team");
   }
   else
   {
      if ($GUI::Host && !$GUI::NoSpawn)
      {
         mSA::setLaunch(true);
      }
      mSA::Panel("Config");
      mSA_Status.setText("Status: Game has not launched");
   }
   if ($GUI::Team) { mSA_Team::Join($GUI::Team); }
   if ($GUI::Mav) { mSA_Config::setMAV(); }
   mSA_Chat_Input.setValue("");
}

function mSA::SetSettings()
{
   // Send Info To Clients
   mSA_Settings::getInfo();
   commandToServer('RelayHostData');
}

function mSA::VerifyMav()
{
   mSA_Config::SaveSettings();
}

function mSA::EndEarly()
{
   MessageBoxOKCancel("End Game","This will abort the current mission, are you sure you want to end it early?", "mSA::EndIt();");
}

function mSA::EndIt()
{
   commandToServer('AbortMission');
}

function menuStagingArea2::onSleep()
{
   //Close IRC window
   mSA_Chat_Output.detach();
}

function mSA::FullReset()
{
   echo("FullReset");
   if ($GUI::Host) {
      mSA_Settings_ReportStats.setValue(true);
      $GUI::Launched = false;
   }
   mSA_Player::clearLists();
   //Setup Player Lists
   mSA_Player_FS_Team_List.addRow(1,"FS Troops");
   mSA_Player_EC_Team_List.addRow(1,"EC Troops");
   mSA_Player_OB_Team_List.addRow(1,"Neutral");
   mSA_Player::checkSizes();
   //Set Launch in active
   mSA::SetLaunch(false);
   $GUI::Team = "";
   $GUI::Mav = "";
   $GUI::NoSpawn = false;
   commandToServer('SetReady',false);
   mSA_Status.setText("Status: Game has not launched");
   if ($GUI::Faction == 1 || $GUI::Faction == 2)
      mSA_Team::Join($GUI::Faction);

}

function mSA::PartialReset()
{
   echo("PartialReset");
   mSA_Player::clearFields();
   mSA_Player::checkSizes();
   //Set Launch in active
   mSA::SetLaunch(false);
   $GUI::Launched = false;
   $GUI::Team = "";
   $GUI::Mav = "";
   $GUI::NoSpawn = false;
   commandToServer('SetReady',false);
   if ($GUI::Faction == 1 || $GUI::Faction == 2)
      mSA_Team::Join($GUI::Faction);
}

function mSA::Team()
{
   mSA_Team_ECDecal.setObject("Logo", "fps/data/shapes/logos/eastern.dts","",0);
   mSA_Team_ECDecal.ForceFOV = 62;
   mSA_Team_ECDecal.setRotate(0.25);
   mSA_Team_FSDecal.setObject("Logo", "fps/data/shapes/logos/fedstates.dts","",0);
   mSA_Team_FSDecal.ForceFOV = 62;
   mSA_Team_FSDecal.setRotate(0.25);
}

function mSA_Chat_Input::eval(%this)
{
   %text = trim(mSA_Chat_Input.getValue());
   if(%text $= "")
      return;

   if (!$INGAMEIRC)
      commandToServer('messageSent', %text);
   else
      IRCClient::ingameSend("GLOBAL",%text);

   mSA_Chat_Input.setValue("");
}


//----------------------------------------------------------------------------//
// Team Info                                                                  //
//----------------------------------------------------------------------------//
// Keeping it simple for now. feature set will grow later -Ace

function mSA_Team::Join(%teamID)
{
   commandToServer('PlayerUpdate',1,%teamID);
   $GUI::Team = %teamID;
   $INGAME.Team = %teamID;
   $GUI::Mav = "";
   mSA_Panel_ConfigMav.setActive(true);
   mSA_Config::setMAV();
   $GUI::Ready = true;
   mSA_Status.setText("Status: Game has not launched.");
   if ($GUI::Host || $GUI::LReady && !$GUI::NoSpawn)
   {
      mSA::setLaunch(true);
      mSA_Status.setText("Status: You can now launch.");
   }
}

//----------------------------------------------------------------------------//
// Mission Info                                                               //
//----------------------------------------------------------------------------//
// Pretty simple. Fill in the Info settings.
function mSA::HostUpdate(%name,%type,%time,%score,%spawns,%practice,%report,%attack,%defend)
{
   mSA_Info_Location.setText("Location : " @ %name);
   mSA_Info_Mission.setText("Mission  : " @ %type);
   mSA_Info_Practice.setValue(%practice);
   mSA_Info_Reportstats.setValue(%report);
   if (%time == -1) {
      mSA_Info_Time.setText("Time     : No Limit");
   } else {
      mSA_Info_Time.setText("Time     : " @ %time);
   }
   if (%score == -1) {
      mSA_Info_Score.setText("Score    : No Limit");
   } else {
      mSA_Info_Score.setText("Score    : " @ %score);
   }
   if (%spawns == -1) {
      mSA_Info_Respawns.setText("Respawns : No Limit");
   } else {
      mSA_Info_Respawns.setText("Respawns : " @ %spawns);
   }
   if (!%practice)
      if ($GUI::Faction != $GUI::Team && $GUI::Faction != 0)
         mSA_Team::Join($GUI::Faction);
}


//----------------------------------------------------------------------------//
// Player Panel                                                               //
//----------------------------------------------------------------------------//
// Clears out the hidden information (between missions)
function mSA_Player::clearFields(%this)
{
   // This actually takes all FS and EC players and puts them into the Observer
   // sections as teams are reset between missions
   for (%i = 0; %i < mSA_Player_FS_List.rowCount(); %i++)
   {
      %id = mSA_Player_FS_List.getRowId(%i);
      %text = mSA_Player_FS_List.getRowText(%i);
      mSA_Player_FS_List.removeRowById(%id);
      mSA_Player_OB_List.addRow(%id,getField(%text,0) TAB "None" TAB "None");
   }
   for (%i = 0; %i < mSA_Player_EC_List.rowCount(); %i++)
   {
      %id = mSA_Player_EC_List.getRowId(%i);
      %text = mSA_Player_EC_List.getRowText(%i);
      mSA_Player_EC_List.removeRowById(%id);
      mSA_Player_OB_List.addRow(%id,getField(%text,0) TAB "None" TAB "None");
   }
}
function mSA_Player::clearLists(%this)
{
   // This actually takes all FS and EC players and puts them into the Observer
   // sections as teams are reset between missions
   mSA_Player_FS_List.clear();
   mSA_Player_EC_List.clear();
   mSA_Player_OB_List.clear();
   mSA_Player_FS_Team_List.clear();
   mSA_Player_EC_Team_List.clear();
   mSA_Player_OB_Team_List.clear();
}
function mSA_Player::checkSizes(%this)
{
   // Set initial values for resizing
   %fontsize = 18; //4 higher then actual value for spacing
   %y1 = 10;
   %team[0] = "FS";
   %team[1] = "EC";
   %team[2] = "OB";
   for (%i = 0; %i < 3; %i++)
   {
      // Check to see if Team exists first then resize
      %rows = ("mSA_Player_" @ %team[%i] @ "_List").rowCount();
      if (%rows > 0) {
         ("mSA_Player_" @ %team[%i] @ "_Team_Scroll").setVisible(true);
         ("mSA_Player_" @ %team[%i] @ "_Team_Scroll").resize(10,%y1,100,%fontsize);
         %y1 += %fontsize;
         ("mSA_Player_" @ %team[%i] @ "_Scroll").setVisible(true);
         ("mSA_Player_" @ %team[%i] @ "_Scroll").resize(10,%y1,100,%fontsize * %rows);
         %y1 += %fontsize * %rows;
      }
      else
      {
         ("mSA_Player_" @ %team[%i] @ "_Team_Scroll").setVisible(false);
         ("mSA_Player_" @ %team[%i] @ "_Scroll").setVisible(false);
      }
   }
}

function mSA_Player::PlayerUpdate(%clientID, %clientName, %MAV, %TeamID)
{
   %team[1] = "FS";
   %team[2] = "EC";
   %team[3] = "OB";
   %TeamName = (%teamID != 0) ? $GUI::Team[%teamID] : "None";
   %MAVName  = "None";
   if (!%TeamID || %TeamID == 0)
   {
      %TeamID = 3;
   }
   for (%i = 0; %i < $GUI::UnitInfo.getCount(); %i++)
   {
      %temp = $GUI::UnitInfo.getObject(%i);
      if (%temp.LoadCommand $= %MAV)
      {
         %MAVName = %temp.Name;
      }
   }
   mSA_Player::RemovePlayer(%clientID);
   ("mSA_Player_" @ %team[%TeamID] @ "_List").addRow(%clientID, %clientName TAB %TeamName TAB %MAVName);
   mSA_Player::checkSizes();
}

function mSA_Player::RemovePlayer(%clientID)
{
   if (mSA_Player_FS_List.getRowNumById(%clientID) != -1)
      mSA_Player_FS_List.removeRowById(%clientID);
   if (mSA_Player_EC_List.getRowNumById(%clientID) != -1)
      mSA_Player_EC_List.removeRowById(%clientID);
   if (mSA_Player_OB_List.getRowNumById(%clientID) != -1)
      mSA_Player_OB_List.removeRowById(%clientID);
}

//----------------------------------------------------------------------------//
// Custom Mav Panel                                                           //
//----------------------------------------------------------------------------//

// Display Mav Code
// SetMav, NextMav, PreviousMav
function mSA_Config::displayMAV()
{
   %Path = $GUI::MAV.OVPath;
   %Name = $GUI::MAV.OVName;
   %Command = $GUI::MAV.LoadCommand;
   mSA_Config_View.setObject(%Name,%Path,"",0);
   mSA_Config_View.ForceFOV = 75;
   mSA_Config_View.setRotate(0.25);
   commandToServer('PlayerUpdate',0,%command);
   commandToServer('GetWeapons',$GUI::MAV.LoadCommand);
   mSA_Label_MavName.setText("Designation:" SPC $GUI::MAV.Name @ ", " SPC $GUI::MAV.Class);
}

function mSA_Config::setMAV()
{
   if (!$GUI::MAV)
   {
      for (%i = 0; %i < $GUI::UnitInfo.getCount(); %i++)
      {
         %temp = $GUI::UnitInfo.getObject(%i);
         if (%temp.team $= $GUI::Team)
         {
            $GUI::MAV = %temp;
            break;
         }
      }
   }
   mSA_Config::displayMAV();
}

function mSA_Config::nextMAV()
{
   for (%i = 0; %i < $GUI::UnitInfo.getCount(); %i++)
   {
      %temp = $GUI::UnitInfo.getObject(%i);
      if (%temp == $GUI::Mav)
      {
         %next = true;
      }
      else if (%temp.team $= $GUI::Team && %next)
      {
         $GUI::MAV = %temp;
         %selected = true;
         break;
      }
   }
   if (!%selected)
   {
   for (%i = 0; %i < $GUI::UnitInfo.getCount(); %i++)
   {
      %temp = $GUI::UnitInfo.getObject(%i);
      if (%temp.team $= $GUI::Team && %next)
      {
         $GUI::MAV = %temp;
         %selected = true;
         break;
      }
   }
   }
   mSA_Config::displayMAV();
}

function mSA_Config::prevMAV()
{
   for (%i = $GUI::UnitInfo.getCount() - 1; %i >= 0; %i--)
   {
      %temp = $GUI::UnitInfo.getObject(%i);
      if (%temp == $GUI::Mav)
         %next = true;
      else if (%temp.team $= $GUI::Team && %next)
      {
         $GUI::MAV = %temp;
         %selected = true;
         break;
      }
   }
   if (!%selected)
   {
     for (%i = $GUI::UnitInfo.getCount() - 1; %i >= 0; %i--)
     {
        %temp = $GUI::UnitInfo.getObject(%i);
        if (%temp.team $= $GUI::Team)
        {
           $GUI::MAV = %temp;
           %selected = true;
           break;
        }
     }
   }
   mSA_Config::displayMAV();
}

function mSA_Config_Primary_Mouse::onMouseDown()
{
   DropDown::Display("mSA_Config_Primary","mSA_Dropdown");
}

function mSA_Config_Second_Mouse::onMouseDown()
{
   DropDown::Display("mSA_Config_Second","mSA_Dropdown");
}

// Called by dropdown code
function mSA_Config_Primary_List::onSelect(%this,%id,%text)
{
   DropDown::Select("mSA_Config_Primary","mSA_Dropdown",%id,%text);
   if (getField(%text, 1) $= "")
   {
     mSA_Label_PrimaryAmmo.setText("Ammo: Energy");
   } else {
     mSA_Label_PrimaryAmmo.setText("Ammo:" SPC getField(%text, 1));
   }
   mSA_Label_PrimaryRefire.setText("Refire Rate:" @ getField(%text, 2));
   mSA_Label_PrimaryDamage.setText("Damage:" @ getField(%text, 3));
   mSA_Label_PrimaryRange.setText("Range:" @ getField(%text,4));}

// Called by dropdown code
function mSA_Config_Second_List::onSelect(%this,%id,%text)
{
   DropDown::Select("mSA_Config_Second","mSA_Dropdown",%id,%text);
   mSA_Label_SecondaryAmmo.setText("Ammo:" SPC getField(%text, 1));
   mSA_Label_SecondaryRefire.setText("Refire Rate:" @ getField(%text, 2));
   mSA_Label_SecondaryDamage.setText("Damage:" @ getField(%text, 3));
   mSA_Label_SecondaryRange.setText("Range:" @ getField(%text,4));
}

// Save Settings
function mSA_Config::SaveSettings()
{
  %PNum = mSA_Config_Primary_List.getSelectedId();
  %SNum = mSA_Config_Second_List.getSelectedId();
  %BaseNum = mSA_Config_Slider.getValue();
  commandToServer('SetCustomization',%BaseNum,%PNum,%SNum);
}

// Message Handler Functions
function mSA_Config::clearDropdowns()
{
   mSA_Config_Primary_List.clear();
   mSA_Config_Second_List.clear();
}

function mSA_Config::setDropdowns(%primary,%secondary)
{
   mSA_Config_Primary_List.setSelectedRow(%primary-1);
   mSA_Config_Second_List.setSelectedRow(%secondary-1);
}

function mSA_Config::addDropdown(%num,%type,%name,%ammo,%refire,%damage,%range)
{
  if (%range $= "")
      %range = "N/A";
  if (%ammo $= "")
      %ammo = "Energy";
  ("mSA_Config_" @ %type @ "_List").addRow(%num, %name TAB %ammo TAB %refire TAB %damage TAB %range);
}

//----------------------------------------------------------------------------//
//-Mission Settings Panel                                                     //
//----------------------------------------------------------------------------//

function mSA_Settings::getInfo()
{
   echo("Set Information");
   %id = mSA_Settings_Map_List.getSelectedId();
   $GUI::MissionFile = getField(mSA_Settings_Map_List.getRowTextById(%id), 1);
   $GUI::MissionName = getField(mSA_Settings_Map_List.getRowTextById(%id), 0);
   $GUI::MissionTypeName =  mSA_Settings_MType.getValue();
   $GUI::Duration =  mSA_Settings_TimeCheck.getValue();
   $GUI::EndGameScore =  mSA_Settings_ScoreCheck.getValue();
   $GUI::Respawn =  mSA_Settings_RespawnCheck.getValue();
   $GUI::Practice =  mSA_Settings_PracticeMode.getValue();
   $GUI::Reporting =  mSA_Settings_ReportStats.getValue();
   if ($GUI::Duration)
      $GUI::DurationTime = FirstWord( mSA_Settings_Time.getValue());
   else
      $GUI::DurationTime = -1;

   if ($GUI::Respawn)
      $GUI::RespawnCount = FirstWord( mSA_Settings_Respawn.getValue());
   else
      $GUI::RespawnCount = -1;

   if ($GUI::MissionType > 1)
   {
     $GUI::EndGameScore = true;
     $GUI::EndScore = getWord( mSA_Settings_Kill_Text.getValue(),3);
   }
   else
   {
     if ($GUI::EndGameScore)
        $GUI::EndScore = FirstWord( mSA_Settings_Kill.getValue());
     else
        $GUI::EndScore = -1;
   }
   if (!$GUI::Duration && !$GUI::EndGameScore)
   {
      $GUI::Duration = true;
      $GUI::DurationTime = 15;
      mSA_Settings_TimeCheck.setValue(true);
      mSA_Settings_Time.setValue("15 Minutes");
      
   }
}
function  mSA_Settings_PracticeMode::onAction()
{
   mSA_Settings_ReportStats.setValue(false);
}
function  mSA_Settings_ReportStats::onAction()
{
   mSA_Settings_PracticeMode.setValue(false);
}

function mSA_Settings::MTypeSetup()
{
   //mSA_Settings_MType_List.addRow(0,"Arena");
   mSA_Settings_MType_List.addRow(1,"Team Deathmatch");
   //mSA_Settings_MType_List.addRow(2,"Capture And Hold");
   mSA_Settings_MType_List.addRow(3,"Assault");
   mSA_Settings_MType_List.addRow(4,"Search and Destroy");
   //  SA_MType_List.addRow(5,"King of the Hill");
   mSA_Settings_MType_List.addRow(6,"Capture The Core");
   mSA_Settings_MType_List.setSelectedRow(1);
}
function mSA_Settings_Map_List::onSelect(%this,%id,%text)
{
   %file = getField(mSA_Settings_Map_List.getRowTextById(%id), 1);
   %MissionInfoObject = mSA_Settings::readMissionFile(%file);
   %timemin = %MissionInfoObject.timemin;
   %timemax = %MissionInfoObject.timemax;
   if (%timemin $= "")
      %timemin = 10;
   if (%timemax $= "")
      %timemax = 25;

   DropDown::Setup(%timemin,%timemax,5,"mSA_Settings_Time","Minutes");
   mSA_Settings_Kill_Text.setText("Mission End Score: " @ %MissionInfoObject.totalscore);
}

function createCRCList()
{
   for(%file = findFirstFile($Server::MissionFileSpec);
       %file !$= ""; %file = findNextFile($Server::MissionFileSpec))
   {
      if (strStr(%file, "CVS/") == -1 && strStr(%file, "common/") == -1)
      {
         warn(%file SPC getFileCRC(%file));
      }
   }
}

function mSA_Settings::createMissionList (%MissionType,%ListObject)
{
   %ListObject.clear();
   %i = 0;
   for(%file = findFirstFile($Server::MissionFileSpec);
       %file !$= ""; %file = findNextFile($Server::MissionFileSpec))
   {
      if (strStr(%file, "CVS/") == -1 && strStr(%file, "common/") == -1)
      {
         %MissionInfoObject = mSA_Settings::readMissionFile(%file);
         if (%MissionInfoObject.missiontype == %MissionType )
         {
           %ListObject.addRow(%i++, %MissionInfoObject.name @ "\t" @ %file );
         }
      }
   }
   %ListObject.sort(0);
   %ListObject.setSelectedRow(0);
}
function mSA_Settings::readMissionFile (%missionFile)
{
   %file = new FileObject();

   %MissionInfoObject = "";

   if ( %file.openForRead( %missionFile ) ) {
		%inInfoBlock = false;

		while ( !%file.isEOF() ) {
			%line = %file.readLine();
			%line = trim( %line );

			if( %line $= "new ScriptObject(MissionInfo) {" )
				%inInfoBlock = true;
			else if( %inInfoBlock && %line $= "};" ) {
				%inInfoBlock = false;
				%MissionInfoObject = %MissionInfoObject @ %line;
				break;
			}

			if( %inInfoBlock )
			   %MissionInfoObject = %MissionInfoObject @ %line @ " ";
		}

		%file.close();
	}
	%MissionInfoObject = "%MissionInfoObject = " @ %MissionInfoObject;
	eval( %MissionInfoObject );

   %file.delete();
   return %MissionInfoObject;
}
// Dropdown Code
function mSA_Settings_Time_Mouse::onMouseDown(%this, %obj)
{
   DropDown::Display("mSA_Settings_Time","mSA_Dropdown");
}
function mSA_Settings_Time_List::onSelect(%this,%id,%text)
{
   DropDown::Select("mSA_Settings_Time","mSA_Dropdown",%id,%text);
}
function mSA_Settings_Kill_Mouse::onMouseDown(%this, %obj)
{
   DropDown::Display("mSA_Settings_Kill","mSA_Dropdown");
}
function mSA_Settings_Kill_List::onSelect(%this,%id,%text)
{
   DropDown::Select("mSA_Settings_Kill","mSA_Dropdown",%id,%text);
}
function mSA_Settings_Respawn_Mouse::onMouseDown(%this, %obj)
{
   DropDown::Display("mSA_Settings_Respawn","mSA_Dropdown");
}
function mSA_Settings_Respawn_List::onSelect(%this,%id,%text)
{
   DropDown::Select("mSA_Settings_Respawn","mSA_Dropdown",%id,%text);
}
function mSA_Settings_MType_Mouse::onMouseDown(%this,%obj)
{
   DropDown::Display("mSA_Settings_MType","mSA_Dropdown");
}
function mSA_Settings_MType_List::onSelect(%this,%id,%text)
{
   DropDown::Select("mSA_Settings_MType","mSA_Dropdown",%id,%text);
   $GUI::MissionType = %id;
   mSA_Settings::createMissionList(%id,mSA_Settings_Map_List);
   if ($Server::MapNumber > mSA_Settings_Map_List.rowCount())
   {
      $Server::MapNumber = 0;
   }
   if (mSA_Settings_Map_List.rowCount() > 0)
   {
      if ($Server::Dedicated)
        mSA_Settings_Map_List.setSelectedRow($Server::MapNumber);
      else
        mSA_Settings_Map_List.setSelectedRow(0);
   }
   if (%id == 0)
   {
      mSA_Settings_ReportStats.setValue(false);
      mSA_Settings_ReportStats.setActive(false);
   }
   else
   {
      mSA_Settings_ReportStats.setValue(true);
      mSA_Settings_ReportStats.setActive(true);
   }
   if (%id <= 1)
   {
      mSA_Settings_Kill_Base.setVisible(true);
      mSA_Settings_ScoreCheck.setVisible(true);
      mSA_Settings_Kill_Text.setVisible(false);
   } else {
      mSA_Settings_Kill_Base.setVisible(false);
      mSA_Settings_ScoreCheck.setVisible(false);
      mSA_Settings_ScoreCheck.setValue(true);
      mSA_Settings_Kill_Text.setVisible(true);
   }
}
