//------------------------------------------------------------------------------
// Menu Support Functions
// - Created to cleanup all our files. Too many small scripts with 2 functions
// - Ace

// Splash screen
function Next()
{
   if (Background.bitmap $= "fps/client/ui/backgrounds/MGTsplash.jpg")
      Background.setBitmap("fps/client/ui/backgrounds/DGDsplash.jpg");
   else if (Background.bitmap $= "fps/client/ui/backgrounds/DGDsplash.jpg")
      Background.setBitmap("fps/client/ui/backgrounds/GarageGames.jpg");
   else if (Background.bitmap $= "fps/client/ui/backgrounds/GarageGames.jpg")
      Background.setBitmap("fps/client/ui/backgrounds/splash.jpg");
   else if (Background.bitmap $= "fps/client/ui/backgrounds/splash.jpg" && isDemo())
      Background.setBitmap("fps/client/ui/guiimages/buyScr01.jpg");
   else if (Background.bitmap $= "fps/client/ui/guiimages/buyScr01.jpg" && isDone())
   {
      Canvas.setContent("finalScreen");
      cancel($GUI::Schedule);
   }
   else
   {
      Canvas.setcontent("rssGui");
      if (!ignitionTurnTheKey() && !isDemo())
         Canvas.pushDialog(yesggRegDlg);

      if ($Client::LanOnly)
         canvas.setcontent("menuMainGui");
      return;
   }
   cancel($GUI::Schedule);
   $GUI::Schedule = schedule(5000, 0, "Next");
}

function menuSplashGui::onSleep()
{
   cancel($GUI::Schedule);
}
function SplashButton::onMouseDown()
{
   Next();
}
function SplashQuitButton::onMouseDown()
{
   Quit();
}
function menuSplashGui::onWake()
{

   $GUI::Schedule = schedule(5000, 0, "Next");
}


//------------------------------------------------------------------------------
//GUI Login Functions ----------------------------------------------------------
//------------------------------------------------------------------------------

//--- Wake Function 
function menuMultiLogin::onWake()
{
   if ($pref::Player::AutoLogin)
      PasswordField.setText($Pref::Player::Pass);
}

//--- Login Check
function menuMultiLogin::login()
{
  if (strlen(PasswordField.getValue()) > 4)
  {
    $Pref::Player::Pass = PasswordField.getValue();
    IRCClient::cmdLogin(LoginField.getValue(),PasswordField.getValue(),LoginRegister.getValue());
  }
  else
  {
    // Error Password Length must be greater then 5 characters.
    MessageBoxOk("Password Too Short","Passwords are required to be a minimum of 5 characters in length");
  }
}
//------------------------------------------------------------------------------
//GUI New Game (Multi) Functions -----------------------------------------------
//------------------------------------------------------------------------------

//---------------------------------------
function NG_getInfo()
{
   if (NG_ServerName.getValue() $= "")
   {
      NG_ServerName.setValue("Dark Horizons-Lore Server");
   }
   $GUI::Host = true;
   $GUI::ServerName = NG_ServerName.getValue();
   $GUI::ServerPass = NG_Password.getValue();
   if (NG_PlayerMax.getValue() == 0)
   {
      NG_PlayerMax.setValue(16);
   }
   $GUI::MaxPlayers = NG_PlayerMax.getValue();
}

//----------------------------------------
function menuMultiNewGameGui::onWake()
{
   if ($Pref::Server::Name $= "")
      $Pref::Server::Name = "Dark Horizons Server";
   NG_ServerName.setValue($Pref::Server::Name);
   NG_Password.setValue("");
   NG_PlayerMax.setValue(16);
}

//----------------------------------------
function SM_StartMission()
{
   NG_GetInfo();
   %serverType = "MultiPlayer";
   if ($GUI::Lan)
      createServerLan(%serverType, %mission);
   else
      createServer(%serverType, %mission);
      
   %conn = new GameConnection(ServerConnection);
   IRCClient::ingameHost($GUI::ServerName);
   RootGroup.add(ServerConnection);
   %conn.setConnectArgs($pref::Player::Name);
   %conn.setJoinPassword($GUI::ServerPass);
   %conn.connectLocal();
}

//------------------------------------------------------------------------------
//GUI Single Player Functions --------------------------------------------------
//------------------------------------------------------------------------------
//----------------------------------------
function menuSinglePlayerGui::onWake()
{
   mSA_Settings::createMissionList(-1,SP_missionList);
}

function  checkSPStatus(%this)
{
   schedule( 9000, 0, "resetTimers");
   if(!$Game::Schedule || $resetComplete)
      SP_Launch.setVisible(1);
   else
      schedule( 111, 0, "checkSPStatus" );
}

function resetTimers()
{
   $resetComplete = true;
}

//-----------------------------------------------------
//--- Map Functions -----------------------------------

function SP_MissionList()
{
   SP_missionList.clear();
   %i = 0;
   for(%file = findFirstFile($Server::MissionFileSpec);
         %file !$= ""; %file = findNextFile($Server::MissionFileSpec))
      if (strStr(%file, "CVS/") == -1 && strStr(%file, "common/") == -1)
         SP_missionList.addRow(%i++, getMissionDisplayName(%file) @ "\t" @ %file );
   SP_missionList.sort(0);
   SP_missionList.setSelectedRow(0);
}

//-----------------------------------------------------
//--- Launch ------------------------------------------

function SP_StartMission()
{
   $GUI::MaxPlayers = 5;
   $GUI::Duration = true;
   $GUI::DurationTime = 10;
   $GUI::MainMenu = true;
   $GUI::SP = true;
   %id = SP_missionList.getSelectedId();
   %mission = getField(SP_missionList.getRowTextById(%id), 1);
   %serverType = "SinglePlayer";
   createServer(%serverType, %mission);
   %conn = new GameConnection(ServerConnection);
   RootGroup.add(ServerConnection);
   %conn.setConnectArgs("Trainee");
   %conn.setJoinPassword($Client::Password);
   %conn.connectLocal();
}

function DHLVersion()
{
   %text = "Dark Horizons: Lore" SPC getVersionString();
   return %text;
}

function showMachineGUID()
{
   %igguidtext = "Machine GUID " @ ignitionGetMachineGUID();
   return %igguidtext;
}

//-----------------------------------------------------------------------------
// Server Admin Commands
//-----------------------------------------------------------------------------

function SAD(%password)
{
   if (%password !$= "")
      commandToServer('SAD', %password);
}

function SADSetPassword(%password)
{
   commandToServer('SADSetPassword', %password);
}


//----------------------------------------------------------------------------
// Misc server commands
//----------------------------------------------------------------------------

function GameConnection::prepDemoRecord(%this)
{
   %this.demoChatLines = HudMessageVector.getNumLines();
   for(%i = 0; %i < %this.demoChatLines; %i++)
   {
      %this.demoChatText[%i] = HudMessageVector.getLineText(%i);
      %this.demoChatTag[%i] = HudMessageVector.getLineTag(%i);
   }
}

function GameConnection::prepDemoPlayback(%this)
{
   for(%i = 0; %i < %this.demoChatLines; %i++)
      HudMessageVector.pushBackLine(%this.demoChatText[%i], %this.demoChatTag[%i]);

   // beffy: changed / added below
   $GUI::SP = true;
   $GUI::MainMenu = true;
   $Server::ServerType = "SinglePlayer";

   StartClientReplication();
   StartFoliageReplication();

   Canvas.setContent(gameHudFS);
}

function quit2()
{
   if (isDemo())
   {
      Canvas.setContent("finalScreen");
   }
   else
      quit();
}

function MGTggRegDlg::onWake( %this )
{
if (isDemo()   )
{
ggIgnitionKeyBox.setText("DEMO-DEMO-DEMO-DEMO");
}
}
