//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2001 GarageGames.Com
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Hook into the client update messages to maintain our player list
// and scoreboard.
//-----------------------------------------------------------------------------

// Config Mav Weapon Callbacks
addMessageCallback('MsgConfigMavClear' , handleConfigMavClear);
addMessageCallback('MsgConfigMavWeapon', handleConfigMavWeapon);
addMessageCallback('MsgConfigMavEnd',    handleConfigMavEnd);
addMessageCallback('MsgSetLaunch',       handleSetLaunch);

// Mission Info and Player Info updates
addMessageCallback('MsgHSUpdate',        handleHSUpdate);
addMessageCallback('MsgHSPlayerUpdate',  handleHSPlayerUpdate);

// Normal Callbacks
addMessageCallback('MsgClientJoinInfo',  handleClientJoinInfo);
addMessageCallback('MsgClientTeamInfo',  handleClientTeamInfo);
addMessageCallback('MsgClientJoin',      handleClientJoin);
addMessageCallback('MsgClientDrop',      handleClientDrop);
addMessageCallback('MsgClientJoinTeam',  handleClientJoinTeam);

// Score Callbacks
addMessageCallback('MsgClientScoreChanged',           handleClientScoreChanged);
addMessageCallback('MsgClientTeamScoreChanged',       handleClientTeamScoreChanged);
addMessageCallback('MsgClientDeathsChanged',          handleClientDeathsChanged);
addMessageCallback('MsgClientKillsChanged',           handleClientKillsChanged);
addMessageCallback('MsgClientObjectivesChanged',      handleClientObjectivesChanged);
addMessageCallback('MsgClientTeamObjectiveChanged',   handleClientTeamObjectiveChanged);

// Hud Callbacks
addMessageCallback('MsgWeaponArmed',     handleWeaponArmed);
addMessageCallback('MsgWeaponUsed',      handleWeaponUsed);
addMessageCallback('MsgWeaponAmmo',      handleWeaponAmmo);

addMessageCallback('MsgWarning', handleWarning);

// SP Callback
addMessageCallback('MsgClientIsLeaving', handleSPLeaving);

//-----------------------------------------------------------------------------

function handleWarning(%msgType,%msgString,%warning)
{
   FS_Flasher.setText(%warning);
   EC_Flasher.setText(%warning);
   FS_Flasher.startFlashing(1);
   EC_Flasher.startFlashing(1);
}

function handleSPLeaving(%msgType,%msgString)
{
  disconnect();
}

function handleHSUpdate(%msgType, %msgString,%name,%type,%time,%score,%spawns,%practice,
   %report,%attack,%defend)
{
   mSA::HostUpdate(%name,%type,%time,%score,%spawns,%practice,%report,%attack,%defend);
}

function handleHSPlayerUpdate(%msgType, %msgString,%clientid, %clientname,%mav,%team)
{
   mSA_Player::PlayerUpdate(%clientid,detag(%clientName),%mav,%team);
}

function handleClientJoin(%msgType, %msgString, %clientName, %clientId,
   %guid, %isAI, %isAdmin, %isSuperAdmin)
{
   gamePlayerListGui.Join(%clientId,detag(%clientName),%isSuperAdmin,
      %isAdmin,%isAI);
   mSA_Player::PlayerUpdate(%clientID, detag(%clientName), 0, 0);
}

function handleClientJoinInfo(%msgType, %msgString, %clientName, %clientId,
   %score, %isAI, %isAdmin, %isSuperAdmin , %kills, %deaths, %oT,%Team,%MAV)
{
   mSA_Player::PlayerUpdate(%clientID, detag(%clientName), %MAV,%Team);
   gamePlayerListGui.joinInfo(%clientId,detag(%clientName),%isSuperAdmin,
      %isAdmin,%isAI,%score,%kills, %deaths, %oT, %team);
}

function handleClientTeamInfo(%msgType, %msgString, %players1, %players2, %Score1, %score2, %oT1, %oT2)
{
   gamePlayerListGui.teamInfo(%players1, %players2, %Score1, %score2, %oT1, %oT2);
}

function handleClientJoinTeam(%msgType, %msgString, %clientName, %clientId,%clientTeam)
{
   gamePlayerListGui.updateTeam(%clientId,detag(%clientName),%clientTeam);
}

function handleClientDrop(%msgType, %msgString, %clientName, %clientId)
{
   mSA_Player::RemovePlayer(%clientID);
   gamePlayerListGui.removePlayer(%clientId);
}

function handleClientScoreChanged(%msgType, %msgString, %score, %clientId)
{
   gamePlayerListGui.updateField(%clientId,%score,5);
}

function handleClientDeathsChanged(%msgType, %msgString, %deaths, %clientId)
{
   gamePlayerListGui.updateField(%clientId, %deaths,4);
}

function handleClientKillsChanged(%msgType, %msgString, %kills, %clientId)
{
   gamePlayerListGui.updateField(%clientId,%kills,2);
}

function handleClientObjectivesChanged(%msgType, %msgString, %oT, %clientId)
{
   gamePlayerListGui.updateField(%clientId, %oT,3);
}

function handleClientTeamScoreChanged(%msgType, %msgString, %score, %clientId)
{
   gamePlayerListGui.updateTeamField(%clientId,%score,5);
}

function handleClientTeamObjectiveChanged(%msgType, %msgString, %score, %clientId)
{
   gamePlayerListGui.updateTeamField(%clientId,%score,4);
}

function handleWeaponArmed(%msgType,%msgString, %id1, %id2,%value1,%value2,%ammo1,%ammo2,%SpecialDisplay)
{
   UpdateWeaponsHud(%value1,%value2,%id1, %id2,%ammo1,%ammo2,%SpecialDisplay);
}


function handleWeaponAmmo(%msgType,%msgString, %pammo,%sammo,%cm)
{
   UpdateWeaponAmmo(%pammo,%sammo,%cm);
}

function handleWeaponUsed(%msgType,%msgString, %id)
{
   UpdateWeaponsSelected(%id);
}

function handleConfigMavClear(%msgType,%msgString)
{
   mSA_Config::clearDropdowns();
}
function handleConfigMavWeapon(%msgType,%msgString,%num, %type, %name, %ammo, %refire, %damage,%range)
{
   mSA_Config::addDropdown(%num, %type, %name, %ammo, %refire, %damage,%range);
}

function handleConfigMavEnd(%msgType,%msgString, %num1,%num2)
{
   mSA_Config::setDropdowns(%num1,%num2);
}

function handleSetLaunch(%msgType,%msgString,%value)
{
   mSA::SetLaunch(%value);
}
