//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2001 GarageGames.Com
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Override base controls
GuiButtonProfile.soundButtonOver = "AudioButtonOver";

new GuiControlProfile ("LoadingGuiContentProfile")
{
   opaque = true;
   fillColor = "200 200 200";
   border = true;
   borderColor   = "0 0 0";
};

//-----------------------------------------------------------------------------
// Chat Hud profiles

new GuiControlProfile ("ChatHudMessageProfile")
{
   fontType = "Shoestring SSi";
   fontSize = 14;
   fontColor =     "255 255 255";  // default color (death msgs, scoring, inventory)
   fontColors[1] = "150 150 255";  // client join/drop, tournament mode
   fontColors[2] = "50 255 50";    // gameplay, admin/voting, pack/deployable
   fontColors[3] = "150 255 150";  // team chat, spam protection message, client tasks
   fontColors[4] = "255 50 50";    // warnings, inventory, negative kills (suicides, team kills)
   fontColors[5] = "255 150 150";  // death msgs, scoring, inventory
   // WARNING! Colors 6-9 are reserved for name coloring 
   autoSizeWidth = false;
   autoSizeHeight = true;
};

new GuiControlProfile ("ChatHudScrollProfile")
{
   opaque = false;
   border = true;
   borderColor = "100 100 255";
   bitmap = "./guiimages/loreScroll";
   hasBitmapArray = true;
};

new GuiControlProfile ("GuiGameObjectView1Profile")
{
   border = true;
   borderColor = "100 100 255";
};

//------------------------------------------------------------------------------
// Player List Profiles
new GuiControlProfile ("HudECScrollProfile")
{
   opaque = true;
   border = true;
   borderColor = "238 190 87";
   fontColor = "255 255 255";
   fillColor = "238 190 87 128";
   bitmap = "./guiimages/loreScroll";
   hasBitmapArray = true;
};

new GuiControlProfile ("HudFSScrollProfile")
{
   opaque = true;
   border = true;
   borderColor = "0 0 200";
   fontColor = "255 255 255";
   fillColor = "0 0 200 128";
   bitmap = "./guiimages/loreScroll";
   hasBitmapArray = true;
};

new GuiControlProfile ("HudOBScrollProfile")
{
   opaque = true;
   border = true;
   borderColor = "180 180 180";
   fontColor = "255 255 255";
   fillColor = "180 180 180 128";
   bitmap = "./guiimages/loreScroll";
   hasBitmapArray = true;
};
//------------------------------------------------------------------------------
// Common Hud profiles

new GuiControlProfile ("HudScrollProfile")
{
   opaque = false;
   border = true;
   borderColor = "0 255 0";
   bitmap = "./guiimages/loreScroll";
   hasBitmapArray = true;
};

new GuiControlProfile ("HudTextProfile")
{
   opaque = false;
   fillColor = "128 128 128";
   fontColor = "255 255 255";
   border = true;
   borderColor = "0 255 0";
};


//-----------------------------------------------------------------------------
// Center and bottom print

new GuiControlProfile ("CenterPrintProfile")
{
   opaque = false;
   fillColor = "128 128 128";
   fontColor = "255 255 255";
};

new GuiControlProfile ("CenterPrintTextProfile")
{
   opaque = false;
   fontType = "Arial";
   fontSize = 12;
   fontColor = "255 255 255";
};

//-----------------------------------------------------------------------------
// Ammo hud profile
new GuiControlProfile ("AmmoPrintProfile"){
    opaque = false;
    fontType = "Shoestring SSi";
    fontSize = 14;
    fillColor = "128 128 128";
    fontColor = "255 255 255";
    border = true;
    borderColor = "100 100 255";
};

new GuiControlProfile ("BitmapButtonProfile")
{   opaque = false;
    border = false;
	soundButtonOver = "AudioButtonOver";
};

