//-----------------------------------------------------------------------------
// Dark Horizons: Lore
// GUI Profiles by Sebastien 'TheAce' Bourgon
// Copyright (c) 2003 Maxgaming Technologies
//-----------------------------------------------------------------------------

$Gui::BackgroundImage = "./backgrounds/loreBG.jpg";
$Gui::Scrollbar       = "./guiimages/loreScroll";
$Gui::Checkbox        = "./guiimages/loreCheck";
$Gui::BBorder         = "./guiimages/loreBorder";
$Gui::BFill           = "./guiimages/loreFill";
$Gui::BBorderAlt      = "./guiimages/loreBorderAlt";
$Gui::BFillAlt        = "./guiimages/loreFillAlt";
$Gui::StaticValue     = "./guiimages/loreTextValue";
$Gui::DropDown        = "./guiimages/loreDropdown1";
$Gui::DropDown2       = "./guiimages/loreDropdown2";

//-----------------------------------------------------------------------------
// Shell profiles
new GuiControlProfile(GuiSliderProfile)
{
    bitmap = "./guiimages/normSlider";
    hasBitmapArray = true;
    fontColor = "0 0 0 0";
};

new GuiControlProfile(GuiShellSpecialSliderProfile)
{
    bitmap = "./guiimages/loreSlider";
    hasBitmapArray = true;
    fontColor = "0 0 0 0";
};

new GuiControlProfile (GuiShellCheckBoxProfile)
{
   opaque = false;
   justify = "left";
   bitmap = $Gui::Checkbox;
   hasBitmapArray = true;
   fontType = "Shoestring SSi";
   fontSize = 14;
   fontColor = "255 255 255";
};

new GuiControlProfile ("GuiShellTextProfile")
{
   fontType = "Shoestring SSi";
   fontSize = 14;
   fontColor = "255 255 255";
   fontColorHL = "255 128 128";
   autoSizeWidth = false;
   autoSizeHeight = false;
};

// Inherit text properties from RSSTextProfile, expand for Large Text Profile
new GuiControlProfile (GuiShellBigTextProfile : GuiShellTextProfile)
{
   fontType = "Shoestring SSi";
   fontSize = 36;						// Change font size to 36
};

new GuiControlProfile (GuiShellHeaderProfile : GuiShellTextProfile)
{
   fontType = "Shoestring SSi";
   fontSize = 18;
};

new GuiControlProfile ("GuiShellTextCenterProfile")
{
   justify = "center";
   fontType = "Shoestring SSi";
   fontSize = 14;
   fontColor = "255 255 255";
   autoSizeWidth = false;
   autoSizeHeight = false;
};

new GuiControlProfile ("GuiShellScrollProfile")
{
   bitmap = $Gui::Scrollbar;
   hasBitmapArray = true;
};


new GuiControlProfile ("GuiShellObjectViewProfile")
{
   border = true;
   borderColor = "0 69 117";
};

new GuiControlProfile ("GuiShellScrollBorderedProfile")
{
   border = true;
   borderColor = "0 69 117";
   bitmap = $Gui::Scrollbar;
   hasBitmapArray = true;
};

new GuiControlProfile ("GuiShellBackgroundProfile")
{
   border = true;
   opaque = true;
   borderColor = "0 69 117";
   fillColor = "0 0 0";
};

new GuiControlProfile ("GuiShellTextListFixedProfile")
{
   fontColor = "255 255 255";
   fontType = "Shoestring SSi";
   fontSize = 14;
   fontColor = "255 255 255";
   autoSizeWidth = true;
   autoSizeHeight = true;
};

new GuiControlProfile ("GuiShellTextListProfile")
{

   autoSizeHeight = true;
   autoSizeWidth = true;
   fontType = "Shoestring SSi";
   fontSize = 14;
   fontColor = "255 255 255";
   fontColorHL = "255 128 128";
};

new GuiControlProfile ("GuiShellBitmapBorderProfile")
{
   opaque = true;
   fillColor = "0 32 57";
   bitmap = $Gui::BBorder;
   hasBitmapArray = true;
};


new GuiControlProfile ("GuiShellBitmapBorderAltProfile")
{

   fillColor = "0 53 93";
   opaque = true;
   bitmap = $Gui::BBorderAlt;
   hasBitmapArray = true;
};

new GuiControlProfile ("GuiShellTextEditProfile")
{
   textOffset = "15 1";
   border = 1;
   borderThickness = 1;
   borderColor = "0 0 0";
   fillColor = "0 53 93";
   opaque = true;
   bitmap = "./guiimages/loreTextEdit.png";
   hasBitmapArray = true;
   fontType = "Shoestring SSi";
   fontSize = 14;
   fontColor = "255 255 255";
   fontColorHL = "255 128 128";
   cursorColor = "255 255 255";
   tab = true;
   canKeyFocus = true;
};

new GuiControlProfile ("GuiShellDropdownProfile")
{
   textOffset = "15 1";
   border = 1;
   fillColor = "0 53 93";
   opaque = true;
   bitmap = "./guiimages/loreTextEdit.png";
   hasBitmapArray = true;
   fontType = "Shoestring SSi";
   fontSize = 14;
   fontColor = "255 255 255";
   cursorColor = "255 255 255";
   tab = true;
   canKeyFocus = true;
};

new GuiControlProfile ("GuiShellBitmapProfile")
{
   opaque = true;
};

new GuiControlProfile ("GuiShellButtonProfile")
{
   fixedExtent = true;
   opaque = true;
   border = 4;
   justify = "center";
   fillColor = "0 53 93";
   fontColor = "255 255 255";
   soundButtonOver = "AudioButtonOver";
};

new GuiControlProfile ("GuiShellMouseOverProfile")
{
   soundButtonOver = "AudioButtonOver";
};

new GuiControlProfile ("GuiShellWindowProfile")
{
   opaque = false;
   border = 2;
   fillColor = ($platform $= "macos") ? "211 211 211" : "192 192 192";
   fillColorHL = ($platform $= "macos") ? "190 255 255" : "64 150 150";
   fillColorNA = ($platform $= "macos") ? "255 255 255" : "150 150 150";
   fontColor = ($platform $= "macos") ? "255 255 255" : "255 255 255";
   fontColorHL = "255 128 128";
   text = "GuiWindowCtrl test";
   bitmap = ($platform $= "macos") ? "/common/ui/osxWindow" : "/common/ui/darkWindow";
   textOffset = ($platform $= "macos") ? "5 5" : "6 6";
   hasBitmapArray = true;
   justify = ($platform $= "macos") ? "center" : "left";
};

new GuiControlProfile ("GuiShellBlackProfile")
{
   opaque = true;
   fillColor = ($platform $= "macos") ? "0 0 0" : "0 0 0";
};

//-----------------------------------------------------------------------------
// IRC Screen Profiles


new GuiControlProfile ("GuiIRCBitmapBorderProfile")
{

   fillColor = "13 21 97";
   opaque = true;
   bitmap = $Gui::BBorderAlt;
   hasBitmapArray = true;
};

new GuiControlProfile ("GuiIRCChatProfile")
{
   fontType = "Shoestring SSi";
   fontSize = 14;
   fontColor = "255 255 255";
   opaque = false;
   fontColor     = "255 255 255"; // Normal Text
   fontColors[1] = "255 100 100"; // (Kicks/Bans)
   fontColors[2] = "50 255 50";   // (Join/Modes)
   fontColors[3] = "100 200 255"; // (Part/Quit)
   fontColors[4] = "255 0 0";     // (Errors)
   fontColors[5] = "115 250 250"; // Teal (Actions)
   fontColors[6] = "250 200 100"; //  (Notices)
   fontColors[7] = "250 200 100"; //  (Info)
   fontColors[8] = "200 200 200"; // Dark Teal (MOTD)
   fontColors[9] = "150 150 50";  // Darkest Green (Private Msgs)
   autoSizeWidth = true;
   autoSizeHeight = true;
};

//-----------------------------------------------------------------------------
// Cursors

new GuiCursor(DefaultCursor)
{
   hotSpot = "5 5";
   bitmapName = "./guiimages/loreMouseArrow.png";
};

new GuiCursor(MouseOverCursor)
{
   hotSpot = "5 5";
   bitmapName = "./guiimages/loreMouseArrow2.png";
};
