
function AIPlayer::startMovementTraining(%this, %wayPointArea)
{
   // messageAll( 'MsgGame', '\c2Training Level: %1 .', $singlePlayerLevel );
  // messageAll( 'MsgGame', '\c2I will begin by pressing \c4W \c2to move \c5forward \c2 .' );
   //go to first location
   //do routine
   //talk to player

   %botArea = "BotTrainerMarkers" @ %wayPointArea;

   if(isObject(%botArea))
   {
   // as long as this bot hasn't completed the waypoint path:
   if(%this.countMyMoves < %botArea.getCount())      {
      %dest = %botArea.getObject(%this.countMyMoves).position;
      //go to movement start->forward
      %this.setAimLocation(%dest);
      %this.setMoveDestination(%dest);
      %this.countMyMoves++;
      }
   }
}

function AIPlayer::forwardSequenceTraining(%this, %wayPointArea)
{
   //messageAll( 'MsgGame', '\c2Next I will press \c4S \c2to move \c5backwards.' );
   %botArea = "BotTrainerMarkers" @ %wayPointArea;

   if(isObject(%botArea))
   {
   // as long as this bot hasn't completed the waypoint path:
   if(%this.countMyMoves < %botArea.getCount())      {
      %dest = %botArea.getObject(%this.countMyMoves).position;
      //go to movement forward->backward
      //%this.setAimLocation(%dest);
      %this.setMoveDestination(%dest);
      %this.countMyMoves++;
      }
   }
}

function AIPlayer::backwardSequenceTraining(%this, %wayPointArea)
{
   %botArea = "BotTrainerMarkers" @ %wayPointArea;

   if(isObject(%botArea))
   {
   // as long as this bot hasn't completed the waypoint path:
   if(%this.countMyMoves < %botArea.getCount())      {
       %dest = %botArea.getObject(%this.countMyMoves).position;
       //go to movement backwards->left
       //%this.setAimLocation(%dest);
       %this.setMoveDestination(%dest);
       %this.countMyMoves++;
       }
   }
}

function AIPlayer::rightSequenceTraining(%this, %wayPointArea)
{
   messageAll( 'MsgGame', '\c2"A" will make your MAV strafe to the left and "D" will make it strafe to the right.' );
       alxPlay("AudioBotSpeachSP1_2");
       $SP::AISpeak  = schedule(12459,alxStop,"AudioBotSpeachSP1_2");

     %botArea = "BotTrainerMarkers" @ %wayPointArea;
   %this.playThread(1,"l_flame");
   //%this.pauseThread(1);
   if(isObject(%botArea))
   {
   // as long as this bot hasn't completed the waypoint path:
   if(%this.countMyMoves < %botArea.getCount())      {
       %dest = %botArea.getObject(%this.countMyMoves).position;
       //go to movement right->left
       //%this.setAimLocation(%dest);
       %this.setMoveDestination(%dest);
       %this.countMyMoves++;
       }
   }
}

function AIPlayer::leftSequenceTraining(%this, %wayPointArea)
{
   //messageAll( 'MsgGame', '\c2Finally you move left by pressing \c4A\c2.' );
   %botArea = "BotTrainerMarkers" @ %wayPointArea;
   %this.setThreadDir(1,false);

   %this.playThread(2,"r_flame");

   if(isObject(%botArea))
   {
   // as long as this bot hasn't completed the waypoint path:
   if(%this.countMyMoves < %botArea.getCount())      {
      %dest = %botArea.getObject(%this.countMyMoves).position;
      //go to movement left->exit
      //%this.setAimLocation(%dest);
      %this.setMoveDestination(%dest);
      %this.countMyMoves++;
      }
   }
}

function AIPlayer::leaveMovmentCross(%this, %wayPointArea)
{
   //messageAll( 'MsgGame', '\c2We will finish movement with \c5jumping \c2and \c5jetting \c2.' );
   %botArea = "BotTrainerMarkers" @ %wayPointArea;

   %this.setThreadDir(2,false);
   if(isObject(%botArea))
   {
   // as long as this bot hasn't completed the waypoint path:
   if(%this.countMyMoves < %botArea.getCount())      {
       %dest = %botArea.getObject(%this.countMyMoves).position;
       //go to movement exit->jump
       %this.setAimLocation(%dest);
       %this.setMoveDestination(%dest);
       %this.countMyMoves++;
       }
   }
   messageAll( 'MsgGame', '\c2The space bar will make your MAV jump while your right mouse button will make you jet. Incidently, only scout and infantry MAVs have jets.' );
   %this.doJump(true);
}

function AIPlayer::jumpingTraining(%this, %wayPointArea)
{
   %this.doJump(false);
   //messageAll( 'MsgGame', '\c5Jumping\c2 can give you an advantage when \c5jetting.' );
   %this.jettingTraining(%this.wayPointArea);
}

function AIPlayer::jettingTraining(%this, %wayPointArea)
{
   //messageAll( 'MsgGame', '\c2The \c4right mouse button \c2activates your \c5jets.' );
   //messageAll( 'MsgGame', '\c2My MAV is not equipped with jets, so I can not demonstrate this.' );
   %botArea = "BotTrainerMarkers" @ %wayPointArea;


   if(isObject(%botArea))
   {
   // as long as this bot hasn't completed the waypoint path:
   if(%this.countMyMoves < %botArea.getCount())      {
       %dest = %botArea.getObject(%this.countMyMoves).position;
       //go to movement exit->jump
       %this.setAimLocation(%dest);
       %this.setMoveDestination(%dest);
       %this.countMyMoves++;
       }
   }
   $SP::phase1 = true;
}
 
//--------------------------------------------------
//hud names
// hud = aiming
// comms = chat area
// objectives_bg = mission description
// weapons_bg = weapons
// armor_bg = health
// HudMap_Bg = map
// time_bg = time
// ammoAmount = ammo
// energy_bar/energytxt = energy
// compass_bg/compass_control  = compasss
//-----------------------------------------------------
function startHudTraining(%this)
{
   //$stopTalking = false;
   alxPlay("AudioBotSpeachSP1_3");
   $SP::AISpeak  = schedule(33305,alxStop,"AudioBotSpeachSP1_3");
   messageAll( 'MsgGame', '\c2Here is a quick explanation of your HUD, this is the Communications Display,' );
   //messageAll( 'MsgGame', '\c2This is the communication display!' );
   flashGuiElement(fs_tophud);
   $SP::ActionSchdule = schedule(1500, 0, "flashGuiElement" ,fs_tophud);
   $SP::Continue = schedule(3500, 0, "continueHudTraining1" );
 
}

function continueHudTraining1(%this)
{
   messageAll( 'MsgGame', '\c2and here is your reticule for aiming,' );
   flashGuiElement(fs_hud);
   $SP::ActionSchdule = schedule(1500, 0, "flashGuiElement" ,fs_hud);
   $SP::Continue = schedule(3500, 0, "continueHudTraining2" );
}

function continueHudTraining2(%this)
{
   messageAll( 'MsgGame', '\c2your weapons display can be found here' );
   flashGuiElement(FS_weapons);
   $SP::ActionSchdule = schedule(1500, 0, "flashGuiElement" ,fs_weapons);
   $SP::Continue = schedule(3500, 0, "continueHudTraining3" );
}
function continueHudTraining3(%this)
{
   messageAll( 'MsgGame', '\c2while mission specifics here.' );
   flashGuiElement(FS_objectives);
   $SP::ActionSchdule = schedule(1500, 0, "flashGuiElement" ,fs_objectives);
   $SP::Continue =  schedule(3500, 0, "continueHudTraining4" );
}
function continueHudTraining4(%this)
{
   messageAll( 'MsgGame', "\c2 Your remaining health is located to the left; don't let this get all the way down." );
   flashGuiElement(FS_HEALTH);
   $SP::ActionSchdule = schedule(1500, 0, "flashGuiElement" ,FS_HEALTH);
   $SP::Continue = schedule(3500, 0, "continueHudTraining5" );
}
function continueHudTraining5(%this)
{
   messageAll( 'MsgGame', '\c2In the center is your Radar display,in it you will find your awareness information; friendlies are indicated by green icons while any enemies are in red, any capturable objectives are shown as a yellow dots.' );
   flashGuiElement(FS_HudMap);
   $SP::ActionSchdule = schedule(1500, 0, "flashGuiElement" ,FS_HudMap);
   $SP::Continue = schedule(10000, 0, "continueHudTraining6" );
}
function continueHudTraining6(%this)
{
   messageAll( 'MsgGame', '\c2Mission time is at the top and ' );
   flashGuiElement(fs_time_bg);
   $SP::ActionSchdule = schedule(1500, 0, "flashGuiElement" ,fs_time_bg);
   $SP::Continue = schedule(3500, 0, "continueHudTraining7" );
}
function continueHudTraining7(%this)
{
   messageAll( 'MsgGame', '\c2your energy is to the right' );
   flashGuiElement(FS_ENERGY);
   $SP::ActionSchdule = schedule(1500, 0, "flashGuiElement" ,FS_ENERGY);
   $SP::Continue = schedule(3500, 0, "continueHudTraining8" );

}
function continueHudTraining8(%this)
{
   messageAll( 'MsgGame', '\c2with the compass at the bottom.' );
   flashGuiElement(FS_compass);
   $SP::ActionSchdule = schedule(1500, 0, "flashGuiElement" ,FS_compass);
   $SP::Continue = schedule(3500, 0, "endTraining" );
   $SP::phaseOneDone = true;
}

//------------------------------------------------------------------------------
//misc
//-------------------------------------------------------------------------
function flashGuiElement(%elementName)
{
   if (%elementName.isVisible())
      %elementName.setVisible(false);
   else
      %elementName.setVisible(true);
   if(!%elementName.isVisible())
      $SP::ActionSchdule = schedule( 777, 0, "flashGuiElement" ,%elementName);
}

