//------------------------------------------------------------
//------ Functions for Server Command AddVehicle -------------
//------------------------------------------------------------
// This script file is used solely for SPAWNING
// Functions:
//   serverCmdAddVehicle(BaseDatablockName,DataBlock Number);
//   serverCmdAddWeapons();
//   addBlueScout();
//------------------------------------------------------------
// Created by Sebastien Bourgon for MaxGaming Technologies
// Last Update : September 17th, 2003
//------------------------------------------------------------

//Load Player Datablocks
exec("./players/defaultDatablocks.cs");
exec("./players/DefaultMav.cs");
exec("./players/ShaddrackMavs.cs");
exec("./players/HunterScoutMavs.cs");
exec("./players/LocustMavs.cs");
exec("./players/MantisMavs.cs");
exec("./players/JuggernautMavs.cs");
exec("./players/AbolisherMavs.cs");
exec("./players/BeastMAVs.cs");
exec("./players/predatorMAVs.cs");

// Server Command AddVehicle
function serverCmdAddVehicle(%client,%vehicle,%vehiclenum)
{
   // Make sure player is not mounted
   // Delete old client player
   if(%client.player) {
      if(%client.player.isMounted()) {
         return;
      }
      %client.player.delete();
   }
   // Prevent Angus Ghost
   if (%this.player > 0)  {
      error( "Attempting to create an angus ghost!" );
   }
   // Make sure vehiclenum has a value!
   if (%vehiclenum $= "" || %vehiclenum == 0) {
      %vehiclenum = 3;
   }
   // Make sure a vehicle is set.
   //(Should be impossible not to be)
   // But just incase...
   if (%vehicle $= "") {
      %vehicle = %client.team.defaultMAV;
   }

   // Create new player object
   %player = new Player() {
         dataBlock = %vehicle @ %vehiclenum;
         client = %client;
         };
   MissionCleanup.add(%player);

   // Player setup...
   %player.setTransform(%client.spawnPoint);
   %player.setEnergyLevel(%player.getDataBlock().MaxEnergy);
   %player.setShapeName(%client.name);
   %player.setTeam(%client.team.teamId);
    // Update the camera to start with the player
   %client.camera.setTransform(%player.getEyeTransform());
   // Give the client control of the player
   %client.player = %player;
   %client.dbname = %vehicle @ %vehiclenum;
   serverCmdAddWeapons(%client);
   %client.setControlObject(%player);
   commandToClient(%client,'SetHud',%client.team.hud);
}

// Server Command Add Weapons
function serverCmdAddWeapons(%client)
{
   //Setup Variables
   //%Ammo is the Ammo tag (for Datablock names)
   //%Name is the Player Datablock name
   %Ammo = "Ammo";
   %Name = %client.dbname;
   //Primary Weapon
   //Get Variant Number and create Weapon Datablock Name
   %currentNum = (%client.primaryNum) ? %client.primaryNum : (%Name).primaryNum;
   %currentName = (%Name).primaryName @ %currentNum;
   %primaryAmmoName = (%Name).primaryName @ %Ammo @ %currentNum;
   //Set Inventory, and Add Ammo (except for Laserbeam)
   %client.player.setInventory(%currentName, 1);
   if(!(%currentName).laser) {
      %client.player.setInventory(%primaryAmmoName, (%Name).maxInv[%primaryAmmoName]);
   }
   //Set Display Name Variable and Set Primary Weapon Variable (For Firing)
   %PrimaryDisplay = (%currentName).displayName;
   %client.player.primary = %currentName;

   //Get Missile Name/Number
   //Get Variant Number and create Weapon Datablock Name
   %currentNum = (%client.secondaryNum) ? %client.secondaryNum : (%Name).secondaryNum;
   %currentName = (%Name).secondaryName @ %currentNum;
   %secondaryAmmoName = (%Name).secondaryName @ %Ammo @ %currentNum;

   //Set Inventory, and Add Ammo
   %client.player.setInventory(%currentName, 1);
   %client.player.setInventory(%secondaryAmmoName, (%Name).maxInv[%secondaryAmmoName]);

   //Set Display Name Variable and Set Primary Weapon Variable (For Firing)
   %SecondaryDisplay = (%currentName).displayName;
   %client.player.secondary = %currentName;

   //implimenting Special

   if(isSpecial(%Name)) {
   //error("you are special");
      %SpecialWeapon   = getSpecial(%Name);
      %SpecialDisplay  = %SpecialWeapon.displayName;
      %client.player.setInventory(%SpecialWeapon, 1);
   }
   else
   {
      %SpecialDisplay  = "";
   }
   //Send Client the Display Names and Datablock Names for Weapons Display on Huds
   messageClient(%client, 'MsgWeaponArmed', "", %client.player.primary, %client.player.secondary,%PrimaryDisplay,%SecondaryDisplay,(%Name).maxInv[%primaryAmmoName],(%Name).maxInv[%secondaryAmmoName], %SpecialDisplay );
   //Use the Primary Weapon
   %client.player.use(%client.player.primary);
   %client.setCounterAmountHud(%client.player.MaxCounters);
}

function AddBlueScout(%client)
{
   // Make sure player is not mounted
   // Delete old client player
   if(%client.player) {
      if(%client.player.isMounted()) {
         return;
      }
      %client.player.delete();
   }
   // Prevent Angus Ghost
   if (%this.player > 0)  {
      error( "Attempting to create an angus ghost!" );
   }

   %player = new Player() {
          dataBlock = HunterScout1;
          client = %client;
          };
   MissionCleanup.add(%player);

   // Player setup...
   %player.setTransform(%client.spawnPoint);
   %player.setEnergyLevel(%player.getDataBlock().MaxEnergy);
   %player.setShapeName(%client.name);

   // Update the camera to start with the player
   %client.camera.setTransform(%player.getEyeTransform());

   // Give the client control of the player
   // Setup Initial Inventory
   %player.setInventory(HunterScoutSecondary2,1);
   %player.setInventory(HunterScoutSecondaryAmmo2,50);
   %player.setInventory(HunterScoutPrimary1,1);
   %player.setInventory(HunterScoutPrimaryAmmo1,500);
   //Set Player to Client
   //Setup Firing Select Variables and send off Weapons Hud information
   %client.player = %player;
   %client.player.primary = "HunterScoutPrimary1";
   %client.player.secondary = "HunterScoutSecondary2";
   messageClient(%client, 'MsgWeaponArmed', "", %client.player.primary, %client.player.secondary,"Plasma Rifle","Homing Missile",500,50);
   //Use the Primary Weapon
   %client.player.use(%client.player.primary);
   %client.setCounterAmountHud(%client.player.MaxCounters);
   %client.setControlObject(%player);
}
