// phdana turrets ->
function AITurretData::create(%this,%data)
{
   // The mission editor invokes this method when it wants to create
   // an object of the given datablock type.
   %obj = new AITurret() {
      dataBlock = %data;
   };
   MissionCleanup.add(%obj);
   %obj.isTurret = true;
   %obj.setTeam(%this.team);
   return %obj;
}

function AITurretData::onAdd(%this,%obj)
{
	%obj.setEnergyLevel(%this.MaxEnergy);
   %obj.setHeat(%this.heat);
    // mount the barrel if one is specified
    if (%this.barrel !$= "")
    {
	    %obj.mountImage(%this.barrel,%this.barrelSlot);
    }

   %size = %this.triggerRadius;
   %scale = VectorScale("2 2 2",%size);
   %obj.setTeam(%obj.team);
   %obj.isTurret = true;
   %name = "Turret-" @ %obj;
   // now we have to give the static shape a
   // controlling trigger of the right size and location
   %trigger = new Trigger(%name)
   {
      dataBlock = AITurretTriggerData;
      position = %obj.position;
      rotation = "1 0 0 0";
      scale = %scale;
      polyhedron = "0.000000 1.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
   };
   MissionGroup.add(%trigger);
   %trigger.setOwner(%obj);
   %obj.setTrigger(%trigger);
   //owned triggers go into a cleanup group of their own
   %obj.setHeat(%this.heat);
   %obj.setDamageLevel(0);
}

function AITurretData::onRemove(%this,%obj)
{
   %obj.clearAim();
   %trigger = %obj.getTrigger();
   if (isObject(%trigger))
   {
      %obj = %trigger.getOwner();
      if (isObject(%obj))
         %obj.setTrigger(0);
      %trigger.delete();
   }
}
function AITurretData::onNewDatablock(%this,%obj) { }
function AITurretData::onThink(%this,%obj) { //  error("think");
}
function AITurretData::onEnterTrigger(%this,%turret,%obj)
{       // error("enter trigger");
   if (%turret.hasTarget)
      return;
   %this.resetTarget(%turret);
}
function AITurretData::onLeaveTrigger(%this,%turret,%obj)
{         //        error("leave trigger");
      if (%turret.hasTarget)
      return;
   %turret.clearAim();
   if (%turret.getNumObjects() > 0)
   %this.resetTarget(%turret);
 }
function AITurretData::onTickTrigger(%this,%turret) {   //  error("tick trigger");
   if (%turret.hasTarget)
      return;
   if (%turret.getNumObjects() > 0) {
   %this.resetTarget(%turret);
   }
}
function AITurretData::onTargetAquired(%this,%turret, %target)
{  //  error("targ arquired");
}
function AITurretData::onTargetChanged(%this,%turret, %oldTarget, %newTarget) { //  error("target changes");
}
function AITurretData::onTargetEnterLOS(%this,%turret) {   // error("target enter LOS");
   if (%turret.hasTarget)
      return;
   %this.resetTarget(%turret);
}
function AITurretData::onTargetLost(%this,%turret,%target)
{     // error("targetlost");
   %turret.clearAim();

   // if there are no more in zone
   if (%turret.getNumObjects() < 1)
       %turret.fire(0,false);
 }
function AITurretData::onTargetDeleted(%this,%turret) {     error("target deleted");
   %turret.clearAim();
  // if (%turret.getNumObjects() > 0)
   //%this.resetTarget(%turret);
 }
function AITurretData::onTargetExitLOS(%this,%turret)
{    //    error("targetet exit LOS");
   %turret.clearAim();
   if (%turret.getNumObjects() > 0)
   %this.resetTarget(%turret);
 }

// fire turret gun and setup to fire again fireRate seconds later
function AITurretData::fireGun(%this,%turret)
{     // error("fireGun");
   // fire gun
   %turret.fire(0,true);
}

function AITurretData::resetTarget(%this,%turret)
{       //           error("resetTarget");
   // if this is not the last object to leave do nothing
   // stop firing
   %turret.fire(0,false);
   %turret.clearAim();
   // Get new target
   if (%turret.getNumObjects() > 0)
   %turret.pickTarget();
   // Fire if you get one.
   if (%turret.hasTarget())
      %turret.fire(0,true);
}
function AITurretData::onDestroyed(%data, %obj, %prevState)
{
   %trigger = %obj.getTrigger();
   %trigger.schedule(1500, "delete");
   %obj.schedule(2000, "delete");
   if (%obj.client)
      %obj.client.currentDeployed--;
}

function AITurretData::damage(%this,%obj,%sourceObj,%vel,%damage, %damageType)
{
   %obj.applyDamage(%damage);
   %damage = %obj.getDamageLevel();
   if (%damage >= %this.maxDamage)
   {
      if (%obj.getDamageState() !$= "Destroyed")
      {
         %obj.setDamageState(Destroyed);
      }
   }
}
