//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2001 GarageGames.Com
// Portions Copyright (c) 2001 by Sierra Online, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Single shot sounds
//-----------------------------------------------------------------------------
new AudioProfile(takeme)
{
   filename = "~/data/sound/takeme.ogg";
   description = AudioDefaultLooping3d;
   preload = false;
};

new AudioProfile(AudioButtonOver)
{
   filename = "~/data/sound/buttonOver.ogg";
   description = AudioGui;
   preload = true;
};

new AudioProfile(PlaceWaypoint)
{
   filename = "~/data/sound/boltpull.ogg";
   description = AudioGui;
   preload = true;
};


//------------------------------------------------------------------------------
// -- MAV Sound Effects --
//------------------------------------------------------------------------------

datablock AudioProfile(GatlingMountSound)
{
	filename = "~/data/sound/boltpull.ogg";
	description = AudioClosest3d;
	preload = true;
};

datablock AudioProfile(GatlingFireStartSound)
{
	filename = "~/data/sound/GU11START.ogg";
	description = AudioClosest3d;
	preload = true;
};

datablock AudioProfile(GatlingFireSound)
{
	filename = "~/data/sound/gu11.ogg";
	description = AudioClosestLooping3d;
	preload = true;
};

datablock AudioProfile(GatlingFireStopSound)
{
	filename = "~/data/sound/GU11STOP.ogg";
	description = AudioClosest3d;
	preload = true;
};

datablock AudioProfile(GatlingDryFireSound)
{
	filename = "~/data/sound/boltpull.ogg";
	description = AudioClose3d;
	preload = true;
};


//------------------------------------------------------------------------------
// -- Misc Sound Effects --
//------------------------------------------------------------------------------

datablock AudioProfile(ChatMessageSound)
{
	filename = "~/data/sound/message_recieved.ogg";
	description = Audio2D;
	preload = true;
};




//------------------------------------------------------------------------------
// -- Explosions --
//------------------------------------------------------------------------------


datablock AudioProfile(VehicleExplosionSound)
{
	filename = "~/data/sound/medexplode.ogg";
	description = AudioClose3d;
	preload = true;
};

//------------------------------------------------------------------------------
// -- Environmentals --
//------------------------------------------------------------------------------

datablock AudioProfile(GeneratorSound)
{
	filename = "~/data/sound/genloop.ogg";
	description = ObjectEmmiters;
	preload = true;
};

datablock AudioProfile(DieselMotor)
{
	filename = "~/data/sound/diesel2.ogg";
	description = ObjectEmmiters;
	preload = true;
};

datablock AudioProfile(electronic)
{
	filename = "~/data/sound/electronic.ogg";
	description = shortObjectEmmiters;
	preload = false;
};

datablock AudioProfile(shipsounds)
{
	filename = "~/data/sound/spaceshiphum.ogg";
	description = ObjectEmmiters;
	preload = true;
};

datablock AudioProfile(radar)
{
	filename = "~/data/sound/radar2.ogg";
	description = shortObjectEmmiters;
	preload = false;
};

datablock AudioProfile(oilpump)
{
	filename = "~/data/sound/oilpump.ogg";
	description = shortObjectEmmiters;
	preload = true;
};

datablock AudioProfile(oceanwaves)
{
	filename = "~/data/sound/wavebig.ogg";
	description = ObjectEmmiters;
	preload = true;
};

datablock AudioProfile(morning_birds)
{
	filename = "~/data/sound/morning_birds2.ogg";
	description = ObjectEmmiters;
	preload = false;
};

datablock AudioProfile(sea_gulls)
{
	filename = "~/data/sound/seagulls.ogg";
	description = ObjectEmmiters;
	preload = false;
};

datablock AudioProfile(wind_effects)
{
	filename = "~/data/sound/peakwind.ogg";
	description = ObjectEmmiters;
	preload = false;
};

datablock AudioProfile(riversound)
{
	filename = "~/data/sound/river.ogg";
	description = ObjectEmmiters;
	preload = false;
};

datablock AudioProfile(streamsound)
{
	filename = "~/data/sound/stream.ogg";
	description = ObjectEmmiters;
	preload = false;
};

datablock AudioProfile(wind_sound2)
{
	filename = "~/data/sound/wind.ogg";
	description = ObjectEmmiters;
	preload = false;
};

datablock AudioProfile(wind_sound3)
{
	filename = "~/data/sound/Windloop1.ogg";
	description = ObjectEmmiters;
	preload = false;
};

datablock AudioProfile(splash)
{
	filename = "~/data/sound/splash.ogg";
	description = shortObjectEmmiters;
	preload = false;
};

datablock AudioProfile(electric_hum)
{
	filename = "~/data/sound/electric_hum.ogg";
	description = shortObjectEmmiters;
	preload = false;
};


