
//----------------------------------------------------------------------------
// Armor Datablock methods
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
//never called
function Armor::onAdd(%this,%obj)
{
   // phdana strafe anims ->
   Parent::onAdd(%this,%obj);
   // <- phdana strafe anims

}

function Armor::onRemove(%this, %obj)
{
   // phdana strafe anims ->
   Parent::onRemove(%this,%obj);
   // <- phdana strafe anims

   if (%obj.client.player == %obj)
      %obj.client.player = 0;
}

function Armor::onNewDataBlock(%this,%obj)
{
}


//----------------------------------------------------------------------------

function Armor::onMount(%this,%obj,%vehicle,%node)
{
   if (%node == 0)  {
      %obj.setTransform("0 0 0 0 0 1 0");
      %obj.setActionThread(%vehicle.getDatablock().mountPose[%node],true,true);
      %obj.lastWeapon = %obj.getMountedImage($WeaponSlot);

      %obj.unmountImage($WeaponSlot);
      %obj.setControlObject(%vehicle);
      %obj.client.setObjectActiveImage(%vehicle, 2);
   }
}

function Armor::onUnmount( %this, %obj, %vehicle, %node )
{
   if (%node == 0)
      %obj.mountImage(%obj.lastWeapon, $WeaponSlot);
}

function Armor::doDismount(%this, %obj, %forced)
{
   // This function is called by player.cc when the jump trigger
   // is true while mounted
   if (!%obj.isMounted())
      return;

   // Position above dismount point
   %pos    = getWords(%obj.getTransform(), 0, 2);
   %oldPos = %pos;
   %vec[0] = " 0  0  1";
   %vec[1] = " 0  0  1";
   %vec[2] = " 0  0 -1";
   %vec[3] = " 1  0  0";
   %vec[4] = "-1  0  0";
   %impulseVec  = "0 0 0";
   %vec[0] = MatrixMulVector( %obj.getTransform(), %vec[0]);

   // Make sure the point is valid
   %pos = "0 0 0";
   %numAttempts = 5;
   %success     = -1;
   for (%i = 0; %i < %numAttempts; %i++) {
      %pos = VectorAdd(%oldPos, VectorScale(%vec[%i], 3));
      if (%obj.checkDismountPoint(%oldPos, %pos)) {
         %success = %i;
         %impulseVec = %vec[%i];
         break;
      }
   }
   if (%forced && %success == -1)
      %pos = %oldPos;

   // phdana turrets ->
   if(%obj.mVehicle)
   {
      %data = %obj.mVehicle.getDataBlock();
      if (%data.className $= TurretData)
         %data.playerDismounted(%obj.mVehicle, %obj);

      %obj.mVehicle.mountable = true;
	  %client = %obj.client;
 	  if(%obj.mVehicle.mountedTurret.currentDriver == %client)
 		%obj.mVehicle.mountedTurret.currentDriver = "";
   }
   // <- phdana turrets

   %obj.mountVehicle = false;
   %obj.schedule(4000, "mountVehicles", true);

   // Mount last weapon used, unmount from node, and give player control.
   %obj.unMount();
   %this.onUnMount(%obj);
   %obj.setControlObject(%obj);

   // Position above dismount point
   %obj.setTransform(%pos);
   %obj.applyImpulse(%pos, VectorScale(%impulseVec, %obj.getDataBlock().mass));
   %obj.setPilot(false);
   %obj.vehicleTurret = "";
}

//----------------------------------------------------------------------------

function Armor::onCollision(%this,%obj,%col,%vec,%speed)
{
   if (%obj.getState() $= "Dead")
      return;

   // Try and pickup all items
   if (%col.getClassName() $= "Item")
      %obj.pickup(%col);
      
      // phdana turrets ->
   %obj.mountedTurret = "";

   // Mount vehicles or turrets
   %this = %col.getDataBlock();

          //now set for WHEELED and FLYING vehicals
     if ((%this.className $= WheeledVehicleData || %this.className $= FlyingVehicleData ||
             %this.className $= TurretData)
        && %obj.mountVehicle && %obj.getState() $= "Move" && %col.mountable)


   if ((%this.className $= WheeledVehicleData ||
       %this.className $= TurretData) && %obj.mountVehicle &&
         %obj.getState() $= "Move" && %col.mountable) {

         %node = findEmptySeat(%col, %this);
         if(%col.mountedTurret.currentDriver $= "" && %node > 0)
         {
            %col.mountedTurret.mountObject(%obj, 0);
            %col.mountedTurret.currentDriver = %client;
            %turretMounted = true;
         }

         %col.mountable=true;// Set Vehicle mountable for other passengers

         if(!%turretMounted)
         {
            %col.mountObject(%obj,%node);
 		 	%player = %client.player;
 		 	%col.currentDriver = %client;
 		 	%client.currentMountedVehicle = %col;
 		 }
 		 %obj.mVehicle = %col;

        if(%this.className $= TurretData)
        {
          %this.playerMounted(%col,%obj, %node);
        }
   }
   // <- phdana turrets
}
// phdana turrets ->
// if you dont already have this for vehicles
// you need it for turrets
function findEmptySeat(%vehicle, %vehicleblock)
{
  for (%i = 0; %i <  %vehicleblock.numMountPoints; %i++)
  {
    %node = %vehicle.getMountNodeObject(%i);
    if (%node == 0)
    {
         return %i;
    }
  }
  return -1;
}
// <- phdana turrets

function Armor::onImpact(%this, %obj, %collidedObject, %vec, %vecLen)
{
   %obj.damage(0, VectorAdd(%obj.getPosition(),%vec),
      %vecLen * %this.speedDamageScale, "Impact");
}


//----------------------------------------------------------------------------

function Armor::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
   if (%obj.getState() $= "Dead")
      return;
   %obj.applyDamage(%damage);
   %location = "Body";

   // Deal with client callbacks here because we don't have this
   // information in the onDamage or onDisable methods
   %client = %obj.client;
   %sourceClient = %sourceObject ? %sourceObject.client : 0;

   if (%obj.getState() $= "Dead")
      %client.onDeath(%sourceObject, %sourceClient, %damageType, %location);
}

function Armor::onDamage(%this, %obj, %delta)
{
   // This method is invoked by the ShapeBase code whenever the 
   // object's damage level changes.
   if (%delta > 0 && %obj.getState() !$= "Dead") {

      // Increment the flash based on the amount.
      %flash = %obj.getDamageFlash() + ((%delta / %this.maxDamage) * 2);
      if (%flash > 0.75)
         %flash = 0.75;
      %obj.setDamageFlash(%flash);

      // If the pain is excessive, let's hear about it.
      if (%delta > 10)
         %obj.playPain();
   }
}

function Armor::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType, %momVec) 
{ 
  error("Jeez!! I've been damaged with" SPC %amount); 
  %data.damage(%targetObject, %sourceObject, %position, %amount, %damageType); 
}

function Armor::onDestroyed(%this,%obj,%state)
{
   // The player object sets the "disabled" state when damage exceeds
   // it's maxDamage value.  This is method is invoked by ShapeBase
   // state mangement code.

   // caused this death, then we would have to move this code into
   // the script "damage" method.
   %obj.playDeathCry();
   %obj.playDeathAnimation();
   %obj.setDamageFlash(0.75);

   // Release the main weapon trigger
   %obj.setImageTrigger(0,false);

   %pos = %obj.getPosition();
   radiusDamage(%obj,%pos,%data.damageRadius,%data.radiusDamage,"MAV",0);

   // Schedule corpse removal.  Just keeping the place clean.
   %obj.schedule($CorpseTimeoutValue - 1000, "startFade", 1000, 0, true);
   %obj.schedule($CorpseTimeoutValue, "delete");
}


//-----------------------------------------------------------------------------

function Armor::onLeaveMissionArea(%this, %obj)
{
   // Inform the client
   %obj.client.onLeaveMissionArea();
   messageClient(%obj.client,"","\c4**WARNING You have left the mission area!**");
   %force = MissionArea.bounce;
   %min_x = getWord(MissionArea.area, 0);
   %min_y = getWord(MissionArea.area, 1);
   %max_x = %min_x + getWord(MissionArea.area, 2);
   %max_y = %min_y + getWord(MissionArea.area, 3);
   %x = getWord(%obj.getPosition(), 0);
   %y = getWord(%obj.getPosition(), 1);
   %vx = 0;%vy = 0;%vz = 0;
   if (%x<(%min_x+10)) %vx = %force;
   if (%y<(%min_y+10)) %vy = %force;
   if (%x>(%max_x-10)) %vx = -%force;
   if (%y>(%max_y-10)) %vy = -%force;
   %vec = %vx @ " " @ %vy @ " " @ %vz;
   %obj.setVelocity(%vec);
   messageClient(%obj.client,"","\c4**WARNING Bouncing you back to mission area!**");
}

function Armor::onLeaveMissionAreaViaRoof(%this, %obj)
{
%obj.client.onLeaveMissionArea();
%force = MissionArea.bounce;
%min_x = getWord(MissionArea.area, 0);
%min_y = getWord(MissionArea.area, 1);
%max_x = %min_x + getWord(MissionArea.area, 2);
%max_y = %min_y + getWord(MissionArea.area, 3);
%x = getWord(%obj.getPosition(), 0);
%y = getWord(%obj.getPosition(), 1);
%vx = 0; %vy = 0; %vz = %force * -1;
if (%x<(%min_x+10)) %vx = %force;
if (%y<(%min_y+10)) %vy = %force;
if (%x>(%max_x-10)) %vx = -%force;
if (%y>(%max_y-10)) %vy = -%force;
%vec = %vx @ " " @ %vy @ " " @ %vz;
%obj.setVelocity(%vec);
}

function Armor::onEnterMissionArea(%this, %obj)
{
   // Inform the client
   %obj.client.onEnterMissionArea();
   messageClient(%obj.client,"","\c4**Welcome back to the mission area!**");
}

//-----------------------------------------------------------------------------

function Armor::onEnterLiquid(%this, %obj, %coverage, %type)
{
   switch(%type)
   {
      case 0: //Water
      case 1: //Ocean Water
      case 2: //River Water
      case 3: //Stagnant Water
      case 4: //Lava
         %obj.setDamageDt(%this, $DamageLava, "Lava");
      case 5: //Hot Lava
         %obj.setDamageDt(%this, $DamageHotLava, "Lava");
      case 6: //Crusty Lava
         %obj.setDamageDt(%this, $DamageCrustyLava, "Lava");
      case 7: //Quick Sand
   }
}

function Armor::onLeaveLiquid(%this, %obj, %type)
{
   %obj.clearDamageDt();
}


//-----------------------------------------------------------------------------

function Armor::onTrigger(%this, %obj, %triggerNum, %val)
{
   // This method is invoked when the player receives a trigger
   // move event.  The player automatically triggers slot 0 and
   // slot one off of triggers # 0 & 1.  Trigger # 2 is also used
   // as the jump key.
}
