//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2003 ToRK / 3D-Diggers
// Portions Copyright (c) 2001 by GarageGames.Com, Sierra Online, Inc.
//-----------------------------------------------------------------------------
 $PointsForDestruction = 1000;
//*************************************
// Destroyables by 3D-Diggers/ToRK. Modificed to a class by MGT
//*************************************

//*************************************++
// Damage sounds
//*************************************++

function Destroyables::DamageSound(%obj)
{
	if(%obj.soundfile $= "")
       %obj.soundfile = DestroyablesHitSound;
	if (!alxIsPlaying(%obj.audiohandle))
   {
      //%obj.audiohandle = alxPlay(%obj.soundfile);
   }
}

//**************************************
// Explosion
//**************************************
datablock AudioProfile(DestroyExplosionSound)
{
   filename = "fps/data/sound/barrel/explode3.ogg";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(DestroyablesHitSound)
{
   filename = "fps/data/sound/barrel/hit1.ogg";
   description = AudioDefault3d;
   preload = true;
};
datablock ParticleData(DestroyablesExplosionParticle)
{
   textureName          = "~/data/specialfx/smoke";
   dragCoefficient      = 2;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 150;
   colors[0]     = "0.56 0.56 0.56 1.0";
   colors[1]     = "0.26 0.36 0.36 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 1.0;
};

datablock ParticleEmitterData(DestroyablesExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "DestroyablesExplosionParticle";
};

datablock ParticleData(DestroyablesExplosionSmoke)
{
   textureName          = "~/data/specialfx/smoke";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.25;
   constantAcceleration = -0.80;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 300;
   useInvAlpha =  false;
   spinRandomMin = -80.0;
   spinRandomMax =  80.0;

   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.2 0.2 0.2 1.0";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 1.0;
   sizes[1]      = 1.5;
   sizes[2]      = 2.0;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(DestroyablesExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 220;
   particles = "DestroyablesExplosionSmoke";
};

datablock ParticleData(DestroyablesExplosionSparks)
{
   textureName          = "~/data/specialfx/spark";
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 350;

   colors[0]     = "0.30 0.30 0.30 1.0";
   colors[1]     = "0.30 0.30 0.30 1.0";
   colors[2]     = "0.10 0.10 0.10 0.0";

   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
   sizes[2]      = 0.25;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(DestroyablesExplosionSparksEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 13;
   velocityVariance = 6.75;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "DestroyablesExplosionSparks";
};

datablock ExplosionData(DestroyablesExplosion)
{
   soundProfile  = DestroyExplosionSound;
   lifeTimeMS = 1800;
   explosionShape = "~/data/shapes/weapons/effect_plasma_explosion.dts";
   playSpeed = 1.5;
   faceViewer = true;
   debrisThetaMin = 10;
   debrisThetaMax = 80;
   debrisNum = 3;
   debrisNumVariance = 1;
   debrisVelocity = 20.0;
   debrisVelocityVariance = 5.0;
   shakeCamera = true;
   camShakeFreq = "11.0 13.0 9.0";
   camShakeAmp = "40.0 40.0 40.0";
   camShakeDuration = 0.7;
   camShakeRadius = 25.0;
};

//*****************************************+
// specific decals
//*****************************************+
datablock DecalData(DestroyablesBulletHoleData)
{
   sizeX       = 0.045;
   sizeY       = 0.045;
   textureName = "fps/data/specialfx/schuss";
};


//*****************************************+
// debris and building1 shapes
//*****************************************+

datablock DebrisData(DestroyablesShapeDebris)
{
	explodeOnMaxBounce = false;
	elasticity = 0.1;
	friction = 0.6;
	lifetime = 12.0;
	lifetimeVariance = 1.5;
	minSpinSpeed = 40;
	maxSpinSpeed = 220;
	numBounces = 3;
	bounceVariance = 1.5;
	staticOnMaxBounce = true;
	gravModifier = 1.0;
	useRadiusMass = true;
	baseRadius = 1;
	velocity = 13.0;
	velocityVariance = 3.0;
};

datablock StaticShapeData(DestroyablesDestroyedShape)
{
   className = Destroyables;
   category = "Destroyables";
   shapeFile = "~/data/shapes/shapes/destroyables/woodbarrel/woodbarrel01_broken2.dts";
   renderWhenDestroyed = true;

   // Damage
   maxDamage = 100;
   destroyedLevel = 100;
   destroyable = "1";

   //Explosion
   explosion = DestroyablesExplosion;
   explosionDamage = 4.5;
   explosionRadius = 11.0;

   //Number of Mesh datablocks and number of fragments to toss
   DamageMeshName = "DestroyablesDestroyDamageMesh";
   numDamageMeshes = "1";
   numDamageFragments = "35";

   // Debris
   decalData = DestroyablesBulletHoleData;
   debrisShapeName = "~/data/shapes/destroyables/woodbarrel/woodbarrel01_debris1.dts";
   debris = DestroyablesShapeDebris;
};

datablock StaticShapeData(DestroyablesBaseShape)
{
   className = Destroyables;
   category = "Destroyables";
   destroyable = "1";
   shapeFile = "~/data/shapes/destroyables/woodbarrel/woodbarrel01.dts";
   decalData = DestroyablesBulletHoleData;
   nextObject = "DestroyablesDestroyedShape";
   
   // Destroyable stats
   mass = 12.8;
   maxDamage = 140;
   destroyedLevel = 140;
   
   // Explosion
   explosion = DestroyablesExplosion;
   explosionDamage = 8.5;
   explosionRadius = 12.0;

   // Fragments
   DamageMeshName = "DestroyablesDestroyDamageMesh";
   numDamageMeshes = "1";
   numDamageFragments = "40";

   // Debris
   debrisShapeName = "~/data/shapes/destroyables/woodbarrel/woodbarrel01_debris1.dts";
   debris = DestroyablesShapeDebris;
   renderWhenDestroyed = true;
};

function Destroyables::onAdd(%this,%obj)
{ %obj.audiohandle = 0; }

function StaticShapeData::create(%block)
{
   %obj = new StaticShape()
   {
      dataBlock = %block;
   };
   return(%obj);
}

//*****************************
// Fragments
//*****************************

// fragment 0
datablock ShapeBaseImageData(DestroyablesDamageMeshImage0)
{
   shapeFile = "~/data/shapes/destroyables/woodbreak/break01.dts";
   item = DestroyablesDestroyDamageMesh0;
   mountPoint = 0;
   offset = "0 0.16 0";
};
datablock ItemData(DestroyablesDestroyDamageMesh0)
{
   className = "DestroyablesMesh";
   image = DestroyablesDamageMeshImage0;
   shapeFile = "~/data/shapes/destroyables/woodbreak/break01.dts";
   mass = 3.5;
   elasticity = 0.1;
   friction = 0.7;
   pickUpName = "a wood mesh";
   maxInventory = 2;
};

//*********************************
// Stage 1
//*********************************

function Destroyables::onCollision(%this,%obj,%col,%vec,%speed)
{

  %damage = %col.getDatablock().mass * %speed /500;
  %obj.applyDamage(mFloor(%damage));
}

function Destroyables::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
   if(%obj.destroyable || %obj.getDatablock().destroyable)
   {
	   %currDamage = %obj.getDamageLevel();
	   %obj.applyDamage(%damage);
   }
   if(%obj.getDamageState() $= "Destroyed") {
      if(%obj.pointsForCapture){
        %sourceObject.client.incTeamScore(%obj.pointsForCapture);
        %sourceObject.client.incScore(%obj.pointsForCapture);
      } else if (%obj.pointsForDestruction) {
        if (%obj.getTeam() == %sourceObject.client.team.teamID)
            %points -= %obj.pointsForDestruction;
        else
            %points = %obj.pointsForDestruction;
            
        %sourceObject.client.incTeamScore(%points);
        %sourceObject.client.incScore(%points);
      }
   }
}

function Destroyables::onDamage(%this, %obj)
{
   %damage = %obj.getDamageLevel();
   if (%damage >= %this.destroyedLevel)
   {
      if(%obj.getDamageState() !$= "Destroyed")
      {
         //if(%obj.respawnTime !$= "")
         //   %obj.marker.schedule = %obj.marker.data.schedule(%obj.respawnTime, "respawn", %obj.marker);
         %obj.setDamageState(Destroyed);
      }
   }
   else
   {
      %this.DamageSound(%obj);
      if(%obj.getDamageState() !$= "Enabled")
         %obj.setDamageState(Enabled);
   }
}

function Destroyables::onDestroyed(%this, %obj, %prevState)
{
   %pos = %obj.getPosition();
   radiusDamage(%obj,%pos,%obj.explosionDamage,%obj.explosionRadius,"Building",0);
   
   %newPosition = %obj.getPosition();
   %finalPos = %obj.getTransform();
   %newScale = %obj.scale;
   if (%this.nextObject !$= ""){
      %brokenshape = new StaticShape() {
         position = %newPosition;
         rotation = "1 0 0 0";
         dataBlock = %this.nextObject;
         scale = "1 1 1";
      };
      %brokenshape.setTransform(%finalPos);
   }

   // now spread the meshes:
   for(%j = 0; %j < %obj.numDamageFragments; %j++)
   {
   	%rand = getRandom(%obj.numDamageMeshes-1);
   	%newBlock = %obj.DamageMeshName @ %rand;
   	%newRot = getRandom(1) SPC getRandom(1) SPC getRandom(1) SPC getRandom(360);
   	%flingee = new Item("WoodMesh"){
   		dataBlock = %newBlock;
   		static = "false";
   		rotate = "false";
   		rotation = %newRot;
   		scale = "0.2 0.2 0.2";
   	};
    	%flingee.collideable = "false";
     	MissionCleanup.add(%flingee);
   	%windowTransform = %obj.getTransform();
   	// do a random switch between sides so that the pieces really spread in both directions from the window...
   	if(%rand % 2 == 0)
   	{
         VectorAdd(%windowTransform,"3 3 0");
   	}
   	else
   	{
         VectorAdd(%windowTransform,"-3 -3 0");
   	}
   	// make sure the initial position is above the ground:
   	if(%winZ < 1.0)
         VectorAdd(%windowTransform,"0 0 3");
   	%flingee.position = %windowTransform;
   	%xVel = 100.0 - (getRandom() * 160.0);
   	%yVel = 80.0 - (getRandom() * 160.0);
   	%zVel = (getRandom() * 80.0) + 30.0;
   	%flingVel = %xVel SPC %yVel SPC %zVel;
   	%flingee.applyImpulse(%flingee.getTransform(), %flingVel);
   	%flingee.damage(0, %obj.getPosition(), 0.4, $DamageType::Explosion);
   	// delete pieces after some time...
      %flingee.schedule(5000, "delete");
   }
   // delete object
   %obj.schedule(100, "delete");
}


