//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2001 GarageGames.Com
// Portions Copyright (c) 2001 by Sierra Online, Inc.
//-----------------------------------------------------------------------------

// Timeouts for corpse deletion.
$CorpseTimeoutValue = 2 * 1000;//was 22


// Damage Rate for entering Liquid
$DamageLava       = 0.01;
$DamageHotLava    = 0.01;
$DamageCrustyLava = 0.01;

//
$PlayerDeathAnim::TorsoFrontFallForward = 1;
$PlayerDeathAnim::TorsoFrontFallBack = 2;
$PlayerDeathAnim::TorsoBackFallForward = 3;
$PlayerDeathAnim::TorsoLeftSpinDeath = 4;
$PlayerDeathAnim::TorsoRightSpinDeath = 5;
$PlayerDeathAnim::LegsLeftGimp = 6;
$PlayerDeathAnim::LegsRightGimp = 7;
$PlayerDeathAnim::TorsoBackFallForward = 8;
$PlayerDeathAnim::HeadFrontDirect = 9;
$PlayerDeathAnim::HeadBackFallForward = 10;
$PlayerDeathAnim::ExplosionBlowBack = 11;

//-----------------------------------------------------------------------------
// Player methods
//-----------------------------------------------------------------------------

//----------------------------------------------------------------------------

function Player::kill(%this, %damageType)
{
   %this.damage(0, %this.getPosition(), 10000, %damageType);
}


//----------------------------------------------------------------------------

function Player::mountVehicles(%this,%bool)
{
   // If set to false, this variable disables vehicle mounting.
   %this.mountVehicle = %bool;
}

function Player::isPilot(%this)
{
   %vehicle = %this.getObjectMount();
   // There are two "if" statements to avoid a script warning.
   if (%vehicle)
      if (%vehicle.getMountNodeObject(0) == %this)
         return true;
   return false;
}


//----------------------------------------------------------------------------

function Player::playDeathAnimation(%this)
{
   if (%this.deathIdx++ > 11)
      %this.deathIdx = 1;
   %this.setActionThread("Death" @ %this.deathIdx);
}

function Player::playCelAnimation(%this,%anim)
{
   if (%this.getState() !$= "Dead")
      %this.setActionThread("cel"@%anim);
}


//----------------------------------------------------------------------------

function Player::playDeathCry( %this )
{
   %client = %this.client;
   //playTargetAudio( %client.target, "replaceme", AudioClosest3d, false );
}

function Player::playPain( %this )
{
   %client = %this.client;
   //playTargetAudio( %client.target, "replaceme", AudioClosest3d, false);
}

//fix for remounting
function Player::setMountVehicle(%this, %val)
{
 %this.mountVehicle = %val;
}

// phdana strafe anims ->
//datablock StaticShapeData(PlayerThrustFlame)
//{
//   shapeFile = "~/data/shapes/player/flames.dts";
//   preload = true;
//};

function PlayerThrustFlame::onAdd(%this,%obj)
{
   error("FLAME added ");
   %obj.playThread(0,"ambient");
   %obj.playThread(1,"Flame_on");
   %obj.pauseThread(1);
   %obj.setThreadPos(1,0.0);
}

function PlayerData::OLDonAdd(%this,%obj)
{
   error("PLAYER on add");

   // ok create two objects and hang onto them
   // we delete them when this object is deleted
   // in either Armor::onRemove() or Mecha::onRemove()
   %obj.leftFlame = new StaticShape()
   {
      dataBlock = PlayerThrustFlame;
   };
   %obj.mountObject(%obj.leftFlame,8);
   MissionCleanup.add(%obj.leftFlame);

   %obj.rightFlame = new StaticShape()
   {
      dataBlock = PlayerThrustFlame;
   };
   %obj.mountObject(%obj.rightFlame,9);
   MissionCleanup.add(%obj.rightFlame);

   // tell player object about these flames...
   %obj.setFlames(%obj.leftFlame,%obj.rightFlame);

   error("MECH" SPC %this SPC "HAS STRAFE SET-UP");
}

function PlayerData::OLDonRemove(%this,%obj)
{
   // tell C++ code they are no-more
   %obj.setFlames(0,0);
   if (isObject(%obj.leftFlame))
      %obj.leftFlame.delete();
   if (isObject(%obj.rightFlame))
      %obj.rightFlame.delete();
}

function PlayerData::onAdd(%this,%obj)
{
   // the flames are inside the shape itself

   %obj.playThread(0,"ambient");
   %obj.playThread(1,"l_flame");
   %obj.pauseThread(1);
   %obj.setThreadPos(1,0.0);

   %obj.playThread(2,"r_flame");
   %obj.pauseThread(2);
   %obj.setThreadPos(2,0.0);
   %obj.MaxCounters = 36;
   //%obj.client.setCounterAmountHud(%obj.MaxCounters);
}

function PlayerData::onRemove(%this,%obj)
{
  // nothing to do here under this scheme
}
// <- phdana strafe anims
function Player::onDeath(%this, %sourceObject, %sourceClient, %damageType, %location)
{
  %client = %this.client;
  %client.onDeath(%sourceObject, %sourceClient, %damageType, %location);
  if($Server::ServerType $= "SinglePlayer")
    youLose();
}
