//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2003 ToRK / 3D-Diggers
// Portions Copyright (c) 2001 by GarageGames.Com, Sierra Online, Inc.
//-----------------------------------------------------------------------------

//*************************************
// Destroyable barrel by 3D-Diggers/ToRK
//*************************************

datablock ParticleData(BarrelDestroyExplosionParticle)
{
   textureName          = "~/data/specialfx/smoke1";
   dragCoefficient      = 2;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 150;

   colors[0]     = "0.56 0.56 0.56 1.0";
   colors[1]     = "0.26 0.36 0.36 0.0";

   sizes[0]      = 0.5;
   sizes[1]      = 1.0;
};

datablock ParticleEmitterData(BarrelDestroyExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "BarrelDestroyExplosionParticle";
};

datablock ParticleData(BarrelDestroyExplosionSmoke)
{
   textureName          = "~/data/specialfx/smoke1";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.25;
   constantAcceleration = -0.80;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 300;
   useInvAlpha =  false;
   spinRandomMin = -80.0;
   spinRandomMax =  80.0;

   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.2 0.2 0.2 1.0";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 1.0;
   sizes[1]      = 1.5;
   sizes[2]      = 2.0;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(BarrelDestroyExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 220;
   particles = "BarrelDestroyExplosionSmoke";
};

datablock ParticleData(BarrelDestroyExplosionSparks)
{
   textureName          = "~/data/specialfx/spark";
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 350;

   colors[0]     = "0.30 0.30 0.30 1.0";
   colors[1]     = "0.30 0.30 0.30 1.0";
   colors[2]     = "0.10 0.10 0.10 0.0";

   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
   sizes[2]      = 0.25;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(BarrelDestroyExplosionSparkEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 13;
   velocityVariance = 6.75;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "BarrelDestroyExplosionSparks";
};

datablock ExplosionData(BarrelDestroyExplosion)
{
//   soundProfile   = BarrelDestroyExplosionSound;
   lifeTimeMS = 1800;

   explosionShape = "~/data/shapes/weapons/effect_plasma_explosion.dts";
   playSpeed = 1.5;
//   soundProfile = VehicleExplosionSound;
   faceViewer = true;
   debrisThetaMin = 10;
   debrisThetaMax = 80;
   debrisNum = 3;
   debrisNumVariance = 1;
   debrisVelocity = 20.0;
   debrisVelocityVariance = 5.0;
   shakeCamera = true;
   camShakeFreq = "11.0 13.0 9.0";
   camShakeAmp = "40.0 40.0 40.0";
   camShakeDuration = 0.7;
   camShakeRadius = 25.0;
};

//*****************************************+
// specific decals
//*****************************************+
datablock DecalData(BarrelBulletHoleData)
{
   sizeX       = 0.045;
   sizeY       = 0.045;
   textureName = "~/data/specialfx/schuss";
};


//*****************************************+
// debris and barrel shapes
//*****************************************+

datablock DebrisData(BarrelDestroyShapeDebris)
{
	explodeOnMaxBounce = false;

	elasticity = 0.1;
	friction = 0.6;

	lifetime = 12.0;
	lifetimeVariance = 1.5;

	minSpinSpeed = 40;
	maxSpinSpeed = 220;

	numBounces = 3;
	bounceVariance = 1.5;

	staticOnMaxBounce = true;
	gravModifier = 1.0;

	useRadiusMass = true;
	baseRadius = 1;

	velocity = 13.0;
	velocityVariance = 3.0;
};

datablock StaticShapeData(BrokenBarrelDestroyShape1)
{
   category = "Barrels";
   className = Destroyables;
   destroyable = "1";
   shapeFile = "~/data/shapes/destroyables/woodbarrel/woodbarrel01_broken.dts";
   mass = 9.8;
   maxDamage = 100;
   destroyedLevel = 100;
   explosion = BarrelDestroyExplosion;
   numDamageMeshes = "5";
   numDamageFragments = "35";
   explosionDamage = 4.5; 
   explosionRadius = 11.0; 
   decalData = BarrelBulletHoleData;
   debrisShapeName = "~/data/shapes/destroyables/woodbarrel/woodbarrel01_debris1.dts";
   debris = BarrelDestroyShapeDebris;
   renderWhenDestroyed = true;
};

datablock StaticShapeData(BarrelDestroyShape)
{
   category = "Barrels";
   className = Destroyables;
   destroyable = "1";
   nextObject = "BrokenBarrelDestroyShape1";
   shapeFile = "~/data/shapes/destroyables/woodbarrel/woodbarrel01.dts";
   mass = 12.8;
   maxDamage = 140;
   destroyedLevel = 140;
   explosion = BarrelDestroyExplosion;
   numDamageMeshes = "6";
   numDamageFragments = "40";
   explosionDamage = 8.5; 
   explosionRadius = 12.0; 
   decalData = BarrelBulletHoleData;
   DamageMeshName = "DestroyableDestroyDamageMesh";
   debrisShapeName = "~/data/shapes/destroyables/woodbarrel/woodbarrel01_debris1.dts";
   debris = BarrelDestroyShapeDebris;
   renderWhenDestroyed = true;
};

//*****************************
// Fragments
//*****************************

// fragment 0
datablock ShapeBaseImageData(BarrelDestroyDamageMeshImage0)
{
   shapeFile = "~/data/shapes/destroyables/woodbreak/break01.dts";
   item = BarrelDestroyDamageMesh0;
   mountPoint = 0;
   offset = "0 0.16 0";
};
datablock ItemData(BarrelDestroyDamageMesh0)
{
   className = "BarrelDestroyMesh0";
   image = BarrelDestroyDamageMeshImage0;
   shapeFile = "~/data/shapes/destroyables/woodbreak/break01.dts";
   mass = 3.5;
   elasticity = 0.1;
   friction = 0.7;
   pickUpName = "a wood mesh";
   maxInventory = 2;
};
