//********************************************
// Default Emitter Data
//********************************************
datablock ParticleData(DefaultParticle)
{
   textureName          = "~/data/shapes/particles/sprite01";
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.3;   // rises slowly
   inheritedVelFactor   = 0.00;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 250;
   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0.8 0.6 0.0 0.1";
   colors[1]     = "0.8 0.6 0.0 0.1";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 1.0;
   sizes[1]      = 1.0;
   sizes[2]      = 5.0;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};
datablock ParticleEmitterData(DefaultEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 5;

   ejectionVelocity = 0.25;
   velocityVariance = 0.10;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = "DefaultParticle";
};


datablock ParticleEmitterNodeData(DefaultEmitterNode)
{
   timeMultiple = 1;
};

datablock ParticleEmitterNodeData(DoubleTimeEmitterNode)
{
   timeMultiple = 2;
};

datablock ParticleEmitterNodeData(HalfTimeEmitterNode)
{
   timeMultiple = 0.5;
};

//********************************************
// Fountain Emitters
//********************************************

datablock ParticleData(fountain01)
{
   textureName          = "~/data/shapes/particles/sprite01";
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -1.5;   // gerade hoch
   windCoefficient = 0;
   inheritedVelFactor   = 0.00;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 25;
   useInvAlpha = false;
   spinRandomMin = -0.0;
   spinRandomMax = 0.0;

   colors[0]     = "0.3 0.5 0.5 0.1";
   colors[1]     = "0.3 0.5 0.5 0.2";
   colors[2]     = "0.3 0.5 0.5 0.2";

   sizes[0]      = 0.6;
   sizes[1]      = 0.9;
   sizes[2]      = 1.5;

   times[0]      = 0.1;
   times[1]      = 0.3;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(fountain01Emitter)
{
   ejectionPeriodMS = 60;
   periodVarianceMS = 0;

   ejectionVelocity = 0.0;
   velocityVariance = 0.0;

   thetaMin         = 0.0;
   thetaMax         = 0.0;

   particles = fountain01;
};

//---------------------------
datablock ParticleData(fountain01a)
{
   textureName          = "~/data/shapes/particles/wasser03a";
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = 1.5;  // ausstossrichtung
   windCoefficient = 1;
   inheritedVelFactor   = 1.00;
   lifetimeMS           = 1800;
   lifetimeVarianceMS   = 25;
   useInvAlpha = false;
   spinRandomMin = -30.0;  // rotation
   spinRandomMax = 30.0;   // rotation

   colors[0]     = "1.0 1.0 1.0 0.3";
   colors[1]     = "1.0 1.0 1.0 0.3";
   colors[2]     = "1.0 1.0 1.0 0.5";

   sizes[0]      = 1.0;    // grsse des partikels
   sizes[1]      = 4.5;
   sizes[2]      = 5.5;

   times[0]      = 0.3;
   times[1]      = 0.8;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(fountain01aEmitter)
{
   ejectionPeriodMS = 100;    // zeit des ausstosses pro partikel
   periodVarianceMS = 0;

   ejectionVelocity = 0.50;
   velocityVariance = 0.50;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   particles = fountain01a;
};

//-------------------mnneken Piss--------------//
datablock ParticleData(strull)
{
   textureName          = "~/data/shapes/particles/sprite03";
   dragCoeffiecient     = 1.0;
   gravityCoefficient   = 0.6;  // ausstossrichtung
   windCoefficient = 1.2;
   inheritedVelFactor   = 0.00;
   lifetimeMS           = 850;
   lifetimeVarianceMS   = 100;
   useInvAlpha = false;
   spinRandomMin = -0.0;  // rotation
   spinRandomMax = 0.0;   // rotation

   colors[0]     = "0.5 0.5 0.5 0.3";
   colors[1]     = "1.0 1.0 1.0 0.3";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 0.2;    // grsse des partikels
   sizes[1]      = 0.7;
   sizes[2]      = 1.5;

   times[0]      = 0.3;
   times[1]      = 0.8;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(strullEmitter)
{
   ejectionPeriodMS = 25;    // zeit des ausstosses pro partikel
   periodVarianceMS = 0;

   ejectionVelocity = 0.50;
   velocityVariance = 0.50;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   particles = strull;
};

//----------------------mini fountain------------//
datablock ParticleData(minifountain)
{
   textureName          = "~/data/shapes/particles/sprite02";
   dragCoeffiecient     = 1.0;
   windCoefficient = 0;
   gravityCoefficient   = -0.2;  // ausstossrichtung
   inheritedVelFactor   = 1.00;
   lifetimeMS           = 1800;
   lifetimeVarianceMS   = 200;
   useInvAlpha = false;
   spinRandomMin = -90.0;  // rotation
   spinRandomMax = 90.0;   // rotation

   colors[0]     = "1.0 1.0 0.7 0.1";
   colors[1]     = "1.0 1.0 0.7 0.1";
   colors[2]     = "0.0 0.0 1.0 0.0";

   sizes[0]      = 0.5;    // grsse des partikels
   sizes[1]      = 1.0;
   sizes[2]      = 4.0;

   times[0]      = 0.7;
   times[1]      = 0.8;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(minifountainEmitter)
{
   ejectionPeriodMS = 50;    // zeit des ausstosses pro partikel
   periodVarianceMS = 10;

   ejectionVelocity = 0.0;
   velocityVariance = 0.0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   particles = minifountain;
};

//---------------------------
datablock ParticleData(miniFountain02)
{
    dragCoefficient = 3;
    gravityCoefficient = 0.9;
    windCoefficient = 1.0;
    inheritedVelFactor = 0.780822;
    constantAcceleration = -1.54118;
    lifetimeMS = 3000;
    lifetimeVarianceMS = 300;
    useInvAlpha = 0;
    spinRandomMin = -0;
    spinRandomMax = 0;
    textureName = "~/data/shapes/particles/sprite03";
    spinSpeed = 0;
    times[0] = 0;
    times[1] = 0.556863;
    times[2] = 1;
    colors[0] = "1.0 1.0 0.7 0.1";
    colors[1] = "1.0 1.0 0.7 0.1";
    colors[2] = "0.000000 0.000000 0.000000 0.000000";
    sizes[0] = 1.5;
    sizes[1] = 3;
    sizes[2] = 5;
};

datablock ParticleEmitterData(miniFountain02Emitter)
{
    ejectionPeriodMS = 50;
    periodVarianceMS = 0.5;
    ejectionVelocity = 3;
    velocityVariance = 0.5;
    ejectionOffset = 1.0;
    thetaMin = 0;
    thetaMax = 80;
    phiReferenceVel = 245;
    phiVariance = 319;
    overrideAdvances = 0;
    orientParticles= 0;
    orientOnVelocity = 1;
    particles = "miniFountain02";
};


