//********************************************
// FOUNTAINS
// by 3D-Diggers and Stefan "Beffy" Moises
// (c) 2003 3D-Diggers
//********************************************

// utility function in case it's missing
function StaticShapeData::create(%block)
{
   %obj = new StaticShape()
   {
      dataBlock = %block;
   };
   return(%obj);
}

//********************************************
// FOUNTAIN 1
//********************************************
datablock StaticShapeData(Fountain01Shape)
{
   category = "Fountains";
   shapeFile = "~/data/shapes/park/fountain1.dts";
};
function Fountain01Shape::onAdd(%this,%obj)
{
   schedule(1000,0,"fountainAfterAdd",%obj);
}
function fountainAfterAdd(%obj)
{
   // get position
   %finalPos1 = %obj.getTransform();
   %finalPos2 = %obj.getTransform();
   // adjust 1st position
   %x = getWord(%finalPos1,0);
   %y = getWord(%finalPos1,1);
   %z = getWord(%finalPos1,2);
   %z += 2.4;
   %finalPos1 = %x SPC %y SPC %z;
   // create 1st emitter
   %fountainEmitter1 = new ParticleEmitterNode(FountainEmitter01a) {
      position = %finalPos1;
      rotation = "1 0 0 0";
      dataBlock = "DefaultEmitterNode";
      emitter = "fountain01Emitter";
      scale = "1.0 1.0 1.0";
      velocity = "1";
   };
   // place 1st emitter
   %fountainEmitter1.setTransform(%finalPos1);

   // adjust 2nd position
   %x = getWord(%finalPos2,0);
   %y = getWord(%finalPos2,1);
   %z = getWord(%finalPos2,2);
   %z += 10.2;
   %finalPos2 = %x SPC %y SPC %z;
   // create 2nd emitter
   %fountainEmitter2 = new ParticleEmitterNode(FountainEmitter01b) {
      position = %finalPos2;
      rotation = "1 0 0 0";
      dataBlock = "DefaultEmitterNode";
      emitter = "fountain01aEmitter";
      scale = "1.0 1.0 1.0";
      velocity = "1";
   };
   // place 2nd emitter
   %fountainEmitter2.setTransform(%finalPos2);

   // create simgroup
   %newGroup = new SimGroup("Fountain01Group");
   %newGroup.add(%fountainEmitter1);
   %newGroup.add(%fountainEmitter2);
   %newGroup.add(%obj);
   EWorldEditor.selectObject(%obj);
   EWorldEditor.selectObject(%fountainEmitter1);
   EWorldEditor.selectObject(%fountainEmitter2);
}

//********************************************
// FOUNTAIN 2
//********************************************
datablock StaticShapeData(Fountain02Shape)
{
   category = "Fountains";
   shapeFile = "~/data/shapes/park/fountain2.dts";
};
function Fountain02Shape::onAdd(%this,%obj)
{
   schedule(1000,0,"fountain02AfterAdd",%obj);
}
function fountain02AfterAdd(%obj)
{
   // get position
   %finalPos1 = %obj.getTransform();
   %finalPos2 = %obj.getTransform();
   // adjust 1st position
   %x = getWord(%finalPos1,0);
   %y = getWord(%finalPos1,1);
   %z = getWord(%finalPos1,2);
   %z += 2.0;
   %finalPos1 = %x SPC %y SPC %z;
   // create 1st emitter
   %fountainEmitter1 = new ParticleEmitterNode(FountainEmitter02a) {
      position = %finalPos1;
      rotation = "1 0 0 0";
      dataBlock = "DefaultEmitterNode";
      emitter = "minifountainEmitter";
      scale = "1.0 1.0 1.0";
      velocity = "1";
   };
   // place 1st emitter
   %fountainEmitter1.setTransform(%finalPos1);

   // adjust 2nd position
   %x = getWord(%finalPos2,0);
   %y = getWord(%finalPos2,1);
   %z = getWord(%finalPos2,2);
   %z += 7.2;
   %finalPos2 = %x SPC %y SPC %z;
   // create 2nd emitter
   %fountainEmitter2 = new ParticleEmitterNode(FountainEmitter02b) {
      position = %finalPos2;
      rotation = "1 0 0 0";
      dataBlock = "DefaultEmitterNode";
      emitter = "miniFountain02Emitter";
      scale = "1.0 1.0 1.0";
      velocity = "1";
   };
   // place 2nd emitter
   %fountainEmitter2.setTransform(%finalPos2);

   // create simgroup
   %newGroup = new SimGroup("Fountain02Group");
   %newGroup.add(%fountainEmitter1);
   %newGroup.add(%fountainEmitter2);
   %newGroup.add(%obj);
   EWorldEditor.selectObject(%obj);
   EWorldEditor.selectObject(%fountainEmitter1);
   EWorldEditor.selectObject(%fountainEmitter2);
}

//********************************************
// FOUNTAIN 3
//********************************************
datablock StaticShapeData(Fountain03Shape)
{
   category = "Fountains";
   shapeFile = "~/data/shapes/park/fountain3.dts";
};
function Fountain03Shape::onAdd(%this,%obj)
{
   schedule(1000,0,"fountain03AfterAdd",%obj);
}
function fountain03AfterAdd(%obj)
{
   // get position
   %finalPos = %obj.getTransform();
   // adjust position
   %x = getWord(%finalPos,0);
   %y = getWord(%finalPos,1);
   %z = getWord(%finalPos,2);
   %x -= 0.3;
   %y -= 0.5;
   %z += 3.4;
   %finalPos = %x SPC %y SPC %z;
   // create emitter
   %fountainEmitter = new ParticleEmitterNode(FountainEmitter03) {
      position = %finalPos;
      rotation = "1 0 0 0";
      dataBlock = "DefaultEmitterNode";
      emitter = "strullEmitter";
      scale = "1.0 1.0 1.0";
      velocity = "1";
   };
   // place emitter
   %fountainEmitter.setTransform(%finalPos);
   // create simgroup
   %newGroup = new SimGroup("Fountain03Group");
   %newGroup.add(%fountainEmitter);
   %newGroup.add(%obj);
   EWorldEditor.clearSelection();
   EWorldEditor.selectObject(%obj);
   EWorldEditor.selectObject(%fountainEmitter);
}
