//-----------------------------------------------------------
//NEW Health TRIGGER
//--------------------------------------------------------------
//--------------------------------------------------------------
// Trigger datablock
//--------------------------------------------------------------
datablock TriggerData(HealthTrigger)
{
    tickPeriodMS = 100;
};


//--------------------------------------------------------------
// Events
//--------------------------------------------------------------
function HealthTrigger::onEnterTrigger( %this, %trigger, %obj )
{
   // This method is called whenever an object enters the %trigger
   // area, the object is passed as %obj.  The default onEnterTrigger
   // method (in the C++ code) invokes the ::onTrigger(%trigger,1) method on
   // every object (whatever it's type) in the same group as the trigger.
   Parent::onEnterTrigger( %this, %trigger, %obj );

   //echo("ENTERING A HealthTrigger TRIGGER");
   // check to see if the lad who is in this trigger is on the our team
   if( %obj.client.team.teamId $= %trigger.team )
   {
    //echo("This is your HealthTrigger");
    //echo("you have " @ %obj.getDamageLevel() @ " health");

		if (%obj.getDamageLevel() > 0)
           %obj.setWhiteOut(1);

   }
}




function HealthTrigger::onTickTrigger( %this, %trigger )
{
   Parent::onTickTrigger( %this, %trigger );
   //echo("onTick A HealthTrigger TRIGGER");

   for (%i = 0; %i < %trigger.getNumObjects(); %i++)
   {
   		%obj = %trigger.getObject(%i);
   if( %obj.client.team.teamId $= %trigger.team )
   {
      // Dont heal the dead!
      if (%obj.getState() $= "Dead")
         return;
		if (%obj.getDamageLevel() > 0)
		{
         %currentLevel = %obj.getDamageLevel();
         %repairedDamage = %currentLevel - 7;
         %obj.setDamageLevel(%repairedDamage);

         }
	}
   }
}

function HealthTrigger::onLeaveTrigger( %this, %trigger, %obj )
{    //echo("leaving HealthTrigger trigger");
   // This method is called whenever an object leaves the %trigger
   // area, the object is passed as %obj.  The default onLeaveTrigger
   // method (in the C++ code) invokes the ::onTrigger(%trigger,0) method on
   // every object (whatever it's type) in the same group as the trigger.
   Parent::onLeaveTrigger( %this, %trigger, %obj );
}

