// phdana turrets ->

datablock DebrisData(TurretDebris)
{
	explodeOnMaxBounce = false;

	elasticity = 0.15;
	friction = 0.5;

	lifetime = 2.0;
	lifetimeVariance = 0.0;

	minSpinSpeed = 40;
	maxSpinSpeed = 200;

	numBounces = 5;
	bounceVariance = 0;

	staticOnMaxBounce = true;
	gravModifier = 1.0;

	useRadiusMass = true;
	baseRadius = 1;

	velocity = 30.0;
	velocityVariance = 12.0;
};

datablock TurretData(GenericTurret)
{
	category						= "Turrets";
    numPoints                       = 100;
    
	shapeFile						= "~/data/shapes/turrets/mav_cannon01.dts";
   maxDamage                       = 210;
   destroyedLevel                  = 110;
   disabledLevel                   = 0.84;
	debrisShapeName		   	        = "~/data/shapes/turrets/mav_cannon_debris.dts";
   debris                          = TurretDebris;
   renderWhenDestroyed             = false;
  	mountPose[0]					= sitting;
	numMountPoints					= 2;
	isProtectedMountPoint[0]		= true;
	cameraMaxDist					= 10;
	cameraOffset					= 2.5;
	maxEnergy						= 280;
	rechargeRate					= 0.8;
 	heat                            = 1.0;
  
    // turret specific stuff
    //minYaw = -90.0;
    //maxYaw = 90;
       maxInv[SmallTurretBarrel] = 1;
    // mounted by default in TurretData if specified
    barrelSlot                      = 0;
    barrel                          = SmallTurretGun;
};

datablock ShapeBaseImageData(SmallTurretGun)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/turrets/weapon.dts";
   mass = 15;
   //category					= "Turrets";  // you dont want to place these

   mountPoint = 0;
   offset = "0 0 0";

   projectile = acProjectile;
   projectileType = Projectile;
   correctMuzzleVector = true;   // not sure how this is used

    usesEnergy = true;
    fireEnergy = 10;
    minEnergy = 4;
   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
      // State transitions
   stateName[0]                     = "Activate";
   stateTimeoutValue[0]             = 0.01;
   stateTransitionOnTimeout[0]      = "Ready";
   //stateSound[0]                    = TurretSwitchSound;

   stateName[1]                     = "Ready";
   stateTransitionOnTriggerDown[1]  = "Fire";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Fire";
   stateTransitionOnTimeout[2]      = "Reload";
   stateTimeoutValue[2]             = 0.5;
   stateFire[2]                     = true;
   stateRecoil[2]                   = LightRecoil;
   stateAllowImageChange[2]         = false;
   stateSequence[2]                 = "Fire";
   //stateSound[2]                    = TurretGunFireSound;
   stateScript[2]                   = "onFire";

   stateName[3]                     = "Reload";
   stateTimeoutValue[3]             = 0.40;
   stateAllowImageChange[3]         = false;
   stateTransitionOnTimeout[3]      = "Ready";
   stateTransitionOnNoAmmo[3]       = "NoAmmo";

   stateName[4]                     = "NoAmmo";
   stateTransitionOnAmmo[4]         = "Reload";
   stateSequence[4]                 = "NoAmmo";
};
datablock ItemData(SmallTurretBarrel)
{
   // Mission editor category
   category = "Turret Barrel";

   // Hook into Item Weapon class hierarchy. The weapon namespace
   // provides common weapon handling functions in addition to hooks
   // into the inventory system.
   className = "Turret Barrel";

   // Basic Item properties
   shapeFile = "~/data/shapes/turrets/weapon.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

	// Dynamic properties defined by the scripts
	pickUpName = "a small Turret Barrel";
	image = SmallTurretGun;
};

// <- phdana turrets
function SmallTurretGun::onFire(%data, %obj, %slot)
{
	%projectile = %data.projectile;
	%muzzleVector = VectorAdd(%obj.getMuzzleVector(%slot),"0 0 0.01");
   %muzzleVelocity = VectorScale(%muzzleVector, %projectile.muzzleVelocity);

   if(%obj.getTeam() == -1)
   %obj.name =  "Turret";
   else
    %obj.name =   $Team[%obj.getTeam()].name @  " Turret";

        %p = new (%data.projectileType)() {
         dataBlock        = %data.projectile;
         initialVelocity  = %muzzleVelocity;
         initialDirection = %muzzleVector;
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         client           = %obj;
      };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;

   MissionCleanup.add(%p);

   return %p;
}


function GenericTurret::onAdd(%this,%obj)
{
    // we specified a barrel so the parent class does all the work
    // in fact we could remove this GenericTurret::onAdd() method completely
    Parent::onAdd(%this,%obj);

    // if you do not specify a barrel then you
    // need to do this...
    %turretSlot = 0;
    %obj.setEnergyLevel(%this.MaxEnergy);
    %obj.getMountedImage(%turretSlot);
    //echo("Created Generic Turret By hand");
    //%obj.mountImage(SmallTurretGun,%turretSlot);
    %obj.setInventory(SmallTurretBarrel,1);
    %obj.use(SmallTurretBarrel);
    if(%obj.team){
    %obj.setTeam(%obj.team);
    %weapon = getInventory(SmallTurretBarrel);
    %weapon.setTeam(%obj.team);
     }
}
