//------------------------------------------------------------------------------
// Beast MAV datablocks. Since DefaultMAV is actually the Beast mav
// No settings are set here. But if default mav is changed, this needs to be
// changed FIRST (so we keep original Beast values)

exec("~/data/shapes/player/fsHeavy/fsHeavy.cs");

datablock PlayerData(Beast : DefaultMAV)
{
   className = Mecha;
   shapeFile = "~/data/shapes/player/fsHeavy/fsHeavy.dts";
   
   heat =1.0;
   repairRate = 0.20;
   maxEnergy =  170;
   turnForce = 150;

   canObserve = true;
   cmdCategory = "Clients";

   debrisShapeName = "~/data/shapes/player/fsHeavy/fsheavy_debris.dts";
   debris = MechaDebris;
   explosion = MechaExplosion;
   explosionDamage = 125.0;
   explosionRadius = 15.0;
   renderWhenDestroyed = false;
   
   jetSound = ArmorJetSound;
   // Foot Prints
   decalData   = FSFootprint;
   decalOffset = 0.75;
   thrustSound = ArmorThrustSound;
   maxInv[Flag2] = 1;
   maxInv[BeastSecondaryAmmo1] = 240;
   maxInv[BeastSecondary1] = 1;
   maxInv[BeastSecondaryAmmo2] = 80;
   maxInv[BeastSecondary2] = 1;
   maxInv[BeastSecondaryAmmo3] = 30;
   maxInv[BeastSecondary3] = 1;
   maxInv[BeastPrimaryAmmo1] = 500;
   maxInv[BeastPrimary1] = 1;
   maxInv[BeastPrimaryAmmo2] = 300;
   maxInv[BeastPrimary2] = 1;
   //maxInv[BeastPrimaryAmmo3] = 100;
   maxInv[BeastPrimary3] = 1;
   maxInv[PredatorSpecial] = 1;
   enemyMapRadius = 300;

   //Names
   secondaryName = "BeastSecondary";
   primaryName = "BeastPrimary";
   // Defaults
   primaryNum = "2";
   secondaryNum = "2";
   //Number of Primary and Secondary Weapons
   primaryTotal = "3";
   secondaryTotal = "3";
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
   
   //Water Movement
   maxUnderwaterForwardSpeed = 16; // 80% of runforce
   maxUnderwaterBackwardSpeed = 15; // 90% of max water forward speed
   maxUnderwaterSideSpeed = 15; // 90% of max water forward speed
   heat =1.0;
   //Runforce is Acceleration. Which in code is Force/Mass. Mass is based off STANDARD VARIANT!! (3)
   //20 for Lights, 16(80%) for mediums, 13.2(66%) for heavies, 12(60%) for tanks.
   jetForce = 0 * 2250 * 0.8;
   jumpForce = 12.5 * 2975 * 0.8;
   runForce = 22 * 2250 * 0.8;
   underwaterJetForce = 22 * 2975 * 1.5;
};

datablock PlayerData(Beast1 : Beast)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 2250;
  //armor (+- 15% per lvl)
  maxDamage = 900;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 24;
  maxBackwardSpeed = 20;
  maxSideSpeed = 20;
  jetSound = ArmorJetSound;
  thrustSound = ArmorThrustSound;
};

datablock PlayerData(Beast2 : Beast)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 2580;
  //armor (+- 15% per lvl)
  maxDamage = 1035;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 22;
  maxBackwardSpeed = 18;
  maxSideSpeed = 18;
  jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Beast3 : Beast)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 2975;
  //armor (+- 15% per lvl)
  maxDamage = 1190;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 19;
  maxBackwardSpeed = 16;
  maxSideSpeed = 16;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Beast4 : Beast)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 3421;
  //armor (+- 15% per lvl)
  maxDamage = 1369;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 17;
  maxBackwardSpeed = 15;
  maxSideSpeed = 15;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Beast5 : Beast)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 3935;
  //armor (+- 15% per lvl)
  maxDamage = 1574;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 16;
  maxBackwardSpeed = 13;
  maxSideSpeed = 13;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;

};
