//-----------------------------------------------------------------------------
// Torque Game Engine
// Copyright (c) BraveTree Productions
// Copyright (c) 2001 GarageGames.Com
// Portions Copyright (c) 2001 by Sierra Online, Inc.
//-----------------------------------------------------------------------------

datablock PlayerData(Abolisher: DefaultMAV)
{
   className = Mecha;
   shapeFile = "~/data/shapes/loretank/loretank.dts";
   cameraMaxDist = 12;
   computeCRC = true;

   //Conforms the Tank object to the terrain
   conformToGround = 1;
   smoothCamera = 0.97;
   turnForce = 125;

   canObserve = true;
   cmdCategory = "Clients";

   debrisShapeName = "~/data/shapes/loretank/tank02_debris.dts";
   debris = TankArmorDebris;
   explosion = TankArmorExplosion;
   explosionDamage = 100.0;
   explosionRadius = 15.0;
   renderWhenDestroyed = false;

   aiAvoidThis = true;
   heat =1.0;
   minLookAngle = -0.907571;
   maxLookAngle = 0.574533;
   maxFreelookAngle = 3.0;

   mass = 4400;
   drag = 0.3;
   maxdrag = 0.4;
   density = 10;
   maxDamage = 1000;
   maxEnergy =  200;
   repairRate = 0.25;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.256;

  //Runforce is Acceleration. Which in code is Force/Mass. Mass is based off STANDARD VARIANT!! (3)
  //20 for Lights, 16 for mediums, 12 for heavies, 12 for tanks.
   runForce = 16 * 4400;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 14;
   maxBackwardSpeed = 13;
   maxSideSpeed = 0;

   jumpForce = 2 * 4400;

   minImpactSpeed = 45;
   speedDamageScale = 0.4;

   //boundingBox = "6 6 5";
   boundingBox = "4 6 4";
   pickupRadius = 0.75;

   footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   dustEmitter = LiftoffDustEmitter;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 50;
   jumpSurfaceAngle = 60;
   footstepSplashHeight = 0.35;

   // Footstep Sounds
   FootSoftSound        = fstankSound;
   FootHardSound        = fstankSound;
   FootMetalSound       = fstankSound;
   FootSnowSound        = fstankSnowSound;
   FootShallowSound     = fstankSound;
   FootWadingSound      = fstankwaterSound;
   FootUnderwaterSound  = fstankwaterSound;

   FootBubblesSound     = tankwaterSound;
   movingBubblesSound   = ArmorMoveBubblesSound;

   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;

   //exitingWater         = ExitingWaterLightSound;
   observeParameters = "0.5 4.5 4.5";
   //maxInv[Flag2] = 1;
   maxInv[AbolisherSecondaryAmmo1] = 45;
   maxInv[AbolisherSecondary1] = 1;
   maxInv[AbolisherSecondaryAmmo2] = 35;
   maxInv[AbolisherSecondary2] = 1;
   maxInv[AbolisherSecondaryAmmo3] = 40;
   maxInv[AbolisherSecondary3] = 1;
   maxInv[AbolisherPrimaryAmmo1] = 400;
   maxInv[AbolisherPrimary1] = 1;
   maxInv[AbolisherPrimaryAmmo2] = 300;
   maxInv[AbolisherPrimary2] = 1;
   //maxInv[AbolisherPrimaryAmmo3] = 100;
   maxInv[AbolisherPrimary3] = 1;

   //Names
   secondaryName = "AbolisherSecondary";
   primaryName = "AbolisherPrimary";
   // Defaults
   primaryNum = "3";
   secondaryNum = "2";
   //Number of Primary and Secondary Weapons
   primaryTotal = "3";
   secondaryTotal = "3";
   
   //Water Movement
   maxUnderwaterForwardSpeed = 11; // org 8.4
   maxUnderwaterBackwardSpeed = 11; // org 7.8
   maxUnderwaterSideSpeed = 11; // org 7.8
   
   //jetting varibales
   jetForce = 20 * 4400 * 0;
   underwaterJetForce = 26.21 * 4400 * 1.5 * 0;
   underwaterVertJetFactor = 1.5;
   jetEnergyDrain =  0.0;
   underwaterJetEnergyDrain = 0.6;
   minJetEnergy = 1;
   maxJetHorizontalPercentage = 0.8;
   targetedSound = TargetedSound;
   enemyMapRadius = 1500;
};

datablock PlayerData(Abolisher1 : Abolisher)
{
  //armor (+- 15% per lvl)
  maxDamage = 1250;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 24;
  maxBackwardSpeed = 24;
};
datablock PlayerData(Abolisher2 : Abolisher)
{
  //armor (+- 15% per lvl)
  maxDamage = 1438;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 22;
  maxBackwardSpeed = 22;
};
datablock PlayerData(Abolisher3 : Abolisher)
{
  //armor (+- 15% per lvl)
  maxDamage = 1650;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 19;
  maxBackwardSpeed = 19;
};
datablock PlayerData(Abolisher4 : Abolisher)
{
  //armor (+- 15% per lvl)
  maxDamage = 1900;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 17;
  maxBackwardSpeed = 17;
};
datablock PlayerData(Abolisher5 : Abolisher)
{
  //armor (+- 15% per lvl)
  maxDamage = 2186;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 16;
  maxBackwardSpeed = 16;
};
