datablock PlayerData(DefaultMAV) // (Technically its the thumper)
{
   renderFirstPerson = false;
   emap = true;

   className = Mecha;
   shapeFile = "~/data/shapes/player/player.dts";
   cameraMaxDist = 12;
   computeCRC = true;

   radiusDamage = 100;
   damageRadius = 12.5;
   //Conforms the object to the terrain
   conformToGround = 0;
   smoothCamera = 0.95;

   turnForce = 150;
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;

   debrisShapeName = "~/data/shapes/player/blue_mecha_debris.dts";
   debris = MechaDebris;
   explosion = MechaExplosion;
   explosionDamage = 100.0;
   explosionRadius = 12.5;
   renderWhenDestroyed = false;

   aiAvoidThis = true;

   minLookAngle = -0.907571;
   maxLookAngle = 1.4;
   maxFreelookAngle = 3.0;

   mass = 1800;
   drag = 0.3;
   maxdrag = 0.4;
   density = 10;
   maxDamage = 700;
   maxEnergy =  70;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.33;

   runForce = 30 * 1800;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 25;
   maxBackwardSpeed = 15;
   maxSideSpeed = 10;
   thrustEmitter = MechaJetEmitter;
   maxUnderwaterForwardSpeed = 11; // org 8.4
   maxUnderwaterBackwardSpeed = 11; // org 7.8
   maxUnderwaterSideSpeed = 9; // org 7.8

   jumpForce = 10.5 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 15;

   recoverDelay = 9;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 45;
   speedDamageScale = 0.4;

   boundingBox = "3 3 6";
   pickupRadius = 0.75;

   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.4;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;
   hardSplashSoundVelocity = 20.0;
   exitSplashSoundVelocity = 5.0;
//   maxInv[Flag2] = 1;
   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 70;
   jumpSurfaceAngle = 80;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;

   footstepSplashHeight = 0.35;
   
   maxTimeScale = 1;

   //NOTE:  some sounds commented out until wav's are available

   // Footstep Sounds
   FootSoftSound        = FootLightSoftSound;
   FootHardSound        = FootLightHardSound;
   FootMetalSound       = FootLightMetalSound;
   FootSnowSound        = FootLightSnowSound;
   FootShallowSound     = FootLightShallowSplashSound;
   FootWadingSound      = FootLightWadingSound;
   FootUnderwaterSound  = FootLightUnderwaterSound;
   FootBubblesSound     = FootLightBubblesSound;
   movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   impactSoftSound      = ImpactLightSoftSound;
   impactHardSound      = ImpactLightHardSound;
   impactMetalSound     = ImpactLightMetalSound;
   impactSnowSound      = ImpactLightSnowSound;

   impactWaterEasy      = ImpactLightWaterEasySound;
   impactWaterMedium    = ImpactLightWaterMediumSound;
   impactWaterHard      = ImpactLightWaterHardSound;

   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;

   exitingWater         = ExitingWaterLightSound;

   observeParameters = "0.5 4.5 4.5";

   //jetting varibales
   jetForce = 20 * 90;
   underwaterJetForce = 26.21 * 90 * 1.5;
   underwaterVertJetFactor = 1.5;
   jetEnergyDrain =  1.2;
   underwaterJetEnergyDrain = 0.6;
   minJetEnergy = 1;
   maxJetHorizontalPercentage = 0.8;


   //fading FX
   fadeIn = 1;
   fadeInTime = 20;
   fadeInDelay = 5;
   targetingSound = TargetingSound;
   targetLockedSound = TargetLockedSound;
   enemyMapRadius = 300;
   
   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   //damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 0.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;
};

function DefaultMAV::onAdd(%this,%obj)
{
   // phdana strafe anims ->
   // this is not called because the class is
   // set to Mecha...i put this here in case soemeone changes that
   // this same code is in mecha as well..
   Parent::onAdd(%this,%obj);
   // <- phdana strafe anims

   //echo("Hunter HEAT is " @ %this.heat);
   %obj.setHeat(%this.heat);
   %obj.setRechargeRate(%this.rechargeRate);
   %obj.setRepairRate(0);
   %obj.mountVehicle = true;
}

// phdana strafe anims ->
function DefaultMAV::onRemove(%this,%obj)
{
   // this is not called because the class is
   // set to Mecha...i put this here in case soemeone changes that
   // this same code is in mecha as well..
   Parent::onRemove(%this,%obj);
}
// <- phdana strafe anims

