//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2001 GarageGames.Com
// Portions Copyright (c) 2001 by Sierra Online, Inc.
//-----------------------------------------------------------------------------

// Load dts shapes and merge animations
exec("~/data/shapes/player/bluescoutmech/bluescout.cs");

//----------------------------------------------------------------------------
// Blue Scout Datablocks
//----------------------------------------------------------------------------
            
datablock PlayerData(HunterScout : DefaultMAV)
{
   className = Mecha;
   shapeFile = "~/data/shapes/player/bluescoutmech/bluescout.dts";
   cameraMaxDist = 8;
   computeCRC = true;

   debrisShapeName = "~/data/shapes/player/bluescoutmech/blue_scout_debris.dts";
   decalData   = FSFootprint;
   explosion = MechaExplosion;
   explosionDamage = 50.0;
   explosionRadius = 10;
   renderWhenDestroyed = false;
   
   decalOffset = 1;
   
   minLookAngle = -1.4;
   maxLookAngle = 1.4;
   maxFreelookAngle = 3.0;
   
   maxEnergy =  70;
   repairRate = 0.5;

   // Movement Variables
   underwaterVertJetFactor = 1.5;
   jetEnergyDrain =  0.8; // org 0.8
   jetSound = ArmorJetSound;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 12;
   turnForce = 200;

   boundingBox = "3 3 5";
   pickupRadius = 0.75;
   
   // Allowable Inventory Items
   maxInv[HunterScoutSecondaryAmmo1] = 40;
   maxInv[HunterScoutSecondary1] = 1;
   maxInv[HunterScoutSecondaryAmmo2] = 20;
   maxInv[HunterScoutSecondary2] = 1;
   maxInv[HunterScoutSecondaryAmmo3] = 15;
   maxInv[HunterScoutSecondary3] = 1;
   maxInv[HunterScoutPrimaryAmmo1] = 300;
   maxInv[HunterScoutPrimary1] = 1;
   maxInv[HunterScoutPrimaryAmmo2] = 150;
   maxInv[HunterScoutPrimary2] = 1;
   maxInv[HunterScoutPrimaryAmmo3] = 100;
   maxInv[HunterScoutPrimary3] = 1;
   maxInv[Flag2] = 1;

   //Names
   secondaryName = "HunterScoutSecondary";
   primaryName = "HunterScoutPrimary";
   // Defaults
   primaryNum = "1";
   secondaryNum = "2";
   //Number of Primary and Secondary Weapons
   primaryTotal = "3";
   secondaryTotal = "3";

   enemyMapRadius = 1200;
   thrustSound = ArmorThrustSound;
   heat =1.0;
   //Water Movement
   maxUnderwaterForwardSpeed = 16; // 80% of runforce
   maxUnderwaterBackwardSpeed = 15; // 90% of max water forward speed
   maxUnderwaterSideSpeed = 15; // 90% of max water forward speed
   
   //Runforce is Acceleration. Which in code is Force/Mass. Mass is based off STANDARD VARIANT!! (3)
   //20 for Lights, 16(80%) for mediums, 13.2(66%) for heavies, 12(60%) for tanks.
   underwaterJetForce = 20 * 1500 * 1.5;
   jetForce = 18 * 1500;
   jumpForce = 18.5 * 1500;
   runForce = 22 * 1500;
};

//----------------------------------------------------------------------------


datablock PlayerData(HunterScout1 : HunterScout)
{
  //mass is roughly +-0% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 1220;
 //armor (+- 15% per lvl)
  maxDamage = 270;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 36;
  maxBackwardSpeed = 26;
  maxSideSpeed = 30;
};

datablock PlayerData(HunterScout2 : HunterScout)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 1403;
  //armor (+- 15% per lvl)
  maxDamage = 311;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 32;
  maxBackwardSpeed = 23;
  maxSideSpeed = 27;

};

datablock PlayerData(HunterScout3 : HunterScout)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 1613;
   //armor (+- 15% per lvl)
   maxDamage = 357;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 29;
   maxBackwardSpeed = 21;
   maxSideSpeed = 24;
};

datablock PlayerData(HunterScout4 : HunterScout)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 1855;
   //armor (+- 15% per lvl)
   maxDamage = 411;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 26;
   maxBackwardSpeed = 19;
   maxSideSpeed = 22;
};

datablock PlayerData(HunterScout5 : HunterScout)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 2134;
   //armor (+- 15% per lvl)
   maxDamage = 472;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 24;
   maxBackwardSpeed = 17;
   maxSideSpeed = 20;
};
