//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2001 GarageGames.Com
// Portions Copyright (c) 2001 by Sierra Online, Inc.
//-----------------------------------------------------------------------------

// Load dts shapes and merge animations

//----------------------------------------------------------------------------
// Player Audio Profiles
//----------------------------------------------------------------------------

datablock PlayerData(Juggernaut : DefaultMAV)
{
   className = Mecha;
   shapeFile = "~/data/shapes/loretank2/tank01.dts";
   cameraMaxDist = 12;
   computeCRC = true;
   
   heat =1.0;
  
   //Conforms the Tank object to the terrain
   conformToGround = 1;
   smoothCamera = 0.97;
   turnForce = 125;

   canObserve = true;
   cmdCategory = "Clients";

   debrisShapeName = "~/data/shapes/loretank2/tank01_debris.dts";
   debris = ECTankDebris;
   explosion = ECTankExplosion;
   explosionDamage = 100.0;
   explosionRadius = 15.0;
   renderWhenDestroyed = false;

   aiAvoidThis = true;

   minLookAngle = -0.907571;
   maxLookAngle = 0.574533;
   maxFreelookAngle = 3.0;

   mass = 4800;
   drag = 0.3;
   maxdrag = 0.4;
   density = 10;
   maxDamage = 1100;
   maxEnergy =  200;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.256;

  //Runforce is Acceleration. Which in code is Force/Mass. Mass is based off STANDARD VARIANT!! (3)
  //20 for Lights, 16 for mediums, 12 for heavies, 12 for tanks.
   runForce = 16 * 4800;
   maxForwardSpeed = 16;
   maxBackwardSpeed = 16;
   maxSideSpeed = 0;

   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   //Force variable is as follows: light mavs are 1.0; medium mavs are 0.75; heavy mavs are 0.66; tanks are 0.5
   jumpForce = 2 * 4800;

   recoverDelay = 9;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 45;
   speedDamageScale = 0.4;

   //boundingBox = "6 6 5";
   boundingBox = "4 6 4";
   pickupRadius = 0.75;
   
   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 60;
   jumpSurfaceAngle = 80;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   footstepSplashHeight = 0.35;

   // Footstep Sounds
   FootSoftSound        = tankSound;
   FootHardSound        = tankSound;
   FootMetalSound       = tankSound;
   FootSnowSound        = tankSnowSound;
   FootShallowSound     = tankSound;
   FootWadingSound      = tankwaterSound;
   FootUnderwaterSound  = tankwaterSound;

   FootBubblesSound     = tankwaterSound;
   movingBubblesSound   = ArmorMoveBubblesSound;

   observeParameters = "0.5 4.5 4.5";

   // Allowable Inventory Items
   maxInv[JuggernautSecondaryAmmo1] = 72;
   maxInv[JuggernautSecondary1] = 1;
   maxInv[JuggernautSecondaryAmmo2] = 60;
   maxInv[JuggernautSecondary2] = 1;
   maxInv[JuggernautSecondaryAmmo3] = 40;
   maxInv[JuggernautSecondary3] = 1;
   maxInv[JuggernautPrimaryAmmo1] = 750;
   maxInv[JuggernautPrimary1] = 1;
   maxInv[JuggernautPrimaryAmmo2] = 300;
   maxInv[JuggernautPrimary2] = 1;
   maxInv[JuggernautPrimaryAmmo3] = 600;
   maxInv[JuggernautPrimary3] = 1;

   //Names
   secondaryName = "JuggernautSecondary";
   primaryName = "JuggernautPrimary";
   // Defaults
   primaryNum = "2";
   secondaryNum = "2";
   //Number of Primary and Secondary Weapons
   primaryTotal = "3";
   secondaryTotal = "3";

   targetedSound = TargetedSound;
   enemyMapRadius = 1250;
   
   jetForce = 20 * 4800 * 0;
   underwaterJetForce = 26.21 * 4800 * 1.5 * 0;
   underwaterVertJetFactor = 1.5;
   jetEnergyDrain =  0.0;
};

datablock PlayerData(Juggernaut1 : Juggernaut)
{
  //armor (+- 15% per lvl)
  maxDamage = 1200;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 21;
  maxBackwardSpeed = 21;
};

datablock PlayerData(Juggernaut2 : Juggernaut)
{
  //armor (+- 15% per lvl)
  maxDamage = 1380;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 19;
  maxBackwardSpeed = 19;
};

datablock PlayerData(Juggernaut3 : Juggernaut)
{
  //armor (+- 15% per lvl)
  maxDamage = 1585;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 17;
  maxBackwardSpeed = 17;
};

datablock PlayerData(Juggernaut4 : Juggernaut)
{
  //armor (+- 15% per lvl)
  maxDamage = 1825;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 15;
  maxBackwardSpeed = 15;
};

datablock PlayerData(Juggernaut5 : Juggernaut)
{
  //armor (+- 15% per lvl)
  maxDamage = 2100;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 14;
  maxBackwardSpeed = 14;
};
