//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2001 GarageGames.Com
// Portions Copyright (c) 2001 by Sierra Online, Inc.
//-----------------------------------------------------------------------------

// Load dts shapes and merge animations
exec("~/data/shapes/player/mech2/slasher.cs");

//----------------------------------------------------------------------------
// Player Audio Profiles
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Foot puffs
//----------------------------------------------------------------------------


datablock PlayerData(Locust : DefaultMAV)
{
  
   className = Mecha;
   shapeFile = "~/data/shapes/player/mech2/slasher.dts";
   cameraMaxDist = 12;
   computeCRC = true;
   
   minLookAngle = -1.4;
   maxLookAngle = 1.4;
   maxFreelookAngle = 3.0;
   turnForce = 200;
   
   maxEnergy =  70;
   heat =1.0;
  
   debrisShapeName = "~/data/shapes/player/mech2/slasher_debris.dts";
   debris = MechaDebris;
   explosion = MechaExplosion;
   explosionDamage = 50.0;
   explosionRadius = 10.0;
   renderWhenDestroyed = false;

   aiAvoidThis = true;

   repairRate = 0.5;

   //runForce variable is as follows: light mavs are 48; medium mavs are 40; heavy mavs are 33; tanks are 25
   runEnergyDrain = 0;
   minRunEnergy = 0;

   //Jump
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 15;

   minImpactSpeed = 45;
   speedDamageScale = 0.4;

   boundingBox = "3 3 5";
   pickupRadius = 0.75;
   decalData   = ECFootprint;
   // Controls over slope of runnable/jumpable surfaces
   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   maxInv[Flag1] = 1;
   maxInv[LocustSecondaryAmmo1] = 360;
   maxInv[LocustSecondary1] = 1;
   maxInv[LocustSecondaryAmmo2] = 240;
   maxInv[LocustSecondary2] = 1;
   maxInv[LocustSecondaryAmmo3] = 120;
   maxInv[LocustSecondary3] = 1;
   maxInv[LocustPrimaryAmmo1] = 750;
   maxInv[LocustPrimary1] = 1;
   maxInv[LocustPrimaryAmmo2] = 500;
   maxInv[LocustPrimary2] = 1;
   maxInv[LocustPrimaryAmmo3] = 300;
   maxInv[LocustPrimary3] = 1;

   //Names
   secondaryName = "LocustSecondary";
   primaryName = "LocustPrimary";
   // Defaults
   primaryNum = "2";
   secondaryNum = "2";
   //Number of Primary and Secondary Weapons
   primaryTotal = "3";
   secondaryTotal = "3";
   
   //Water Movement
   maxUnderwaterForwardSpeed = 18; // 80% of runforce
   maxUnderwaterBackwardSpeed = 15; // 90% of max water forward speed
   maxUnderwaterSideSpeed = 15; // 90% of max water forward speed
   
   //jetting varibales

   underwaterVertJetFactor = 1.5;
   jetEnergyDrain =  0.8; // org 0.8
   underwaterJetEnergyDrain = 0.6;
   minJetEnergy = 1;
   maxJetHorizontalPercentage = 0.8;
   jetSound = ArmorJetSound;
   thrustEmitter = MechaJetEmitter;
   thrustSound = ArmorThrustSound;
   enemyMapRadius = 1000;
   
  //Runforce is Acceleration. Which in code is Force/Mass. Mass is based off STANDARD VARIANT!! (3)
  //20 for Lights, 16(80%) for mediums, 13.2(66%) for heavies, 12(60%) for tanks.
  jetForce = 20 * 1320;
  underwaterJetForce = 18 * 1320 * 1.5;
  jumpForce = 18.5 * 1320;
  runForce = 22 * 1320;

   
};

datablock PlayerData(Locust1 : Locust)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 1070;
  //armor (+- 15% per lvl)
  maxDamage = 280;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 38;
  maxBackwardSpeed = 28;
  maxSideSpeed = 32;
  jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Locust2 : Locust)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 1231;
  //armor (+- 15% per lvl)
  maxDamage = 322;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 34;
  maxBackwardSpeed = 25;
  maxSideSpeed = 29;
  jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Locust3 : Locust)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 1415;
  //armor (+- 15% per lvl)
  maxDamage = 370;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 31;
  maxBackwardSpeed = 23;
  maxSideSpeed = 26;
  jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Locust4 : Locust)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 1627;
  //armor (+- 15% per lvl)
  maxDamage = 426;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 28;
  maxBackwardSpeed = 20;
  maxSideSpeed = 23;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Locust5 : Locust)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 1871;
  //armor (+- 15% per lvl)
  maxDamage = 490;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 25;
  maxBackwardSpeed = 18;
  maxSideSpeed = 21;
  jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};
