//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2001 GarageGames.Com
// Portions Copyright (c) 2001 by Sierra Online, Inc.
//-----------------------------------------------------------------------------

// Load dts shapes and merge animations
exec("~/data/shapes/player/greyassault/greyassault.cs");

//----------------------------------------------------------------------------
// Player Audio Profiles
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
datablock PlayerData(Mantis : DefaultMAV)
{
   className = Mecha;
   renderFirstPerson = true;
   shapeFile = "~/data/shapes/player/greyassault/greyassault.dts";
   cameraMaxDist = 12;
   computeCRC = true;
   
   heat =1.0;
   repairRate = 0.27;
   maxEnergy =  120;

   canObserve = true;
   cmdCategory = "Clients";

   debrisShapeName = "~/data/shapes/player/greyassault/grey_assault_debris.dts";
   debris = MechaDebris;
   explosion = MechaExplosion;
   explosionDamage = 100.0;
   explosionRadius = 12.5;
   renderWhenDestroyed = false;

   aiAvoidThis = true;

   minLookAngle = -1.4;
   maxLookAngle = 1.4;
   maxFreelookAngle = 3.0;
   turnForce = 175;

   maxTimeScale = 1;

   jumpDelay = 15;
   recoverDelay = 9;
   recoverRunForceScale = 1.2;
   minImpactSpeed = 45;
   speedDamageScale = 0.4;
   boundingBox = "4 4 5";

   decalData   = ECFootprint;
   footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 1.00;

   thrustEmitter = MechaJetEmitter;
   maxInv[Flag1] = 1;

   maxInv[MantisSecondaryAmmo1] = 148;
   maxInv[MantisSecondary1] = 1;
   maxInv[MantisSecondaryAmmo2] = 60;
   maxInv[MantisSecondary2] = 1;
   maxInv[MantisSecondaryAmmo3] = 120;
   maxInv[MantisSecondary3] = 1;
   maxInv[MantisPrimaryAmmo1] = 400;
   maxInv[MantisPrimary1] = 1;
   maxInv[MantisPrimaryAmmo2] = 300;
   maxInv[MantisPrimary2] = 1;
   maxInv[MantisPrimaryAmmo3] = 200;
   maxInv[MantisPrimary3] = 1;
   maxInv[MantisSpecial] = 1;
   
   //Names
   secondaryName = "MantisSecondary";
   primaryName = "MantisPrimary";
   // Defaults
   primaryNum = "2";
   secondaryNum = "2";
   //Number of Primary and Secondary Weapons
   primaryTotal = "3";
   secondaryTotal = "3";

   //jetting varibales
   underwaterVertJetFactor = 1.5;
   jetEnergyDrain =  1.2;
   underwaterJetEnergyDrain = 0.6;
   minJetEnergy = 1;
   maxJetHorizontalPercentage = 0.8;

   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
   enemyMapRadius = 500;

   //Water Movement
   maxUnderwaterForwardSpeed = 16; // 80% of runforce
   maxUnderwaterBackwardSpeed = 15; // 90% of max water forward speed
   maxUnderwaterSideSpeed = 15; // 90% of max water forward speed
   
   //Runforce is Acceleration. Which in code is Force/Mass. Mass is based off STANDARD VARIANT!! (3)
   //20 for Lights, 16(80%) for mediums, 13.2(66%) for heavies, 12(60%) for tanks.
   jetForce = 20 * 2000 * 0.8;
   jumpForce = 16 * 2000 * 0.8;
   runForce = 22 * 2000 * 0.8;
   underwaterJetForce = 22 * 2000 * 1.5;

};

datablock PlayerData(Mantis1 : Mantis)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 1780;
   //armor (+- 15% per lvl)
   maxDamage = 560;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 28;
   maxBackwardSpeed = 18;
   maxSideSpeed = 22;
};

datablock PlayerData(Mantis2 : Mantis)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 2047;
   //armor (+- 15% per lvl)
   maxDamage = 644;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 25;
   maxBackwardSpeed = 16;
   maxSideSpeed = 20;
};

datablock PlayerData(Mantis3 : Mantis)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 2354;
   //armor (+- 15% per lvl)
   maxDamage = 741;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 23;
   maxBackwardSpeed = 15;
   maxSideSpeed = 18;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Mantis4 : Mantis)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 2707;
   //armor (+- 15% per lvl)
   maxDamage = 852;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 20;
   maxBackwardSpeed = 13;
   maxSideSpeed = 16;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Mantis5 : Mantis)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 3113;
   //armor (+- 15% per lvl)
   maxDamage = 979;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 18;
   maxBackwardSpeed = 12;
   maxSideSpeed = 14;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};
