//-----------------------------------------------------------------------------
// Torque Game Engine
// 
// Copyright (c) 2001 GarageGames.Com
// Portions Copyright (c) 2001 by Sierra Online, Inc.
//-----------------------------------------------------------------------------

// Load dts shapes and merge animations
exec("~/data/shapes/player/ecHeavy/ecHeavy.cs");

//----------------------------------------------------------------------------
// Player Audio Profiles
//----------------------------------------------------------------------------


//----------------------------------------------------------------------------
datablock PlayerData(Predator : DefaultMAV)
{
   className = Mecha;
   renderFirstPerson = true;
   shapeFile = "~/data/shapes/player/ecHeavy/echeavy.dts";
   cameraMaxDist = 12;
   computeCRC = true;
   
   heat =1.0;
   repairRate = 0.27;
   maxEnergy =  170;

   canObserve = true;
   cmdCategory = "Clients";

   debrisShapeName = "~/data/shapes/player/ecHeavy/echeavy_debris.dts";
   debris = MechaDebris;
   explosion = MechaExplosion;
   explosionDamage = 125.0;
   explosionRadius = 15.0;
   renderWhenDestroyed = false;

   aiAvoidThis = true;

   minLookAngle = -1.4;
   maxLookAngle = 1.4;
   maxFreelookAngle = 3.0;
   turnForce = 150;

   maxTimeScale = 1;

   jumpDelay = 15;
   recoverDelay = 9;
   recoverRunForceScale = 1.2;
   minImpactSpeed = 45;
   speedDamageScale = 0.4;
   boundingBox = "4 4 5";

   decalData   = ECFootprint;
   footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 1.00;

   thrustEmitter = MechaJetEmitter;
   maxInv[Flag1] = 1;

   maxInv[PredatorSecondaryAmmo1] = 800;
   maxInv[PredatorSecondary1] = 1;
   maxInv[PredatorSecondaryAmmo2] = 240;
   maxInv[PredatorSecondary2] = 1;
   maxInv[PredatorSecondaryAmmo3] = 120;
   maxInv[PredatorSecondary3] = 1;
   maxInv[PredatorPrimaryAmmo1] = 750;
   maxInv[PredatorPrimary1] = 1;
   maxInv[PredatorPrimaryAmmo2] = 350;
   maxInv[PredatorPrimary2] = 1;
   maxInv[PredatorPrimaryAmmo3] = 25;
   maxInv[PredatorPrimary3] = 1;
   maxInv[PredatorSpecial] = 1;

   //Names
   secondaryName = "PredatorSecondary";
   primaryName = "PredatorPrimary";
   // Defaults
   primaryNum = "2";
   secondaryNum = "2";
   //Number of Primary and Secondary Weapons
   primaryTotal = "3";
   secondaryTotal = "3";

   //jetting varibales
   underwaterVertJetFactor = 1.5;
   jetEnergyDrain =  1.2;
   underwaterJetEnergyDrain = 0.6;
   minJetEnergy = 1;
   maxJetHorizontalPercentage = 0.8;

   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
   enemyMapRadius = 500;

   //Water Movement
   maxUnderwaterForwardSpeed = 16; // 80% of runforce
   maxUnderwaterBackwardSpeed = 15; // 90% of max water forward speed
   maxUnderwaterSideSpeed = 15; // 90% of max water forward speed
   
   //Runforce is Acceleration. Which in code is Force/Mass. Mass is based off STANDARD VARIANT!! (3)
   //20 for Lights, 16(80%) for mediums, 13.2(66%) for heavies, 12(60%) for tanks.
   jetForce = 0 * 2300 * 0.8;
   jumpForce = 12.5 * 2300 * 0.8;
   runForce = 22 * 2300 * 0.8;
   underwaterJetForce = 22 * 2300 * 1.5;

};

datablock PlayerData(Predator1 : Predator)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 2300;
   //armor (+- 15% per lvl)
   maxDamage = 925;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 22;
   maxBackwardSpeed = 21;
   maxSideSpeed = 18;
};

datablock PlayerData(Predator2 : Predator)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 2645;
   //armor (+- 15% per lvl)
   maxDamage = 1064;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 20;
   maxBackwardSpeed = 19;
   maxSideSpeed = 16;
};

datablock PlayerData(Predator3 : Predator)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 3042;
   //armor (+- 15% per lvl)
   maxDamage = 1223;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 18;
   maxBackwardSpeed = 17;
   maxSideSpeed = 15;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Predator4 : Predator)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 3500;
   //armor (+- 15% per lvl)
   maxDamage = 1407;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 16;
   maxBackwardSpeed = 15;
   maxSideSpeed = 13;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Predator5 : Predator)
{
   //mass is roughly +-90% of the previous level (level 3 is the default)
   //Forces are constant across all variants.
   //Only in main datablock
   mass = 4023;
   //armor (+- 15% per lvl)
   maxDamage = 1618;
   //speed (+- 15% per lvl)
   maxForwardSpeed = 14;
   maxBackwardSpeed = 14;
   maxSideSpeed = 12;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};
