//------------------------------------------------------------------------------
// Shaddrack MAV datablocks. Since DefaultMAV is actually the Shaddrack mav
// No settings are set here. But if default mav is changed, this needs to be
// changed FIRST (so we keep original Shaddrack values)

datablock PlayerData(Shaddrack : DefaultMAV)
{
   className = Mecha;
   shapeFile = "~/data/shapes/player/player.dts";
   jetSound = ArmorJetSound;
   // Foot Prints
   decalData   = FSFootprint;
   decalOffset = 0.75;
   thrustSound = ArmorThrustSound;
   maxInv[Flag2] = 1;
   maxInv[ShaddrackSecondaryAmmo1] = 100;
   maxInv[ShaddrackSecondary1] = 1;
   maxInv[ShaddrackSecondaryAmmo2] = 80;
   maxInv[ShaddrackSecondary2] = 1;
   maxInv[ShaddrackSecondaryAmmo3] = 60;
   maxInv[ShaddrackSecondary3] = 1;
   maxInv[ShaddrackPrimaryAmmo1] = 350;
   maxInv[ShaddrackPrimary1] = 1;
   maxInv[ShaddrackPrimaryAmmo2] = 200;
   maxInv[ShaddrackPrimary2] = 1;
   maxInv[ShaddrackPrimaryAmmo3] = 100;
   maxInv[ShaddrackPrimary3] = 1;
   
   enemyMapRadius = 600;
   maxEnergy =  120;

   //Names
   secondaryName = "ShaddrackSecondary";
   primaryName = "ShaddrackPrimary";
   // Defaults
   primaryNum = "2";
   secondaryNum = "2";
   //Number of Primary and Secondary Weapons
   primaryTotal = "3";
   secondaryTotal = "3";
   jetEnergyDrain =  1.25;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
   turnForce = 175;
   
   //Water Movement
   maxUnderwaterForwardSpeed = 16; // 80% of runforce
   maxUnderwaterBackwardSpeed = 15; // 90% of max water forward speed
   maxUnderwaterSideSpeed = 15; // 90% of max water forward speed
   heat =1.0;
   //Runforce is Acceleration. Which in code is Force/Mass. Mass is based off STANDARD VARIANT!! (3)
   //20 for Lights, 16(80%) for mediums, 13.2(66%) for heavies, 12(60%) for tanks.
   jetForce = 20 * 2000 * 0.8;
   jumpForce = 16 * 2000 * 0.8;
   runForce = 22 * 2000 * 0.8;
   underwaterJetForce = 22 * 2000 * 1.5;
};

datablock PlayerData(Shaddrack1 : Shaddrack)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 1720;
  //armor (+- 15% per lvl)
  maxDamage = 490;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 30;
  maxBackwardSpeed = 20;
  maxSideSpeed = 24;
  jetSound = ArmorJetSound;
  thrustSound = ArmorThrustSound;
};

datablock PlayerData(Shaddrack2 : Shaddrack)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 1978;
  //armor (+- 15% per lvl)
  maxDamage = 564;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 27;
  maxBackwardSpeed = 18;
  maxSideSpeed = 22;
  jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Shaddrack3 : Shaddrack)
{
  //mass is roughly +-90% 5of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 2275;
  //armor (+- 15% per lvl)
  maxDamage = 648;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 24;
  maxBackwardSpeed = 16;
  maxSideSpeed = 19;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Shaddrack4 : Shaddrack)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 2626;
  //armor (+- 15% per lvl)
  maxDamage = 745;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 22;
  maxBackwardSpeed = 15;
  maxSideSpeed = 17;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;
};

datablock PlayerData(Shaddrack5 : Shaddrack)
{
  //mass is roughly +-90% of the previous level (level 3 is the default)
  //Forces are constant across all variants.
  //Only in main datablock
  mass = 3008;
  //armor (+- 15% per lvl)
  maxDamage = 857;
  //speed (+- 15% per lvl)
  maxForwardSpeed = 20;
  maxBackwardSpeed = 13;
  maxSideSpeed = 16;
   jetSound = ArmorJetSound;
   thrustSound = ArmorThrustSound;

};
