//=================================================================
// Dark Horizons: Lore Special Effects for explosions etc....
// 
// - soundfx
// - Mecha MEDIUM EXPLOSION SMOKE
// - Debris (pieces)
// - Explosions (vehicles & Mecha)
//
//=================================================================

//--------------------------------------------------------------
//Sound FX
//--------------------------------------------------------------

datablock AudioProfile(MechaExplosionSound)
{
  filename = "~/data/sound/death_explode.ogg";
  description = AudioMAVExplosion;
  preload = true;
};

datablock AudioProfile(ExplosionSound)
{
  filename = "~/data/sound/medexplode.ogg";
  description = AudioPlaceableExplosion;
  preload = true;
};

datablock AudioProfile(generatorSound)
{
  filename = "~/data/sound/genloop.ogg";
  description = "AudioClosestLooping3d";
  preload = true;
};




//--------------------------------------------------------------
// Mecha MEDIUM EXPLOSION SMOKE
//--------------------------------------------------------------

datablock ParticleData(ChimneySmoke)
{
   textureName          = "~/data/specialfx/smoke";
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.25;   // rises slowly org -0.2
   inheritedVelFactor   = 0.00;
   lifetimeMS           = 3000;
   lifetimeVarianceMS   = 250;
   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0.6 0.6 0.6 0.1";
   colors[1]     = "0.6 0.6 0.6 0.8"; // org 0.6 0.6 0.6 0.1
   colors[2]     = "0.6 0.6 0.6 0.0";

   sizes[0]      = 10;
   sizes[1]      = 15;
   sizes[2]      = 22.5; // org 20

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(ChimneySmokeEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 5;

   ejectionVelocity = 0.25;
   velocityVariance = 0.10;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = ChimneySmoke;
};

datablock ParticleEmitterNodeData(ChimneySmokeEmitterNode)
{
   timeMultiple = 1;
};

datablock ParticleData(tankSmoke)
{
   textureName          = "~/data/specialfx/smoke";
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.25;   // rises slowly org -0.2
   inheritedVelFactor   = 0.00;
   lifetimeMS           = 3000;
   lifetimeVarianceMS   = 250;
   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0.6 0.6 0.6 0.1";
   colors[1]     = "0.6 0.6 0.6 0.8"; //org 0.6 0.6 0.6 0.1
   colors[2]     = "0.6 0.6 0.6 0.0";

   sizes[0]      = 15; // org 2.5
   sizes[1]      = 22.5; // org 4
   sizes[2]      = 37; // org 6

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(tankSmokeEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 5;

   ejectionVelocity = 0.25;
   velocityVariance = 0.10;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = tankSmoke;
};

datablock ParticleEmitterNodeData(tankSmokeEmitterNode)
{
   timeMultiple = 1;
};


datablock ParticleData(MESmoke)
{
   dragCoeffiecient     = 0.4;
   gravityCoefficient   = -0.5;   // rises slowly
   inheritedVelFactor   = 0.025;

   lifetimeMS           = 1250;
   lifetimeVarianceMS   = 0;

   textureName          = "~/data/specialfx/particleTest";

   useInvAlpha =  true;
   spinRandomMin = -200.0;
   spinRandomMax =  200.0;

   textureName = "~/data/specialfx/smoke1";

   colors[0]     = "1.0 0.7 0.5 1.0";
   colors[1]     = "0.3 0.3 0.3 1.0";
   colors[2]     = "0.0 0.0 0.0 0.0";
   sizes[0]      = 2.0;
   sizes[1]      = 6.0;
   sizes[2]      = 2.0;
   times[0]      = 0.0;
   times[1]      = 0.3;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(MESmokeEMitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 6.25;
   velocityVariance = 0.25;

   thetaMin         = 0.0;
   thetaMax         = 180.0;

   lifetimeMS       = 250;

   particles = "MESmoke";
};


// -Debris (pieces)

datablock DebrisData(MechaDebris)
{
   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 4.0;
   lifetimeVariance = 0.0;

   minSpinSpeed = 40;
   maxSpinSpeed = 120; // org 600 

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.15; // org 1

   useRadiusMass = true;
   baseRadius = 1;

   velocity = 15.0; // org 20
   velocityVariance = 6.0; // org 12
};

// - Explosions (vehicles & Mecha)
 
datablock ExplosionData(SubExplosion1)
{
   offset = 1.0;
   explosionShape = "~/data/fx/explosions/explosion02.dts";
};

datablock ExplosionData(MechaSubExplosion1)
{
   offset = 0; // org 1
   explosionShape = "~/data/fx/explosions/ringwave01.dts";
   };

datablock ExplosionData(ReactorExplosion1)
{
   offset = 1.0;
   explosionShape = "~/data/fx/explosions/ringwave01.dts";
};


// new data to add some explosion particles to the mav death
datablock ParticleData(MAVExpPartsParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.15; // org 0.5
   inheritedVelFactor   = 0.75; // org 0.2
   constantAcceleration = 0.0;
   lifetimeMS           = 2000; // org 750
   lifetimeVarianceMS   = 150; // org 150
   textureName          = "~/data/specialfx/smoke2";
   colors[0]     = "1 1 1 1"; //org 0 0.2 1 1.0
   //colors[1]     = "0.0078125 0.2421875 0.6875 0.75"; //org 0 0.2 1 1.0
   colors[1]     = "0.68359375 0.75 0.0078125 0.66"; //colors[2]     = "0.68359375 0.75 0.0078125 0.66";
   colors[2]     = "0.74609375 0.09765625 0.04296875 0.33"; //colors[3]     = "0.74609375 0.09765625 0.04296875 0.33";
   colors[3]     = "0 0 0 0"; //colors[4]     = "0 0 0 0";
   sizes[0]      = 7.5; // org 0.5
   sizes[1]      = 4; // org 2
   sizes[2]      = 2.5; //new
   sizes[3]      = 1; //new
  //sizes[4]      = 0.1; //new
   times[0]      = 0.33; //new
   times[1]      = 0.5; //new
   times[2]      = 0.66; //new
   times[3]      = 1; //new
   //times[4]      = 1.0; //new
};

datablock ParticleEmitterData(MAVExpPartsEmitter)
{
   ejectionPeriodMS = 3000; //org 7
   periodVarianceMS = 350; // org 0 ... 35
   ejectionVelocity = 35; // org 0.5
   velocityVariance = 15; // org 0
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 15; // org 60
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MAVExpPartsParticle";
};

datablock ExplosionData(MechaExplosion)
{
   lifeTimeMS = 3000; //new org 1500
    // particles upon explosion
   particleEmitter = MAVExpPartsEmitter; //new
   particleDensity = 150; //new org 50
   particleRadius = 1; //new org 1
   
   explosionShape = "~/data/shapes/weapons/effect_plasma_explosion.dts";  //explosionShape = "~/data/fx/explosions/explosion01.dts";
   //playSpeed = 0.5;
   soundProfile = MechaExplosionSound;
   faceViewer = true;
   debris = MechaDebris;
   debrisThetaMin = 10;
   debrisThetaMax = 80;
   debrisNum = 3;
   debrisNumVariance = 1;
   debrisVelocity = 5.0; // org 20
   debrisVelocityVariance = 2.5; // org 5
   
   
   // Sub explosion objects
   //subExplosion[0] = MechaSubExplosion1;
  
  

   shakeCamera = true;
   camShakeFreq = "11.0 13.0 9.0";
   camShakeAmp = "40.0 40.0 40.0";
   camShakeDuration = 0.7;
   camShakeRadius = 25.0;

   // Dynamic light
   lightStartRadius = 20;
   lightEndRadius = 0;
   lightStartColor = "1 1 1"; // org 0 0.2 1 1.0
   lightEndColor = "0 0.75 0.75"; // org 0 0 0

};

datablock ExplosionData(smallExplosion)
{
   explosionShape = "~/data/fx/explosions/explosion02.dts";
   playSpeed = 1.0;
   soundProfile = ExplosionSound;
   faceViewer = true;
   // emitter[0] = MESmokeEmitter;
   debris = MechaDebris;
   debrisThetaMin = 10;
   debrisThetaMax = 80;
   debrisNum = 3;
   debrisNumVariance = 1;
   debrisVelocity = 20.0;
   debrisVelocityVariance = 5.0;

   shakeCamera = true;
   camShakeFreq = "11.0 13.0 9.0";
   camShakeAmp = "40.0 40.0 40.0";
   camShakeDuration = 0.7;
   camShakeRadius = 25.0;

   // Dynamic light
   lightStartRadius = 20;
   lightEndRadius = 0;
   lightStartColor = "0.6 0 0";
   lightEndColor = "0 0 0";
};

datablock ParticleData(VehicleLiftoffDust)
{
   dragCoefficient      = 1.0;
   gravityCoefficient   = -0.01;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 500.0;
   textureName          = "~/data/specialfx/smoke1";
   colors[0]     = "0.46 0.36 0.26 0.0";
   colors[1]     = "0.46 0.46 0.36 0.4";
   colors[2]     = "0.46 0.46 0.36 0.0";
   sizes[0]      = 1.2;
   sizes[1]      = 2.6;
   sizes[2]      = 3.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(VehicleLiftoffDustEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;
   ejectionVelocity = 10.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 90;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   useEmitterColors = true;
   particles = "VehicleLiftoffDust";
};
datablock ParticleData(MechaJetParticle) // Mecha Jump Jetting Color
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 200; // org 90
   lifetimeVarianceMS   = 0;
   textureName          = "~/data/specialfx/flash2";
   colors[0]     = "1 1 1 1";
   colors[1]     = "0 0.2 1 1.0"; // org 0 0.2 1 1.0
   colors[2]     = "0 0.2 1 0.33"; // org 0 0.2 1 0.25
   colors[3]     = "0 0 0 0";
   sizes[0]      = 0.50; // org 0.5
   sizes[1]      = 0.66; // org 0.125
   sizes[2]      = 0.75; // new
   sizes[3]      = 1; // new
   times[0]      = 0.25; //new
   times[1]      = 0.5; //new
   times[2]      = 0.8; //new
   times[3]      = 1; //new
};

datablock ParticleEmitterData(MechaJetEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 2.9;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 5;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "MechaJetParticle";
};
