

function GameConnection::joinTeam(%this, %teamid){
  //We only have 2 teams so if team is greater than 2 or less than 0 its invalid.

   if (%teamid > 2 || %teamid == 0)
      return false;
   //If we already are on that team return.
   if (%teamid == %this.team.teamId) {
      %this.spawnpoint = pickSpawnPoint(%this);
      return false;
   }
   //Reset personal score to 0 when changing teams
   if(%this.team)
   {
      %this.score = 0;
      //if (%client.player)
      //%client.player.delete();
      $Team[%this.team.teamid].numPlayers--;
   }

   $Team[%teamid].numPlayers++;
   %this.team = $Team[%teamid];
   %this.spawnpoint =  pickSpawnPoint(%this);

   for (%cl = 0; %cl < ClientGroup.getCount(); %cl++) {
      %other = ClientGroup.getObject(%cl);
      if ((%other != %this)) {
          messageClient(%other, 'MsgClientJoinTeam', '\c1%1 has joined %4' ,
          %this.name, %this, %this.team.teamID,%this.team.name);
      }
   }
   %msg = "\c1You have joined " @ %this.team.name;
   messageClient(%this, 'MsgClientJoinTeam', %msg, %this.name, %this, %this.team.teamID);
}

function pickSpawnPoint(%client)
{
   //Only check for the base spawn points when they exist, and its the right team.
   if (isObject(BaseTeam))
   {
      if (BaseTeam.getCount() > 0 && %client.team.teamID == BaseTeam.teamid)
         %random = getRandom(0,10);
      else
         %random = 11;
         
      error("Random Spawn: " @ %random);
      if (%random <= 5)
         %Tree = BaseTeam;
      else
         %Tree = %client.team.spawn;
   }
   else
   {
      %Tree = %client.team.spawn;
   }
   if ((%Tree).getCount() != 0)
   {
      %random = getRandom((%Tree).getCount() - 1);
      %Leaf = %Tree.getObject(%random);
      if (%Leaf.getCount() != 0) {
          %index = getRandom(%Leaf.getCount() - 1);
          %spawn = %Leaf.getObject(%index);
          return getTerrainLevel(%spawn.position,%spawn.radius);
      }
      else
         error("No " @ %client.team.name @ " team spawn points found in " @ %Leaf);

   }
   // Could be no spawn points, in which case we'll stick the
   // player at the center of the world.
   return "0 0 300 1 0 0 0";
}


//gets the terrain hight withing a radius to a given point (I think...)
function getTerrainLevel(%pos,%rad)
{
	while(%retries < 500)
	{
		%x = getWord(%pos, 0) + mFloor(getRandom(%rad * 2) - %rad);
		%y = getWord(%pos, 1) + mFloor(getRandom(%rad * 2) - %rad);
		%z = getWord(%pos, 2) + mFloor(getRandom(%rad * 2) - %rad);

		%start 		= %x @ " " @ %y @ " 5000";
		%end 		= %x @ " " @ %y @ " -1";
		%ground 	= containerRayCast(%start, %end, $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType , 0);
		%z 		= getWord(%ground, 3);


		//PC: move the guy up a little bit, to make sure he doesnt start under the land.
		// or has time to collide with it.
		%z += 0.05;

		error ("Spawn Position   : " @ %x SPC %y);
		error ("Ground Level     : " @ %z);


		%position = %x @ " " @ %y @ " " @ %z;

		%mask = ($TypeMasks::VehicleObjectType |
			$TypeMasks::MoveableObjectType |
			$TypeMasks::StaticShapeObjectType |
			$TypeMasks::ForceFieldObjectType |
			//$TypeMasks::InteriorObjectType |
			$TypeMasks::ItemObjectType);

		if (ContainerBoxEmpty(%mask,%position,3.5))
		{
			error ("Spawn Position Is Good");
			return %position;
		}
		else
			%retries++;
	}
	// PC: raised the default failure height a bit.. MIGHT be applied in some unreasonable cases?
	return "0 0 1300 1 0 0 0";
}


