//------------------------------------------------------------------------------
// Abolisher Primary Weapon Systems
//------------------------------------------------------------------------------
// How to change
//   ItemData -> THIS IS WHAT GETS ADDED TO INVENTORY.
//               Just make sure image points to the ShapeBaseImage
//   ImageData -> If you cant pick up Ammo, it doesn't need to change.
//                So use the base ammo.
//                If you want to change state sounds/timeouts/emitters,
//                Do it here!! If your comming up with new states completely
//                MAKE A NEW BASE IMAGE!!
//   ProjectileData -> THIS IS WHERE DMG, RADIUS, ETC is set
//                This is also where the emitters are for FX.
//                So if you want them changed, you'll have to do that here.
//                Make sure to add them to the weaponsFX scripts.
//                That is where weapon FX variants go.
//                If you want to add an extra field from the base, this is where to do it.
//                I'm looking at you Ed on this one :p

datablock ProjectileData(AbolisherPrimaryProjectile1 : plasmaProjectile)
{
   //Damage
   directDamage        = 45;
   radiusDamage        = 5;
   damageRadius        = 1; //org 2

   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 200; // org 100
   lifetime            = 1875; // org 6400
   fadeDelay           = 250; // org 1500
   explosion           = plasmaExplosion1;
   particleEmitter     = plasmaSmokeEmitter1;
};
datablock ItemData(AbolisherPrimaryAmmo1 : plasmaAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(AbolisherPrimary1 : plasma)
{
	//
	pickUpName = "DK-25 Plasma Rifle";
   displayName = "DK25 PR";
	image = AbolisherPrimaryImage1;
     amount = "400";
   refire = "high";
   damage = "50 ap";
   range  = "640 m";
};

datablock ShapeBaseImageData(AbolisherPrimaryImage1 : plasmaImage)
{

   item = AbolisherPrimary1;
   ammo = AbolisherPrimaryAmmo1;
   projectile = AbolisherPrimaryProjectile1;
};

datablock ProjectileData(AbolisherPrimaryProjectile2 : acProjectile)
{
   directDamage        = 100;
   radiusDamage        = 0;
   damageRadius        = 0;
   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 400; // org 750
   lifetime            = 1500; // org 2400
   fadeDelay           = 250; // org 500
   explosion           = acExplosion;
   particleEmitter     = acSmokeEmitter1;
};
datablock ItemData(AbolisherPrimaryAmmo2 : acAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(AbolisherPrimary2 : ac)
{
	pickUpName = "LiveFire 30 AC";
   displayName = "LF-30 AC";
	image = AbolisherPrimaryImage2;
     amount = "300";
   refire = "medium";
   damage = "100";
   range  = "750m";
};

datablock ShapeBaseImageData(AbolisherPrimaryImage2 : acImage)
{
   item = AbolisherPrimary2;
   ammo = AbolisherPrimaryAmmo2;
   projectile = AbolisherPrimaryProjectile2;
};

datablock BeamData(AbolisherPrimaryProjectile3 : laserProjectile)
{
   directDamage        = 100;
   radiusDamage        = 0;
   damageRadius        = 0;
   beamStyle         = 1;
   beamStartRadius   = 0.4;
   beamEndRadius     = 0.0;
   materialList = "~/data/shapes/weapons/purple.dml";
   //beamLength        = 1000;
};

datablock ItemData(AbolisherPrimaryAmmo3 : laserAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(AbolisherPrimary3 : laser)
{
	pickUpName = "XL7 Brimstone Laser";
   displayName = "XL7 BS L";
	image = AbolisherPrimaryImage3;
     amount = "Unlimited";
   refire = "high";
   damage = "100d";
   range  = "unlim";
   materialList = "~/data/shapes/weapons/purple.dml";
};

datablock ShapeBaseImageData(AbolisherPrimaryImage3 : laserImage)
{
   item = AbolisherPrimary3;
   ammo = AbolisherPrimaryAmmo3;
   projectile = AbolisherPrimaryProjectile3;
   minEnergy = 20;
   fireEnergy = 10;
   fireTimeout = 1000;
   stateSound[3]					      = "altLaserFireSound";
};


//------------------------------------------------------------------------------
// SECONDARY WEAPONS
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// SECONDARY WEAPONS
//------------------------------------------------------------------------------

datablock SeekerProjectileData(AbolisherSecondaryProjectile1 : homingProjectile)
{
   directDamage        = 65;
   radiusDamage        = 10;
   damageRadius        = 5;
   explosion           = homingExplosion;
   particleEmitter     = homingSmokeEmitter;
};
datablock ItemData(AbolisherSecondaryAmmo1 : homingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(AbolisherSecondary1 : homing)
{
	//
   pickUpName = "T5 Yellow Jacket Homing Missile";
   displayName = "T5 YJ HM";
	image = AbolisherSecondaryImage1;
     amount = "45";
   refire = "high";
   damage = "75";
   range  = "na";
};

datablock ShapeBaseImageData(AbolisherSecondaryImage1 : homingImage)
{

   item = AbolisherSecondary1;
   ammo = AbolisherSecondaryAmmo1;
   projectile = AbolisherSecondaryProjectile1;
   seekRadius = 750;
};



//------------------------------------------------------------------------------
datablock SeekerProjectileData(AbolisherSecondaryProjectile2 : homingProjectile)
{
   directDamage        = 70;
   radiusDamage        = 25;
   damageRadius        = 10;
   explosion           = homingExplosion;
   particleEmitter     = homingSmokeEmitter;
};

datablock ItemData(AbolisherSecondaryAmmo2 : homingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(AbolisherSecondary2 : homing)
{
 	pickUpName = "T15 Viper Homing Missile";
   displayName = "T15 V HM";
	image = AbolisherSecondaryImage2;
     amount = "35";
   refire = "medium";
   damage = "95 ap";
   range = "na";
};

datablock ShapeBaseImageData(AbolisherSecondaryImage2 : homingImage)
{
   item = AbolisherSecondary2;
   ammo = AbolisherSecondaryAmmo2;
   projectile = AbolisherSecondaryProjectile2;
   seekRadius = 750;
};


//------------------------------------------------------------------------------
datablock ProjectileData(AbolisherSecondaryProjectile3 : LARBProjectile)
{
   directDamage        =50;
   radiusDamage        = 200;
   damageRadius        = 50;
   muzzleVelocity      = 160;
   lifetime            = 6000;
   fadeDelay           = 500;
   explosion           = LARBExplosion;
};
datablock ItemData(AbolisherSecondaryAmmo3 : LARBAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(AbolisherSecondary3 : LARB)
{
	pickUpName = "Long Range Artillery Bombardment";
   displayname = "LARB";
	image = AbolisherSecondaryImage3;
    amount = "40";
   refire = "low";
   damage = "200 r";
   range  = "900 m";
};

datablock ShapeBaseImageData(AbolisherSecondaryImage3 : LARBImage)
{
   item = AbolisherSecondary3;
   ammo = AbolisherSecondaryAmmo3;
   projectile = AbolisherSecondaryProjectile3;
};

