//-----------------------------------------------------------------------------
// Torque Game Engine
//
// Copyright (c) 2001 GarageGames.Com
//-----------------------------------------------------------------------------
// Livefire-10 Auto Cannon	5	800	low
// Livefire-20 Auto Cannon	4	640	medium
// Livefire-30 Auto Cannon	3	480	high

//-----------------------------------------------------------------------------
// ac weapon. This file contains all the items related to this weapon
// including explosions, ammo, the item and the weapon item image.
// These objects rely on the item & inventory support system defined
// in item.cs and inventory.cs
//-----------------------------------------------------------------------------

datablock AudioProfile(acMountSound)
{
	filename = "~/data/sound/weapons/Cannon3.ogg";
	description = AudioClosest3d;
	preload = true;
};

datablock AudioProfile(acFireSound)
{
  filename = "~/data/sound/Cannon3.ogg";
  description = AudioClosest3d;
  preload = true;
};

datablock AudioProfile(acDryFireSound)
{
	filename = "~/data/sound/weapons/ac/cock.ogg";
	description = AudioClose3d;
	preload = true;
};


//-----------------------------------------------------------------------------
// Projectile trail emitter
datablock ParticleData(acSmokeParticle)
{
   textureName          ="~/data/specialfx/wave";
   
   dragCoefficient     = 0.0;
   gravityCoefficient   = -0.1;  // rises -- org -0.2
   inheritedVelFactor   = -55; // org -55 -- if you increase the velocity of the weapon you must change this!!!
   lifetimeMS           = 450;   // particle life in ms; org 450
   lifetimeVarianceMS   = 50;   // ...more or less -- org 150
   useInvAlpha = true;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "1 1 1 1";  // org 0.85 1 0.66 0.5
   colors[1]     = "1 1 1 0.5"; // org 1 1 1 0.25
   colors[2]     = "1 1 1 0"; // org 0 0 0 0
   sizes[0]      = 1.25; // org 0.2
   sizes[1]      = 2; // org 0.5
   sizes[2]      = 2.5; // org 1
   times[0]      = 0;
   times[1]      = 0.33; // org 0.25
   times[2]      = 1; // org 1.25
   
};

datablock ParticleEmitterData(acSmokeEmitter)
{
   ejectionPeriodMS = 12; // org 8
   periodVarianceMS = 5; // org 0
   ejectionVelocity = 0.25; // org 0
   velocityVariance = 0.0; // org 0
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   particles = acSmokeParticle;
	
};

datablock ParticleData(acProjectilePuff)
{
   textureName          = "~/data/shapes/weapons/acSmoke01";

   dragCoeffiecient     = 0.0;
   gravityCoefficient   = 0.0;  // rises org -0.25
   inheritedVelFactor   = 0.3; // org 0.3

   lifetimeMS           = 850;   // Time in ms -- org 250
   lifetimeVarianceMS   = 100;    // ...more or less -- org 10

   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0.25 0.62 0.73 0.75"; // org 0 0.2 1 1.0
   colors[1]     = "0.25 0.62 0.73 0.66"; // org 1 1 1 1.0
   colors[2]     = "0.25 0.62 0.73 0"; // org 0 0 0 0

   sizes[0]      = 0.25;
   sizes[1]      = 0.5;
   sizes[2]      = 1;

   times[0]      = 0.0;
   times[1]      = 0.3;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(acProjPuffEmitter)
{
   particles = acProjectilePuff; // new
};

datablock ParticleData(acSmokeParticle2 :acSmokeParticle)
{
   // controls the particle trail colors and sizes for the Hunter Scout
   colors[0]     = "1 1 1 0.33"; // org 1 1 0.2 0.5
   colors[1]     = "1 1 1 0.15"; // org 0.9 0.9 0.2 0.5
   colors[2]     = "1 1 1 0";
   sizes[0]     = 0.5;
   sizes[1]     = 0.66;
   sizes[2]     = 1;
   times[0]     = 0;
   times[1]     = 0.15;
   times[2]     = 1;
};

datablock ParticleEmitterData(acSmokeEmitter2 : acSmokeEmitter)
{
   particles = acSmokeParticle; // org 2
   //particles = acProjectilePuff; // new
};
datablock ParticleData(acSmokeParticle1 : acSmokeParticle)
{
   // controls the particle trail colors and sizes used by Abolisher and Shaddrack
   colors[0]     = "1 1 1 0.33"; // org 0.56640625 0.50390625 0.02734375 0.5
   colors[1]     = "1 1 1 0.15"; // org 0.9 0.9 0.2 0.5
   colors[2]     = "1 1 1 0";
   sizes[0]     = 0.66;
   sizes[1]     = 0.75;
   sizes[2]     = 1.25;
   times[0]     = 0;
   times[1]     = 0.22;
   times[2]     = 1;
};

datablock ParticleEmitterData(acSmokeEmitter1 : acSmokeEmitter)
{
   particles = acSmokeParticle; // org 2
   //particles = acProjectilePuff; // new
};

//-----------------------------------------------------------------------------
// Weapon fire emitter
//-----------------------------------------------------------------------------

datablock ParticleData(acFireParticle)
{
   textureName          = "~/data/specialfx/smoke1";

   dragCoeffiecient     = 200; // org 0
   gravityCoefficient   = -0.15;  // rises org -0.1
   inheritedVelFactor   = 0.3; // org 0.3

   lifetimeMS           = 250;   // Time in ms -- org 250
   lifetimeVarianceMS   = 10;    // ...more or less -- org 10
   //particleDensity = 10; // new
   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "1 0.84 0.44 0.66"; // org 1 1 1 1
   colors[1]     = "0.25 0.62 0.73 1"; // org 0.9 0.6 0.21 1
   colors[2]     = "0.25 0.72 0.85 0"; // org 1 0 0 0

   sizes[0]      = 2; // org 0.2
   sizes[1]      = 0.66; // org 1
   sizes[2]      = 0.25; // org 1

   times[0]      = 0.0;
   times[1]      = 0.3;
   times[2]      = 1.0;
   
  
};



datablock ParticleEmitterData(acFireEmitter)
{
   ejectionPeriodMS = 10; // org 10
   periodVarianceMS = 0; // org 5

   ejectionVelocity = 2; // org 0.25
   velocityVariance = 0.25; // org 0.1

   thetaMin         = 0.0;
   thetaMax         = 180.0; // org 90

   particles = acFireParticle;
   
    // Dynamic light
   lightStartRadius = 1; // org 5
   lightEndRadius = 0;
   lightStartColor = "0.25 0.62 0.73 1.0";  //org 1 1 1
   lightEndColor = "0.25 0.62 0.73 0";  //org 0 0 0
   
   
};


//-----------------------------------------------------------------------------
// Projectile Explosion

datablock ParticleData(acExplosionParticle)
{
   dragCoefficient      = 50; // org 2
   gravityCoefficient   = 0.35; // org 0.2
   inheritedVelFactor   = 1; // org 0.2
   constantAcceleration = -0.75; // org 0
   lifetimeMS           = 300; // org 750
   lifetimeVarianceMS   = 150;
   spinRandomMin        = -80.0; // new
   spinRandomMax        =  80.0; // new
   textureName          = "~/data/specialfx/smoke2";
   colors[0]     = "0.25 0.62 0.73 1.0"; // org 1 1 1
   colors[1]     = "1 1 1 0"; // org 1 1 1 1
   sizes[0]      = 0.25; // org 0.5
   sizes[1]      = 1.5; // org 1.0
};

datablock ParticleEmitterData(acExplosionEmitter)
{
   ejectionPeriodMS = 3; // org 10
   periodVarianceMS = 0;
   ejectionVelocity = 13; // org 4
   velocityVariance = 5; // org 1.0
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180; // org 60
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "acExplosionParticle";
};

datablock ParticleData(acExplosionSparks)
{
   textureName          = "~/data/specialfx/spark";
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 350; // org 500
   lifetimeVarianceMS   = 100;  // org 350

   colors[0]     = "0.60 0.40 0.30 1.0";
   colors[1]     = "1.0 0.40 0.30 1.0";
   colors[2]     = "0 0 0 0";

   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
   sizes[2]      = 0.25;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(acExplosionSparkEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 13;
   velocityVariance = 6.75;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "acExplosionSparks";
};

datablock ExplosionData(acExplosion)
{
   lifeTimeMS = 250; // new -- org 1500
   particleEmitter = acExplosionEmitter;
   particleDensity = 20; // how many particles to emit -- org 20
   particleRadius = 1; // how much of a radius should they emit from -- org 1.5

   faceViewer     = true;
   explosionScale = "1.5 1.5 1.5"; // org 1 1 1

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.2;
   camShakeRadius = 3.0;
   
   // Point emission
   emitter[0] = acExplosionEmitter;
   emitter[1] = acExplosionSparkEmitter;
   
    // Dynamic light
   lightStartRadius = 2; // org 5
   lightEndRadius = 0;
   lightStartColor = "0.25 0.62 0.73 1.0";  //org 1 1 1
   lightEndColor = "1 1 1";  //org 0 0 0
};


//-----------------------------------------------------------------------------
// Projectile Object

datablock ProjectileData(acProjectile)
{
   projectileShapeName = "~/data/shapes/weapons/acammo.dts";
   directDamage        = 25;
   radiusDamage        = 2;
   damageRadius        = 2;
   explosion           = acExplosion;
   particleEmitter     = acSmokeEmitter;
   emitter[0]         = acSmokeEmitter;
   emitter[1]         = acProjPuffEmitter;

   muzzleVelocity      = 300;
   velInheritFactor    = 0.1;

   armingDelay         = 0;
   lifetime            = 2000;
   fadeDelay           = 1500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.10;

   hasLight    = true;
   lightRadius = 2.0; // org 1.0
   colors[0]     = "0.25 0.62 0.73"; // org 0 0.2 1 1.0
};

//-----------------------------------------------------------------------------
// Ammo Item

datablock ItemData(acAmmo)
{
   // Mission editor category
   category = "Ammo";

   // Add the Ammo namespace as a parent.  The ammo namespace provides
   // common ammo related functions and hooks into the inventory system.
   className = "Ammo";

   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/ammo.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;

	// Dynamic properties defined by the scripts
	pickUpName = "ac ammo";
   maxInventory = 1000;
};


//--------------------------------------------------------------------------
// ac shell that's ejected during reload.

datablock DebrisData(acShell)
{
   shapeFile = "~/data/shapes/weapons/shell.dts";
   lifetime = 3.0;
   minSpinSpeed = 300.0;
   maxSpinSpeed = 400.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 4;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;
};


//--------------------------------------------------------------------------
// Weapon Item.  This is the item that exists in the world, i.e. when it's
// been dropped, thrown or is acting as re-spawnable item.  When the weapon
// is mounted onto a shape, the RifleImage is used.

datablock ItemData(ac)
{
   // Mission editor category
   category = "Weapon";

   // Hook into Item Weapon class hierarchy. The weapon namespace
   // provides common weapon handling functions in addition to hooks
   // into the inventory system.
   className = "Weapon";

   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/defaultcannons.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

	// Dynamic properties defined by the scripts
	pickUpName = "an ac";
	image = acImage;
};


//--------------------------------------------------------------------------
// ac image which does all the work.  Images do not normally exist in
// the world, they can only be mounted on ShapeBase objects.

datablock ShapeBaseImageData(acImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/ac.dts";

   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   correctMuzzleVector = true;
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ac;
   ammo = acAmmo;
   projectile = acProjectile;
   projectileType = Projectile;

   // Initial start up state
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";
   //stateSound[0] = "acMountSound";

   // Activating the gun.  Called when the weapon is first
   // mounted and there is ammo.
   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;
   stateSequence[1]                 = "Activate";
   //stateSound[1] = "acMountSound";

   // Ready to fire, just waiting for the trigger
   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   // Fire the weapon. Calls the fire script which does
   // the actual work.
   stateName[3]                     = "Fire";
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "fire";
   stateScript[3]                   = "onFire";
   stateEmitter[3]                  = acFireEmitter;
   stateEmitterTime[3]              = 0.1; // org 0 controls the flash emitter
   stateSound[3] 		            = "acFireSound";
   stateTimeoutValue[3]             = 0.5; // org 1.0
   stateTransitionOnTimeout[3]      = "Reload";
  
  
   // Play the relead animation, and transition into
   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.001;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateEjectShell[4]               = true;
   //stateSound[4] = "acmountSound";

   // No ammo in the weapon, just idle until something
   // shows up. Play the dry fire sound if the trigger is
   // pulled.
   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   // No ammo dry fire
   stateName[6]                     = "DryFire";
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
   stateSound[6] = "acDryFireSound";

};


//-----------------------------------------------------------------------------

function acImage::onFire(%this, %obj, %slot)
{
   %projectile = %this.projectile;

   // automatically by the ammo inventory hooks.
   %obj.decInventory(%this.ammo,1);

      //inv on screen
   %currentAmmo = %obj.getInventory(%this.ammo);
   //%currentAmmo = %obj.getInvItem(%this.ammo,"amount");
   //echo("weapon fired now it has " @ %currentAmmo @" amount of ammo");
   if(!%obj.client.isAIControlled())
   %obj.client.setAmmoAmountHud(%currentAmmo);

   // Determin initial projectile velocity based on the
   // gun's muzzle point and the object's current velocity
   %muzzleVector = %obj.getMuzzleVector(%slot);
   %objectVelocity = %obj.getVelocity();
   %muzzleVelocity = VectorAdd(
      VectorScale(%muzzleVector, %projectile.muzzleVelocity),
      VectorScale(%objectVelocity, %projectile.velInheritFactor));

   // Create the projectile object
   %p = new (%this.projectileType)() {
      dataBlock        = %projectile;
      initialVelocity  = %muzzleVelocity;
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      client           = %obj.client;
   };
   MissionCleanup.add(%p);
   return %p;
}

function baseAC::onFire(%this, %obj, %slot,%ammo)
{
   %projectile = %this.projectile;
   %obj.decInventory(%this.ammo,%ammo);
  if(!isSpecialWeapon(%this.item))
   if(!%obj.aiPlayer)
      %obj.client.setAmmoAmountHud(%obj.getInventory(%this.ammo));

   if(!%obj.aiPlayer)
     %clientID = %obj.client;
   else
     %clientID = %obj;

   %muzzleVector = %obj.getMuzzleVector(%slot);
   %objectVelocity = %obj.getVelocity();
   %muzzleVelocity = VectorAdd(
      VectorScale(%muzzleVector, %projectile.muzzleVelocity),
      VectorScale(%objectVelocity, %projectile.velInheritFactor));

   %p = new (%this.projectileType)() {
      dataBlock        = %projectile;
      initialVelocity  = %muzzleVelocity;
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      client           = %clientID;
   };
   MissionCleanup.add(%p);

   return %p;
}

