//-----------------------------------------------------------------------------
// homing Launcher, fires rockets and can seek players
//-----------------------------------------------------------------------------

datablock AudioProfile(homingFireSound)
{
   filename = "~/data/sound/missile2.ogg";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(homingExplosionSound)
{
   filename = "~/data/sound/medexplode.ogg";
   description = AudioDefault3d;
   preload = true;
};

//--------------------------------------------------------------------------
// Particle effects
//--------------------------------------
datablock ParticleData(homingSmokeParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.02;
   inheritedVelFactor   = 0.1;

   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 100;

   textureName          = "~/data/specialfx/smoke1";

   useInvAlpha = true;
   spinRandomMin = -90.0;
   spinRandomMax = 90.0;

   colors[0]     = "1.0 0.75 0.0 0.0";
   colors[1]     = "0.5 0.5 0.5 1.0";
   colors[2]     = "0.3 0.3 0.3 0.0";
   sizes[0]      = 1;
   sizes[1]      = 2;
   sizes[2]      = 3;
   times[0]      = 0.0;
   times[1]      = 0.1;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(homingSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionVelocity = 1.5;
   velocityVariance = 0.3;

   thetaMin         = 0.0;
   thetaMax         = 50.0;  

   particles = "homingSmokeParticle";
};
datablock ParticleData(homingFireParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 1.0;

   lifetimeMS           = 300;
   lifetimeVarianceMS   = 000;

   textureName          = "~/data/specialfx/particleTest";

   spinRandomMin = -135;
   spinRandomMax =  135;

   colors[0]     = "1.0 0.75 0.2 1.0";
   colors[1]     = "1.0 0.5 0.0 1.0";
   colors[2]     = "1.0 0.40 0.0 0.0";
   sizes[0]      = 0.33; // org 0
   sizes[1]      = 1;
   sizes[2]      = 1.5;
   times[0]      = 0.0;
   times[1]      = 0.3;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(homingFireEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;

   ejectionVelocity = 15.0;
   velocityVariance = 0.0;

   thetaMin         = 0.0;
   thetaMax         = 0.0;  

   particles = "homingFireParticle";
};



datablock ParticleData(homingPuffParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.0;

   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;

   textureName          = "~/data/specialfx/smoke2";

   spinRandomMin = -135;
   spinRandomMax =  135;

   colors[0]     = "1.0 1.0 1.0 0.5";
   colors[1]     = "0.7 0.7 0.7 0.0";
   sizes[0]      = 0.25;
   sizes[1]      = 1.0;
   times[0]      = 0.0;
   times[1]      = 1.0;
};

datablock ParticleEmitterData(homingPuffEmitter)
{
   ejectionPeriodMS = 50;
   periodVarianceMS = 3;

   ejectionVelocity = 0.5;
   velocityVariance = 0.0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   particles = "homingPuffParticle";
};
datablock ParticleData(homingExhaustParticle)
{
    dragCoeffiecient = 0.0;
    gravityCoefficient = 0.01;
    inheritedVelFactor = 1.0;

    lifetimeMS = 500;
    lifetimeVarianceMS    = 300;

    textureName = "~/data/specialfx/smoke1";

    useInvAlpha = true;
    spinRandomMin = -135;
    spinRandomMax = 135;

    colors[0] = "1.0 1.0 1.0 1.0";
    colors[1] = "1.0 1.0 1.0 1.0";
    sizes[0] = 0.12;
    sizes[1] = 0.50;
    times[0] = 0.0;
    times[1] = 1.0;
};

datablock ParticleEmitterData(homingExhaustEmitter)
{
    ejectionPeriodMS = 15;
    periodVarianceMS = 0;

    ejectionVelocity = 3.0;
    velocityVariance = 0.0;

    thetaMin = 0.0;
    thetaMax    = 20.0;

    particles = "homingExhaustParticle";
};
//----------------------------------------------------------------------------
// Explosion smoke particles
//----------------------------------------------------------------------------

datablock ParticleData(homingExplosionSmoke)
{
    dragCoeffiecient    = 0.3;
    gravityCoefficient    = -0.2;
    inheritedVelFactor    = 0.025;

    lifetimeMS = 1250;
    lifetimeVarianceMS    = 0;

    useInvAlpha = true;
    spinRandomMin = -100.0;
    spinRandomMax = 100.0;

    textureName = "~/data/specialfx/smoke";

    colors[0] = "1.0 1.0 1.0 1.0";
    colors[1] = "0.7 0.7 0.7 0.5"; // org 1.0 1.0 1.0 1.0
    colors[2] = "0 0 0 0"; // org 1.0 1.0 1.0 1.0
    sizes[0] = 1.0;
    sizes[1] = 3.0;
    sizes[2] = 4.0; // org 0.1
    times[0] = 0.0;
    times[1] = 0.5;
    times[2] = 1.0;
	
	
};
      datablock ParticleData( homingSmokeSpike )
{
    dragCoeffiecient = 1.0;
    gravityCoefficient = 0.0;
    inheritedVelFactor = 0.2;

    lifetimeMS = 1000;
    lifetimeVarianceMS    = 100;

    textureName = "~/data/specialfx/smoke";

    useInvAlpha = true;

    spinRandomMin = -60.0;
    spinRandomMax = 60.0;

    colors[0] = "1.0 1.0 1.0 1.0";
    colors[1] = "0.7 0.7 0.7 0.66"; // org 1.0 1.0 1.0 1.0
    colors[2] = "0 0 0 0"; // org 1.0 1.0 1.0 1.0
    sizes[0] = 0.0;
    sizes[1] = 1.0;
    sizes[2] = 2; // org 0.5
    times[0] = 0.0;
    times[1] = 0.66; // org 0.5
    times[2] = 1.0;
};

datablock ParticleEmitterData( homingSmokeSpikeEmitter )
{
    ejectionPeriodMS = 7;
    periodVarianceMS = 1;

    ejectionVelocity = 1.0; // A little oomph at the back end
    velocityVariance = 0.2;

    thetaMin    = 0.0;
    thetaMax    = 40.0;

    particles = "homingSmokeSpike";
};
datablock ParticleEmitterData(homingExplosionSmokeEMitter)
{
    ejectionOffset = 0.0;
    ejectionPeriodMS = 5;
    periodVarianceMS = 0;

    ejectionVelocity = 3.25;
    velocityVariance = 0.25;

    thetaMin = 0.0;
    thetaMax = 180.0;

    lifetimeMS = 250;

    particles = "homingExplosionSmoke";
};
 datablock DebrisData( homingSpikeDebris )
{
    emitters[0] = homingSmokeSpikeEmitter;
    explodeOnMaxBounce = true;
    elasticity = 0.4;
    friction = 0.2;
    lifetime = 0.3;
    lifetimeVariance = 0.02;
};

//-----------------------------------------------------------------------------
// Weapon fire emitter
//-----------------------------------------------------------------------------

datablock ParticleData(homerFireParticle)
{
   textureName          = "~/data/specialfx/smoke1";

   dragCoeffiecient     = -5; // org 0
   gravityCoefficient   = 0.05;  // rises org -0.1
   inheritedVelFactor   = 0.3; // org 0.3

   lifetimeMS           = 750;   // Time in ms -- org 250
   lifetimeVarianceMS   = 20;    // ...more or less -- org 10
   //particleDensity = 10; // new
   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "1 0.84 0.44 0.75"; // org 1 1 1 1
   colors[1]     = "0.9 0.6 0.21 1"; // org 0.7 0.7 0.7 0.66
   colors[2]     = "0.75 0.75 0.75 0.66"; // org 1 0 0 0.33
   colors[3]     = "0 0 0 0.75"; // new
   colors[4]     = "0 0 0 0"; // new

   sizes[0]      = 0.75; // org 0.2
   sizes[1]      = 1; // org 0.5
   sizes[2]      = 1.15; // org 1
   sizes[3]      = 1.5; // new
   sizes[4]      = 1.75; // new
   
   times[0]      = 0.0;
   times[1]      = 0.6;
   times[2]      = 0.7;
   times[3]      = 0.75;
   times[4]      = 1;
   
 };



datablock ParticleEmitterData(homerFireEmitter)
{
   ejectionPeriodMS = 10; // org 10
   periodVarianceMS = 0; // org 5

   ejectionVelocity = 1.75; // org 0.25
   velocityVariance = 0.1; // org 0.1

   thetaMin         = 0.0;
   thetaMax         = 180.0; // org 90

   particles = homerFireParticle;
   
   // Dynamic light
   lightStartRadius = 1; // org 5
   lightEndRadius = 0;
   lightStartColor = "1 0.84 0.44 0.75";  //org 1 1 1
   lightEndColor = "0.9 0.6 0.21 0";  //org 0 0 0
   
   
};



//---------------------------------------------------------------------------
// Explosions
//---------------------------------------------------------------------------
datablock ExplosionData(homingExplosion)
{
    lifeTimeMS = 3000;
	explosionShape = "~/data/fx/explosions/explosion02.dts";
    //playSpeed = 1.5;
    soundProfile = homingExplosionSound;
    faceViewer = true;

    sizes[0] = "0.5 0.5 0.5";
    sizes[1] = "0.75 0.75 0.75"; // org 0.5 0.5 0.5
    sizes[2] = "1 1 1"; // org 0.5 0.5 0.5

    emitter[0] = homingExplosionSmokeEmitter;
	particleDensity = 75; // org 50
    particleRadius = 5;

    debris = homingSpikeDebris;
    debrisThetaMin = 10;
    debrisThetaMax = 170;
    debrisNum = 8;
    debrisNumVariance = 6;
    debrisVelocity = 15.0;
    debrisVelocityVariance = 2.0;

    shakeCamera = true;
    camShakeFreq = "6.0 7.0 7.0";
    camShakeAmp = "70.0 70.0 70.0";
    camShakeDuration = 1.0;
    camShakeRadius = 7.0;
	
	// Dynamic light
    lightStartRadius = 15; // org 6
    lightEndRadius = 0;
    lightStartColor = "0.56 0.36 0.26 1.0";  //new
    lightEndColor = "0 0 0";  //new
	
	};

datablock SeekerProjectileData(homingProjectile)
{
    projectileShapeName = "~/data/shapes/weapons/mmammo.dts";
    directDamage = 50;
    radiusDamage = 20;
    damageRadius = 0.5;
    explosion = homingExplosion;
    particleEmitter = homingSmokeEmitter;
    delayEmitter = homingFireEmitter;
    puffEmitter = homingPuffEmitter;

    velInheritFactor = 0;

    armingDelay = 300;
    lifetime = 6000;
    fadeDelay = 1500;
    isBallistic = false;
    gravityMod = 0.10;

    muzzleVelocity = 7.0;
    maxVelocity = 80.0;
    turningSpeed = 110.0;
    acceleration = 200.0;

    proximityRadius = 0;

    flareRadius = 200;
    flareAngle    = 45;

    hasLight = true;
    lightRadius = 3.0;
    lightColor    = "1 1 0";
    
//    useTargetAudio = 1;
};

//-----------------------------------------------------------------------------
// Ammo Item

datablock ItemData(homingAmmo)
{
    category = "Ammo";
    className = "Ammo";

    // Basic Item properties
    shapeFile = "~/data/shapes/weapons/ammo_missile.dts";
    mass = 1;
    elasticity = 0.2;
    friction = 0.6;

    // Dynamic properties defined by the scripts
    pickUpName = "missile launcher ammo";
    maxInventory = 500;
};

datablock ItemData(homing)
{
    category = "Weapon";
    className = "Weapon";

    shapeFile = "~/data/shapes/weapons/weapon_missile.dts";
    mass = 1;
    elasticity = 0.2;
    friction = 0.6;
    emap = true;

    pickUpName = "a missile launcher";
    weaponName = "homing Launcher";
    image = homingImage;
};

datablock ShapeBaseImageData(homingImage)
{
    isSeeker    = true;

    seekRadius = 600;
    maxSeekAngle = 20;
    seekTime    = 1000;
    minSeekHeat = 0.2;
    armThread = lookms;
    lockObjectType = $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::TurretObjectType | $TypeMasks::ItemObjectType ;

    shapeFile = "~/data/shapes/weapons/weapon_missile.dts";
    emap = true;

    mountPoint = 1;

    correctMuzzleVector = true;

    className = "WeaponImage";

    item = homing;
    ammo = homingAmmo;
    projectile = homingProjectile;
    projectileType = SeekerProjectile;

    stateName[0] = "Preactivate";
    stateTransitionOnLoaded[0] = "Activate";
    stateTransitionOnNoAmmo[0] = "NoAmmo";
    

    stateName[1] = "Activate";
    stateTransitionOnTimeout[1] = "Ready";
    stateTimeoutValue[1] = 0.5;
    stateSequence[1] = "Activate";

    stateName[2] = "Ready";
    stateTransitionOnNoAmmo[2] = "NoAmmo";
    stateTransitionOnTriggerDown[2] = "Fire";

    stateName[3] = "Fire";
    stateTransitionOnTimeout[3] = "Reload";
    stateTimeoutValue[3] = 1.0;
    stateFire[3] = true;
    stateRecoil[3] = LightRecoil;
    stateAllowImageChange[3] = false;
    stateSequence[3] = "Fire";
    stateScript[3] = "onFire";
	stateEmitter[3] = homerFireEmitter; // -- new
   	stateEmitterTime[3] = 0.33; // org 0 controls the flash emitter -- new
    stateSound[3] = "homingFireSound";
    
    stateName[4] = "Reload";
    stateTransitionOnNoAmmo[4] = "NoAmmo";
    stateTransitionOnTimeout[4]    = "Ready";
    stateTimeoutValue[4] = 2.00;
    stateAllowImageChange[4] = false;
    stateSequence[4] = "Reload";
    stateEjectShell[4] = true;
    stateSound[4] = "GatlingDryFireSound";

    stateName[5] = "NoAmmo";
    stateTransitionOnAmmo[5] = "Reload";
    stateSequence[5] = "NoAmmo";
    stateTransitionOnTriggerDown[5] = "DryFire";

    stateName[6] = "DryFire";
    stateTimeoutValue[6] = 1.0;
    stateTransitionOnTimeout[6] = "NoAmmo";
    stateSound[6] = "GatlingDryFireSound";
};

//------------------------------------------------------------------------------
// Base Projectile Functions
//------------------------------------------------------------------------------


function baseHoming::onFire(%this, %obj, %slot,%ammo)
{
    %target = %obj.getLockedTarget(%slot);
    %projectile = %this.projectile;
    %obj.decInventory(%this.ammo,%ammo);
    %currentAmmo = %obj.getInventory(%this.ammo);
    if(!%obj.aiPlayer)
    %obj.client.setAmmoAmountHud(%currentAmmo);
    if(!%obj.aiPlayer)
      %clientID = %obj.client;
    else
       %clientID = %obj;
    %muzzleVector = %obj.getMuzzleVector(%slot);
    echo(%this.projectileType);
    echo(%projectile);
    %p = new (%this.projectileType)() {
        dataBlock        = %projectile;
        initialVelocity  = VectorScale(%muzzleVector, %projectile.muzzleVelocity);
        initialPosition  = %obj.getMuzzlePoint(%slot);
        sourceObject     = %obj;
        sourceSlot = %slot;
        client           = %clientID;
        target = %obj.getLockedTarget(%slot);
    };
    MissionCleanup.add(%p);
    return %p;
}
