//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------
// DK5 Plasma Rifle	320	medium (20/10/1) (2)
// DK15 Plasma Rifle	800	low (15/5/1)
// DK25 Plasma Rifle	640	high (25/15/2)   (1)
//-----------------------------------------------------------------------------
// PLASMA WEAPON.
//-----------------------------------------------------------------------------

datablock AudioProfile(plasmaFireSound)
{
  filename = "~/data/sound/plasma.ogg";
  description = AudioClosest3d;
  preload = true;
};

//-----------------------------------------------------------------------------
// Projectile trail emitter
//-----------------------------------------------------------------------------

datablock ParticleData(plasmaSmokeParticle)
{
   textureName          = "~/data/specialfx/plasma";
   dragCoefficient     = 0.0;
   gravityCoefficient   = 0;  // rises
   inheritedVelFactor   = -25; // org 0
   lifetimeMS           = 225;   // time in ms -- org 300
   lifetimeVarianceMS   = 0;   // ...more or less -- org 150
   useInvAlpha = true;
   spinRandomMin = 30.0;
   spinRandomMax = 60.0;
   colors[0]     = "1 1 1 1.0"; // org 0 0.2 1 1.0
   colors[1]     = "1 1 1 0.33"; // org 0.2 0.2 0.8 1.0
   colors[2]     = "0.2 0.2 0.8 0.25"; // org 0 0 0 0
   colors[3]     = "0 0 0 0";
   sizes[0]      = 1.8; // org 1
   sizes[1]      = 0.75; // org 0.5
   sizes[2]      = 0.1;
   sizes[3]      = 0.1; // new
   times[0]      = 0.0;
   times[1]      = 0.5; // org 0.3
   times[2]      = 0.75; // org 0.3
   times[3]      = 1; // new
};

datablock ParticleEmitterData(plasmaSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0; // org 5
   ejectionVelocity = 0.25;
   velocityVariance = 0.0; // org 0.10
   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = plasmaSmokeParticle;
};
// DK 25
datablock ParticleData(plasmaSmokeParticle1 : plasmaSmokeParticle )
{
   colors[0]     = "1 1 1 1.0"; // org 0 0.0 0.5 1.0
   colors[1]     = "0 0.75 0.75 0.15"; // org 0.1 0.1 0.4 1.0
   colors[2]     = "0 0.5 0.5 0"; //org 0 0 0 0
   sizes[0]      = 3; // org 1
   sizes[1]      = 1.12; // org 0.5
   sizes[2]      = 0.1; // org 0.1
   times[0]      = 0.33;  // new
   times[1]      = 0.45; // new
   times[2]      = 1; // new
};
datablock ParticleEmitterData(plasmaSmokeEmitter1 : plasmaSmokeEmitter)
{
   particles = plasmaSmokeParticle1;
};
// DK 5
datablock ParticleData(plasmaSmokeParticle2 : plasmaSmokeParticle )
{
   colors[0]     = "1 1 1 1"; // org 0 0.5 0.5 1
   colors[1]     = "0 0.75 0.75 0.15";
   colors[2]     = "0 0.75 0.75 0"; // new
   sizes[0]      = 2; // org 1.4
   sizes[1]      = 0.9;
   sizes[2]      = 0.1;
   times[0]      = 0.25; // new
   times[1]      = 0.45; // new
   times[2]      = 1; // new
};

datablock ParticleEmitterData(plasmaSmokeEmitter2 : plasmaSmokeEmitter)
{
   particles = plasmaSmokeParticle2;
};

//-----------------------------------------------------------------------------
// Weapon fire emitter
//-----------------------------------------------------------------------------

datablock ParticleData(plasmaFireParticle)
{
   textureName          = "~/data/shapes/weapons/smoke1";

   dragCoefficient     = 50; // org 0
   gravityCoefficient   = -0.05;  // rises
   inheritedVelFactor   = 0.3; // org 0

   lifetimeMS           = 250;   // Time in ms -- org 200
   lifetimeVarianceMS   = 25;    // ...more or less -- org 50

   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "1 1 1 0.66"; // org 0 0.2 1 1.0
   colors[1]     = "0 0.75 0.75 1"; // org 0.75 0.75 0.75 0.4
   colors[2]     = "0 0.75 0.75 0";

   sizes[0]      = 1.5;
   sizes[1]      = 1;
   sizes[2]      = 0.2; //org 1

   times[0]      = 0.0;
   times[1]      = 0.3; // org 0.3
   times[2]      = 1;
};

datablock ParticleEmitterData(plasmaFireEmitter)
{
   ejectionPeriodMS = 15; // org 30
   periodVarianceMS = 2; // org 5

   ejectionVelocity = 1;
   ejectionOffset   = 0.1;
   velocityVariance = 0; //org 0.09

   thetaMin         = 0.0;
   thetaMax         = 90.0;  // org 10

   particles = plasmaFireParticle;
};

//---------------------------------------------------------------------------
// Explosions
//---------------------------------------------------------------------------
datablock ParticleData(plasmaExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1250; // org 750
   lifetimeVarianceMS   = 150; // org 150
   textureName          = "~/data/specialfx/smoke2";
   colors[0]     = "1 1 1 1"; //org 0 0.2 1 1.0
   colors[1]     = "0 0.75 0.75 0"; //org 0 0.2 1 1.0
   sizes[0]      = 0.5; // org 0.5
   sizes[1]      = 2; // org 1.0
};

datablock ParticleEmitterData(plasmaExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 0.5;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "plasmaExplosionParticle";
};

datablock ExplosionData(plasmaExplosion)
{
   lifeTimeMS = 1500;

   particleEmitter = plasmaExplosionEmitter;
   particleDensity = 50;
   particleRadius = 1;

   faceViewer     = true;
   explosionScale = "1.5 1.5 1.5"; // org 1 1 1

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 0;
   lightStartColor = "1 1 1"; //org 0 0 0.6
   lightEndColor = "0 0.75 0.75"; // org 0 0 0.6
};


//-----------------------------------------------------------------------------
// Projectile Object

datablock ProjectileData(plasmaProjectile)
{
   // projectileShapeName = "~/data/shapes/weapons/projectile.dts";
   directDamage        = 15;
   radiusDamage        = 1;
   damageRadius        = 0.5;
   explosion           = plasmaExplosion;
   particleEmitter     = plasmaSmokeEmitter;

   muzzleVelocity      = 100;
   velInheritFactor    = 0.1;

   armingDelay         = 0;
   lifetime            = 2000;
   fadeDelay           = 500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod          = 0.10;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "0 0.75 0.75"; // org 0 0 0.2
};

//-----------------------------------------------------------------------------
// Ammo Item

datablock ItemData(plasmaAmmo)
{
   category = "Ammo";
   className = "Ammo";

   shapeFile = "~/data/shapes/weapons/ammo.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickUpName = "plasma ammo";
   maxInventory = 50;
};

//--------------------------------------------------------------------------
// Weapon Item.  This is the item that exists in the world, i.e. when it's
// been dropped, thrown or is acting as re-spawnable item.  When the weapon
// is mounted onto a shape, the RifleImage is used.

datablock ItemData(plasma)
{
   // Mission editor category
   category = "Weapon";
   className = "Weapon";

   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/Gatling.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

	// Dynamic properties defined by the scripts
	pickUpName = "Base Plasma Rifle";
	image = plasmaImage;
 
};


//--------------------------------------------------------------------------
// Rifle image which does all the work.  Images do not normally exist in
// the world, they can only be mounted on ShapeBase objects.

datablock ShapeBaseImageData(plasmaImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/Gatling.dts";
   mountPoint = 0;
   emap = true;
   correctMuzzleVector = true;
   className = "WeaponImage";

   // Projectile && Ammo.
   item = plasma;
   ammo = plasmaAmmo;
   projectile = plasmaProjectile;
   projectileType = Projectile;

   // Initial start up state
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   // Activating the gun.  Called when the weapon is first
   // mounted and there is ammo.
   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;
   stateSequence[1]                 = "Activate";

   // Ready to fire, just waiting for the trigger
   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   // Fire the weapon. Calls the fire script which does 
   // the actual work.
   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.1;
   stateSound[3]		               = plasmaFireSound;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateEmitter[3]                  = plasmaFireEmitter;
   stateEmitterTime[3]              = 0.15;

   // Play the relead animation, and transition into
   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.1;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateEjectShell[4]               = true;

   // No ammo in the weapon, just idle until something
   // shows up. Play the dry fire sound if the trigger is
   // pulled.
   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   // No ammo dry fire
   stateName[6]                     = "DryFire";
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

function basePlasma::onFire(%this, %obj, %slot,%ammo)
{
   %projectile = %this.projectile;
   %obj.decInventory(%this.ammo,%ammo);
  if(!isSpecialWeapon(%this.item))
   if(!%obj.aiPlayer)
      %obj.client.setAmmoAmountHud(%obj.getInventory(%this.ammo));

   if(!%obj.aiPlayer)
     %clientID = %obj.client;
   else
     %clientID = %obj;

   %muzzleVector = %obj.getMuzzleVector(%slot);
   %objectVelocity = %obj.getVelocity();
   %muzzleVelocity = VectorAdd(
      VectorScale(%muzzleVector, %projectile.muzzleVelocity),
      VectorScale(%objectVelocity, %projectile.velInheritFactor));

   %p = new (%this.projectileType)() {
      dataBlock        = %projectile;
      initialVelocity  = %muzzleVelocity;
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      client           = %clientID;
   };
   MissionCleanup.add(%p);

   return %p;
}

