//------------------------------------------------------------------------------
// Beast Primary Weapon Systems
//------------------------------------------------------------------------------
// How to change
//   ItemData -> THIS IS WHAT GETS ADDED TO INVENTORY.
//               Just make sure image points to the ShapeBaseImage
//   ImageData -> If you cant pick up Ammo, it doesn't need to change.
//                So use the base ammo.
//                If you want to change state sounds/timeouts/emitters,
//                Do it here!! If your comming up with new states completely
//                MAKE A NEW BASE IMAGE!!
//   ProjectileData -> THIS IS WHERE DMG, RADIUS, ETC is set
//                This is also where the emitters are for FX.
//                So if you want them changed, you'll have to do that here.
//                Make sure to add them to the weaponsFX scripts.
//                That is where weapon FX variants go.
//                If you want to add an extra field from the base, this is where to do it.
//                I'm looking at you Ed on this one :p

datablock ProjectileData(BeastPrimaryProjectile1 : plasmaProjectile)
{
   //Damage
   directDamage        = 40;
   radiusDamage        = 0;
   damageRadius        = 0; //org 2

   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 150; // org 100
   lifetime            = 4270; // org 6400
   fadeDelay           = 250; // org 1500
   explosion           = plasmaExplosion1;
   particleEmitter     = plasmaSmokeEmitter1;
};
datablock ItemData(BeastPrimaryAmmo1 : plasmaAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(BeastPrimary1 : plasma)
{
	//
	pickUpName = "DK-25 Plasma Rifle";
   displayName = "DK25 PR";
	image = BeastPrimaryImage1;
     amount = "500";
   refire = "high";
   damage = "40 ap";
   range  = "640 m";
};

datablock ShapeBaseImageData(BeastPrimaryImage1 : plasmaImage)
{

   item = BeastPrimary1;
   ammo = BeastPrimaryAmmo1;
   projectile = BeastPrimaryProjectile1;
};

datablock ProjectileData(BeastPrimaryProjectile2 : acProjectile)
{
   directDamage        = 65;
   radiusDamage        = 10;
   damageRadius        = 3;
   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 200; // org 750
   lifetime            = 3750; // org 2400
   fadeDelay           = 250; // org 500
   explosion           = acExplosion;
   particleEmitter     = acSmokeEmitter1;
};
datablock ItemData(BeastPrimaryAmmo2 : acAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(BeastPrimary2 : ac)
{
	pickUpName = "LiveFire 30 AC";
   displayName = "LF-30 AC";
	image = BeastPrimaryImage2;
     amount = "300";
   refire = "medium";
   damage = "75 ap";
   range  = "750 m";
};

datablock ShapeBaseImageData(BeastPrimaryImage2 : acImage)
{
   item = BeastPrimary2;
   ammo = BeastPrimaryAmmo2;
   projectile = BeastPrimaryProjectile2;
};

datablock BeamData(BeastPrimaryProjectile3 : laserProjectile)
{
   directDamage        = 75;
   radiusDamage        = 0;
   damageRadius        = 0;
   beamStyle         = 1;
   beamStartRadius   = 0.4;
   beamEndRadius     = 0.0;
   materialList = "~/data/shapes/weapons/purple.dml";
   //beamLength        = 1000;
};

datablock ItemData(BeastPrimaryAmmo3 : laserAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(BeastPrimary3 : laser)
{
	pickUpName = "XL7 Brimstone Laser";
   displayName = "XL7 BS L";
	image = BeastPrimaryImage3;
     amount = "Energy";
   refire = "high";
   damage = "75 ap";
   range  = "unlim";
};

datablock ShapeBaseImageData(BeastPrimaryImage3 : laserImage)
{
   item = BeastPrimary3;
   ammo = BeastPrimaryAmmo3;
   projectile = BeastPrimaryProjectile3;
   minEnergy = 20;
   fireEnergy = 10;
   fireTimeout = 1000;
   stateSound[3]					      = "altLaserFireSound";
};


//------------------------------------------------------------------------------
// SECONDARY WEAPONS
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// SECONDARY WEAPONS
//------------------------------------------------------------------------------

datablock ProjectileData(BeastSecondaryProjectile1 : rocketProjectile)
{
   directDamage        = 15;
   radiusDamage        = 0;
   damageRadius        = 1;
   muzzleVelocity      = 300;
   lifetime            = 2050;
   fadeDelay           = 500;
};
datablock ItemData(BeastSecondaryAmmo1 : rocketAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(BeastSecondary1 : rocket)
{
	pickUpName = "K4 Kisten'I Rocket";
   displayname = "K4 KR";
	image = BeastSecondaryImage1;
    amount = "240";
   refire = "medium";
   damage = "15 x 6 ap";
   range  = "600 m";
};

datablock ShapeBaseImageData(BeastSecondaryImage1 : rocketImage)
{
   item = BeastSecondary1;
   ammo = BeastSecondaryAmmo1;
   projectile = BeastSecondaryProjectile1;
};



//------------------------------------------------------------------------------
datablock SeekerProjectileData(BeastSecondaryProjectile2 : homingProjectile)
{
   directDamage        = 50;
   radiusDamage        = 20;
   damageRadius        = 10;
   explosion           = homingExplosion;
   particleEmitter     = homingSmokeEmitter;
};

datablock ItemData(BeastSecondaryAmmo2 : homingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(BeastSecondary2 : homing)
{
 	pickUpName = "T15 Viper Homing Missile";
   displayName = "T15 V HM";
	image = BeastSecondaryImage2;
     amount = "80";
   refire = "medium";
   damage = "70";
   range  = "na";
};

datablock ShapeBaseImageData(BeastSecondaryImage2 : homingImage)
{
   item = BeastSecondary2;
   ammo = BeastSecondaryAmmo2;
   projectile = BeastSecondaryProjectile2;
   seekRadius = 300;
};


//------------------------------------------------------------------------------
datablock SeekerProjectileData(BeastSecondaryProjectile3 : homingProjectile)
{
   directDamage        = 100;
   radiusDamage        = 30;
   damageRadius        = 12.5;
   explosion           = homingExplosion;
   particleEmitter     = homingSmokeEmitter;
};

datablock ItemData(BeastSecondaryAmmo3 : homingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(BeastSecondary3 : homing)
{
	pickUpName = "T25 Jumbo HM";
   displayName = "T25 J HM";
	image = BeastSecondaryImage3;
     amount = "30";
   refire = "low";
   damage = "130 ap";
   range  = "na";
};

datablock ShapeBaseImageData(BeastSecondaryImage3 : homingImage)
{
   item = BeastSecondary3;
   ammo = BeastSecondaryAmmo3;
   projectile = BeastSecondaryProjectile3;
   seekRadius = 300;
};
