//-----------------------------------------------------------------------------
// Torque Content Pack
// Copyright (C) 2003 GameBeavers.org
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// flamer weapon. This file contains all the items related to this weapon
// including explosions, ammo, the item and the weapon item image.
// These objects rely on the item & inventory support system defined
// in item.cs and inventory.cs
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Sounds
datablock AudioProfile(flamerFire)
{
   filename    = "~/data/sound/weapons/flamer_fire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(flamerEmpty)
{
   filename    = "~/data/sound/weapons/flamer_noammo.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(flamerReload)
{
  filename    = "~/data/sound/weapons/flamer_reload.wav";
   description = AudioClosest3d;
   preload = true;
};

//datablock AudioProfile(flamerActivate)
//{
//   filename    = "~/data/sound/weapons/flamer_switch.wav";
//   description = AudioClosest3d;
//   preload = true;
//};
//-----------------------------------------------------------------------------
// Projectile trail emitter
datablock ParticleData(flamerSmokeParticle)
{
   textureName          = "~/data/shapes/weapons/flamer/blackSmoke";

   dragCoefficient     = 0.0;
   gravityCoefficient   = 0.05;  // rises
   inheritedVelFactor   = 0.03;
   windCoefficient  = 0.09;

   lifetimeMS           = 2100;   // time in ms
   lifetimeVarianceMS   = 200;   // ...more or less

   useInvAlpha = false;
   spinRandomMin = -90.3;
   spinRandomMax = 90.8;

   colors[0]     = "0.7 0.2 0.2 0.9";
   colors[1]     = "0.6 0.4 0.3 0.8";
   colors[2]     = "0.3 0.1 0.1 0.4";
   colors[3]     = "0.3 0.1 0.1 0.4";
   colors[4]     = "0.3 0.1 0.1 0.4";

   sizes[0]      = 1;
   sizes[1]      = 5;
   sizes[2]      = 8;
   sizes[3]      = 10;
   sizes[4]      = 13;

   times[0]      = 0.1;
   times[1]      = 0.2;
   times[2]      = 0.3;
   times[3]      = 0.5;
   times[4]      = 1.0;
};


datablock ParticleData(flamerFireParticle)
{
   textureName          = "~/data/shapes/weapons/flamer/flame1";

   windCoefficient  = 0.1;

   dragCoefficient     = 0;
   gravityCoefficient   = 0.05;
   inheritedVelFactor   = 0.3;

   lifetimeMS           = 2000;   // Time in ms
   lifetimeVarianceMS   = 500;    // ...more or less

   useInvAlpha = false;
   spinRandomMin = -180.0;
   spinRandomMax = 180.0;

   sizes[0]      = 0.2;
   sizes[1]      = 5.0;
   sizes[2]      = 8.0;
   sizes[3]      = 10.0;
   sizes[4]      = 5.2;

   times[0]      = 0.3;
   times[1]      = 0.3;
   times[2]      = 0.5;
   times[3]      = 1.0;
   times[4]      = 0.5;

   
};

datablock ParticleEmitterData(flamerFireEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 5;

   ejectionVelocity = 30;
   ejectionOffset   = 0.2;
   velocityVariance = 0.3;

   thetaMin         = 0.3;
   thetaMax         = 0.7;

   particles = "flamerFireParticle";
};



//-----------------------------------------------------------------------------
 datablock ParticleData(flameExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 150;
   textureName          = "~/data/specialfx/particleTest";
   colors[0]     = "0.56 0.00 0.00 1.0";
   colors[1]     = "0.56 0.56 0.00 0.0";
   colors[1]     = "1.00 0.56 0.00 0.0";
   sizes[0]      = 0.15; // org 0.5
   sizes[1]      = 1.0;
   sizes[1]      = 3.0;
};

datablock ParticleEmitterData(flameExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "flameExplosionParticle";
};

datablock ExplosionData(flameExplosion)
{
   particleEmitter = flameExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.75;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.2;
   camShakeRadius = 3.0;

   // Dynamic light
   lightStartRadius = 0.5; // org 6
   lightEndRadius = 0;
   lightStartColor = "0.56 0.36 0.26";  //new
   lightEndColor = "0 0 0";  //new
};

// Projectile Object

datablock ProjectileData(PredatorSpecialProjectile)
{
   projectileShapeName = "~/data/shapes/weapons/flamer/projectile.dts";
   directDamage        = 30;
   radiusDamage        = 10;
   damageRadius        = 2.0;
   //particleEmitter     = PredatorSpecialSmokeEmitter;
   explosion           = flameExplosion;
   muzzleVelocity      = 30;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 1500;
   fadeDelay           = 750;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.10;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.7 0.3 0.2";
};

//try making the particles cause damage


function PredatorSpecialProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }

//-----------------------------------------------------------------------------
// Ammo Item

datablock ItemData(PredatorSpecialAmmo : gatlingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

//--------------------------------------------------------------------------
// Weapon Item.  This is the item that exists in the world, i.e. when it's
// been dropped, thrown or is acting as re-spawnable item.  When the weapon
// is mounted onto a shape, the flamerImage is used.

datablock ItemData(PredatorSpecial)
{
   // Mission editor category
   category = "Weapon";

   className = "Weapon";

   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/ac.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;
   amount = "500";
   refire = "medium";
   damage = "medium";
      displayName = "Flame Thrower";
	// Dynamic properties defined by the scripts
	pickUpName = "Flame Thrower";
	image = PredatorSpecialImage;
};

//--------------------------------------------------------------------------
// flamer image which does all the work.  Images do not normally exist in
// the world, they can only be mounted on ShapeBase objects.

datablock ShapeBaseImageData(PredatorSpecialImage)
{     usesEnergy                       = true;
   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/ac.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.12 0.35 -0.40";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = PredatorSpecial;
  // ammo = PredatorSpecialAmmo;
   projectile = PredatorSpecialProjectile;
   projectileType = Projectile;
   //casing = flamerShell;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   // Activating the gun.  Called when the weapon is first
   // mounted and there is ammo.
   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;
   stateSequence[1]                 = "Activate";
   //stateSound[1]                    = flamerActivate;

   // Ready to fire, just waiting for the trigger
   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateSequence[2]                 = "bob";
   stateTransitionOnTriggerDown[2]  = "Fire";



   // Fire the weapon. Calls the fire script which does
   // the actual work.
   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.05;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateEmitter[3]                  = flamerFireEmitter;
   stateEmitterTime[3]              = 0.15;
   stateSound[3]                    = flamerFire;
   stateEnergyDrain[3]              = 50;

   // Play the relead animation, and transition into
   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.05;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateEjectShell[4]               = true;


   // No ammo in the weapon, just idle until something
   // shows up. Play the dry fire sound if the trigger is
   // pulled.
   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "bob";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   // No ammo dry fire
   stateName[6]                     = "DryFire";
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
   stateSequence[6]                 = "Reload";
   stateSound[6]                    = flamerEmpty;
};

//-----------------------------------------------------------------------------

function PredatorSpecialImage::onFire(%this, %obj, %slot)
{
 baseGatling::onFire(%this, %obj, %slot,2);
}


