//------------------------------------------------------------------------------
// HunterScout Primary Weapon Systems
//------------------------------------------------------------------------------
// How to change
//   ItemData -> THIS IS WHAT GETS ADDED TO INVENTORY.
//               Just make sure image points to the ShapeBaseImage
//   ImageData -> If you cant pick up Ammo, it doesn't need to change.
//                So use the base ammo.
//                If you want to change state sounds/timeouts/emitters,
//                Do it here!! If your comming up with new states completely
//                MAKE A NEW BASE IMAGE!!
//   ProjectileData -> THIS IS WHERE DMG, RADIUS, ETC is set
//                This is also where the emitters are for FX.
//                So if you want them changed, you'll have to do that here.
//                Make sure to add them to the weaponsFX scripts.
//                That is where weapon FX variants go.
//                If you want to add an extra field from the base, this is where to do it.
//                I'm looking at you Ed on this one :p

datablock ProjectileData(HunterScoutPrimaryProjectile1 : plasmaProjectile)
{
   //Damage
   directDamage        = 18; // org 20
   radiusDamage        = 0;
   damageRadius        = 1;
   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 200; // org 150
   lifetime            = 2250; // originally 3200
   fadeDelay           = 250;  // How long before it fades out of existance after it turns into a dud
   explosion           = plasmaExplosion2;
   particleEmitter     = plasmaSmokeEmitter2;
};
datablock ItemData(HunterScoutPrimaryAmmo1 : plasmaAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(HunterScoutPrimary1 : plasma)
{
	//
	pickUpName = "DK-5 Plasma Rifle";
   displayName = "DK5 PR";
	image = HunterScoutPrimaryImage1;
     amount = "300";
   refire = "high";
   damage = "18";
   range  = "450 m";
};

datablock ShapeBaseImageData(HunterScoutPrimaryImage1 : plasmaImage)
{
   //shapeFile = "~/data/shapes/weapons/huntercannons.dts";
   item = HunterScoutPrimary1;
   ammo = HunterScoutPrimaryAmmo1;
   projectile = HunterScoutPrimaryProjectile1;
};

datablock ProjectileData(HunterScoutPrimaryProjectile2 : acProjectile)
{
   directDamage        = 50; // org 25
   radiusDamage        = 0;
   damageRadius        = 1;
   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 200; // org 750
   lifetime            = 7500; // org 2000
   fadeDelay           = 250; // org 500
   explosion           = acExplosion;
   particleEmitter     = acSmokeEmitter2;
};
datablock ItemData(HunterScoutPrimaryAmmo2 : acAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(HunterScoutPrimary2 : ac)
{
	pickUpName = "LiveFire 10 AC";
	displayName = "LF-10 AC";
	image = HunterScoutPrimaryImage2;
     amount = "150";
   refire = "medium";
   damage = "50 ap";
   range  = "1500 m";
};

datablock ShapeBaseImageData(HunterScoutPrimaryImage2 : acImage)
{
   item = HunterScoutPrimary2;
   ammo = HunterScoutPrimaryAmmo2;
   projectile = HunterScoutPrimaryProjectile2;
};

datablock BeamData(HunterScoutPrimaryProjectile3 : laserProjectile)
{
   directDamage        = 60;
   radiusDamage        = 0;
   damageRadius        = 0;
   beamStyle         = 1;
   beamStartRadius   = 0.2;
   beamEndRadius     = 0.5;
   materialList = "~/data/shapes/weapons/blue.dml";
   //beamLength        = 1000;
};

datablock ItemData(HunterScoutPrimaryAmmo3 : laserAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(HunterScoutPrimary3 : laser)
{
	pickUpName = "XL1 Firefly Laser";
   displayName = "XL1 FF L";
	image = HunterScoutPrimaryImage3;
     amount = "100";
   refire = "low";
   damage = "60";
   range  = "unlim";

};

datablock ShapeBaseImageData(HunterScoutPrimaryImage3 : laserImage)
{
  // shapeFile = "~/data/shapes/weapons/huntercannons.dts";
   item = HunterScoutPrimary3;
   ammo = HunterScoutPrimaryAmmo3;
   projectile = HunterScoutPrimaryProjectile3;
   minEnergy = 5;
   fireEnergy = 20;
   fireTimeout = 1000;
};


//------------------------------------------------------------------------------
// SECONDARY WEAPONS
//------------------------------------------------------------------------------

datablock SeekerProjectileData(HunterScoutSecondaryProjectile1 : homingProjectile)
{
   directDamage        = 40;
   radiusDamage        = 10;
   damageRadius        = 5;
   explosion           = homingExplosion;
   particleEmitter     = homingSmokeEmitter;
};
datablock ItemData(HunterScoutSecondaryAmmo1 : homingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(HunterScoutSecondary1 : homing)
{
	//
   pickUpName = "T5s Yellow Jacket Homing Missile";
   displayName = "T5s YJ HM";
	image = HunterScoutSecondaryImage1;
     amount = "25";
   refire = "high";
   damage = "50";
   range  = "na";

};

datablock ShapeBaseImageData(HunterScoutSecondaryImage1 : homingImage)
{

   item = HunterScoutSecondary1;
   ammo = HunterScoutSecondaryAmmo1;
   projectile = HunterScoutSecondaryProjectile1;
   seekRadius = 1200;
   
};



//------------------------------------------------------------------------------
datablock SeekerProjectileData(HunterScoutSecondaryProjectile2 : homingProjectile)
{
   directDamage        = 50;
   radiusDamage        = 20;
   damageRadius        = 10;
   explosion           = homingExplosion;
   particleEmitter     = homingSmokeEmitter;
};

datablock ItemData(HunterScoutSecondaryAmmo2 : homingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(HunterScoutSecondary2 : homing)
{
 	pickUpName = "T15s Viper Homing Missile";
   displayName = "T15s V HM";
	image = HunterScoutSecondaryImage2;
     amount = "20";
   refire = "medium";
   damage = "70";
   range  = "na";
};

datablock ShapeBaseImageData(HunterScoutSecondaryImage2 : homingImage)
{
   item = HunterScoutSecondary2;
   ammo = HunterScoutSecondaryAmmo2;
   projectile = HunterScoutSecondaryProjectile2;
   seekRadius = 1200;
};


//------------------------------------------------------------------------------
datablock SeekerProjectileData(HunterScoutSecondaryProjectile3 : homingProjectile)
{
   directDamage        = 60;
   radiusDamage        = 30;
   damageRadius        = 12.5;
   explosion           = homingExplosion;
   particleEmitter     = homingSmokeEmitter;
};

datablock ItemData(HunterScoutSecondaryAmmo3 : homingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(HunterScoutSecondary3 : homing)
{
	pickUpName = "T25s Guardian Homing Missile";
   displayName = "T25s G HM";
	image = HunterScoutSecondaryImage3;
     amount = "15";
   refire = "low";
   damage = "90";
   range  = "na";
};

datablock ShapeBaseImageData(HunterScoutSecondaryImage3 : homingImage)
{
   item = HunterScoutSecondary3;
   ammo = HunterScoutSecondaryAmmo3;
   projectile = HunterScoutSecondaryProjectile3;
   seekRadius = 1200;
};
