// Mine script
// ------------------------------------------------------------------------

datablock AudioProfile(MineGrenadeBurnSound)
{
   filename = "~/data/sound/fan1.ogg";
   description = AudioDefaultLooping3d;
   preload = true;
};

//--------------------------------------------------------------------------
// Projectile - Mine Grenade
//--------------------------------------


datablock ItemData(MineGrenade)
{
   category = "Mine";
   //texture = "common/lighting/corona";
   // Basic Item properties
   shapeFile = "~/data/shapes/items/mine01.dts";
   mass = 1;
   friction = 1;
   elasticity = 0.3;

   // Dynamic properties defined by the scripts
   pickupName = "a Mine";
   repairAmount = 50;
      maxDamage = 0.2;
   directDamage = 100;
   damageRadius = 2;
   radiusDamage = 30;
   dynamicType = $TypeMasks::DamagableItemObjectType;
       explosion = homingExplosion;
         fadeIn = 0;
};

function MineGrenade::onAdd(%this, %obj)
{
%obj.setHeat(0);
}

function MineGrenade::onRemove(%this, %obj)
{
%obj.stopAudio(0);
}
//------------------------------------------------------------------------------
// Functions:
//------------------------------------------------------------------------------
function MineGrenade::onCollision( %data, %obj, %col )
{
   //echo("damaging Object");
   //echo(%data.directDamage);

   // Apply damage to the object all shape base objects
   //if (%col.getType() & $TypeMasks::ShapeBaseObjectType)
   //   %col.damage(%obj,%col,%data.directDamage,"Mine");
   //%obj.delete();
   %obj.setDamageState(Destroyed);
   %obj.schedule(999, "delete");
}

function MineGrenade::onDestroyed(%data,%obj)
{
   // Radius damage is a support scripts defined in radiusDamage.cs
   %pos = %obj.getPosition();
   echo (%obj.clientID);
   echo (%obj.sourceObject);
   radiusDamage(%obj,%pos,%data.damageRadius,%data.radiusDamage,"Mine",0);
}

function ShapeBase::throwItem(%this,%data,%client){
   // Construct item to throw from the given datablock
   // (with a random rotation around the z axis)
   %item = new Item() {
      dataBlock    = %data;
      rotation     = "0 0 1 " @ (getRandom() * 360);
      sourceObject   = %client.player;
      client       = %client;
   };
   MissionCleanup.add(%item);
   // %item.schedule(5555, "delete");
   // Call the workhorse throw method...
   %this.throwObject(%item);
   if(%data $= "Flag1" || %data $= "Flag2") {
   %item.flagCreation =  getSimTime();
   montiorFlag(%item);
   
   }
}

function ShapeBase::throwObject(%this,%obj){
   // Throw the given object in the direction the shape is
   // looking.  The force values are hardcoded...
   %eye = %this.getEyeVector();
   %vec = vectorScale(%eye, 20);
   // Add a vertical component to give the item a better arc
   
   %dot = vectorDot("0 0 1",%eye);
      if (%dot < 0)
            %dot = -%dot;
      %vec = vectorAdd(%vec,vectorScale("0 0 7",1 - %dot));
      // Add the shape's velocity
      %vec = vectorAdd(%vec,%this.getVelocity());
      // Set the object's position and initial velocity
      %pos = getBoxCenter(%this.getWorldBox());
      %obj.setTransform(%pos);
      %obj.applyImpulse(%pos,%vec);
      // Since the object is thrown from the center of the
      // shape, the object needs to avoid colliding with it&#180;s
      // thrower.
      %obj.setCollisionTimeout(%this);

}

//function serverCmdThrowMine(%client){
//   if(%client.player.MaxCounters != 0){
               //echo("throwing Mine");
//   %client.player.throwItem(MineGrenade,%client);
//   %client.player.MaxCounters--;
//   %client.setCounterAmountHud(%client.player.MaxCounters);
//   }
//}

