//------------------------------------------------------------------------------
// Locust Primary Weapon Systems
//------------------------------------------------------------------------------
// How to change
//   ItemData -> THIS IS WHAT GETS ADDED TO INVENTORY.
//               Just make sure image points to the ShapeBaseImage
//   ImageData -> If you cant pick up Ammo, it doesn't need to change.
//                So use the base ammo.
//                If you want to change state sounds/timeouts/emitters,
//                Do it here!! If your comming up with new states completely
//                MAKE A NEW BASE IMAGE!!
//   ProjectileData -> THIS IS WHERE DMG, RADIUS, ETC is set
//                This is also where the emitters are for FX.
//                So if you want them changed, you'll have to do that here.
//                Make sure to add them to the weaponsFX scripts.
//                That is where weapon FX variants go.
//                If you want to add an extra field from the base, this is where to do it.
//                I'm looking at you Ed on this one :p

datablock ProjectileData(LocustPrimaryProjectile1 : gatlingProjectile)
{
   //Damage
   directDamage        = 5;
   radiusDamage        = 0;
   damageRadius        = 0;

   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 200; // org 300
   lifetime            = 4050; // org 2700
   fadeDelay           = 1500;
   explosion           = gatlingExplosion;
   particleEmitter     = gatlingSmokeEmitter;
};

datablock ItemData(LocustPrimary1 : gatling)
{
	//
	pickUpName = "Sulitsa Gatling Gun";
   displayName = "Sul Vulcan";
	image = LocustPrimaryImage1;
	   amount = "750";
   refire = "high";
   damage = "5 ap";
   range  = "150 m effective";
};
datablock ItemData(LocustPrimaryAmmo1 : gatlingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ShapeBaseImageData(LocustPrimaryImage1 : gatlingImage)
{

   item = LocustPrimary1;
   ammo = LocustPrimaryAmmo1;
   projectile = LocustPrimaryProjectile1;
   
};

datablock ProjectileData(LocustPrimaryProjectile2 : gatlingProjectile)
{
   directDamage        = 10;
   radiusDamage        = 0;
   damageRadius        = 0;
   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 175; // org 300
   lifetime            = 3685; // org 2150
   fadeDelay           = 1500;
   explosion           = gatlingExplosion;
   particleEmitter     = gatlingSmokeEmitter;
};
datablock ItemData(LocustPrimaryAmmo2 : gatlingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(LocustPrimary2 : gatling)
{
	pickUpName = "Kopyo Gatling";
   displayName = "Kop Vulcan";
	image = LocustPrimaryImage2;
    amount = "500";
   refire = "medium";
   damage = "10 ap";
   range  = "150 effective";
};

datablock ShapeBaseImageData(LocustPrimaryImage2 : gatlingImage)
{
   item = LocustPrimary2;
   ammo = LocustPrimaryAmmo2;
   projectile = LocustPrimaryProjectile2;
};


datablock ProjectileData(LocustPrimaryProjectile3 : eacProjectile)
{
   directDamage        = 40;
   radiusDamage        = 0;
   damageRadius        = 2;
   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 400; // org 300
   lifetime            = 2400; // org 3200
   fadeDelay           = 500;
   explosion           = eacExplosion;
   particleEmitter     = eacSmokeEmitter;
};
datablock ItemData(LocustPrimaryAmmo3 : eacAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(LocustPrimary3 : eac)
{
	pickUpName = "EC AutoCannon A";
   displayName = "EAC A";
	image = LocustPrimaryImage3;
    amount = "300";
   refire = "low";
   damage = "40 ap";
   range  = "960 m";
};

datablock ShapeBaseImageData(LocustPrimaryImage3 : eacImage)
{
   item = LocustPrimary3;
   ammo = LocustPrimaryAmmo3;
   projectile = LocustPrimaryProjectile3;
};


//------------------------------------------------------------------------------
// SECONDARY WEAPONS
//------------------------------------------------------------------------------
datablock ProjectileData(LocustSecondaryProjectile1 : rocketProjectile)
{
   directDamage        = 5;
   radiusDamage        = 0;
   damageRadius        = 1;
   muzzleVelocity      = 300;
   lifetime            = 2050;
   fadeDelay           = 500;
};
datablock ItemData(LocustSecondaryAmmo1 : rocketAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(LocustSecondary1 : rocket)
{
	pickUpName = "K4 Kisten'I Rocket";
   displayname = "K4 KR";
	image = LocustSecondaryImage1;
    amount = "360";
   refire = "high";
   damage = "5 X 6 ap";
   range  = "600 m";
};

datablock ShapeBaseImageData(LocustSecondaryImage1 : rocketImage)
{
   item = LocustSecondary1;
   ammo = LocustSecondaryAmmo1;
   projectile = LocustSecondaryProjectile1;
};


//------------------------------------------------------------------------------
datablock ProjectileData(LocustSecondaryProjectile2 : rocketProjectile)
{
   directDamage        = 7;
   radiusDamage        = 0;
   damageRadius        = 0;
   muzzleVelocity      = 225;
   lifetime            = 2050;
   fadeDelay           = 500;
   explosion           = rocketXPExplosion;
};
datablock ItemData(LocustSecondaryAmmo2 : rocketAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(LocustSecondary2 : rocket)
{
	pickUpName = "K4 Kisten'I Explosive Rocket";
   displayname = "K4 KR XP";
	image = LocustSecondaryImage2;
    amount = "240";
   refire = "medium";
   damage = "7 X 6 ap";
   range  = "450 m";
};

datablock ShapeBaseImageData(LocustSecondaryImage2 : rocketImage)
{
   item = LocustSecondary2;
   ammo = LocustSecondaryAmmo2;
   projectile = LocustSecondaryProjectile2;
};


//------------------------------------------------------------------------------
datablock ProjectileData(LocustSecondaryProjectile3 : rocketProjectile)
{
   directDamage        = 10;
   radiusDamage        = 0;
   damageRadius        = 5;
   muzzleVelocity      = 300;
   lifetime            = 2050;
   fadeDelay           = 500;
};
datablock ItemData(LocustSecondaryAmmo3 : rocketAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(LocustSecondary3 : rocket)
{
	pickUpName = "K12 Drota Rocket";
   displayname = "K12 DR";
	image = LocustSecondaryImage3;
    amount = "120";
   refire = "low";
   damage = "10 X 6 ap";
   range  = "600 m";
};

datablock ShapeBaseImageData(LocustSecondaryImage3 : rocketImage)
{
   item = LocustSecondary3;
   ammo = LocustSecondaryAmmo3;
   projectile = LocustSecondaryProjectile3;
};
