//------------------------------------------------------------------------------
// Mantis Primary Weapon Systems
//------------------------------------------------------------------------------
// How to change
//   ItemData -> THIS IS WHAT GETS ADDED TO INVENTORY.
//               Just make sure image points to the ShapeBaseImage
//   ImageData -> If you cant pick up Ammo, it doesn't need to change.
//                So use the base ammo.
//                If you want to change state sounds/timeouts/emitters,
//                Do it here!! If your comming up with new states completely
//                MAKE A NEW BASE IMAGE!!
//   ProjectileData -> THIS IS WHERE DMG, RADIUS, ETC is set
//                This is also where the emitters are for FX.
//                So if you want them changed, you'll have to do that here.
//                Make sure to add them to the weaponsFX scripts.
//                That is where weapon FX variants go.
//                If you want to add an extra field from the base, this is where to do it.
//                I'm looking at you Ed on this one :p

datablock ProjectileData(MantisPrimaryProjectile1 : eacProjectile)
{
   directDamage        = 15;
   radiusDamage        = 0;
   damageRadius        = 2;
   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 400; // org 300
   lifetime            = 2400; // org 3200
   fadeDelay           = 500;
   explosion           = eacExplosion;
   particleEmitter     = eacSmokeEmitter;
};

datablock ItemData(MantisPrimary1 : eac)
{
	pickUpName = "EC AutoCannon A";
   displayName = "EAC A";
	image = MantisPrimaryImage1;
    amount = "400";
   refire = "medium";
   damage = "30 ap";
   range  = "960 m";
};
datablock ItemData(MantisPrimaryAmmo1 : eacAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ShapeBaseImageData(MantisPrimaryImage1 : eacImage)
{
   mountPoint = 1;
   item = MantisPrimary1;
   ammo = MantisPrimaryAmmo1;
   projectile = MantisPrimaryProjectile1;
};

datablock ProjectileData(MantisPrimaryProjectile2 : eacProjectile)
{
   directDamage        = 18.5;
   radiusDamage        = 0;
   damageRadius        = 5;
   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 400; // org 300
   lifetime            = 1920; // org 2560
   fadeDelay           = 1500;
   explosion           = eacExplosion;
   particleEmitter     = eacSmokeEmitter;
};
datablock ItemData(MantisPrimaryAmmo2 : eacAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(MantisPrimary2 : eac)
{
	pickUpName = "EC AutoCannon B";
   displayName = "EAC B";
	image = MantisPrimaryImage2;
    amount = "300";
   refire = "medium";
   damage = "36 ap";
   range  = "760 m";
};

datablock ShapeBaseImageData(MantisPrimaryImage2 : eacImage)
{
   mountPoint = 1;
      item = MantisPrimary2;
   ammo = MantisPrimaryAmmo2;
   projectile = MantisPrimaryProjectile2;
};


datablock ProjectileData(MantisPrimaryProjectile3 : eacProjectile)
{
   directDamage        = 25;
   radiusDamage        = 0;
   damageRadius        = 5;
   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 400; // org 300
   lifetime            = 1440; // org 1920
   fadeDelay           = 1500;
   explosion           = eacExplosion;
   particleEmitter     = eacSmokeEmitter;
};

datablock ItemData(MantisPrimaryAmmo3 : eacAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(MantisPrimary3 : eac)
{
	pickUpName = "EC AutoCannon C";
   displayName = "EAC C";
	image = MantisPrimaryImage3;
    amount = "200";
   refire = "med";
   damage = "50 ap";
   range  = "560 m";
};

datablock ShapeBaseImageData(MantisPrimaryImage3 : eacImage)
{
   mountPoint = 1;
      item = MantisPrimary3;
   ammo = MantisPrimaryAmmo3;
   projectile = MantisPrimaryProjectile3;
};


//------------------------------------------------------------------------------
// SECONDARY WEAPONS
//------------------------------------------------------------------------------
datablock ProjectileData(MantisSecondaryProjectile1 : rocketProjectile)
{
   directDamage        = 7.5;
   radiusDamage        = 0;
   damageRadius        = 5;
   muzzleVelocity      = 300;
   lifetime            = 2050;
   fadeDelay           = 500;
   explosion           = rocketXPExplosion;
};
datablock ItemData(MantisSecondaryAmmo1 : rocketAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(MantisSecondary1 : rocket)
{
	pickUpName = "K4x Kisten'I Rocket";
   displayname = "K4x KR";
	image = MantisSecondaryImage1;
    amount = "148";
   refire = "medium";
   damage = "7.5 X 6";
   range  = "600 m";
};

datablock ShapeBaseImageData(MantisSecondaryImage1 : rocketImage)
{
   mountPoint = 0;
   shapeFile = "~/data/shapes/weapons/mantismissiles.dts";
   item = MantisSecondary1;
   ammo = MantisSecondaryAmmo1;
   projectile = MantisSecondaryProjectile1;
};


//------------------------------------------------------------------------------
datablock ProjectileData(MantisSecondaryProjectile2 : rocketProjectile)
{
   directDamage        = 5;
   radiusDamage        = 10;
   damageRadius        = 5;
   muzzleVelocity      = 250;
   lifetime            = 2050;
   fadeDelay           = 500;
   explosion           = rocketXPExplosion;
};
datablock ItemData(MantisSecondaryAmmo2 : rocketAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(MantisSecondary2 : rocket)
{
	pickUpName = "K4x Kisten'I Explosive Rocket";
   displayname = "K4x KR XP";
	image = MantisSecondaryImage2;
    amount = "60";
   refire = "medium";
   damage = "15 X 6 ap";
   range  = "500 m";
};

datablock ShapeBaseImageData(MantisSecondaryImage2 : rocketImage)
{
   mountPoint = 0;
   shapeFile = "~/data/shapes/weapons/mantismissiles.dts";
   item = MantisSecondary2;
   ammo = MantisSecondaryAmmo2;
   projectile = MantisSecondaryProjectile2;
};


//------------------------------------------------------------------------------
datablock ProjectileData(MantisSecondaryProjectile3 : rocketProjectile)
{
   directDamage        = 13;
   radiusDamage        = 0;
   damageRadius        = 5;
   muzzleVelocity      = 200;
   lifetime            = 2050;
   fadeDelay           = 500;
};
datablock ItemData(MantisSecondaryAmmo3 : rocketAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(MantisSecondary3 : rocket)
{
	pickUpName = "K12x Drota Rocket";
   displayname = "K12x DR";
	image = MantisSecondaryImage3;
    amount = "120";
   refire = "low";
   damage = "13 X 6 ap";
   range  = "400 m";
};

datablock ShapeBaseImageData(MantisSecondaryImage3 : rocketImage)
{
   mountPoint = 0;
   shapeFile = "~/data/shapes/weapons/mantismissiles.dts";
   item = MantisSecondary3;
   ammo = MantisSecondaryAmmo3;
   projectile = MantisSecondaryProjectile3;
};


