//------------------------------------------------------------------------------
// Predator Primary Weapon Systems
//------------------------------------------------------------------------------
// How to change
//   ItemData -> THIS IS WHAT GETS ADDED TO INVENTORY.
//               Just make sure image points to the ShapeBaseImage
//   ImageData -> If you cant pick up Ammo, it doesn't need to change.
//                So use the base ammo.
//                If you want to change state sounds/timeouts/emitters,
//                Do it here!! If your comming up with new states completely
//                MAKE A NEW BASE IMAGE!!
//   ProjectileData -> THIS IS WHERE DMG, RADIUS, ETC is set
//                This is also where the emitters are for FX.
//                So if you want them changed, you'll have to do that here.
//                Make sure to add them to the weaponsFX scripts.
//                That is where weapon FX variants go.
//                If you want to add an extra field from the base, this is where to do it.
//                I'm looking at you Ed on this one :p


datablock ProjectileData(PredatorPrimaryProjectile1 : gatlingProjectile)
{
   //Damage
   directDamage        = 15;
   radiusDamage        = 0;
   damageRadius        = 0;

   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 125; // org 300
   lifetime            = 2000; // org 2700
   fadeDelay           = 1500;
   explosion           = gatlingExplosion;
   particleEmitter     = gatlingSmokeEmitter;
};
datablock ItemData(PredatorPrimaryAmmo1 : gatlingAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(PredatorPrimary1 : gatling)
{
	//
	pickUpName = "Sulitsa Heavy Vulcan";
    displayName = "Sul HV";
	image = PredatorPrimaryImage1;
	amount = "750";
    refire = "high";
    damage = "15 ap";
    range  =  "100 m effective";
};

datablock ShapeBaseImageData(PredatorPrimaryImage1 : gatlingImage)
{

   mountPoint = 0;
   item = PredatorPrimary1;
   ammo = PredatorPrimaryAmmo1;
   projectile = PredatorPrimaryProjectile1;
   
};

datablock ProjectileData(PredatorprimaryProjectile2 : eacProjectile)
{
   directDamage        = 75;
   radiusDamage        = 0;
   damageRadius        = 5;
   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 400; // org 300
   lifetime            = 1920; // org 2560
   fadeDelay           = 1500;
   explosion           = eacExplosion;
   particleEmitter     = eacSmokeEmitter;
};
datablock ItemData(PredatorprimaryAmmo2 : eacAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(Predatorprimary2 : eac)
{
	pickUpName = "EC AutoCannon As";
   displayName = "EAC As";
	image = PredatorprimaryImage2;
    amount = "350";
   refire = "medium";
   damage = "75 ap";
   range  = "760 m";
};

datablock ShapeBaseImageData(PredatorprimaryImage2 : eacImage)
{
   mountPoint = 0;
      item = Predatorprimary2;
   ammo = PredatorprimaryAmmo2;
   projectile = PredatorprimaryProjectile2;
};


datablock ProjectileData(PredatorPrimaryProjectile3 : rocketProjectile)
{
   directDamage        = 25;
   radiusDamage        = 75;
   damageRadius        = 30;
   muzzleVelocity      = 150;
   lifetime            = 6400;
   fadeDelay           = 500;
   explosion           = LARBExplosion;
};
datablock ItemData(PredatorPrimaryAmmo3 : rocketAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(PredatorPrimary3 : rocket)
{
	pickUpName = "R51a Strela Artillery";
   displayname = "R51a";
	image = PredatorPrimaryImage3;
    amount = "25";
   refire = "low";
   damage = "75r";
   range  = "960 m";
};

datablock ShapeBaseImageData(PredatorPrimaryImage3 : rocketImage)
{
   mountPoint = 0;
   item = PredatorPrimary3;
   ammo = PredatorPrimaryAmmo3;
   projectile = PredatorPrimaryProjectile3;
   shapeFile = "~/data/shapes/weapons/mantismissiles.dts";
};

//------------------------------------------------------------------------------
// SECONDARY WEAPONS
//------------------------------------------------------------------------------
datablock ProjectileData(PredatorSecondaryProjectile1 : gatlingProjectile)
{
   //Damage
   directDamage        = 7;
   radiusDamage        = 0;
   damageRadius        = 0;

   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 175; // org 300
   lifetime            = 2000; // org 2700
   fadeDelay           = 1500;
   explosion           = gatlingExplosion;
   particleEmitter     = gatlingSmokeEmitter;
};

datablock ItemData(PredatorSecondary1 : gatling)
{
	//
	pickUpName = "Sulitsa Light Vulcan";
   displayName = "Sul LV";
	image = PredatorSecondaryImage1;
	amount = "800";
   refire = "high";
   damage = "7 x 2 ap";
   range  = "350 m";
};
datablock ItemData(PredatorSecondaryAmmo1 : gatlingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ShapeBaseImageData(PredatorSecondaryImage1 : gatlingImage)
{

   mountPoint = 1;
   item = PredatorSecondary1;
   ammo = PredatorSecondaryAmmo1;
   projectile = PredatorSecondaryProjectile1;
   projectileSpread = 0.003;
};


//------------------------------------------------------------------------------
datablock ProjectileData(PredatorSecondaryProjectile2 : rocketProjectile)
{
   directDamage        = 7.5;
   radiusDamage        = 0;
   damageRadius        = 5;
   muzzleVelocity      = 200;
   lifetime            = 2550;
   fadeDelay           = 500;
   explosion           = rocketXPExplosion;
};
datablock ItemData(PredatorSecondaryAmmo2 : rocketAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(PredatorSecondary2 : rocket)
{
	pickUpName = "K4a Kisten'I Explosive Rocket";
   displayname = "K4a KR XP";
	image = PredatorSecondaryImage2;
    amount = "240";
   refire = "medium";
   damage = "7.5 x 6 ap";
   range  = "500 m";
};

datablock ShapeBaseImageData(PredatorSecondaryImage2 : rocketImage)
{
   mountPoint = 1;
   shapeFile = "~/data/shapes/weapons/mantismissiles.dts";
   item = PredatorSecondary2;
   ammo = PredatorSecondaryAmmo2;
   projectile = PredatorSecondaryProjectile2;
};


//------------------------------------------------------------------------------
datablock ProjectileData(PredatorSecondaryProjectile3 : rocketProjectile)
{
   directDamage        = 10;
   radiusDamage        = 10;
   damageRadius        = 5;
   muzzleVelocity      = 200;
   lifetime            = 3050;
   fadeDelay           = 500;
};
datablock ItemData(PredatorSecondaryAmmo3 : rocketAmmo) {  pickUpName="Ammo"; }; // This just has to exist
datablock ItemData(PredatorSecondary3 : rocket)
{
	pickUpName = "K12a Drota Rocket";
   displayname = "K12a DR";
	image = PredatorSecondaryImage3;
    amount = "120";
   refire = "low";
   damage = "10/10r x 6";
   range  = "600 m";
};

datablock ShapeBaseImageData(PredatorSecondaryImage3 : rocketImage)
{
   mountPoint = 1;
   shapeFile = "~/data/shapes/weapons/mantismissiles.dts";
   item = PredatorSecondary3;
   ammo = PredatorSecondaryAmmo3;
   projectile = PredatorSecondaryProjectile3;
};


