//------------------------------------------------------------------------------
// Shaddrack Primary Weapon Systems
//------------------------------------------------------------------------------
// How to change
//   ItemData -> THIS IS WHAT GETS ADDED TO INVENTORY.
//               Just make sure image points to the ShapeBaseImage
//   ImageData -> If you cant pick up Ammo, it doesn't need to change.
//                So use the base ammo.
//                If you want to change state sounds/timeouts/emitters,
//                Do it here!! If your comming up with new states completely
//                MAKE A NEW BASE IMAGE!!
//   ProjectileData -> THIS IS WHERE DMG, RADIUS, ETC is set
//                This is also where the emitters are for FX.
//                So if you want them changed, you'll have to do that here.
//                Make sure to add them to the weaponsFX scripts.
//                That is where weapon FX variants go.
//                If you want to add an extra field from the base, this is where to do it.
//                I'm looking at you Ed on this one :p

datablock ProjectileData(ShaddrackPrimaryProjectile1 : plasmaProjectile)
{
   //Damage  (DK 15)
   directDamage        = 35;
   radiusDamage        = 0;
   damageRadius        = 2;

   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 200; // org 150
   lifetime            = 2000; // org 8000
   fadeDelay           = 250; // org 250
   explosion           = plasmaExplosion;
   particleEmitter     = plasmaSmokeEmitter;
};
datablock ItemData(ShaddrackPrimaryAmmo1 : plasmaAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(ShaddrackPrimary1 : plasma)
{
	//
	pickUpName = "DK15 Plasma Rifle";
   displayName = "DK15 PR";
	image = ShaddrackPrimaryImage1;
   amount = "350";
   refire = "high";
   damage = "35 ap";
   range  = "400 m";
};

datablock ShapeBaseImageData(ShaddrackPrimaryImage1 : plasmaImage)
{

   item = ShaddrackPrimary1;
   ammo = ShaddrackPrimaryAmmo1;
   projectile = ShaddrackPrimaryProjectile1;
};

datablock ProjectileData(ShaddrackPrimaryProjectile2 : acProjectile)
{
   directDamage        = 75;
   radiusDamage        = 0;
   damageRadius        = 2;
   //Range = Velocity * LifeTime /1000
   muzzleVelocity      = 400; // org 750
   lifetime            = 3000; // org 3200
   fadeDelay           = 250; // org 500
   explosion           = acExplosion;
   particleEmitter     = acSmokeEmitter;
};
datablock ItemData(ShaddrackPrimaryAmmo2 : acAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(ShaddrackPrimary2 : ac)
{
	pickUpName = "LiveFire 20 AC";
   displayName = "LF-20 AC";
	image = ShaddrackPrimaryImage2;
   amount = "200";
   refire = "medium";
   damage = "75 ap";
   range  = "1200 m";
};

datablock ShapeBaseImageData(ShaddrackPrimaryImage2 : acImage)
{

   item = ShaddrackPrimary2;
   ammo = ShaddrackPrimaryAmmo2;
   projectile = ShaddrackPrimaryProjectile2;
};

datablock BeamData(ShaddrackPrimaryProjectile3 : laserProjectile)
{
   directDamage        = 80; // org 10
   radiusDamage        = 0; // org 0
   damageRadius        = 5; // org 0
   beamStyle         = 1;
   beamStartRadius   = 0.2;
   beamEndRadius     = 0.2;
   //beamLength        = 4000;
   //Range = Velocity * LifeTime /1000
   explosion           = laserExplosion;
};

datablock ItemData(ShaddrackPrimaryAmmo3 : laserAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(ShaddrackPrimary3 : laser)
{
	pickUpName = "XL3 Hellfire Laser";
   displayName = "XL3 HF L";
	image = ShaddrackPrimaryImage3;
   amount = "100";
   refire = "low";
   damage = "80";
   range  = "unlim";
};

datablock ShapeBaseImageData(ShaddrackPrimaryImage3 : laserImage)
{
   item = ShaddrackPrimary3;
   ammo = ShaddrackPrimaryAmmo3;
   projectile = ShaddrackPrimaryProjectile3;
   minEnergy = 12.5; // org 10
   fireEnergy = 10;
   fireTimeout = 1000;
};


//------------------------------------------------------------------------------
// SECONDARY WEAPONS
//------------------------------------------------------------------------------

datablock SeekerProjectileData(ShaddrackSecondaryProjectile1 : homingProjectile)
{
   directDamage        = 65;
   radiusDamage        = 10;
   damageRadius        = 5;
   explosion           = homingExplosion;
   particleEmitter     = homingSmokeEmitter;
};
datablock ItemData(ShaddrackSecondaryAmmo1 : homingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(ShaddrackSecondary1 : homing)
{
	//
   pickUpName = "T5i Yellow Jacket Homing Missile";
   displayName = "T5i YJ HM";
	image = ShaddrackSecondaryImage1;
    amount = "100";
   refire = "high";
   damage = "75";
   range  = "na";
};

datablock ShapeBaseImageData(ShaddrackSecondaryImage1 : homingImage)
{

   item = ShaddrackSecondary1;
   ammo = ShaddrackSecondaryAmmo1;
   projectile = ShaddrackSecondaryProjectile1;
   seekRadius = 600;
};



//------------------------------------------------------------------------------
datablock SeekerProjectileData(ShaddrackSecondaryProjectile2 : homingProjectile)
{
   directDamage        = 70;
   radiusDamage        = 25;
   damageRadius        = 10;
   explosion           = homingExplosion;
   particleEmitter     = homingSmokeEmitter;
};

datablock ItemData(ShaddrackSecondaryAmmo2 : homingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(ShaddrackSecondary2 : homing)
{
 	pickUpName = "T15i Viper Homing Missile";
   displayName = "T15i V HM";
	image = ShaddrackSecondaryImage2;
   amount = "80";
   refire = "medium";
   damage = "95 ap";
   range  = "na";
};

datablock ShapeBaseImageData(ShaddrackSecondaryImage2 : homingImage)
{
   item = ShaddrackSecondary2;
   ammo = ShaddrackSecondaryAmmo2;
   projectile = ShaddrackSecondaryProjectile2;
   seekRadius = 600;
};


//------------------------------------------------------------------------------
datablock SeekerProjectileData(ShaddrackSecondaryProjectile3 : homingProjectile)
{
   directDamage        = 80;
   radiusDamage        = 30;
   damageRadius        = 12.5;
   explosion           = homingExplosion;
   particleEmitter     = homingSmokeEmitter;
};

datablock ItemData(ShaddrackSecondaryAmmo3 : homingAmmo) {  pickUpName="Ammo"; }; // This just has to exist

datablock ItemData(ShaddrackSecondary3 : homing)
{
	pickUpName = "T25i Guardian Homing Missile";
   displayName = "T25i G HM";
	image = ShaddrackSecondaryImage3;
    amount = "60";
   refire = "low";
   damage = "110 ap";
   range  = "na";
};

datablock ShapeBaseImageData(ShaddrackSecondaryImage3 : homingImage)
{
   item = ShaddrackSecondary3;
   ammo = ShaddrackSecondaryAmmo3;
   projectile = ShaddrackSecondaryProjectile3;
   seekRadius = 600;
};

