//------------------------------------------
//Special Datablocks
//----------------------------------------

datablock AITurretData(ECAITurret : GenericAITurret)
{
	shapeFile						= "~/data/shapes/turrets/portTurret.dts";
   maxDamage                       = 100;
   //explosion                       = RifleExplosion;
   destroyedLevel                  = 100;
   debrisShapeName                 = "~/data/shapes/turrets/portturret_debris.dts";
   barrel                          = SmallTurretGun;
   barrelMountPoint                = 0;
	cameraMaxDist					= 10;
	cameraOffset					= 2.5;
   projectileInheritVelocity       = 1;
    //projectileVelocity              = 100;  // fill this stuff in to describe the projectile you firing
   projectileVelocity              = 300;  // for testing very fast
   projectileGravityMod            = 0;
   projectileBallistic             = false;
   imageSeeks                      = false;
   emap = true;
    // in script only
   firstFireDelay                  = 2.0; // fire this soon after aquiring target...
   firstFireDelayVariance          = 0.3; // .. plus or minus this amount
   fireRate                        = 4.0; // fire every N seconds after that...
   fireRateVariance                = 1.0; // ...plus or minus this amount
};
//------------------------------------------------------------------------
datablock AITurretData(FSAITurret : GenericAITurret)
{
	shapeFile						= "~/data/shapes/turrets/portTurret.dts";
   maxDamage                       = 100;
   //explosion                       = RifleExplosion;
   destroyedLevel                  = 100;
   debrisShapeName                 = "~/data/shapes/turrets/portturret_debris.dts";
   barrel                          = SmallTurretGun;
   barrelMountPoint                = 0;
 	cameraMaxDist					= 10;
	cameraOffset					= 2.5;
   projectileInheritVelocity       = 1;
   //projectileVelocity              = 100;  // fill this stuff in to describe the projectile you firing
   projectileVelocity              = 300;  // for testing very fast
   projectileGravityMod            = 0;
   projectileBallistic             = false;
   imageSeeks                      = false;
   emap = true;
   // in script only
   firstFireDelay                  = 2.0; // fire this soon after aquiring target...
   firstFireDelayVariance          = 0.3; // .. plus or minus this amount
   fireRate                        = 4.0; // fire every N seconds after that...
   fireRateVariance                = 1.0; // ...plus or minus this amount
};

//-------------------------------------------
datablock ItemData(ECMineGrenade : MineGrenade)
{
   category     = "Mine";
   shapeFile    = "~/data/shapes/items/mine01.dts";
   // Dynamic properties defined by the scripts
   pickupName   = "a Mine";
   repairAmount = 50;
   maxDamage    = 0.2;
   directDamage = 150;
   damageRadius = 25;
   radiusDamage = 50;
};
//-----------------------------------------------------------------
datablock ItemData(FSMineGrenade : MineGrenade)
{
   category     = "Mine";
   shapeFile    = "~/data/shapes/items/mine01.dts";
   // Dynamic properties defined by the scripts
   pickupName   = "a Mine";
   repairAmount = 50;
   maxDamage    = 0.2;
   directDamage = 150;
   damageRadius = 25;
   radiusDamage = 50;
};

//------------------------------------------
//Special Functions
//---------------------------------------------------
function isSpecial(%Name)
{
   %substring = getSubStr( %Name, 0, strLen(%Name)  - 1);
   switch$ (%substring)
   {
      case "Predator":
         return true;
      case "Beast":
         return true;
      default:
         return false;
   }
}

function getSpecial(%Name)
{
   %substring = getSubStr( %Name, 0, strLen(%Name)  - 1);
   switch$ (%substring)
   {
      case "Predator":
         return "PredatorSpecial";
      case "Beast":
         return "PredatorSpecial";
   }
}
function serverCmdUseSpecial(%client)
{
   %MavName = %client.dbname;
   %substring = getSubStr( %MavName, 0, strLen(%MavName)  - 1);
   switch$ (%substring)
   {
      case "HunterScout":
         deployMine(%client);
      case "Abolisher":
         deployTurret(%client);
      case "Juggernaut":
         deployTurret(%client);
      case "Locust":
         deployMine(%client);
      case "Predator":
         %client.player.use(PredatorSpecial);
      case "Beast":
         %client.player.use(PredatorSpecial);
   }
}
function isSpecialWeapon(%Name){
      switch$ (%Name)
      {
         //-------------------
         case "PredatorSpecial":
         return true;
         //--------------------
         case "BeastSpecial":
         return true;
         //--------------------
         default:
         return false;
         }
}
//---------------------------------------------------------------------
// DEPLOYS
//----------------------------------------------------
function DeployMine(%client)
{
   if (%client.currentDeployed >= %client.MaxMinesDeployed){
      messageClient(%client, 'MsgMineMax', '\c2The maximum amount of mines %1 has been reached.', %client.MaxMinesDeployed);
      return;
   }
   %obj = %client.player;
   if (!isObject(%obj))
      return;

   if(%client.team.teamID == 1)
       %mineTeam = "FSMineGrenade";
   else
       %mineTeam = "ECMineGrenade";

   %depMine = new Item() {
      dataBlock = %mineTeam;
      position = "0 0 1 " @ (getRandom() * 360);
      sourceObject   = %client.player;
      client = %client;
   };
   %client.currentDeployed++;
   MissionCleanup.add(%depMine);
   messageClient(%client, 'MsgMineDeployed', '\c2You have deployed %1 of %2 mines.', %client.currentDeployed, %client.MaxMinesDeployed);
      %obj.throwObject(%depMine);
}
//----------------------------------------------------
function DeployTurret(%client)
{
   %obj = %client.player;
   if(%client.currentDeployed >= %client.MaxTurretsDeployed){
      messageClient(%client, 'MsgTurretMax', '\c2The maximum amount of turrets %1 has been reached.', %client.MaxTurretsDeployed);
      return;
   }
   // look for 3 meters along player's viewpoint for interior or terrain
   %searchRange = 10.0;
   %mask = $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::StaticShapeObjectType ;
   // get the eye vector and eye transform of the player
   %eyeVec = %obj.getEyeVector();
   %eyeTrans = %obj.getEyeTransform();
   // extract the position of the player's camera from the eye transform (first 3 words)
   %eyePos = posFromTransform(%eyeTrans);
   // normalize the eye vector
   %nEyeVec = VectorNormalize(%eyeVec);
   // scale (lengthen) the normalized eye vector according to the search range
   %scEyeVec = VectorScale(%nEyeVec, %searchRange);
   // add the scaled & normalized eye vector to the position of the camera
   %eyeEnd = VectorAdd(%eyePos, %scEyeVec);
   // see if anything gets hit
   %searchResult = containerRayCast(%eyePos, %eyeEnd, %mask, 0);
   if (!%searchResult )
   {
      messageClient(%data, 'MsgBeaconNoSurface', '\c2Cannot place Turret. Too far from surface.');
      // no terrain/interior collision within search range
      return 0;
   }
   %terrPt = posFromRaycast(%searchResult);
   %terrNrm = normalFromRaycast(%searchResult);

   %intAngle = getTerrainAngle(%terrNrm);
   %rotAxis = vectorNormalize(vectorCross(%terrNrm, "0 0 1"));
   if (getWord(%terrNrm, 2) == 1 || getWord(%terrNrm, 2) == -1)
      %rotAxis = vectorNormalize(vectorCross(%terrNrm, "0 1 0"));
   %rotation = %rotAxis @ " " @ %intAngle;

   if(%obj.getTeam() == 1)
      %turretTeam = "FSAITurret";
   else
      %turretTeam = "ECAITurret";

   %depTur = new AITurret() {
      dataBlock = %turretTeam;
      position = VectorAdd(%terrPt, VectorScale(%terrNrm, 0.05));
      rotation = %rotation;
      client = %client;
   };
   %depTur.team = %obj.getTeam();
   %depTur.setTeam(%obj.getTeam());
   %client.currentDeployed = %client.currentDeployed + 1;
   messageClient(%client, 'MsgTurretDeployed', '\c2You have deployed %1 of %2 turrets.', %client.currentDeployed,%client.MaxTurretsDeployed);
   MissionCleanup.add(%depTur);
}

//----------------------------------------------------
//MINES
//-------------
function FSMineGrenade::onCollision( %data, %obj, %col )
{
   %obj.setDamageState(Destroyed);

   %obj.schedule(1000, "delete");
}
//------------------
function ECMineGrenade::onCollision( %data, %obj, %col )
{
   %obj.setDamageState(Destroyed);

   %obj.schedule(1000, "delete");
}

//-------------------------------------------
function FSMineGrenade::onDestroyed(%data,%obj)
{
   // Radius damage is a support scripts defined in radiusDamage.cs
   %pos = %obj.getPosition();
      %obj.client.currentDeployed--;
   radiusDamage(%obj,%pos,%data.damageRadius,%data.radiusDamage,"Mine",0);
}

//-------------------------------------
function ECMineGrenade::onDestroyed(%data,%obj)
{
   // Radius damage is a support scripts defined in radiusDamage.cs
   %pos = %obj.getPosition();
      %obj.client.currentDeployed--;
   radiusDamage(%obj,%pos,%data.damageRadius,%data.radiusDamage,"Mine",0);
}
