//------------------------------------------
//sounds
//------------------------------------

//--LRM
datablock AudioProfile(LRMFireSound)
{
   filename = "~/data/sound/missile.ogg";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(LRMMountSound)
{
   filename = "~/data/sound/boltpull.ogg";
   description = AudioClosest3d;
   preload = true;
};
//--Laser
datablock AudioProfile(LaserBeamFireSound)
{
   filename = "~/data/sound/lasercannon.ogg";
   description = AudioDefault3d;
   preload = true;
};

// Plasma Explosions

datablock ParticleData(plasmaExplosionParticle2 : plasmaExplosionParticle)
{
   textureName   = "~/data/specialfx/smoke2";  //textureName   = "~/data/specialfx/smoke2";
   colors[0]     = "1 1 1 1";  //colors[0]     = "0 0.5 0.5 1";
   colors[1]     = "0 0.75 0.75 0.5";  //colors[1]     = "0 0.75 0.75 0.5";
   sizes[0]      = 0.5;  //sizes[0]      = 0.5;
   sizes[1]      = 2;  //sizes[1]      = 1.0;
};

datablock ParticleData(plasmaExplosionParticle1:plasmaExplosionParticle)
{
   textureName   = "~/data/specialfx/smoke2";  //textureName   = "~/data/specialfx/smoke2";
   colors[0]     = "1 1 1 1";  //colors[0]     = "0 0.0 0.5 1.0";
   colors[1]     = "0 0.75 0.75 0.5";  //colors[1]     = "0.1 0.1 0.4 1.0";
   sizes[0]      = 0.5;  //sizes[0]      = 0.5;
   sizes[1]      = 4; //sizes[1]      = 1.0;
};

datablock ParticleEmitterData(plasmaExplosionEmitter2 :plasmaExplosionEmitter)
{   particles = plasmaExplosionParticle2;   };
datablock ParticleEmitterData(plasmaExplosionEmitter1:plasmaExplosionEmitter)
{  particles = plasmaExplosionParticle1;    };

datablock ExplosionData(plasmaExplosion2)
{
   lifeTimeMS = 1500;

   particleEmitter = plasmaExplosionEmitter2;
   particleDensity = 50;
   particleRadius = 1;

   faceViewer     = true;
   explosionScale = "1.5 1.5 1.5"; // org 1 1 1

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3; // org 6
   lightEndRadius = 0;
   lightStartColor = "1 1 1";  //lightStartColor = "0 0.5 0.5";
   lightEndColor = "0 0.75 0.75";  //lightEndColor = "0 0 0";
};
datablock ExplosionData(plasmaExplosion1)
{
   lifeTimeMS = 2100;  // org 1500

   particleEmitter = plasmaExplosionEmitter1;
   particleDensity = 60; // org 50
   particleRadius = 2; // org 2

   faceViewer     = true;
   explosionScale = "2 2 2"; //org 1 1 1

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 6; // org 6
   lightEndRadius = 0;
   lightStartColor = "1 1 1";  //lightStartColor = "0 0 0.6";
   lightEndColor = "0 0.75 0.75";  //lightEndColor = "0 0 0";
};

// Explosive rocket explosion
datablock ExplosionData(rocketXPExplosion)
{
   particleEmitter = rocketExplosionEmitter;
   particleDensity = 65; // org 50
   particleRadius = 3.5; //org 2

   faceViewer     = true;
   explosionScale = "3 3 3"; // org 1 1 1

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
   
   // Dynamic light
   lightStartRadius = 3; // org 6
   lightEndRadius = 0;
   lightStartColor = "0.56 0.36 0.26 1.0";  //new
   lightEndColor = "0 0 0";  //new
};
