//------------------------------------------------------------------------------
// Weapon Functions
//------------------------------------------------------------------------------
//-------------------
// Emitter for Extra Fire (test feature)
//-------------------

function ExtraFire(%this, %obj, %slot,%offsetx, %offsety,%offsetz,%rotatez)
{
   %projectile = %this.projectile;
   %position = VectorAdd(%obj.getSlotTransform(%slot),VectorScale(%obj.getWorldBoxCenter(),"-1 -1 0"));
   %multiplyx = getword(%position,0);
   %multiplyy = getword(%position,1);
   %x = ((%offsetx) * %multiplyy);
   %y = ((%offsety) * %multiplyx);
   %z = %offsetz;
   %position = %x SPC %y SPC %z;
   %position = VectorAdd(%obj.getMuzzlePoint(%slot),%position);

   if(!%obj.aiPlayer)
     %clientID = %obj.client;
   else
     %clientID = %obj;
   %rotVec = "0 0" SPC %rotatez;
   %muzzleVector = %obj.getMuzzleVector(%slot);
   %muzzleVector = vectorAdd(%muzzleVector,%rotVec);
   %objectVelocity = %obj.getVelocity();
   %muzzleVelocity = VectorAdd(
      VectorScale(%muzzleVector, %projectile.muzzleVelocity),
      VectorScale(%objectVelocity, %projectile.velInheritFactor));

   %p = new (%this.projectileType)() {
      dataBlock        = %projectile;
      initialVelocity  = %muzzleVelocity;
      initialPosition  = %position;
      sourceObject     = %obj;
      sourceSlot       = %slot;
      client           = %clientID;
   };
   MissionCleanup.add(%p);
   return %p;
}

function ExtraGatlingFire(%this, %obj, %slot,%offsetx, %offsety,%offsetz,%rotatez)
{
   %projectile = %this.projectile;
   %position = VectorAdd(%obj.getSlotTransform(%slot),VectorScale(%obj.getWorldBoxCenter(),"-1 -1 0"));
   %multiplyx = getword(%position,0);
   %multiplyy = getword(%position,1);
   %x = ((%offsetx) * %multiplyy);
   %y = ((%offsety) * %multiplyx);
   %z = %offsetz;
   %position = %x SPC %y SPC %z;
   %position = VectorAdd(%obj.getMuzzlePoint(%slot),%position);

   if(!%obj.aiPlayer)
     %clientID = %obj.client;
   else
     %clientID = %obj;

   // Get the weapons projectile spread and ensure it is never 0
	//   (we need some spread direction even if it is extremely tiny)
	%spread = %this.projectileSpread;
	%spread = %spread $= "" ? 0.001 : %spread;
	%spread = %spread <= 0 ? 0.001 : %spread;

   %muzzleVector = %obj.getMuzzleVector(%slot);
   %muzzleVector = vectorAdd(%muzzleVector,%rotVec);
   %objectVelocity = %obj.getVelocity();
   %muzzleVelocity = VectorAdd(
      VectorScale(%muzzleVector, %projectile.muzzleVelocity),
      VectorScale(%objectVelocity, %projectile.velInheritFactor));

	%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);

   // Alter our projectile vector with our spread matrix
	%muzzleVelocity = MatrixMulVector(%mat, %muzzleVelocity);

   %p = new (%this.projectileType)() {
      dataBlock        = %projectile;
      initialVelocity  = %muzzleVelocity;
      initialPosition  = %position;
      sourceObject     = %obj;
      sourceSlot       = %slot;
      client           = %clientID;
   };
   MissionCleanup.add(%p);
   return %p;
}

function ExtraHoming(%this, %obj, %slot,%offsetx, %offsety,%offsetz,%rotatez)
{      %target = %obj.getLockedTarget(%slot);
   %projectile = %this.projectile;
   %position = VectorAdd(%obj.getSlotTransform(%slot),VectorScale(%obj.getWorldBoxCenter(),"-1 -1 0"));
   %multiplyx = getword(%position,0);
   %multiplyy = getword(%position,1);
   %x = ((%offsetx) * %multiplyy);
   %y = ((%offsety) * %multiplyx);
   %z = %offsetz;
   %position = %x SPC %y SPC %z;
   %position = VectorAdd(%obj.getMuzzlePoint(%slot),%position);

    if(!%obj.aiPlayer)
      %clientID = %obj.client;
    else
       %clientID = %obj;
    %muzzleVector = %obj.getMuzzleVector(%slot);
    echo(%this.projectileType);
    echo(%projectile);

    %p = new (%this.projectileType)() {
        dataBlock        = %projectile;
        initialVelocity  = VectorScale(%muzzleVector, %projectile.muzzleVelocity);
        initialPosition  = %obj.getMuzzlePoint(%slot);
        sourceObject     = %obj;
        sourceSlot = %slot;
        client           = %clientID;
        target = %obj.getLockedTarget(%slot);
    };
   MissionCleanup.add(%p);
   return %p;
}



//------------------------------------------------------------------------------
// Projectile Functions
//------------------------------------------------------------------------------
//Mantis
function MantisPrimaryImage1::onFire(%this, %obj, %slot)
{
baseEAC::onFire(%this, %obj, %slot,2);
   ExtraFire(%this, %obj, %slot,-1,1,0);  }

function MantisPrimaryImage2::onFire(%this, %obj, %slot)
{  baseEAC::onFire(%this, %obj, %slot,2);
   ExtraFire(%this, %obj, %slot,-1,1,0);  }
function MantisPrimaryImage3::onFire(%this, %obj, %slot)
{  baseEAC::onFire(%this, %obj, %slot,2);
   ExtraFire(%this, %obj, %slot,-1,1,0);  }
function MantisSecondaryImage1::onFire(%this, %obj, %slot)
{     %obj.decInventory(%this.ammo,6);
   if(!%obj.aiPlayer)
      %obj.client.setAmmoAmountHud(%obj.getInventory(%this.ammo));
   ExtraHoming(%this, %obj, %slot,-0.4,0.4,0.3,0.01);
   ExtraHoming(%this, %obj, %slot,-0.4,0.4,0);
   ExtraHoming(%this, %obj, %slot,-0.4,0.4,-0.3,-0.01);
   ExtraHoming(%this, %obj, %slot,0.4,-0.4,0.3,0.01);
   ExtraHoming(%this, %obj, %slot,0.4,-0.4,0);
   ExtraHoming(%this, %obj, %slot,0.4,-0.4,-0.3,-0.01);
}
function MantisSecondaryImage2::onFire(%this, %obj, %slot)
{     %obj.decInventory(%this.ammo,6);
   if(!%obj.aiPlayer)
      %obj.client.setAmmoAmountHud(%obj.getInventory(%this.ammo));
   ExtraFire(%this, %obj, %slot,-0.4,0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,-0.4,0.4,0);
   ExtraFire(%this, %obj, %slot,-0.4,0.4,-0.3,-0.01);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,0);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,-0.3,-0.01);
}
function MantisSecondaryImage3::onFire(%this, %obj, %slot)
{     %obj.decInventory(%this.ammo,6);
   if(!%obj.aiPlayer)
      %obj.client.setAmmoAmountHud(%obj.getInventory(%this.ammo));
   ExtraFire(%this, %obj, %slot,-0.4,0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,-0.4,0.4,0);
   ExtraFire(%this, %obj, %slot,-0.4,0.4,-0.3,-0.01);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,0);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,-0.3,-0.01);
}
// Locust
function LocustPrimaryImage1::onFire(%this, %obj, %slot)
{  baseGatling::onFire(%this, %obj, %slot,1); }
function LocustPrimaryImage2::onFire(%this, %obj, %slot)
{  baseGatling::onFire(%this, %obj, %slot,1); }
function LocustPrimaryImage3::onFire(%this, %obj, %slot)
{  baseGatling::onFire(%this, %obj, %slot,1); }
function LocustSecondaryImage1::onFire(%this, %obj, %slot)
{     %obj.decInventory(%this.ammo,6);
   if(!%obj.aiPlayer)
      %obj.client.setAmmoAmountHud(%obj.getInventory(%this.ammo));
   ExtraFire(%this, %obj, %slot,-0.4,0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,-0.4,0.4,0);
   ExtraFire(%this, %obj, %slot,-0.4,0.4,-0.3,-0.01);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,0);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,-0.3,-0.01);
}
function LocustSecondaryImage2::onFire(%this, %obj, %slot)
{     %obj.decInventory(%this.ammo,6);
   if(!%obj.aiPlayer)
      %obj.client.setAmmoAmountHud(%obj.getInventory(%this.ammo));
   ExtraFire(%this, %obj, %slot,-0.4,0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,-0.4,0.4,0);
   ExtraFire(%this, %obj, %slot,-0.4,0.4,-0.3,-0.01);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,0);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,-0.3,-0.01);
}
function LocustSecondaryImage3::onFire(%this, %obj, %slot)
{     %obj.decInventory(%this.ammo,6);
   if(!%obj.aiPlayer)
      %obj.client.setAmmoAmountHud(%obj.getInventory(%this.ammo));
   ExtraFire(%this, %obj, %slot,-0.4,0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,-0.4,0.4,0);
   ExtraFire(%this, %obj, %slot,-0.4,0.4,-0.3,-0.01);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,0);
   ExtraFire(%this, %obj, %slot,0.4,-0.4,-0.3,-0.01);
}
// Jugger
function JuggernautPrimaryImage1::onFire(%this, %obj, %slot)
{  baseGatling::onFire(%this, %obj, %slot,1); }
function JuggernautPrimaryImage2::onFire(%this, %obj, %slot)
{  baseGatling::onFire(%this, %obj, %slot,1); }
function JuggernautPrimaryImage3::onFire(%this, %obj, %slot)
{  baseGatling::onFire(%this, %obj, %slot,1); }
function JuggernautSecondaryImage1::onFire(%this, %obj, %slot)
{  baseRocket::onFire(%this, %obj, %slot,1); }
function JuggernautSecondaryImage2::onFire(%this, %obj, %slot)
{  baseRocket::onFire(%this, %obj, %slot,1); }
function JuggernautSecondaryImage3::onFire(%this, %obj, %slot)
{  baseRocket::onFire(%this, %obj, %slot,1); }

// Predator
function PredatorPrimaryImage1::onFire(%this, %obj, %slot)
{  baseGatling::onFire(%this, %obj, %slot,1); }
function PredatorPrimaryImage2::onFire(%this, %obj, %slot)
{  baseEAC::onFire(%this, %obj, %slot,1); }
function PredatorPrimaryImage3::onFire(%this, %obj, %slot)
{  baseRocket::onFire(%this, %obj, %slot,1); }
function PredatorSecondaryImage1::onFire(%this, %obj, %slot)
{  baseGatling::onFire(%this, %obj, %slot,2);
   ExtraGatlingFire(%this, %obj, %slot,-0.8,0.8,0);
}
function PredatorSecondaryImage2::onFire(%this, %obj, %slot)
{
   %obj.decInventory(%this.ammo,6);
   if(!%obj.aiPlayer)
      %obj.client.setAmmoAmountHud(%obj.getInventory(%this.ammo));
   ExtraFire(%this, %obj, %slot,-1.5,0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,-1.5,0.4,0);
   ExtraFire(%this, %obj, %slot,-1.5,0.4,-0.3,-0.01);
   ExtraFire(%this, %obj, %slot,-0.5,-0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,-0.5,-0.4,0);
   ExtraFire(%this, %obj, %slot,-0.5,-0.4,-0.3,-0.01);
}
function PredatorSecondaryImage3::onFire(%this, %obj, %slot)
{  //baseRocket::onFire(%this, %obj, %slot,6);
   %obj.decInventory(%this.ammo,6);
   if(!%obj.aiPlayer)
      %obj.client.setAmmoAmountHud(%obj.getInventory(%this.ammo));
   ExtraFire(%this, %obj, %slot,-1.5,0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,-1.5,0.4,0);
   ExtraFire(%this, %obj, %slot,-1.5,0.4,-0.3,-0.01);
   ExtraFire(%this, %obj, %slot,-0.5,-0.4,0.3,0.01);
   ExtraFire(%this, %obj, %slot,-0.5,-0.4,0);
   ExtraFire(%this, %obj, %slot,-0.5,-0.4,-0.3,-0.01);
}

function HunterScoutPrimaryImage1::onFire(%this, %obj, %slot)
{  basePlasma::onFire(%this, %obj, %slot,1); }
function HunterScoutPrimaryImage2::onFire(%this, %obj, %slot)
{  baseAC::onFire(%this, %obj, %slot,1); }
function HunterScoutPrimaryImage3::onFire(%this, %obj, %slot)
{  baseLaser::onFire(%this, %obj, %slot,1); }
function HunterScoutSecondaryImage1::onFire(%this, %obj, %slot)
{  baseHoming::onFire(%this, %obj, %slot,1); }
function HunterScoutSecondaryImage2::onFire(%this, %obj, %slot)
{  baseHoming::onFire(%this, %obj, %slot,1); }
function HunterScoutSecondaryImage3::onFire(%this, %obj, %slot)
{  baseHoming::onFire(%this, %obj, %slot,1); }


function ShaddrackPrimaryImage1::onFire(%this, %obj, %slot)
{  basePlasma::onFire(%this, %obj, %slot,1); }
function ShaddrackPrimaryImage2::onFire(%this, %obj, %slot)
{  baseAC::onFire(%this, %obj, %slot,1); }
function ShaddrackPrimaryImage3::onFire(%this, %obj, %slot)
{  baseLaser::onFire(%this, %obj, %slot,1); }
function ShaddrackSecondaryImage1::onFire(%this, %obj, %slot)
{  baseHoming::onFire(%this, %obj, %slot,1); }
function ShaddrackSecondaryImage2::onFire(%this, %obj, %slot)
{  baseHoming::onFire(%this, %obj, %slot,1); }
function ShaddrackSecondaryImage3::onFire(%this, %obj, %slot)
{  baseHoming::onFire(%this, %obj, %slot,1); }

function AbolisherPrimaryImage1::onFire(%this, %obj, %slot)
{  basePlasma::onFire(%this, %obj, %slot,1); }
function AbolisherPrimaryImage2::onFire(%this, %obj, %slot)
{  baseAC::onFire(%this, %obj, %slot,1); }
function AbolisherPrimaryImage3::onFire(%this, %obj, %slot)
{  baseLaser::onFire(%this, %obj, %slot,1); }
function AbolisherSecondaryImage1::onFire(%this, %obj, %slot)
{  baseHoming::onFire(%this, %obj, %slot,1); }
function AbolisherSecondaryImage2::onFire(%this, %obj, %slot)
{  baseHoming::onFire(%this, %obj, %slot,1); }
function AbolisherSecondaryImage3::onFire(%this, %obj, %slot)
{  baseRocket::onFire(%this, %obj, %slot,1); }

// Beast
function BeastPrimaryImage1::onFire(%this, %obj, %slot)
{  basePlasma::onFire(%this, %obj, %slot,1); }
function BeastPrimaryImage2::onFire(%this, %obj, %slot)
{  baseAC::onFire(%this, %obj, %slot,1); }
function BeastPrimaryImage3::onFire(%this, %obj, %slot)
{  baseLaser::onFire(%this, %obj, %slot,1); }
function BeastSecondaryImage1::onFire(%this, %obj, %slot)
{  //baseRocket::onFire(%this, %obj, %slot,4);
   %obj.decInventory(%this.ammo,4);
   if(!%obj.aiPlayer)
      %obj.client.setAmmoAmountHud(%obj.getInventory(%this.ammo));
   ExtraFire(%this, %obj, %slot,0,0,0.5,0);
   ExtraFire(%this, %obj, %slot,0,0,-0.5,0);
   ExtraFire(%this, %obj, %slot,0.5,0,0,0);
   ExtraFire(%this, %obj, %slot,-0.5,0,0,0);
}
function BeastSecondaryImage2::onFire(%this, %obj, %slot)
{  baseHoming::onFire(%this, %obj, %slot,1); }
function BeastSecondaryImage3::onFire(%this, %obj, %slot)
{  baseHoming::onFire(%this, %obj, %slot,1); }

// onCollisions...
//-------------------------------------------------------------------------
function WeaponCollision(%this,%obj,%col,%fade,%pos,%normal)
{
   if (%col.getType() & $TypeMasks::DamagableItemObjectType)
   {
      %col.setDamageState(Destroyed);
      %col.schedule(999, "delete");
   }
   if (%col.getType() & $TypeMasks::ShapeBaseObjectType)
   {
      %col.damage(%obj,%pos,%this.directDamage,"Bullet");
   }
   radiusDamage(%obj,%pos,%this.damageRadius,%this.radiusDamage,"Damage",%this.areaImpulse);
}

function acProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
//Hunter Scout
function HunterScoutPrimaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function HunterScoutPrimaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function HunterScoutPrimaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function HunterScoutSecondaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function HunterScoutSecondaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function HunterScoutSecondaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }

//Shaddrack
function ShaddrackPrimaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function ShaddrackPrimaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function ShaddrackPrimaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function ShaddrackSecondaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function ShaddrackSecondaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function ShaddrackSecondaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
//Abolisher
function AbolisherPrimaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function AbolisherPrimaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function AbolisherPrimaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function AbolisherSecondaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function AbolisherSecondaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function AbolisherSecondaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
//Beast
function BeastPrimaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function BeastPrimaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function BeastPrimaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function BeastSecondaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function BeastSecondaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function BeastSecondaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
//Locust
function LocustPrimaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function LocustPrimaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function LocustPrimaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function LocustSecondaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function LocustSecondaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function LocustSecondaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
//Mantis
function MantisPrimaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function MantisPrimaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function MantisPrimaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function MantisSecondaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function MantisSecondaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function MantisSecondaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
//Juggernaut
function JuggernautPrimaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function JuggernautPrimaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function JuggernautPrimaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function JuggernautSecondaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function JuggernautSecondaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function JuggernautSecondaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
//Predator
function PredatorPrimaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function PredatorPrimaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function PredatorPrimaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function PredatorSecondaryProjectile1::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function PredatorSecondaryProjectile2::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }
function PredatorSecondaryProjectile3::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{ WeaponCollision(%this,%obj,%col,%fade,%pos,%normal); }

