//------------------------------------------------------------------------------
// IRC-CHAT Script v1.0.7
//------------------------------------------------------------------------------
// Contains the functions to deal with all WORD 'code' IRC replies
//------------------------------------------------------------------------------
// Including PING, PONG, NOTICE, PRIVMSG, MODE, JOIN, NICK, QUIT, PART, KICK
// INVITE, and TOPIC
//-------------------`-----------------------------------------------------------
// Original Scripts created or modified by Harold "LabRat" Brown
//
// By Sebastien Bourgon
// Last Updated February 26th, 2003
//------------------------------------------------------------------------------

//--------- PING ---------------------------------------------------------------
function IRCClient::onPing(%prefix,%params)
{
   %time = getSimTime();
   if ((%time - $IRCClient::lastPinged) >= $PING_FLOOD_TIMEOUT)
   {
      $IRCClient::lastPinged = %time;
     if (strlen(%prefix))
     {
        nextToken(%prefix,nick,"!");
       %p = IRCClient::findPerson(%nick);
       if (%p)
          if (%p.ping)
         {
            %p.ping = 0;
         }
         else
         {
            %params = nextToken(%params,nick," :");
            nextToken(%params,key," \x01");
            IRCClient::send("NOTICE " @ %nick @ " :\x01PING " @ %key);
         }
     }
     else
        IRCClient::send("PONG " @ %params);
   }
}

//--------- PONG ---------------------------------------------------------------
function IRCClient::onPong(%prefix,%params)
{
   nextToken(%params,nick," ");
   %p = IRCClient::findPerson(%nick);
   if (%p && %p.ping)
   {
     %p.ping = 0;
   }
}

function IRCClient::onTopic(%prefix,%params)
{
   %prefix = nextToken(%prefix,nick,"!");
   %msg = nextToken(%params,channel," ");
   // messages always lead with a ':'
   if (getSubStr(%msg,0,1) $= ":")
   {
      %msg = getSubStr(%msg,1,strlen(%msg)-1);
   }
   IRCClient::newMessage(%channel,"\c7[TOPIC] " @ %nick @ " has changed topic to: " @ %msg );

}
//--------- Notice -------------------------------------------------------------
function IRCClient::onNotice(%prefix,%params)
{
   //EXAMPLE NOTICE AUTH :*** Found your hostname
   if (%prefix !$= $IRCClient::Server) {
      %prefix = nextToken(%prefix,nick,"!");
      %msg = strchr(%params,"\x01");
      %params = nextToken(%params,params,":");
      IRCClient::newMessage($IRCClient::currentChannel,"\c6[" @ %nick @ "]: " @ %params);
   }
   else
   {
      %msg = strchr(%params,"\x01");
      %params = nextToken(%params,params,":");
	  IRCClient::newMessage("","\c6[Server]: " @ %params);
   }
}

//--------- Invite -------------------------------------------------------------
function IRCClient::onInvite(%prefix,%params)
{
  %prefix = nextToken(%prefix,nick,"!");
  %chan = nextToken(%params,nick," ");
  IRCClient::newMessage($IRCClient::currentChannel,"\c6[INVITE] You have been invited to join " @ %chan @ " by " @ %nick);

}

//--------- On Join ------------------------------------------------------------
function IRCClient::onJoin(%prefix,%params)
{
   %c = IRCClient::findChannel(%params,true);
   %prefix = nextToken(%prefix,nick,"!");

   // if this is me then set this as the current channel
   if (%nick $= $IRCClient::Nick)
   {
      if ($INGAME.Channel !$= %c.name)
      {
      $IRCClient::currentChannel = %c;
      mMM_ChanList.addRow(mMM_ChanList.rowCount(),%c.name);
      IRCUI::addChannel(%c.getName(),mMM_ChanList.rowCount()-1);
      mMM_ChanList.setSelectedRow(mMM_ChanList.rowCount()-1);
      }
   }
   
   IRCClient::newMessage(%c,"\c2[JOIN] "@ %nick @ " has joined the conversation.");
   %p = IRCClient::findPerson(%nick);
   if (!%p)
   {
      %p = IRCClient::createPerson(%nick,true);
   }

   %c.plist.addRow(%p, %nick);
   %c.plist.sort(0,true);

}

//--------- Private Messages ---------------------------------------------------
function IRCClient::onPrivMsg(%prefix,%params)
{
   %p = $IRCClient::people.getObject(0);
   %prefix = nextToken(%prefix,nick,"!");
   %msg = nextToken(%params,channel," ");

   // messages always lead with a ':'
   if (getSubStr(%msg,0,1) $= ":")
      %msg = getSubStr(%msg,1,strlen(%msg)-1);
   if (getSubStr(%msg,0,8) $= "\x01FRIEND\x01")
      {
        %type = nextToken(%msg,ctcp," ");
        if (%type $= "reply")
        {
           IRCClient::FriendOnline(%nick,%msg);
        }
        if (%type $= "query")
        {
           IRCClient::FriendQuery(%nick);
        }
      }
   // checking to see if the channel is the users nick. This only happens for private messages going to user.
   if (%channel $= %p.displayName)
   {
      %c = $IRCClient::currentChannel;
      if (getSubStr(%msg,0,7) $= "\x01ACTION")
      {
         %msg2 = "\c9[Private] \c8" @ %nick SPC getSubStr(%msg,8,strlen(%msg)-8);
      }
      else
      {
         %msg2 = "\c9[Private]\c9<" @ %nick @ "> " @ %msg;
      }
   }
   else
   {
      %c = IRCClient::findChannel(%channel, false);
      if (getSubStr(%msg,0,7) $= "\x01ACTION")
      {
         %msg2 = "\c5" @ %nick @ "\c5 " @ getSubStr(%msg,7,strlen(%msg)-7);
      }
      else
      {
         %msg2 = "<" @ %nick @ "> " @ %msg;
      }
   }
   IRCClient::newMessage(%c,%msg2);
}

//---------- Kick --------------------------------------------------------------
function IRCClient::onKick(%prefix,%params)
{
   %prefix = nextToken(%prefix,nick,"!");
   %params = nextToken(%params,channel," ");
   %reason = nextToken(%params,target," :");
   
   if (%target $= $IRCClient::Nick)
   {
      $IRCClient::channels.getObject(0).pushBackLine("\c1 You have been kicked from " @ %channel @ " by " @ %nick @ " his reason was " @ %reason,0);
      for (%i = 0; %i <= $IRCClient::channels.getCount(); %i++)
      {
         %c = $IRCClient::channels.getObject(%i);
         if (%c.getName() $= %channel)
         {
            $IRCClient::channels.remove(%c);
         }
      }
   IRCClient::guiRebuildList();
   }
   else
   {
      if (%reason $= "")
      {
        %reason = "No Reason Given";
      }
      IRCClient::newMessage(%channel,"\c1[KICK] "@ %nick @ " has kicked " @ %target @ "(" @ %reason @ ")");

      %p = IRCClient::findPerson(%target);
      %channel = IRCClient::findChannel(%channel,false);
      %channel.plist.removeRowById(%p);
   }
}

//---------- Part --------------------------------------------------------------
function IRCClient::onPart(%prefix,%params)
{
   %prefix = nextToken(%prefix,nick,"!");
   if (%nick $= $IRCClient::Nick)
   {
      %channel = %params;
      %reason = nextToken(%params,channel," :");
      $IRCClient::channels.getObject(0).pushBackLine("\c3  You have left " @ %channel,0);
      for (%i = 0; %i <= $IRCClient::channels.getCount(); %i++)
      {
         %c = $IRCClient::channels.getObject(%i);
         if (%c.getName() $= %channel)
         {
            $IRCClient::channels.remove(%c);
         }
      }
   IRCClient::guiRebuildList();
   }
   else
   {
      %reason = nextToken(%params,channel," :");
      if (%reason $= "")
      {
        %reason = "No Reason Given";
      }
      IRCClient::newMessage(%channel,"\c3[PART] "@ %nick @ " has left the conversation. (" @ %reason @ ")");
      %p = IRCClient::findPerson(%nick);
      %channel = IRCClient::findChannel(%channel,false);
      %channel.plist.removeRowById(%p);
   }
   if (%channel $= $INGAME.channel)
   {
      mMM_ChanList.setSelectedById($INGAME.lastChan);
      $INGAME.lastChan = "";
   }
}

//---------- Quit --------------------------------------------------------------
function IRCClient::onQuit(%prefix,%params)
{
   %prefix = nextToken(%prefix,nick,"!");
   if (%nick $= $IRCClient::Nick)
   {
       IRCClient::tcpDisconnect();
   }
   else
   {
      if (getSubStr(%params,0,1) $= ":")
      {
          %reason = getSubStr(%params,0,strlen(%params)-1);
      }
      else
      {
          %reason = %params;
      }
      %p = IRCClient::findPerson(%nick);
      for (%i = 0; %i < $IRCClient::channels.getCount(); %i++)
      {
         %channel = $IRCClient::channels.getObject(%i);
         if (%channel.plist.getRowNumById(%p) !$= "-1")
         {
           IRCClient::newMessage(%channel,"\c3[QUIT] "@ %nick @ " has left the server. (" @ %reason @ ")");
           %channel.plist.removeRowById(%p);
         }
      }
   }

}

//---------- Nick --------------------------------------------------------------
function IRCClient::onNick(%prefix,%params)
{
   %prefix = nextToken(%prefix,nick,"!");
   %p = IRCClient::findPerson(%nick);
   %newnick = %params;
   if (%p.displayName $= $IRCClient::nick)
   {
      $IRCClient::nick = %newnick;
   }
   %p.displayName = %newnick;
   for (%i = 0; %i < $IRCClient::channels.getCount(); %i++)
   {
      %c = $IRCClient::channels.getObject(%i);
      if (%c.plist.getRowNumById(%p) !$= "-1")
      {
         %temp = %c.plist.getRowTextById(%p);
         if (getSubStr(%temp,0,1) $= "@" || getSubStr(%temp,0,1) $= "+")
         {
            %temp = getSubStr(%temp,0,1);
         }
         else
         {
            %temp = "";
         }
         %temp = %temp @ %newnick;
         %temp2 = %nick @ "-Game";
         %temp3 = %newnick @ "-Game";
         if ( %newnick $= %temp2)
            IRCClient::newMessage(%c, "\c7" @ %nick @ " has left to do battle.");
         else if ( %nick $= %temp3)
            IRCClient::newMessage(%c, "\c7" @ %newnick @ " has returned from battle.");
         else
            IRCClient::newMessage(%c, "\c7" @ %nick @ " is now known as " @ %newnick @ ".");
         %c.plist.setRowById(%p,%temp);
      }
   }
}

//---------- Modes -------------------------------------------------------------
function IRCClient::onMode(%prefix,%params)
{
   %prefix = nextToken(%prefix,nick,"!");
   %params = nextToken(%params,ch," ");
   %params = nextToken(%params,mode," ");
   IRCClient::send("NAMES " @ %ch );
   %c = IRCClient::findChannel(%ch);
   if (!%c) return;

   for (%i = 0; %i < strlen(%mode); %i++)
      switch$(getSubStr(%mode,%i,1))
      {
         case "+":
            %toggle = true;
         case "-":
            %toggle = false;
         case "o":   // Operator
            %params = nextToken(%params,target," ");
            if (%toggle)
            {
               IRCClient::newMessage(%c, "[MODE] " @ %nick @ " gave " @ %target @ " op privileges");
               if (%ch $= $INGAME.Channel && $GUI::Host != true)
               {
                  IRCClient::send("MODE " @ $INGAME.Channel @ " +ntsk " @ $INGAME.password);
               }
            }
            else
            {
               IRCClient::newMessage(%c, "[MODE] " @ %nick @ " removed " @ %target @ " op privileges");
            }
         case "v":   // Speaker (voice)
            %params = nextToken(%params,target," ");
            if (%toggle)
               IRCClient::newMessage(%c, "[MODE] " @ %nick @ " gave " @ %target @ " speaking privileges");
            else
               IRCClient::newMessage(%c, "[MODE] " @ %nick @ " removed " @ %target @ " speaking privileges");
         case "h":
            %params = nextToken(%params,target," ");
            if (%toggle)
               IRCClient::newMessage(%c, "[MODE] " @ %nick @ " gave " @ %target @ " halfop privileges");
            else
               IRCClient::newMessage(%c, "[MODE] " @ %nick @ " removed " @ %target @ " halfop privileges");
         case "b":   // Ban
            %params = nextToken(%params,arg," ");
         case "i":   // Channel is Invite only
               IRCClient::newMessage(%c, "[MODE] " @ %nick @ " has made the channel invite only");
         case "l":   // Channel has limited members
               %params = nextToken(%params,target," ");
               IRCClient::newMessage(%c, "[MODE] " @  %nick @ " has made the limited to only " @ %target @ " people");
         case "m":   // Channel is moderated
               IRCClient::newMessage(%c, "[MODE] " @ %nick @ " has made the moderated");
         case "k":   // Channel has secret key
               %params = nextToken(%params,target," ");
               IRCClient::newMessage(%c, "[MODE] " @ %nick @ " has given the channel a key (" @ %target @ ")");
      }
}
