//------------------------------------------------------------------------------
// IRC-ERROR Script v1.0
//------------------------------------------------------------------------------
// Contains the functions to deal with all ERROR replies
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//
// By Sebastien Bourgon
// Last Updated February 26th, 2003
//------------------------------------------------------------------------------

//------ Default Error Parse Function ------------------------------------------
function IRCClient::onError(%prefix,%command,%message)
{
   %message = nextToken(%message,me," ");
   // LETS DO THIS!
   switch(%command)
   {
   // Listing the important ones first. Then I'll follow with the normal ones
   case 401: // No such nick/chan
     IRCClient::errorImportant(%message,1);
   case 403: // No such channel
     IRCClient::errorImportant(%message,1);
   case 404: // Cant send to channel
     IRCClient::errorImportant(%message,1);
   case 405: // Too many channels
     IRCClient::errorImportant(%message,1);
   case 424: // File Error
     IRCClient::errorImportant(%message,2);
   case 431: // No nickname given
     IRCClient::errorImportant(%message,2);
   case 432: // Erroneus nickname
     IRCClient::errorImportant(%message,1);
   case 433: // Nickname in use
     IRCClient::errorNickname(%message,1);
   case 451: // Not registered
     IRCClient::errorImportant(%message,2);
   case 461: // Need more params
     IRCClient::errorImportant(%message,1);
   case 462: // Already registered
     IRCClient::errorImportant(%message,2);
   case 463: // No oper for you
     IRCClient::errorImportant(%message,2);
   case 465: // Youre banned creep
     IRCClient::errorImportant(%message,2);
   case 482: // Youre not a channel op
     IRCClient::errorImportant(%message,1);

   // Normal Ones
   case 402: // No such Server
     IRCClient::errorNormal(%message,1);
   case 406: // There was no such nickname
     IRCClient::errorNormal(%message,1);
   case 407: // Duplicate recipients. No message sent
     IRCClient::errorNormal(%message,1);
   case 409: // No origin
     IRCClient::errorNormal(%message,2);
   case 411: // No recipient
     IRCClient::errorNormal(%message,2);
   case 412: // No text to send
     IRCClient::errorNormal(%message,2);
   case 413: // No toplvl domain specified
     IRCClient::errorNormal(%message,1);
   case 414: // Wildcard in top level domain
     IRCClient::errorNormal(%message,1);
   case 421: // Unknown command
     IRCClient::errorNormal(%message,1);
   case 422: // No MOTD
     IRCClient::errorNormal(%message,2);
   case 436: // Nick Collision Kill
     IRCClient::errorNormal(%message,1);
   case 441: // They aren't on that channel
     IRCClient::errorNormal(%message,1);
   case 442: // Your not in that channel
     IRCClient::errorNormal(%message,1);
   case 443: // They are already in channel
     IRCClient::errorNormal(%message,1);
   case 444: // Not logged in
     IRCClient::errorNormal(%message,1);
   case 445: // Summon disabled
     IRCClient::errorNormal(%message,2);
   case 446: // Users disabled
     IRCClient::errorNormal(%message,2);
   case 464: // Password incorrect
     IRCClient::errorNormal(%message,2);
   case 467: // Key set
     IRCClient::errorNormal(%message,1);
   case 471: // Chan full
     IRCClient::errorNormal(%message,1);
   case 472: // Unknown mode
     IRCClient::errorNormal(%message,1);
   case 473: // Invite Only
     IRCClient::errorNormal(%message,1);
   case 474: // Banned from chan
     IRCClient::errorNormal(%message,1);
   case 475: // Bad Chan key
     IRCClient::errorNormal(%message,1);
   case 481: // No Oper for you
     IRCClient::errorNormal(%message,2);
   case 483: // Cant kill server
     IRCClient::errorNormal(%message,2);
   case 491: // No Oper for you
     IRCClient::errorNormal(%message,2);
   case 501: // Unknown Mode flag
     IRCClient::errorNormal(%message,2);
   case 502: // Cant change other peoples modes!
     IRCClient::errorNormal(%message,2);
   }
}

//------------ Error Output for Important Errors -------------------------------
function IRCClient::errorImportant(%message,%style)
{
  switch(%style)
  {
    case 1: // "Complicated" parser
       %msg = nextToken(%message,info, ":");
       IRCClient::newMessage($IRCClient::CurrentChannel, "\c4[ERROR] " @ %info SPC %msg);
    case 2: // "Simple" parser
       %msg = getSubStr(%message,1,strlen(%message)-1);
       IRCClient::newMessage($IRCClient::CurrentChannel, "\c4[ERROR] " @ %info SPC %msg);
  }
}

function IRCClient::errorNickname(%message,%style)
{
  switch(%style)
  {
    case 1: // In use
       if ($IRCClient::loginState < 5)
       {
       IRCClient::loginFailed("Nickname In Use","The Nickname you have chosen is in use and owned by someone else");
       }
  }
}
//----------- Error Output for Normal Errors -----------------------------------
function IRCClient::errorNormal(%message,%style)
{
  switch(%style)
  {
    case 1: // "Complicated" parser
       %msg = nextToken(%message,info, ":");
       IRCClient::newMessage($IRCClient::Status, "\c4[ERROR] " @ %info SPC %msg);
    case 2: // "Simple" parser
       %msg = getSubStr(%message,1,strlen(%message)-1);
       IRCClient::newMessage($IRCClient::Status, "\c4[ERROR] " @ %info SPC %msg);
  }
}

