// New IRC GUI File
// The "hookup" as it were.
// Min/Max buttons

function IRCUI::minimize()
{
   %currentwidth = getWord(mMM_IRCFrame.getExtent(),0);
   %heightend = getWord(mMM_SmallFrame.getPosition(),1);
   %y = nextToken(mMM_IRCFrame.getPosition(),x," ");
   mMM_IRCFrame.resize(%x,%y,%currentwidth,%heightend - %y - 10);
   mMM_SmallFrame.setVisible(true);
   mMM_FullSizeFrame.setVisible(false);
}

function IRCUI::maximize()
{
   if ($IRCClient::loginStage != 5)
      return;
   %currentwidth = getWord(mMM_IRCFrame.getExtent(),0);
   %heightend = getWord(mMM_FullSizeFrame.getPosition(),1);
   %y = nextToken(mMM_IRCFrame.getPosition(),x," ");
   mMM_IRCFrame.resize(%x,%y,%currentwidth,%heightend - %y - 10);
   mMM_SmallFrame.setVisible(false);
   mMM_FullSizeFrame.setVisible(true);
}

// ---------- Create Channel Function ------------------------------------------------
function IRCUI::cmdCreateRoom()
{
   DialogBoxSingle("Create Room","Name:","IRCUI::cmdCreateRoom2();","");
}

function IRCUI::cmdCreateRoom2()
{
   if ($GUI::Input1 !$= "")
      IRCClient::sendJoin("#" @ $GUI::Input1);
}

// ---------- Text Box Function ------------------------------------------------
function IRCUI::cmdSendText()
{
   if (strlen(mMM_IF_MessageInput.getValue()) != 0){
      IRCClient::dispatchOutput(mMM_IF_MessageInput.getValue(),"");
   }
   mMM_IF_MessageInput.setValue("");
}

// ----------- Previous/Next Functions for Channel Bar -------------------------

function IRCUI::cmdMove(%amount)
{
   //Get box size to compare against (for x value only)
   %fullsize = getWord(mMM_IF_ChanLimiter.getExtent(),0);
   //Get size of inner box
   %currentsize = getWord(mMM_IF_ChanHolder.getExtent(),0);
   //Dont do anything
   if (%fullsize >= %currentsize)
      return;
   %x = getWord(mMM_IF_ChanHolder.getPosition(),0);
   if (%fullsize >= %x - %amount + %currentsize)

      mMM_IF_ChanHolder.resize(%fullsize - %currentsize,0,%currentsize,36);
   else if (%x - %amount > 0 )
      mMM_IF_ChanHolder.resize(0,0,%currentsize,36);
   else
   //y is always 0 as it doesn't move vertically. Y size is always 36.
   //Amount will move it left/right depending on positive/negative values
      mMM_IF_ChanHolder.resize(%x - %amount,0,%currentsize,36);
}

// ------------- Add Channels (Technically non-UI) ----------------------
function IRCUI::addChannel(%name,%id)
{
   // Get holder sizes
   %fullsize = getWord(mMM_IF_ChanLimiter.getExtent(),0);
   %currentsize = getWord(mMM_IF_ChanHolder.getExtent(),0);
   // Force it over to the end so that the new channel is shown
   if (%fullsize < %currentsize + 106)
   {
      %x = %fullsize - %currentsize - 106;
      mMM_IF_ChanHolder.resize(%x,0,%currentsize + 106,36);
   }
   else
   {
      mMM_IF_ChanHolder.resize(0,0,%currentsize + 106,36);
   }
   
   %number = mMM_ChanList.rowCount() - 1;
   %chanbox = new GuiTextCtrl("ircchanneltext" @ %id)
	{
       profile = "GuiShellTextCenterProfile";
       horizSizing = "right";
       vertSizing = "bottom";
       position = (%number * 106) SPC "8";
       extent = "106 18";
       minExtent = "8 8";
       visible = "1";
       helpTag = "0";
       text = %name;
   };
   %chanbutton = new GuiBitmapButtonCtrl("ircchannelbutton" @ %id)
	{
       profile = "GuiShellTextProfile";
       horizSizing = "right";
       vertSizing = "bottom";
       position = (%number * 106) SPC "0";
       extent = "106 36";
       minExtent = "8 8";
       visible = "1";
       helpTag = "0";
       text = "";
       command = "mMM_ChanList.setSelectedRow(" @ %id @ ");";
       bitmap = "fps/client/ui/buttons/tab";
   };
   mMM_IF_ChanHolder.add(%chanbox);
   mMM_IF_ChanHolder.add(%chanbutton);
}


function IRCClient::guiRebuildList()
{
   mMM_ChanList.clear();
   for (%i = 0; %i < mMM_IF_ChanHolder.getCount(); %i++)
   {
      mMM_IF_ChanHolder.getObject(%i).delete();
   }
   mMM_IF_ChanHolder.clear();
   mMM_IF_ChanHolder.resize(0,0,10,36);
   //mMM_ChanList.addRow(0,"STATUS");
   //IRCUI::addChannel("STATUS",0);
   for (%i = 0; %i < $IRCClient::channels.getCount(); %i++)
   {
      %c = $IRCClient::channels.getObject(%i);
      mMM_ChanList.addRow(%i,%c.getName());
      IRCUI::addChannel(%c.getName(),%i);
   }
   if ($IRCClient::LastChannel < 0)
   {
      mMM_ChanList.setSelectedRow(0);
   }
   else
   {
      mMM_ChanList.setSelectedById($IRCClient::LastChannel);
      $IRCClient::LastChannel = -1;
   }
}

//function channel_select::onSelect(%this, %id, %text)
function mMM_ChanList::onSelect(%this,%id,%text)
{
  %c = IRCClient::findChannel(%text,false);
  if ($IRCClient::lastbutton !$= "")
  {
     $IRCClient::lastbutton.setBitmap("fps/client/ui/buttons/tab");
  }
  ("ircchannelbutton" @ %id).setBitmap("fps/client/ui/buttons/currenttab");
  $IRCClient::lastbutton = ("ircchannelbutton" @ %id);
  $IRCClient::currentChannel = %c;
  if ($IRCClient::CurrentChannel $= $IRCClient::Status)
  {
    mMM_IF_PartButton.setActive(0);
    mMM_IF_ChanButton.setActive(1);
    mMM_IF_JoinButton.setActive(1);
  }
  else
  {
    mMM_IF_PartButton.setActive(1);
    mMM_IF_ChanButton.setActive(0);
    mMM_IF_JoinButton.setActive(0);
  }
  %c.plist.sort(0);
  mMM_IF_NickList.clear();
  mMM_IF_NickList.add(%c.plist);
  irc.detach();
  irc.attach(%c);
}

//------------ IRC Client Load -------------------------------------------------
function IRCUI::cmdLoad()
{
  irc.detach();
  IRCUI::maximize();
  canvas.setcontent(menuMultiMain);
  canvas.popDialog();
  if ($IRCClient::initialized == 0)
  {
    IRCClient::init();
    IRCClient::fileLoad();
  } else {
    IRCClient::guiRebuildList();
  }
  if ($IRCClient::loginStage == 0)
  {
     Canvas.pushDialog(menuMultiLogin);
  }
  mMM_ChanList.setSelectedById($IRCClient::LastChannel);
}

//------------- Main Menu Button -----------------------------------------------
function IRCUI::cmdMain()
{
   IRCClient::sendQuit("Gone");
   IRCClient::fileSave();
   //IRCClient::tcpDisconnect();
   $IRCClient::loginStage = 0;
   Canvas.setContent(menuMainGui);
}

//------------- Join Button ----------------------------------------------------
function IRCUI::cmdJoin()
{
   if ($IRCClient::loginStage != 5)
      return;
   %id = $IRCClient::Status.plist.getSelectedId();
   %channel = $IRCClient::Status.plist.getRowTextById(%id);
   if (strlen(%channel) > 0)
   {
      IRCClient::send("JOIN " @ %channel);
   }
}

//------------- Join Button ----------------------------------------------------
function IRCUI::cmdNewGame()
{
   if ($IRCClient::loginStage != 5)
      return;
   $IRCClient::LastChannel = mMM_ChanList.getSelectedId();
   IRCClient::fileSave();
   Canvas.pushDialog(menuMultiNewGameGui);
}
function IRCUI::cmdComcent()
{
   if ($IRCClient::loginStage != 5)
      return;
   $IRCClient::LastChannel = mMM_ChanList.getSelectedId();
   IRCClient::fileSave();
   Canvas.setContent(menuComcent);
}

//------------- Help Button ----------------------------------------------------
function IRCUI::cmdHelp()
{
   getHelp("12. IRC Command Reference");
}

//------------- List/Part Button -----------------------------------------------
function IRCUI::cmdChannel()
{
   if ($IRCClient::CurrentChannel $= $IRCClient::Status)
   {
       IRCClient::send("LIST");
   }
   else
   {
       IRCClient::sendPart("Leaving");
   }
}

