//------------------------------------------------------------------------------
// IRC-INFO Script v1.0.1
//------------------------------------------------------------------------------
// 401 - 499 are error codes and have thier own script
// 200 - 399 (roughly) are command responses
//------------------------------------------------------------------------------
// Original Scripts created or modified by Harold "LabRat" Brown
//
// By Sebastien Bourgon
// Last Updated February 26th, 2003
//------------------------------------------------------------------------------

//------Default Parse Function -------------------------------------------------
function IRCClient::infoDefault(%prefix,%message)
{
   %message = nextToken(%message,me," ");
   $IRCClient::channels.getObject(0).pushBackLine(%message,0);
}

//------Verify Nickname --------------------------------------------------------
function IRCClient::infoVerifyName(%prefix,%message)
{
   %message = nextToken(%message,me," ");
   if (%me !$= $IRCClient::Nick)
   {
      $IRCClient::Nick = %me;
   }
}

//-------- MOTD ----------------------------------------------------------------
function IRCClient::infoMOTD(%prefix,%params,%flag)
{
 %params = nextToken(%params,nick," ");
 switch(%flag)
  {
  case 1: // Start Ex: ':- <Server> Message of the Day -'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c8"@ %msg );
  case 2: // Info  Ex: ':- <text>'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c8"@ %msg );
  case 3: // End   Ex: ':End of /MOTD command'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c8End of the Message of the Day" );
  }
}

//-------- LIST ----------------------------------------------------------------
function IRCClient::infoList(%prefix,%params,%flag)
{
  %params = nextToken(%params,nick," ");
  switch(%flag)
  {
    case 1: // Start Ex: 'Channel :Users Name"
      $IRCClient::Status.plist.clear();
    case 2: // Info  Ex: '<channel> <# visible> :<topic>
      %params = nextToken(%params,ch," ");
      %topic  = nextToken(%params,users," :");
      echo(%ch);
      if (%ch $= "#A")
        return;
      $IRCClient::Status.plist.addRow($IRCClient::Status.plist.rowCount(),%ch);
    case 3: // End   Ex: ':End of /List'
      $IRCClient::Status.plist.sort(0);
 }
}

//------- MODE -----------------------------------------------------------------
function IRCClient::infoMode(%prefix,%params)
{
  // Ex '<channel> <mode> <params>'
  %params = nextToken(%params,nick," ");
  %modes = nextToken(%params,chan," ");
  %chan = IRCClient::findChannel(%chan);
  IRCClient::newMessage(%chan, "\c2 [MODE] The current channel modes are " @ %modes);
}

//------- NAMES ----------------------------------------------------------------
function IRCClient::infoNames(%prefix,%params,%flag)
{
switch(%flag)
 {
 case 1: // Ex '<channel> :[[@|+|]<nick> [[@|+|]<nick> [...]]]'
   %params = nextToken(%params,nick," =@");
   %me = IRCClient::findPerson(%nick);

   // find the end of channel name
   %params = nextToken(%params,ch," :");
   %c = IRCClient::findChannel(%ch);
   %c.plist.clear();
   // loop through the nick and add them to the channel
   while (strlen(%params))
   {
      %params = nextToken(%params,nick," ");
      %p = IRCClient::findPerson(%nick);
      if (%p $= "0")
      {
         %p = IRCClient::createPerson(%nick,true);
      }
      %c.plist.addRow(%p, %nick);
   }
 case 2: // Ex '<channel> :End of /Names List'
    %params = nextToken(%params,chan,":");
    %c = IRCClient::findChannel(%ch);
    %c.plist.sort(0);
 }
}

//------- UMODE ----------------------------------------------------------------
function IRCClient::infoUMode(%prefix,%params)
{
  // Ex '<user mode string>'
  %params = nextToken(%params,nick," ");
  IRCClient::newMessage($IRCClient::CurrentChannel, "\c7[MODE] Your user modes are " @ %params);
}

//------- Password -------------------------------------------------------------
function IRCClient::infoPassword(%prefix,%params)
{
  // Ex ':password accept for nick TheAce'
  %params = nextToken(%params,nick," ");
  %msg = getSubStr(%params,1,strlen(%params)-1);
  IRCClient::newMessage($IRCClient::CurrentChannel, "\c6[Server] " @ %msg);

}

//------- LUSERS----------------------------------------------------------------
function IRCClient::infoLusers(%prefix,%params,%flag)
{
%params = nextToken(%params,nick," ");
switch(%flag)
 {
 case 1: // Ex ':There are 67 users and 18 invisible on 3 servers'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7" @ %msg );
 case 2: // Ex '4 :operator(s) online'                                       \
   %msg = nextToken(%params,count," :");
   IRCClient::newMessage($IRCClient::Status, "\c7" @ %count SPC %msg);
 case 3: // Ex '23 :channels formed'
   %msg = nextToken(%params,count," :");
   IRCClient::newMessage($IRCClient::Status, "\c7" @ %count SPC %msg);
 case 4: // Ex '11 :unknown connections'
   %msg = nextToken(%params,count," :");
   IRCClient::newMessage($IRCClient::Status, "\c7" @ %count SPC %msg);
 case 5: // Ex ':I have 40 clients and 2 servers'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7" @ %msg );
 case 6: // Ex ':Current Local Users: 40  Max: 74'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7" @ %msg );
 case 7: // Ex ':Current Global Users: 85  Max: 157'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7" @ %msg );
 }
}

//------- ADMIN ----------------------------------------------------------------
function IRCClient::infoAdmin(%prefix,%params,%flag)
{
%params = nextToken(%params,nick," ");
switch(%flag)
 {
 case 1: // Admin Info Ex ':<admin info>'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7[ADMIN] " @ %msg );
 case 2: // Admin Loc1 Ex ':<admin info>'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7[ADMIN] " @ %msg );
 case 3: // Admin Loc2 Ex ':<admin info>'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7[ADMIN] " @ %msg );
 case 4: // Admin Email Ex ':<admin info>'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7[ADMIN] " @ %msg );
 }
}

//------- Time -----------------------------------------------------------------
function IRCClient::infoTime(%prefix,%params)
{
  // Ex '<server> :<server time string>'
  %params = nextToken(%params,nick," ");
  %time = nextToken(%params,server,":");
  IRCClient::newMessage($IRCClient::CurrentChannel, "\c7[TIME] Current Time on " @ %server @ " is " @ %time );
}

//------- Ban List -------------------------------------------------------------
function IRCClient::infoBanList(%prefix,%params,%flag)
{
%params = nextToken(%params,mynick," ");
switch(%flag)
  {
  case 1: // Ban List Ex '<channel> <banid>'
    %banid = nextToken(%params,channel,":");
    %channel = IRCClient::findChannel(%channel);
    IRCClient::newMessage(%channel, "\c7[BAN] " @ %banid);
  case 2: // Ban End  Ex '<channel> :end of ban list'
    %banid = nextToken(%params,channel,":");
    %channel = IRCClient::findChannel(%channel);
    IRCClient::newMessage(%channel, "\c7[BAN] End of Ban List");
  }
}

//------- Topic ----------------------------------------------------------------
function IRCClient::infoTopic(%prefix,%params,%flag)
{
%params = nextToken(%params,mynick," ");
switch(%flag)
 {
 case 1: // No Topic  Ex '<channel> :No Topic is set'
   %chan = IRCClient::findChannel(%chan);
   IRCClient::newMessage(%chan, "\c2[TOPIC] No Topic Set");
 case 2: // Topic     Ex '<channel> :<topic>'
   %topic = nextToken(%params,chan," ");
   %topic = getSubStr(%topic,1,strlen(%topic)-1);
   %chan = IRCClient::findChannel(%chan);
   IRCClient::newMessage(%chan, "\c2[TOPIC] " @ %topic);
 }
}

//------- Invite ---------------------------------------------------------------
function IRCClient::infoInvite(%prefix,%params)
{
  %params = nextToken(%params,mynick," ");
  // Ex '<channel> <nick>'
  %chan = nextToken(%params,nick," ");
  IRCClient::newMessage($IRCClient::CurrentChannel, "\c7[INVITE] You have invited " @ %nick @ " to join " @ %chan );
}

//------- Whois ----------------------------------------------------------------
function IRCClient::infoWhois(%prefix,%params,%flag)
{
%params = nextToken(%params,mynick," ");
%params = nextToken(%params,nick," ");

switch(%flag)
 {
 case 7:  // Reged  Ex. ':is a registered nick'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7[WHOIS] " @ %nick SPC %msg );
 case 10: // HelpOp Ex. ':is available for help'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7[WHOIS] " @ %nick SPC %msg );
 case 11: // User   Ex. '<nick> <user> <host> * :<realname>'
   %params = nextToken(%params,user," ");
   %params = nextToken(%params,host," ");
   %realname = nextToken(%params,junk,":");
   IRCClient::newMessage($IRCClient::Status, "\c7[WHOIS] " @ %nick @ "'s host is "@ %user @ "@" @ %host @ " : " @ %realname );
 case 12: // Server Ex. '<nick> <server> :<server info>'
   %params = nextToken(%params,server," ");
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7[WHOIS] " @ %nick @ " is connected to "@ %server SPC %msg );
 case 13: // Oper   Ex. '<nick> :is an IRC operator'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7[WHOIS] " @ %nick SPC %msg );
 case 17: // Idle   Ex. '<nick> <integer> <integer> :seconds idle,signon time'
   %params = nextToken(%params,idle," ");
   %params = nextToken(%params,time," ");
   %time = IRCClient::logOnTime(%time);
   IRCClient::newMessage($IRCClient::Status, "\c7[WHOIS] " @ %nick @ " has been idle for "@ %idle @ " seconds, Signed in at " @%time);
 case 18: // End Of Ex. '<nick> :End of /Whois list'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7[WHOIS] " @ %nick SPC %msg );
 case 19: // Chans  Ex. '<nick> :{[@|+]<channel><space>}'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7[WHOIS] " @ %nick @ " has joined: "@ %msg );
 case 20: // Sa     Ex  ':Is a services admin'
   %msg = getSubStr(%params,1,strlen(%params)-1);
   IRCClient::newMessage($IRCClient::Status, "\c7[WHOIS] " @ %nick SPC %msg );
 }
}

//------- Notify/IsOn/Friends System -------------------------------------------
function IRCClient::infoNotify(%prefix,%params)
{
// Ex ':[<nick>{<space><nick>}]'
// Ex OUTPUT : " 1:TheAce-MGO is offline. "
//             " 2:Adrian-MGT is online. "

  %params = nextToken(%params,nick,":");
  %listed = 0; // 1 for true, 0 for false
  %list = new SimGroup(IsOnList);

  while (strlen(%params))
  {
    %params = nextToken(%params,nick," ");
    %list.add(new SimObject() { nick = %nick; });
  }
  for (%i = 0; %i < $IRCClient::friends.getCount(); %i++)
  {
    %listed = 0;
    %friend = $IRCClient::friends.getObject(%i);
    for (%k = 0; %k < %list.getCount(); %k++)
    {
      %l = %list.getObject(%k);
      if (%friend.nick $= %l.nick)
      {
        %friend.status = "online";
        %listed = 1;
        break;
      }
    }
    if (%listed == 0)
    {
       %friend.status = "offline";
    }
  }
  // Reason for the seperate loops is simply to make it look nice.
  // Server doesn't necessarily return the ison in the same order it went.
  IRCClient::Friends(2);
}

