//------------------------------------------------------------------------------
// IRC-SEND Script v0.9
//------------------------------------------------------------------------------
// Contains the functions to deal all OUTGOING messages to server.
// AKA The commands sent by the user himself
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Original Scripts created or modified by Harold "LabRat" Brown
//
// By Sebastien Bourgon
// Last Updated February 26th, 2003
//------------------------------------------------------------------------------

//---------- Ignore The Given Command ------------------------------------------
function IRCClient::ignoreCommand(%message)
{
}

//------ Default Command -------------------------------------------------------
function IRCClient::sendDefault(%message)
{
    IRCClient::send(getSubStr(%message,1,strlen(%message)-1));
}

//------ Join Command ----------------------------------------------------------
function IRCClient::sendJoin(%params)
{
   %tmp = nextToken(%params,channel," ");
   nextToken(%tmp,key," ");

   // Only allow one channel / key combination at a time - no
   // comma delimiting
   nextToken(%channel,channel,",");
   nextToken(%key,key,",");
   echo(%channel);
   if (%channel $= "#A")
      return;
   %c = IRCClient::findChannel(%channel);
   $IRCClient::key = %key;

   IRCClient::send("JOIN " @ %channel SPC %key);
}
//------- Kick command (My Favorite) -------------------------------------------
function IRCClient::sendKick(%params)
{
   %params = nextToken(%params,channel," ");
   %reason = nextToken(%params,target," ");

   IRCClient::send("KICK " @ %channel SPC %target @ " :" @ %reason );

}
//------- Action/Me command ----------------------------------------------------
function IRCClient::sendAction(%params)
{
   if (!strlen(%params))
      return;

   if (getSubStr(%params,0,1) $= "/")
      IRCClient::send2(%params,"");
   else
   {
      IRCClient::send("PRIVMSG " @ $IRCClient::currentChannel.getName() @ " :\x01ACTION " @ %params @  "\x01");
      %me = $IRCClient::people.getObject(0);
      IRCClient::newMessage($IRCClient::currentChannel, "\c5" @ %me.displayName SPC %params);

   }
}

//-------- Notice Command ---------------------------------------------------------
function IRCClient::sendNotice(%message)
{
  %me = $IRCClient::people.getObject(0);
  %message = nextToken(%message,target," ");
  IRCClient::send("NOTICE " @ %target @ " :" @ %message);
  IRCClient::newMessage($IRCClient::currentChannel, "\c6[Notice to " @ %target @ "]: \c6" @ %message);

}

//-------- Msg Command ---------------------------------------------------------
function IRCClient::sendMsg(%message)
{
  %me = $IRCClient::people.getObject(0);
  %message = nextToken(%message,target," ");
  IRCClient::send("PRIVMSG " @ %target @ " :" @ %message);
  IRCClient::newMessage($IRCClient::currentChannel, "\c9[Msg to " @ %target @ "]: \c9" @ %message);

}

//-------- WHOIS/INFO Command --------------------------------------------------
function IRCClient::sendWhois(%params)
{
  IRCClient::send("WHOIS " @ %params);

}

//-------- Topic Command -------------------------------------------------------
function IRCClient::sentTopic(%params)
{
  %channel = $IRCClient::CurrentChannel.getName();
  IRCClient::send("TOPIC " @ %channel SPC %params);
}

//--------- Help Command -------------------------------------------------------
function IRCClient::sendHelp(%params)
{

}

//--------- IP Command ---------------------------------------------------------
function IRCClient::sendIP(%params)
{

}

//---------- Connect Command ---------------------------------------------------
function IRCClient::sendConnect(%params)
{

}

//--------- Ban Command --------------------------------------------------------
function IRCClient::sendBan(%params)
{
  %channel = $IRCClient::CurrentChannel.getName();
  %params = nextToken(%params,command," ");
  switch$(%command)
  {
  case "add":
    IRCClient::send("MODE " @ %channel @ " +b " @ %params);
  case "del":
    IRCClient::send("MODE " @ %channel @ " -b " @ %params);
  case "list":
    IRCClient::send("MODE " @ %channel @ " b");
  }
}

//---------- Ignore Command ----------------------------------------------------
function IRCClient::sendIgnore(%params)
{
%params = nextToken(%params,%command," ");
  switch$(%command)
  {
  case "add":
    %nick = %params;
    $IRCClient::ignores.add(new SimObject() { nick = %nick; num = $IRCClient::friends.getCount(); status="offline"; });
  case "del":
    %nick = %params;
    for (%i = 0; %i < $IRCClient::ignores.getCount(); %i++)
    {
       %ignore = $IRCClient::ignores.getObject(%i);
       if (%ignore.nick $= %nick)
         $IRCClient::ignores.remove(%friend);
    }
  case "list":
    if ($IRCClient::ignores.getcount() == 0)
    {
       IRCClient::newMessage($IRCClient::currentChannel,"Your ignore list is empty");
    }
    else
    {
      IRCClient::newMessage($IRCClient::currentChannel,"\c1Currently Ignoring");
      for (%i = 0; %i < $IRCClient::ignores.getCount(); %i++)
      {
        %f = $IRCClient::ignores.getObject(%i);
        %msg = "\c1      " @ %f.nick;
        IRCClient::newMessage($IRCClient::currentChannel, %msg);
      }
    }
  }

}

//---------- Friends command ---------------------------------------------------
function IRCClient::sendFriends(%params)
{
  %params = nextToken(%params,command," ");
  switch$(%command)
  {
  case "a":
    %command = "add";
  case "d":
    %command = "del";
  case "l":
    %command = "list";
  case "m":
    %command = "msg";
  }
  switch$(%command)
  {
  case "add":
     %nick = %params;
     for (%i = 0; %i < $IRCClient::friends.getCount(); %i++)
     {
        %friend = $IRCClient::friends.getObject(%i);
        if (%friend.nick $= %nick)
        {
           %found = true;
        }
     }
     if (%found)
     {
        IRCClient::newMessage($IRCClient::currentChannel,"That person is already on your list");
     }
     else
     {
        $IRCClient::friends.add(new SimObject()
       {
        nick = %nick; num = $IRCClient::friends.getCount(); status="offline";
       });
     }
  case "del":
    %nick = %params;
    for (%i = 0; %i < $IRCClient::friends.getCount(); %i++)
    {
       %friend = $IRCClient::friends.getObject(%i);
       if (%friend.nick $= %nick)
         $IRCClient::friends.remove(%friend);
    }
  case "list":
    echo("List");
    if ($IRCClient::friends.getcount() == 0)
    {
       IRCClient::newMessage($IRCClient::currentChannel,"Your friends list is empty");
    }
    else
    {
      echo("Friend");
      for (%i = 0; %i < $IRCClient::friends.getCount(); %i++)
      {
         %friend = $IRCClient::friends.getObject(%i);
         %list = %list SPC %friend.nick;
      }
      IRCClient::send("ISON " @ %list);
    }
  case "msg":
    %msg = nextToken(%params,num," ");
    for (%i = 0; %i < $IRCClient::friends.getCount(); %i++)
    {
      %f = $IRCClient::friends.getObject(%i);
      if (%f.num == %num)
      {
        %friend = %f;
      }
    }
    IRCClient::sendMsg(%friend.nick SPC %msg);
  }
}

//---------- Quit command ------------------------------------------------------
function IRCClient::sendQuit(%params)
{
  IRCClient::send("QUIT :" @ %params );
}

//---------- Topic command ------------------------------------------------------
function IRCClient::sendTopic(%params)
{
  %channel = $IRCClient::CurrentChannel.getName();
  IRCClient::send("TOPIC " @ %channel @ " :" @ %params );
}


//---------- Part command ------------------------------------------------------
function IRCClient::sendPart(%params)
{
  if (getSubStr(%params,0,1) $= "#")
  {
    %params = nextToken(%params,channel," ");
  }
  else
  {
    %channel = $IRCClient::CurrentChannel.getName();
  }
  IRCClient::send("PART " @ %channel @ " :" @%params );
}

//---------- Op command --------------------------------------------------------
function IRCClient::sendOp(%params,%flag)
{
  %channel = $IRCClient::CurrentChannel.getName();
  switch(%flag)
  {
    case 1:
      IRCClient::send("MODE " @ %channel @ " +o " @ %params);
    case 2:
      IRCClient::send("MODE " @ %channel @ " -o " @ %params);
  }
}

//---------- Voice command -----------------------------------------------------
function IRCClient::sendVoice(%params,%flag)
{
  %channel = $IRCClient::CurrentChannel.getName();
  switch(%flag)
  {
    case 1:
      IRCClient::send("MODE " @ %channel @ " +v " @ %params);
    case 2:
      IRCClient::send("MODE " @ %channel @ " -v " @ %params);
  }
}

//---------- UMode command -----------------------------------------------------
function IRCClient::sendUMode(%params)
{
  if (strlen(%params) == 0)
  {
    IRCClient::send("MODE " @ $IRCClient::nick);
  }
  else
  {
    IRCClient::send("MODE " @ $IRCClient::nick SPC %params);
  }
}

//---------- CMode command -----------------------------------------------------
function IRCClient::sendCmode(%params)
{
  %channel = $IRCClient::CurrentChannel.getName();
  if (strlen(%params) == 0)
  {
    IRCClient::send("MODE " @ %channel);
  }
  else
  {
    IRCClient::send("MODE " @ %channel SPC %params);
  }
}
