//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
// Author: beffy
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Package overrides to initialize the mod.

package Mapping
{
function initClient()
{
   Parent::initClient();
   echo("\n--------- Initializing Mapping: Client ---------");
}

function GameConnection::initialControlSet(%this)
{
   echo ("*** Initial Control Object");

   // The first control object has been set by the server
   // and we are now ready to go.
   
   // first check if the editor is active
   if (!Editor::checkActiveLoadDone())
   {
      //if (Canvas.getContent() != PlayGui.getId())
      //   Canvas.setContent(PlayGui);
      // beffy: changed for LORE
      if (Canvas.getContent() != gameHudFS.getId() || Canvas.getContent() != gameHudFS.getId() )
         Canvas.setContent(gameHudFS);
   }
   
   // beffy: now open editor to get ready for mapping ;)
   //if (Canvas.getContent() != EditorGui.getId())
   if(Canvas.getContent() == gameHudFS.getId())
   {
	   echo ("*** Toggling Mission Editor");
	   toggleEditor(true);
   }
}

function loadMainMenu()
{
   exec("~/client/ui/mainMappingGui.gui");
   exec("~/client/ui/startMappingMissionGui.gui");
   $GUI::MusicHandle = alxPlay("Menu_Music");
   Canvas.setCursor("DefaultCursor");
   Canvas.setContent("mainMappingGui");
}

function disconnect()
{
   // Delete the connection if it's still there.
   if (isObject(ServerConnection))
      ServerConnection.delete();
   disconnectedCleanup();

   // Call destroyServer in case we're hosting
   destroyServer();
}

function disconnectedCleanup()
{
   // Clear misc script stuff
   HudMessageVector.clear();

   // Terminate all playing sounds
   alxStopAll();
   if (isObject(MusicPlayer))
      MusicPlayer.stop();

   //
   LagIcon.setVisible(false);
   gamePlayerListGui.clear();
   
   // Clear all print messages
   clientCmdclearBottomPrint();
   clientCmdClearCenterPrint();
   movemap.pop();
   IRCClient::ingameEnd();
   // Back to the launch screen
   Canvas.setContent("mainMappingGui");
   $GUI::MusicHandle = alxPlay("Menu_Music");
   $GUI::MainMenu = false;

   // Dump anything we're not using
   clearTextureHolds();
   purgeResources();
}


};
